/*
 $Id: autoupdate-notifier.js,v 1.4 2018/12/24 13:59:09 ajith.k Exp $
*/
import Ember from 'ember';//NO I18N
import AjaxUtil from "webclient/utils/ajax-util";//No I18N
//ignorei18n_start
export default Ember.Component.extend
({
	creatorURL:null,
	showPopup:false,
	displayName:null,
	updatePopup:function()
	{
		this.set('displayName', this.get('productName'));
		this.getPopupNotifierDetails();
		    
	}.observes('productName').on('init'),
	getPopupNotifierDetails: function()
	{
       var self = this;
       AjaxUtil.ajax('/RestAPI/WC/RoboUpdateAction?mTCall=getPopupNotifierDetails', {})
      .then(function(patchDetails) {
        if (patchDetails.hasOwnProperty('CREATOR_URL')) {
          self.set('creatorURL', patchDetails['CREATOR_URL']);
        }
		if(patchDetails.hasOwnProperty('IS_DB_SUPPORTED') && patchDetails.IS_DB_SUPPORTED)
		{
        if (patchDetails.hasOwnProperty('IS_PATCH_AVAILABLE') && patchDetails.IS_PATCH_AVAILABLE == true)
		{
            self.set('showPopup',patchDetails.IS_PATCH_AVAILABLE);
        } 
		else if(patchDetails.hasOwnProperty('ENABLE_CLIENT_SIDE_PROXY'))
   	    {
            self.checkClientSide();
        }
		}
      });
    },
	
    checkClientSide: function()
	{
		var self = this;
		var url = this.get('creatorURL') + "&variable=patchString";
		Ember.$.getScript(url)
		  .done(function(script, textStatus) {
			if (typeof patchString == 'undefined' || patchString['Robo_Update_Manager'].length==0) 
			{
				   self.set('showPopup',false);
			} 
			else 
			{
			  var data = {};
			  data['patchString'] = JSON.stringify(patchString);
			  var response = AjaxUtil.syncAjax('/RestAPI/WC/RoboUpdateAction?mTCall=savePatchSession', data);
			  if (response.hasOwnProperty('IS_PATCH_AVAILABLE') && response.IS_PATCH_AVAILABLE == true) 
			  {
				   self.set('showPopup',true);
			  }
			}
		  })
		  .fail(function(jqxhr, settings, exception) {
			self.set('patchDetails.PATCH_STATUS', I18NUtil.translate('ads.support.roboupdate.proxy_error'));
		  });
    },
  
    actions: {
    closeDialog: function()
	{
	  AjaxUtil.ajax('/RestAPI/WC/RoboUpdateAction?mTCall=closePopupNotifier', {});
      this.set('showPopup', false); //No I18N
    },
	knowMore: function(){
	 this.set('GLOBAL_DATA.SHOW_AUTOUPDATE', true);
	 this.set('showPopup', false); //No I18N
	},
  },
});
//ignorei18n_end