/*
 * $Id$
 */
import Ember from 'ember'; //NO I18N
import AJAXUtil from 'webclient/utils/ajax-util'; //NO I18N
import I18NUtil from "webclient/utils/i18n-util"; //NO I18N
import CommonUtil from "webclient/utils/ads-common-util"; //NO I18N

//ignorei18n_start

export default Ember.Component.extend({
  mailconfig:false,
  showDayOfWeek:false,
  showDateOfMonth:false,
  updateSchedulerData:null,
  updateCalendarData:null,
  disableEnableNotificationCheckBox:null,
  disableEnableCheckBox:null,
  enbleRoboupdateCheck:false,
  showRoboUpdateInputBox: function() {
    return !(this.get('enbleRoboupdateCheck'));
  }.property('enbleRoboupdateCheck'),
  initialize : function()
  {
      if(this.get('refresh')==false)
      {
        return;
      }
      $('#SETTINGS_UPDATE_HISTORY').hide();
      var clientValuesForRepeatFrequencies = [I18NUtil.translate('ads.support.roboupdate.repeat.daily'),I18NUtil.translate('ads.support.roboupdate.repeat.weekly'),I18NUtil.translate('ads.support.roboupdate.repeat.monthly')];
      var serverValuesForRepeatFrequencies = ["Daily","Weekly","Monthly"];
      var dropDownValuesForRepeatFrequencies=CommonUtil.setDropDownValues(clientValuesForRepeatFrequencies,serverValuesForRepeatFrequencies);
      this.set('REPEAT_FREQUENCIES', dropDownValuesForRepeatFrequencies);//No I18N
      var clientValuesForDayOfWeek = [I18NUtil.translate('ads.support.roboupdate.day.sunday'),I18NUtil.translate('ads.support.roboupdate.day.monday'),I18NUtil.translate('ads.support.roboupdate.day.tuesday'),I18NUtil.translate('ads.support.roboupdate.day.wednesday'),I18NUtil.translate('ads.support.roboupdate.day.thursday'),I18NUtil.translate('ads.support.roboupdate.day.friday'),I18NUtil.translate('ads.support.roboupdate.day.saturday')];
      var serverValuesForDayOfWeek = ["1","2","3","4","5","6","7"];
      var dropDownValuesForDayOfWeek=CommonUtil.setDropDownValues(clientValuesForDayOfWeek,serverValuesForDayOfWeek);
      this.set('DAYS', dropDownValuesForDayOfWeek);//No I18N
      var months=["01","02","03","04","05","06","07","08","09","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25","26","27","28","29","30","31"];
      var dropDownValuesForMonths=CommonUtil.setDropDownValues(months,months);
      this.set('MONTHS', dropDownValuesForMonths);//No I18N
      var hours=["00","01","02","03","04","05","06","07","08","09","10","11","12","13","14","15","16","17","18","19","20","21","22","23"];
      var dropDownValuesForHours=CommonUtil.setDropDownValues(hours,hours);
      this.set('HOURS', dropDownValuesForHours);//No I18N
      var minutes=["00","05","10","15","20","25","30","35","40","45","50","55"];
      var dropDownValuesForMinutes=CommonUtil.setDropDownValues(minutes,minutes);
      this.set('MINUTES', dropDownValuesForMinutes);//No I18N
      this.send('getRoboUpdateSettings');
  }.on('init').observes('refresh'),
  actions: {
    showUpdateHistory:function(){
      var self=this;

      var timeFormat = "DD MMMM YYYY hh:mm A";
      var timeZone = "";
      var isTimeZone = false;
      if(self.get('dateFormat')!=null)
      {
        var timeFormat = self.get('dateFormat.TIME_FORMAT').replace(/d/g,'D').replace(/y/g,'Y').replace(/a/g,'A');
        var timeZone= self.get('dateFormat.TIME_ZONE');
        if(timeFormat.indexOf('z')>0)
        {
          isTimeZone=true;
        }
      }  
      if( $('#SETTINGS_UPDATE_HISTORY').is(":hidden"))
      {
        var responseData=AJAXUtil.syncAjax('/RestAPI/WC/RoboUpdateAction?mTCall=getUpdateHistory',{IS_EMBER:"true",IS_SELF:"true"},false,'json');
        var len =responseData.length;
        var updateHistory=[];
        for(var i=0;i<responseData.length-1;i++) {
          var updateTime =  moment(responseData[i].UPDATE_TIME).format(timeFormat);
          if(isTimeZone)
          {
            updateTime = updateTime + " " + timeZone;
          }
          responseData[i].UPDATE_TIME=updateTime;          
          updateHistory.push(responseData[i]);
        }
        self.set('UPDATE_HISTORY_DETAILS',updateHistory);
        self.set('UPDATE_HISTORY_DETAILS.IS_HISTORY',responseData[len-1]);
        $('#SETTINGS_UPDATE_HISTORY').show();
      }
      else
      {
        $('#SETTINGS_UPDATE_HISTORY').hide();
      }
    },
    ToggleCheckBox: function(val, key){
    },
    dummy:function(){
    },
    getRoboUpdateSettings:function()
    {
      var self=this;
      var roboUpdateDetails = AJAXUtil.syncAjax('/RestAPI/WC/RoboUpdateAction?mTCall=getRoboupdateDetails', {});
            self.set('updateSchedulerData',roboUpdateDetails.SCHEDULER_SETTINGS);
            self.set('updateCalendarData',roboUpdateDetails.CALENDAR_SETTINGS);
            self.set('mailconfig',roboUpdateDetails.MAIL_CONFIG);

            if(self.get('updateCalendarData.REPEAT_FREQUENCY')=='Weekly')
            {
              self.set('showDayOfWeek',true);
            }
            else
            {
              self.set('showDayOfWeek',false);  
            }

            if(self.get('updateCalendarData.REPEAT_FREQUENCY')=='Monthly')
            {
              self.set('showDateOfMonth',true);
            }
            else
            {
              self.set('showDateOfMonth',false);
            }

            self.send('setCheckBoxValue','#SETTINGS_ENABLE_UPDATE',this.get('updateSchedulerData.ENABLE_UPDATE'));
            self.send('setCheckBoxValue','#SETTINGS_AUTO_DOWNLOAD',this.get('updateSchedulerData.UPDATE_MY_SELF'));
            self.send('setCheckBoxValue','#SETTINGS_UPDATES_AVAILABLE',this.get('updateSchedulerData.NOTIFY_ADMIN'));
            self.send('setCheckBoxValue','#SETTINGS_NOTIFY_ME_AFTER_UPGRADE',this.get('updateSchedulerData.NOTIFY_AFTER_UPGRADE'));

            if(self.get('updateSchedulerData.ENABLE_UPDATE')=='true')
            {
                self.set('enbleRoboupdateCheck',true);
                self.set('disableEnableCheckBox',null);
                var autoDownload = $('#SETTINGS_AUTO_DOWNLOAD').is(':checked');
                if(autoDownload)
                {
                  self.set('disableEnableNotificationCheckBox',null);
                }
            }
            else
            {
                self.set('enbleRoboupdateCheck',false);
                self.set('disableEnableCheckBox','disabled');
                self.set('disableEnableNotificationCheckBox','disabled');
            }

            if((self.get('updateCalendarData.DAY_OF_WEEK')==-1)?self.set('updateCalendarData.DAY_OF_WEEK',"1"):"");
            if((self.get('updateCalendarData.DATE_OF_MONTH')==-1)?self.set('updateCalendarData.DATE_OF_MONTH',"01"):"");
            if((self.get('updateCalendarData.HOURS')==-1)?self.set('updateCalendarData.HOURS',"00"):"");
            if((self.get('updateCalendarData.MINUTES')==-1)?self.set('updateCalendarData.MINUTES',"00"):"");
      },
      setCheckBoxValue:function(enableSetting,status)
      {
        if(status=='true')
        {
          $(enableSetting).parent('div').addClass('checked');
        }
        else
        {
          $(enableSetting).parent('div').removeClass('checked');  
        }
        $(enableSetting).prop('checked',(status=='true'));
      },
      repeatFrequencyChanged:function(text,value)
      {
        var self=this;
        if(value=='Weekly')
        {
          self.set('showDayOfWeek',true);
          self.set('showDateOfMonth',false);
        }
        else if(value=='Monthly')
        {
          self.set('showDateOfMonth',true);
          self.set('showDayOfWeek',false);
        }
        else
        {
          self.set('showDateOfMonth',false);
          self.set('showDayOfWeek',false);
        }
        CommonUtil.afterRender();
     },
     saveUpdateSettings:function(){
        var self=this;
        var params={};
        var selectedProductListArray = this.get('updateSchedulerData.CONFIGURED_PRODUCTS');
        for(var i=0;i<selectedProductListArray.length;i++)
        {
          params[selectedProductListArray[i].tagName]=selectedProductListArray[i].productsConfigured;
        }
        var repeatFrequency= $('#SETTINGS_REPEAT_FREQUENCY').val();
        var dayOfWeek = $('#SETTINGS_DAY_OF_WEEK').val();
        if(typeof dayOfWeek === 'undefined')
        {
          dayOfWeek="-1";
        }
        var dateOfMonth= $('#SETTINGS_DATE_OF_MONTH').val();
        if(typeof dateOfMonth === 'undefined')
        {
          dateOfMonth="-1";
        }
        var hours= $('#SETTINGS_HOUR').val();
        var minutes= $('#SETTINGS_MINUTE').val();
        var enableUpdate=$('#SETTINGS_ENABLE_UPDATE').is(':checked');
        var autoDownload =  $('#SETTINGS_AUTO_DOWNLOAD').is(':checked');
        var updateAvailable =  !$('#SETTINGS_UPDATES_AVAILABLE').is(':disabled') ? $('#SETTINGS_UPDATES_AVAILABLE').is(':checked') : self.get('updateSchedulerData.NOTIFY_ADMIN');
        var notifyAfterUpgrade =  !$('#SETTINGS_NOTIFY_ME_AFTER_UPGRADE').is(':disabled') ? $('#SETTINGS_NOTIFY_ME_AFTER_UPGRADE').is(':checked') : self.get('updateSchedulerData.NOTIFY_AFTER_UPGRADE');
      
        if(enableUpdate)
        {
          enableUpdate='true';
        }
        else
        {
          enableUpdate='false';
        }
        if(enableUpdate=='true' && !self.get('mailconfig') && (updateAvailable || notifyAfterUpgrade))
        {
          self.sendAction('showStatus','warning', I18NUtil.translate('ads.support.roboupdate.configure_mail'),'autoUpdate');
          self.send('getRoboUpdateSettings');
          return;
        }
        else
        {
          params['REPEAT_FREQUENCY']=repeatFrequency;
          params['DATE_OF_MONTH']=dateOfMonth;
          params['DAY_OF_WEEK']=dayOfWeek;
          params['HOURS']=hours;
          params['MINUTES']=minutes;
          params['ENABLE_UPDATE']=enableUpdate;
          params['UPDATE_MY_SELF']=autoDownload;
          params['NOTIFY_ADMIN']=updateAvailable;
          params['NOTIFY_AFTER_UPGRADE']=notifyAfterUpgrade;
          params['IS_EMBER']=true;
          var roboUpdateDetails = AJAXUtil.syncAjax('/RestAPI/WC/RoboUpdateAction?mTCall=saveSchedulerSettings',params);
          var failureReason = [];
          var isSuccess = true;
          var reason = null;
          var message = I18NUtil.translate('ads.admin.personalize.message.success');
          if(roboUpdateDetails.hasOwnProperty('eSTATUS'))
          {
            self.sendAction('showStatus','danger',I18NUtil.translate('ads.common.error.demo_mode'),'autoUpdate');
          }
          else
          {
            if (roboUpdateDetails === 'Failure') 
            {
              isSuccess = false;
            } 
            if (isSuccess) 
            {
              self.sendAction('showStatus','success',message,'autoUpdate');
              self.set('updateSchedulerData.NOTIFY_ADMIN',updateAvailable);
              self.set('updateSchedulerData.NOTIFY_AFTER_UPGRADE',notifyAfterUpgrade);
            }
            else
            {
              self.sendAction('showStatus','danger',roboUpdateDetails.EXCEPTION,'autoUpdate');
            }
            self.sendAction('refreshRoboUpdate');
          }
         
        }
    },
    enableDisableNotification:function(val)
    {
      if(val)
      {
        this.set('disableEnableNotificationCheckBox',null);
      }
      else
      {
        this.set('disableEnableNotificationCheckBox','disabled');
      }
    },
    toggleUpdateSettings:function(val)
    {
      if(val)
      {
        this.set('enbleRoboupdateCheck',true);
        this.set('disableEnableCheckBox',null);
        var autoDownload = $('#SETTINGS_AUTO_DOWNLOAD').is(':checked');
        if(autoDownload)
        {
          this.set('disableEnableNotificationCheckBox',null);
        }
      }
      else
      {
        this.set('enbleRoboupdateCheck',false);
        this.set('disableEnableCheckBox','disabled');
        $('.bootstrap-select').each(function(){
          $(this).removeClass('open');
        })
        this.set('disableEnableNotificationCheckBox','disabled');
      }
    },
  },
});

//ignorei18n_end