/*
 * $Id$
 */

//ignorei18n_start
import Ember from 'ember'; //NO I18N
import AJAXUtil from '../utils/ads-ajax-util'; //NO I18N
import I18NUtil from "../utils/i18n-util"; //NO I18N
import DialogUtil from "../utils/ads-dialog-util"; //NO I18N
import ValidationUtil from "../utils/ads-validation-util"; //NO I18N
export default Ember.Component.extend({
    
    pageStatus: {},
    isBlockUserEnabled:true,
    currentConfig:{},
    defaultConfig:{},
    
    didInsertElement: function() {
    this.set('blockUserProp', this);
    },
    getSettings: function(){
        var response = null;
        if(this.hasOwnProperty('blockUserData'))
        {
            response = this.get('blockUserData');
        }
        else
        {
            CommonUtil.showLoading(); 
            response = AJAXUtil.syncAjax('/RestAPI/WC/AuthConfig?mTCall=getBlockUserSettings',{});
            CommonUtil.hideLoading();
        }
        this.set('isBlockUserEnabled',response.IS_ENABLED);
        this.set('currentConfig.MAX_ATTEMPTS',response.MAX_ATTEMPTS);
        this.set('currentConfig.RESET_TIME',response.RESET_TIME);
        this.set('currentConfig.BLOCKING_DURATION',response.BLOCKING_DURATION);
        
        this.set('defaultConfig.MAX_ATTEMPTS',response.MAX_ATTEMPTS);
        this.set('defaultConfig.RESET_TIME',response.RESET_TIME);
        this.set('defaultConfig.BLOCKING_DURATION',response.BLOCKING_DURATION);
    }.observes('blockUserData').on('init'),
    validateBlockUserInputs:function(){
        if(this.get('isBlockUserEnabled'))
        {
            if (this.get('currentConfig.MAX_ATTEMPTS')===undefined || this.get('currentConfig.MAX_ATTEMPTS')==='' || !ValidationUtil.isValidNumber(String(this.get('currentConfig.MAX_ATTEMPTS'))) || this.get('currentConfig.MAX_ATTEMPTS')<1)
            {
                DialogUtil.alert(this, I18NUtil.translate('ads.admin.logonsettings.blockuser.invalid_maxattempts')); //No I18N
                return 'failed';
            }
            else if(this.get('currentConfig.RESET_TIME')===undefined || this.get('currentConfig.RESET_TIME')==='' || !ValidationUtil.isValidNumber(String(this.get('currentConfig.RESET_TIME'))) || this.get('currentConfig.RESET_TIME')<1)
            {
                DialogUtil.alert(this, I18NUtil.translate('ads.admin.logonsettings.blockuser.invalid_resettime')); //No I18N
                return 'failed';
            }
            else if(this.get('currentConfig.BLOCKING_DURATION')===undefined || this.get('currentConfig.BLOCKING_DURATION')==='' || !ValidationUtil.isValidNumber(String(this.get('currentConfig.BLOCKING_DURATION'))) || this.get('currentConfig.BLOCKING_DURATION')<1)
            {
                DialogUtil.alert(this, I18NUtil.translate('ads.admin.logonsettings.blockuser.invalid_blocking_duration')); //No I18N
                return 'failed';
	        }
			else if(parseInt(this.get('currentConfig.BLOCKING_DURATION')) < parseInt(this.get('currentConfig.RESET_TIME')))
            {
                DialogUtil.alert(this, I18NUtil.translate('ads.admin.logonsettings.blockuser.invalid_configuration')); //No I18N
                return 'failed';
            }
        }
        return 'success';
    },
    actions:{
        blockToggle:function(val){
            var self = this;
            this.set('isBlockUserEnabled',val);
        },
        saveSettings:function(defer){
            var self = this;
            var status = 'success';
            var params = null;
            status = this.validateBlockUserInputs();
            if(status=='success')
            {
                if(this.get('isBlockUserEnabled'))
                {
                   params={
                       IS_ENABLED:true,
                       MAX_ATTEMPTS:this.get('currentConfig.MAX_ATTEMPTS'),
                       RESET_TIME:this.get('currentConfig.RESET_TIME'),
                       BLOCKING_DURATION:this.get('currentConfig.BLOCKING_DURATION')
                   }; 
                }
                else
                {
                    params={
                       IS_ENABLED:false,
                       MAX_ATTEMPTS:this.get('defaultConfig.MAX_ATTEMPTS'),
                       RESET_TIME:this.get('defaultConfig.RESET_TIME'),
                       BLOCKING_DURATION:this.get('defaultConfig.BLOCKING_DURATION')
                   }; 
                }
            }
            AJAXUtil.ajax('/RestAPI/WC/AuthConfig?mTCall=updateBlockUserSettings', { blockUserDetails : JSON.stringify(params)}).then(function(responseData){
              var response = (responseData != null && responseData != "") ? responseData : null;
                if(response != null)
                {
                  if(response.sSTATUS.trim() == "")
                  {
                    status='failed';
                    self.sendAction('showStatus','danger',I18NUtil.translate('ads.admin.logonsettings.message.failure'),true);
                  }
                  else
                  {
                    self.sendAction('showStatus','success',I18NUtil.translate(response.sSTATUS),true);
                    self.set("defaultConfig.MAX_ATTEMPTS",self.get("currentConfig.MAX_ATTEMPTS"));
                    self.set("defaultConfig.RESET_TIME",self.get("currentConfig.RESET_TIME"));
                    self.set("defaultConfig.BLOCKING_DURATION",self.get("currentConfig.BLOCKING_DURATION"));
                  }
                }
              });
            if(status=='success' && defer!=null)
            {
                defer.resolve();
            }
            else if(defer!=null)
            {
                defer.reject();
            }
        },
        cancelSettings:function(){
            this.getSettings();
        }
    }
    
});