/*
 * $Id$
 */

//ignorei18n_start
import Ember from 'ember'; //NO I18N
import AJAXUtil from '../utils/ads-ajax-util'; //NO I18N
import I18NUtil from "../utils/i18n-util"; //NO I18N
import DialogUtil from "../utils/ads-dialog-util"; //NO I18N
import CommonUtil from "../utils/ads-common-util"; //NO I18N
import ValidationUtil from "../utils/ads-validation-util"; //NO I18N
export default Ember.Component.extend({
    pageStatus: {},
    TIME_TO_RESET: null,
    isEnabled:false,
    isAudioEnabled:false,
    selectedConfig:null,
    defaultLimit:null,
    defaultResetTime:null,
    saveComp:{},
    currentConfig:{},
    didInsertElement: function() {
    this.set('captchaProp', this);
    },
    getSettings:function(){
        var response = null;
        if(this.hasOwnProperty('captchaData'))
        {
            response = this.get('captchaData');
        }
        else
        {
            CommonUtil.showLoading(); 
            response = AJAXUtil.syncAjax('/RestAPI/WC/CaptchaConfig?mTCall=getCaptchaSettings',{});
            CommonUtil.hideLoading();     
        }
        var showLoginCaptcha = JSON.parse(response['SHOW_LOGIN_CAPTCHA']);
        var showAudioCaptcha = JSON.parse(response['IS_AUDIO_CAPTCHA_ENABLED']);
        this.set('isEnabled',showLoginCaptcha.PARAM_VALUE=='true');
        this.set('isAudioEnabled',showAudioCaptcha.PARAM_VALUE=='true');
        this.set('defaultLimit',response['MAX_INVALID_LOGIN'].toString())
        this.set('defaultResetTime',response['TIME_TO_RESET'].toString())
      if(!response['IS_ENABLED'])
      { 
          this.set('currentConfig.SELECTED_CONFIG','ALWAYS');
          this.set('currentConfig.LOGIN_COUNTER',true);
      }
      else
      {
          this.set('currentConfig.SELECTED_CONFIG','CONFIG');
          this.set('currentConfig.LOGIN_COUNTER',false);
      }
          this.set('currentConfig.CAPTCHA_LIMIT',response['MAX_INVALID_LOGIN'].toString());
          this.set('currentConfig.CAPTCHA_RESET',response['TIME_TO_RESET'].toString());
    }.observes('captchaData').on('init'),
    validateCaptchaConfig:function(){
        if(this.get('currentConfig.SELECTED_CONFIG')=='CONFIG' && this.get('isEnabled',true))
        {
            if (this.get('currentConfig.CAPTCHA_LIMIT')===undefined || this.get('currentConfig.CAPTCHA_LIMIT')==='' || !ValidationUtil.isValidNumber(this.get('currentConfig.CAPTCHA_LIMIT')) || this.get('currentConfig.CAPTCHA_LIMIT')<1)
            {
                DialogUtil.alert(this, I18NUtil.translate('ads.admin.logonsettings.message.invalid_logonlimit')); //No I18N
                return 'failed';
            }

            if (this.get('currentConfig.CAPTCHA_RESET')===undefined || this.get('currentConfig.CAPTCHA_RESET')==='' || !ValidationUtil.isValidNumber(this.get('currentConfig.CAPTCHA_RESET')) || this.get('currentConfig.CAPTCHA_RESET')<1)
            {
                DialogUtil.alert(this, I18NUtil.translate('ads.admin.logonsettings.message.invalid_resetlimit')); //No I18N
                return 'failed';
            }
        }
        return 'success';
    },
    actions:{
        captchaToggle:function(val){
            var self = this;
            this.set('isEnabled',val);
        },
        audioCaptchaToggle:function(val){
            var self = this;
            this.set('isAudioEnabled',val);
        },
        toggleCaptchaConfig:function(params)
        {
            var selectedConfig = JSON.parse(params).columnValue;
            if(selectedConfig=='CONFIG')    
                {
                    this.$(".captcha-limit").eq(0).prop("disabled",false);
                    this.$(".captcha-reset").eq(0).prop("disabled",false);
                    this.set('currentConfig.LOGIN_COUNTER',false);
                }
            else
                {
                    this.$(".captcha-limit").eq(0).prop("disabled",true);
                    this.$(".captcha-reset").eq(0).prop("disabled",true);
                    this.set('currentConfig.LOGIN_COUNTER',true);
                }  
            this.set('currentConfig.SELECTED_CONFIG', selectedConfig);//No I18N
        },
        saveSettings:function(defer)
        {
            var self = this;
            var status = 'success';
            var params = null;
            if (this.get('currentConfig.SELECTED_CONFIG')=='CONFIG' && this.get('isEnabled',true))
            {
                status = this.validateCaptchaConfig();
            }
            else
            {
                self.set("currentConfig.CAPTCHA_LIMIT",self.get("defaultLimit"));
                self.set("currentConfig.CAPTCHA_RESET",self.get("defaultResetTime"));
                status='success';
            }
            if (status == 'success') {
              
               params = {
                  IS_COUNTER_ENABLED : !self.get("currentConfig.LOGIN_COUNTER"),
                  CAPTCHA_PARAMS : {
                    SHOW_LOGIN_CAPTCHA : self.get("isEnabled"),
                    IS_AUDIO_CAPTCHA_ENABLED : self.get("isAudioEnabled")
                  },
                  CAPTCHA_LIMIT : self.get("currentConfig.CAPTCHA_LIMIT"),
                  CAPTCHA_RESET : self.get("currentConfig.CAPTCHA_RESET")
                };  
                  
              CommonUtil.showLoading(); 
              AJAXUtil.ajax('/RestAPI/WC/CaptchaConfig?mTCall=updateCaptchaSettings', { captchaDetails : JSON.stringify(params) }).then(function(responseData){
              CommonUtil.hideLoading();
              var response = (responseData != null && responseData != "") ? responseData : null;
                if(response != null)
                {
                  if(response.sSTATUS.trim() == "")
                  {
                    self.sendAction('showStatus','danger',I18NUtil.translate('ads.admin.logonsettings.message.failure'),true);
                    status='failed';
                  }
                  else
                  {
                    self.sendAction('showStatus','success',I18NUtil.translate(response.sSTATUS),true);
                    self.set("defaultLimit",self.get("currentConfig.CAPTCHA_LIMIT"));
                    self.set("defaultResetTime",self.get("currentConfig.CAPTCHA_RESET"));
                  }
                }
                else{status='failed';}
              });
            }
            if(status=='success' && defer!=null)
            {
                defer.resolve();
            }
            else if(defer!=null)
            {
                defer.reject();
            }
        },
        cancelSettings:function()
        {
            this.getSettings();
        }
    }
});