/*
 * $Id$
 */

//ignorei18n_start

import Ember from 'ember';

export default Ember.Component.extend({
    initialize: function() {
        Ember.run.schedule('afterRender', this, function() {
            var data = this.getAttr('data');
            if(data.constructor === Array)
            {
                for(var i = 0; i < data.length; i++)
                {
                    constructGraph(this, data[i]);
                }
            }
            else
            {
                constructGraph(this, data);
            }
        });

        function constructGraph(th, data)
        {
            var elem = th.get('element');
            //In order to use same height for adjacent components - container height will be considered
            if(data.USE_OFFSET_HEIGHT && data.HEIGHT!=null)
            {
                data.chart.height=data.HEIGHT;
            }
            if(data.plotOptions!=null && data.plotOptions.pie!=null)
            {
                var plotOptions=data.plotOptions;
                var pie=plotOptions.pie;
                var dataLabels=pie.dataLabels;
                dataLabels.format=null;
                var formatter=eval("("+dataLabels.formatter+")");
                if(formatter!=undefined)
                {
                    dataLabels.formatter=formatter;
                }
            }

            if(data.tooltip!=null && data.tooltip.pointFormatter!=null)
            {
                var tooltip=data.tooltip;
                var pointFormatter=eval("("+tooltip.pointFormatter+")");
                tooltip.pointFormatter=pointFormatter;
            }

            if(data.hasOwnProperty("COMPONENT_STYLE"))
            {
                var chartDiv = document.createElement('div');
                Ember.$(chartDiv).css(data.COMPONENT_STYLE);
                Ember.$(elem).append(chartDiv);
                Ember.$(chartDiv).highcharts(data);
                if(data.hasOwnProperty('HTMLData'))
                {
                    Ember.$(chartDiv).append(data.HTMLData);
                }
            }
            else
            {
                Ember.$(elem).highcharts(data);
                if(data.hasOwnProperty('HTMLData'))
                {
                    Ember.$(elem).append(data.HTMLData);
                }
            }
        }
    }.on('init').observes('data')
});

//ignorei18n_end