/*
 $Id$
*/
/*
	Sample Usage :
	{{check-box actionName='checkAllClicked' className='tableMasterCheckbox'}}
	{{check-box actionName='checkboxClicked' params=tableRowItem selectedList=selectedList className='tableRowCheckbox'}}
	{{check-box actionName='advConfigToggle' checked=isAdvConfig}}
	{{check-box checkBoxStyle='toggle' actionName='advConfigToggle' checked=isAdvConfig}}
*/

export default Ember.Component.extend({
    tagName: 'input', //NO I18N
    attributeBindings: ['type', 'disabled', 'name'], //NO I18N
    classNameBindings: ['className'],
    type: 'checkbox', //NO I18N
    selectedList: Ember.A(),
    params: {},
    didInsertElement: function() {
        var thisComp = this;
        var thisEle = this.get('element'); //NO I18N
        var checkBoxStyle = this.get('checkBoxStyle'); //NO I18N
        if (checkBoxStyle == 'toggle') {
            Ember.$(thisEle).bootstrapToggle({
                size: 'mini', //NO I18N
                style: 'ios', //NO I18N
                width: 35,
                height: 19
            });
            if (thisComp.get('checked')) {
                Ember.$(thisEle).bootstrapToggle('on');
                thisComp.sendAction(thisComp.get('actionName'), true, thisComp.get('params'), thisComp.get('parent')); //NO I18N
            } else {
                Ember.$(thisEle).bootstrapToggle('off');
                thisComp.sendAction(thisComp.get('actionName'), false, thisComp.get('params'), thisComp.get('parent')); //NO I18N
            }
            if (thisComp.get('actionName')) {
                thisComp.set(thisComp.get('actionName'), thisComp.get('actionName')); //NO I18N
                Ember.$(thisEle).on('change', function() {
                    var isChecked = Ember.$(thisEle).prop('checked');
                    var prevChecked = thisComp.get('checked'); //NO I18N
                    if (isChecked != prevChecked) {
                        thisComp.set('checked', isChecked); //NO I18N
                    }
                });
            } else {
                Ember.$(thisEle).on('change', function() {
                    var isChecked = Ember.$(thisEle).prop('checked');
                    var prevChecked = thisComp.get('checked'); //NO I18N
                    if (isChecked != prevChecked) {
                        thisComp.set('checked', isChecked); //NO I18N
                    }
                });
            }
        } else {
            thisComp.set(thisComp.get('actionName'), thisComp.get('actionName')); //NO I18N
            Ember.$(thisEle).iCheck({
                checkboxClass: 'chkbox icheckbox_minimal', //NO I18N
                radioClass: 'chkbox icheckbox_minimal', //For IE8 Support //NO I18N
                increaseArea: '20%'
            });
            Ember.$(thisEle).on('ifChecked', function() {
                thisComp.sendAction(thisComp.get('actionName'), true, thisComp.get('params'), thisComp.get('parent')); //NO I18N
            });
            Ember.$(thisEle).on('ifUnchecked', function() {
                thisComp.sendAction(thisComp.get('actionName'), false, thisComp.get('params'), thisComp.get('parent')); //NO I18N
            });
            if (this.get('selectedList') && this.get('selectedList').contains(thisComp.get('params.columnValue'))) { //NO I18N
                Ember.$(thisEle).iCheck('check');
            }
            if (this.get('checked') == 'true' || this.get('checked') == true) {
                Ember.$(thisEle).iCheck('check');
            }
            if (this.get('cssChecked')== true) {
                Ember.$(thisEle).prop('checked', 'checked');
                Ember.$(thisEle).iCheck('update');
            }
            else if(this.get('cssChecked')=='indeterminate')
            {
                Ember.$(thisEle).iCheck('indeterminate');
            }
        }
    },
    willDestroyElement: function(){
        Ember.$(this.get('element')).iCheck('destroy');//No i18n
        Ember.$(this.get('element')).off('ifChecked');//No i18n
        Ember.$(this.get('element')).off('ifUnchecked change');//No i18n
    },
    checkedChanged: function() {
        var self = this;
        var thisEle = self.get('element'); //NO I18N
        var checkBoxStyle = self.get('checkBoxStyle'); //NO I18N
        if (checkBoxStyle == 'toggle') {
            if (self.get('checked')) {
                Ember.$(thisEle).bootstrapToggle('on');
                self.sendAction(self.get('actionName'), true, self.get('params'), self.get('parent')); //NO I18N
            } else {
                Ember.$(thisEle).bootstrapToggle('off');
                self.sendAction(self.get('actionName'), false, self.get('params'), self.get('parent')); //NO I18N
            }
        } else {
            if ((this.get('checked') === true || this.get('checked') === 'true') && !Ember.$(thisEle).parent().hasClass('checked')) { //NO I18N
                Ember.$(thisEle).iCheck('check');
            } else if ((this.get('checked') === false || this.get('checked') === 'false') && Ember.$(thisEle).parent().hasClass('checked')) { //NO I18N
                Ember.$(thisEle).iCheck('uncheck');
            }
        }
    }.observes('checked'), //NO I18N
    cssCheckedChanged: function() {
        var thisEle = this.get('element'); //NO I18N
        if (this.get('cssChecked')== true) {
            Ember.$(thisEle).prop('checked', 'checked');
            Ember.$(thisEle).iCheck('update');
        }
        else if(this.get('cssChecked')=='indeterminate')
        {
            Ember.$(thisEle).iCheck('indeterminate');
        }
        else {
            Ember.$(thisEle).removeProp('checked');
            Ember.$(thisEle).iCheck('update');
        }
    }.observes('cssChecked'), //NO I18N
    disabledChanged: function() {
        if (this.get('disabled')) {
            Ember.$(this.get('element')).iCheck('disable'); //NO I18N
        } else {
            Ember.$(this.get('element')).iCheck('enable'); //NO I18N
        }
    }.observes('disabled') //NO I18N
});
