/*
 * $Id: custom-select.js,v 1.3 2017/12/13 06:02:26 navin.rathinasamy Exp $
 */
//ignorei18n_start
import Ember from 'ember'; //NO I18N
import I18NUtil from "webclient/utils/i18n-util"; //NO I18N
export default Ember.Component.extend({
  newAttributeValue: '',
  status: 'disabled',
  id: 'customSelect',
  dataHeight: '70px',
  emptySearch:false,
  selectedValue: I18NUtil.translate('ads.common.text.selected_none'),
  addNewAttrPlaceHolder: I18NUtil.translate('ads.common.text.add_new_attribute'),
  initialize: function() {
    if (this.get('isEnabled') === undefined) {
      this.set('isEnabled', true);
    }
	if(this.get('placeHolderText')!= undefined && this.get('placeHolderText')!='')
	{
		this.set('addNewAttrPlaceHolder',this.get('placeHolderText'));
	}
    this.enableDisable();
    this.itemsListChange();
  }.on('init'),
  itemsListChange: function() {
    Ember.run.schedule('afterRender', this, function() {
      var itemsList = this.get('itemsList');
      var selectedValue = this.get('selectedValue');
      if(Ember.$.inArray(selectedValue,itemsList)!=-1){
            $('#selected').removeClass('opacity-5');
           }
      if (selectedValue == '' || selectedValue == undefined) {
        this.set('selectedValue', itemsList[0]);
      }
    });
  }.observes('selectedValue'),
  enableDisable: function() {
    var isEnabled = this.get('isEnabled');
    if (isEnabled == true) {
      this.set('status', '')
    } else {
      this.set('status', 'disabled')
    }
  }.observes('isEnabled'),
  didInsertElement: function() {
    var id = this.get('id');
    this.$('#' + id + '_searchText').on("click", function(e) {
      e.stopPropagation();
    });
    this.$('#' + id + '_addText').on("click", function(e) {
      e.stopPropagation();
    });
    this.$('#' + id).find('.dropdown-toggle').on("click", function(e) {
      $('#' + id + '_searchText').val('');
      var listItems = $('#' + id).find("#dropDown li");
      $('#' + id).find('.active').removeClass('active');
      listItems.each(function(index) {
        $(this).css('display', 'block');
      });
    });

    this.$('#' + id).find(".bs-attribute .btn").on("click", function() {
      var par = $(this).closest('div.bs-attribute');
      var val = $(".form-control", par).val();
      if (val.length == 0) {
        return false;
      }
    });
  },
  keyUp: function(event) {
    var self = this;
    self.searchData(event.keyCode);
    event.stopPropagation();
  },
  keyDown: function(event) {
    event.stopPropagation();
  },
  searchData: function(keyCode) {
   var self=this;
    var id = this.get('id');
	if(keyCode!=undefined){
			if (keyCode === 40) {
				var elementX=$('#' + id).find('.active');
				if($('#' + id).find('.active').nextAll('.show:first').length!=0){
				$('#' + id).find('.active').nextAll('.show:first').addClass('active');
				elementX.removeClass('active');
				return false;
				}
			} else if (keyCode === 38) {
				var elementX=$('#' + id).find('.active');
				if($('#' + id).find('.active').prevAll('.show:first').length!=0){
				$('#' + id).find('.active').prevAll('.show:first').addClass('active');
				elementX.removeClass('active');
				return false;
				}
			}
			else if (keyCode === 13) {
			var value=$('#' + id).find('.active').text().trim();
			if(value != '')
			{
			  self.set('selectedValue',value);
			}
			return false;
			}
          }
    this.$('#' + id).find('.active').removeClass('active');
    var input = this.$('#' + id + '_searchText').val().toLowerCase();
    if (input == '') {
      //this.$('#' + id).find('.active').removeClass('active');
      var listItems = this.$('#' + id).find("#dropDown li");
      listItems.each(function(index) {
        $(this).css('display', 'block');
		self.set('emptySearch',false);
      });
    } else {
      var listItems = this.$('#' + id).find("#dropDown li");
      var isFirst = false;
	   var count=0;
      listItems.each(function(index) {
        var $this = this;
		if($(this).attr('id')=='emptyId'){
			return true;
		}
        var text = $("span", $this).text().toLowerCase();
        if (text.indexOf(input) == -1) {
		count++;
          $(this).css('display', 'none');
		  $(this).removeClass('show');
        } else {
          $(this).css('display', 'block');
		  $(this).addClass('show');
          if (!isFirst) {
            $('#' + id).find('.active').removeClass('active');
            $(this).addClass('active');
            isFirst = true;
          }
        }
      });
	   if((!this.get('emptySearch')&&count==listItems.length)||(this.get('emptySearch')&&count==listItems.length-1))
	  {
		  this.set('emptySearch',true);
    }
	 else{ this.set('emptySearch',false);}
    }
  },
  optionChange: function() {
  $('#selected').removeClass('opacity-5');
    var id = this.get('id');
    if ($('#' + id + '_searchText').val() != undefined) {
      $('#' + id + '_searchText').val('');
      this.searchData();
    }
  }.observes('selectedValue'),
  actions: {
    optionSelected: function(selectedValue) {
      this.set('selectedValue', selectedValue);
	   $('#selected').removeClass('opacity-5');
	  if(this.get('changeAction')!= undefined && this.get('changeAction')!='')
	  {
		  this.sendAction('changeAction',selectedValue);
	  }
    },
    addNewAttribute: function(event) {
      var id = this.get('id');
      var value = this.$('#' + id + '_addText').val();
	   this.$('#' + id + '_addText').val("");
	   let maxLength = this.get('maxLength');
	    if (value.length > 0 && Ember.$.trim(value) !='' && (maxLength != null && value.length <= maxLength)) {
        var itemsList = this.get('itemsList');
		var val=value.toLowerCase();
		var index=-1;
		itemsList.some(function(obj, i) {
			console.log(obj.toLowerCase());
			if (val == obj.toLowerCase()) {
				index = i;
			return true;
			}
		});
		if(index>-1){
		this.set('selectedValue', itemsList[index]);}
		else{        
          var newItemsList = [value];
          this.set('itemsList', newItemsList.concat(itemsList));
		  this.set('selectedValue', value);
        }
      }
    if(this.get('changeAction')!= undefined && this.get('changeAction')!='')
    {
      this.sendAction('changeAction',value);
    }
    },

    onOpen() {
      if(this.get('emptySearch'))
      {
        this.set('emptySearch', false);
      }
    }
  }
});
//ignorei18n_end
