/*
 * $Id$
 */
//ignorei18n_start
import Ember from 'ember';
import I18NUtil from '../../utils/i18n-util'; //NO I18N
import AJAXUtil from '../../utils/ajax-util'; //NO I18N
export default Ember.Component.extend({
	closeAddQLPopup:'closeAddQLPopup',
	setRHSData:'setRHSData',
	tempQLlist:[],
	qlIdVsName:{},
	getQuickLinksList:function(){
    var params={};
    var responseData = AJAXUtil.syncAjax(this.get('contextPath')+'/ADSLayoutCustomization.do?mTCall=getQuickLinksList',{params: JSON.stringify(params)});
    var qLTabs = responseData['TABS'];
    if(qLTabs==undefined || qLTabs[0]==undefined){
			this.set('errorMessage',I18NUtil.translate('ads.home.layout.dashboard.no_ql_available'));
			return ;
		}
		this.set('qLTabs',qLTabs);
		if(this.get('qLContainerData')!=undefined){
			var qLContainerData =this.get('qLContainerData');
			var qLs = qLContainerData.CONTAINER_DATA.DATA;
			var newQLList = [];
			var qlIdVsName = this.get('qlIdVsName');
			var tempQLlist = this.get('tempQLlist');
			for(var k=0;k<qLs.length;k++){
				var ql = qLs[k];
				var qlID = ql.UNIQUE_ID.toString();
				Ember.set(qlIdVsName,qlID,ql.DISPLAY_NAME);
				tempQLlist.push(qlID);
				newQLList.push({UNIQUE_ID:qlID,DISPLAY_NAME:ql.DISPLAY_NAME});
			}
			this.set('newQLList',newQLList);
			this.send('addCustomScroll');
			Ember.run.schedule('afterRender', function(){
				$('#ads_ql_widget_name').val(qLContainerData.NAME);
				Ember.$('#ads_ql_widget_name').focus();
			});
		}
		else{
			Ember.run.schedule('afterRender', function(){Ember.$('#ads_ql_widget_name').focus();});
		}
  }.on('init'),
	actions:{
		closeAddQLPopup:function(){
			var tempQLlist = this.get('tempQLlist');
			for(var i=0;i<tempQLlist.length;i++){
				tempQLlist.removeAt(i--);
			}
			this.sendAction('closeAddQLPopup');
		},
		addQLWidget:function(){
			var widgetName = $('#ads_ql_widget_name').val().trim();
		  if(widgetName==''){
				this.send('backToAddQLWidget');
				this.set('errorMessage',I18NUtil.translate('ads.home.layout.dashboard.tab_error'));
				return;
			}
			else if(widgetName.length>250){
				this.send('backToAddQLWidget');
				this.set('errorMessage',I18NUtil.translate('ads.home.layout.dashboard.widget_name_length_error'));
				return;
			}
      let tempQLlist= this.get('tempQLlist');
      if(!tempQLlist.length){
				return this.set('errorMessage',I18NUtil.translate('ads.home.layout.dashboard.select_at_least_one_quicklink'));
			}
			else if(tempQLlist.length>10){
				this.send('backToAddQLWidget');
				return this.set('errorMessage',I18NUtil.translate('ads.home.layout.dashboard.can_not_select_more_than_10_quicklinks'));
			}
			var self = this;
			var params={};
			if(this.get('qLContainerData')!=undefined){
				params['CONTAINER_ID'] = this.get('qLContainerData').CONTAINER_ID;
				params['IS_UPDATE']=true;
			}
			else{
				params['IS_ADD']=true;
			}
			params['WIDGET_NAME']=widgetName;
			params['QUICK_LINK_IDS']=tempQLlist;
			params['USER_ID']=self.get('layoutParams.userId');
			AJAXUtil.ajax('/ADSLayoutCustomization.do?mTCall=addOrUpdateQuickLinksComponent', {params:JSON.stringify(params)}).then(function(result){
				if(result.hasOwnProperty('sSTATUS')){
					self.sendAction('setRHSData',result.RHSDATA);
				}
			});
			this.send('closeAddQLPopup');
    },
		showQLdiv:function(){
			var qLTabs = this.get('qLTabs');
			if(qLTabs==undefined || qLTabs[0]==undefined){
				this.set('errorMessage',I18NUtil.translate('ads.home.layout.dashboard.no_ql_available'));
				return;
			}
      this.send('selectQLCategory',0,0);
      Ember.$('#ads_add_ql_general_div').hide();
      Ember.$('#ads_add_ql_links_div').show();
      Ember.$('#ads_add_ql_links_back_div').show();
	  	Ember.$('#ads_select_ql_popup').addClass('fwdash-popup-ql-expanded');
    },
		selectQLCategory:function(tabIndex, categIndex){
      this.set('selectedQLTabIndex',tabIndex);
      this.set('qLCategories',this.get('qLTabs')[tabIndex]['CATEGORIES']);
      this.set('selectedQLCategIndex',categIndex);
      let qLsDivided = [];
      let qLs = this.get('qLCategories')[categIndex]['QUICK_LINKS'];
      let len = qLs.length;
      if(len>0){
        let reminder = len%3;
        let eachLen = Math.floor(len/3);
        let eI1= reminder>0?eachLen+1:eachLen;
        let eI2= reminder>1?eI1+eachLen+1:eI1+eachLen;
        qLsDivided.push(qLs.slice(0,eI1));
        qLsDivided.push(qLs.slice(eI1,eI2));
        qLsDivided.push(qLs.slice(eI2));
      }
      this.set('qLsDivided',qLsDivided);
    },
		backToAddQLWidget:function(){
			Ember.$('#ads_add_ql_links_div').hide();
      Ember.$('#ads_add_ql_links_back_div').hide();
      Ember.$('#ads_add_ql_general_div').show();
	  	Ember.$('#ads_select_ql_popup').removeClass('fwdash-popup-ql-expanded');
      let newQLList = [];
      let tempQLlist= this.get('tempQLlist');
      let qlIdVsName = this.get('qlIdVsName');
      for(var i=0;i<tempQLlist.length;i++){
        let id = tempQLlist[i];
        newQLList.push({UNIQUE_ID:id,DISPLAY_NAME:qlIdVsName[id]});
      }
      this.set('newQLList',newQLList);
			this.send('addCustomScroll');
		},
		modifyQLSelList:function(value){
			let tempQLlist= this.get('tempQLlist');
      let checked = Ember.$('#cb_ql_'+value).is(':checked');
      if(tempQLlist.length>9 && checked){
        Ember.$('#cb_ql_'+value).prop('checked',false);
        return alert(I18NUtil.translate('ads.home.layout.dashboard.can_not_select_more_than_10_quicklinks'));
      }
      else{
      	checked?tempQLlist.push(value.toString()):tempQLlist.removeObject(value.toString());
      }
      Ember.set(this.get('qlIdVsName'),value.toString(),Ember.$('#cb_ql_'+value).attr('data-name'));
		},
		removeSelQL:function(qlId){
      let qlList = this.get('newQLList');
      for(var i=0;i<qlList.length;i++){
        if(qlList[i]['UNIQUE_ID'] == qlId){
          qlList.removeAt(i);
          this.get('tempQLlist').removeObject(qlId.toString());
          this.set('qLsDivided',undefined);
          break;
        }
			}
    },
		addCustomScroll:function(){
			Ember.run.schedule('afterRender', this,function(){
        $('#ads_select_ql_popup .fwdash-custom-scroll').mCustomScrollbar({theme:"dark",autoHideScrollbar: true,scrollInertia: 500});
      });
		}
	}
});
