/*
 * $Id$
 */

//ignorei18n_start
import Ember from 'ember';
import StatusUtil from "../../utils/status-util"; //NO I18N
import DialogUtil from "../../utils/dialog-util"; //NO I18N
import I18NUtil from "../../utils/i18n-util"; //NO I18N
import AJAXUtil from '../../utils/ajax-util'; //NO I18N
export default Ember.Component.extend({
showWidgets:false,
widgetDetails:'',
widgetsList:'',
pageStatus:{},
selectComponentText:I18NUtil.translate('ads.home.layout.dashboard.select_component'),
selectWidgetText:I18NUtil.translate('ads.home.layout.dashboard.select_widget'),
data:[],
show:false,
showError:false,
isDisabled:true,
getComponents:function(){
	var params=this.getAttr('params');
	this.set('layoutParams',params);
	var componentsList=[];
	var list=AJAXUtil.syncAjax('/ADSLayoutCustomization.do?mTCall=getComponentsList', {});
	for(var i=0;i<list.length;i++){
		componentsList.push({CLIENT_VALUE:list[i].COMPONENT_NAME,SERVER_VALUE:list[i].COMPONENT_ID});
	}
	if(componentsList.length>0){
		this.set('isDisabled',false);
	}
	Ember.run.schedule('afterRender', function(){Ember.$('[data-id=COMPONENTS]').focus();});
	this.set('componentsList',componentsList);
}.on('init'),
actions:
{
	closeAddWidget:function()
	{
		this.sendAction('closeAddWidget');
	},
	getWidgets:function()
	{
		var self=this;
		self.set('DROPDOWN_VALUES_CHANGED',false);
		self.set('selectWidgetText',I18NUtil.translate('ads.home.layout.dashboard.select_widget'));
		self.set('showWidgets',false);
		self.set('showError',false);
		var componentId=$('#COMPONENTS').val();
		var tabId=this.get('GLOBAL_DATA.TAB_ID');
        var currentDomain = this.get('GLOBAL_DATA.TAB_ID_'+tabId);
    if(currentDomain!=null){
           this.set('layoutParams.domainName',currentDomain);
        }
		else if(this.get('GLOBAL_DATA.TAB_ID_MULTI_SELECT_'+tabId) != undefined && this.get('GLOBAL_DATA.TAB_ID_MULTI_SELECT_'+tabId) != null)
		{
			this.set('layoutParams.domainName',JSON.stringify(this.get('GLOBAL_DATA.TAB_ID_MULTI_SELECT_'+tabId)));
		}
		var params=this.get('layoutParams');
		params["COMPONENT_ID"]=componentId;
		var widgetsList=[];
		Ember.$.ajax({
      url:"/ADSLayoutCustomization.do?mTCall=getWidgets",
        type: 'POST',
        async: true,
      data: {params: JSON.stringify(params)},
			success: function(responseData){
				try{
				var widgets = Ember.$.parseJSON(responseData);
					var widgetsExist = false;
					for (var key in widgets){
						widgetsExist = true;
						widgetsList.push({CLIENT_VALUE :widgets[key].WIDGET_NAME,SERVER_VALUE : widgets[key].WIDGET_ID});
					}
					if(widgetsExist){
			        self.set('showError',false);
					self.set('errorMessage',null);
					self.set('showWidgets',true);	
					}
					else{
						self.set('showError',true);
						self.set('errorMessage',I18NUtil.translate('ads.home.layout.dashboard.no_widget_text'));
				}				 
				self.set('widgetsList',widgetsList);
				self.set('widgetDetails',widgets);
			}
				catch(e){
					if(responseData.length<200){
					self.set('errorMessage',responseData);
					self.set('showWidgets',false);
					self.set('showError',true);
				}
					else{
					self.set("DROPDOWN_VALUES_CHANGED",true);
					self.set('showError',false);
				}
			}
				Ember.run.schedule('afterRender', function(){
					$("select").selectpicker({size:false});
					Ember.$("#WIDGETSLIST").find(".bootstrap-select").each(function(){
						$(this).find('ul').css('display','block');
						$(this).find('ul').wrap('<div></div>');
						$(this).find('ul').parent().css('max-height','150px');
						$(this).find('ul').parent().addClass('fwdash-custom-scroll');
						$(this).find('.inner').removeAttr('role');
						$(this).find('ul').parent().attr('role','menu');
						Ember.$(".fwdash-custom-scroll").each(function (){
							if ($(this).attr('data-height')){
								$(this).height($(this).attr('data-height')).css({"overflow":"hidden"});
					}
					$(this).mCustomScrollbar(
					{
						theme:"dark",//NO I18N
						autoHideScrollbar: false,
						snapAmount:28,
						autoScrollOnFocus:false,
						keyboard:false,
					});
			});	
			});
			});
		}
		});
	},
	addComponent:function()
	{
		var self=this;
		if(self.get('isDisabled') || self.get('showError')){
			return;
		}
		if(!self.get("DROPDOWN_VALUES_CHANGED") && !self.get('showError')){
			self.set('errorMessage',I18NUtil.translate('ads.home.layout.dashboard.add_widget.alert_message'));
			self.set('showError',true);
			return;
		}
		var tabId=self.get('GLOBAL_DATA.TAB_ID');
		var params={};
		var widgetId = $('#WIDGETS').val();
		var details=self.get("widgetDetails");
		params['TAB_ID']=tabId;
		params['DATA']=details[widgetId];
		params['IS_ADD']=true;
		params['COMPONENT_ID']=$('#COMPONENTS').val();;
		params['WIDGET_ID']=widgetId;
		params['USER_ID']=self.get("layoutParams.userId");
		AJAXUtil.ajax('/ADSLayoutCustomization.do?mTCall=addOrUpdateComponent', {params:JSON.stringify(params)}).then(function(result) {
	    if(result.hasOwnProperty('sSTATUS')){
			self.set('referenceObject', self.getAttr('referenceObject'));
				self.get('referenceObject')["COMPONENT"].send('changeTab',tabId,true);
			self.sendAction('closeAddWidget');
            StatusUtil.showStatusWithMessage(self,'success',result.sSTATUS,true);
		}
			else{
			StatusUtil.showStatusWithMessage(self,'danger',result.eSTATUS,true);
		}
		});
	},
	setErrorMessage:function()
	{
		this.set("DROPDOWN_VALUES_CHANGED",true);
		this.set("showError",false);
	},
}
});

//ignorei18n_end	