/*
 * $Id$
 */

//ignorei18n_start
import Ember from 'ember';
import DialogUtil from "../../utils/dialog-util"; //NO I18N
import I18NUtil from "../../utils/i18n-util"; //NO I18N
import AJAXUtil from '../../utils/ajax-util'; //NO I18N
export default Ember.Component.extend({
  classNames: ['fwdash-dashboard-layout'],
  attributeBindings: ['style'],
  style: 'position:absolute',
  layoutDetails: null,
  layoutParams: null,
  contextPath: '',
  tabRHS: null,
  enableRHS: null,
  enableRHSMenu: false,
  showRHS: null,
  showSingleTab: false,
  referenceObject: null,
  pageStatus:{},
  didUpdateAttrs: function() {
      this.didInsertElement();
  },
  
  didInsertElement: function() {
    Ember.run.schedule('afterRender', this, function() {
      if (this.get('referenceObject') != undefined && this.get('referenceObject') != null) {
        if ('onLoadLayout' in this.get('referenceObject')) {
          this.get('referenceObject').onLoadLayout();
        }
      }
      var $rightPane = Ember.$('.fwdash-right-pane');
      var $bodyPane = Ember.$('.fwdash-body-pane');
      var $topPane = Ember.$('.fwdash-top-pane');
      var $body = Ember.$("body");
      //mini-top enabled scrolltop



      //toggle left pane
      Ember.$('.fwdash-toggle-btn').on("click", function() {
        Ember.$('.fwdash-right-pane-box').toggle();
        Ember.$(this).toggleClass('fwdash-open');
        $rightPane.toggleClass('fwdash-open');
        $bodyPane.toggleClass('fwdash-open');
      });


    });
    this.set('canTrack', false);
  },

  loadLayoutDetails: function() {
    var self = this;
    var referenceObject = {};
    this.set('layoutParams', {});
    var givenParams = self.getAttr('data');
    if (givenParams == undefined || Object.keys(givenParams).length == 0) {
      this.setDefaultDetails();
      return;
    }

    if (givenParams != undefined) {
      for (var key in givenParams) {
        if (key === 'referenceObject') {
          referenceObject = givenParams[key];
          referenceObject["COMPONENT"] = self;
          self.set('referenceObject', referenceObject);
        } else if (key === 'tabRHS') {
          this.set('tabRHS', givenParams[key]);
        } else if (key === 'showSingleTab') {
          this.set('showSingleTab', givenParams[key]);
        } else if (key === 'enableRHS') {
          this.set('enableRHS', givenParams[key]);
          this.set('showRHS', givenParams[key]);
        } else if (key === 'enableRHSMenu') {
            this.set('enableRHSMenu', givenParams[key]);
        } else if (key === 'contextPath') {
          this.set('contextPath', givenParams[key]);
        } else {
          this.set('layoutParams.' + key, givenParams[key]);
        }
      }
      this.set('layoutParams.isEmber', true);
      Ember.$.ajax({
        url: self.get('contextPath') +
          "/ADSLayout.do?mTCall=loadLayout",
        type: 'POST',
        async: false,
        data: {
          params: JSON.stringify(self.get('layoutParams'))
        },
        success: function(jsonData) {
          self.set('layoutDetails', Ember.$.parseJSON(jsonData));
          if(self.get('layoutDetails.LAYOUT.LAYOUT_ID')!=undefined)
            self.set('layoutParams.LAYOUT_ID',self.get('layoutDetails.LAYOUT.LAYOUT_ID'));
		  self.set('layoutParams.ENABLE_EMBED_WIDGET',self.get('layoutDetails.ENABLE_EMBED_WIDGET')!=null?self.get('layoutDetails.ENABLE_EMBED_WIDGET'):false);
		  self.set('layoutParams.ENABLE_EMBED_DASHBOARD',self.get('layoutDetails.ENABLE_EMBED_DASHBOARD')!=null?self.get('layoutDetails.ENABLE_EMBED_DASHBOARD'):false);
		  self.set('layoutParams.ENABLE_MANAGE_DASHBOARD',self.get('layoutDetails.ENABLE_MANAGE_DASHBOARD')!=null?self.get('layoutDetails.ENABLE_MANAGE_DASHBOARD'):false);
          self.set('layoutParams.ENABLE_MANAGE_RHS',self.get('layoutDetails.ENABLE_MANAGE_DASHBOARD')!=null?self.get('layoutDetails.ENABLE_MANAGE_DASHBOARD'):false);
          self.set('layoutParams.DISABLE_RHS',self.get('layoutDetails.DISABLE_RHS')!=null?self.get('layoutDetails.DISABLE_RHS'):false);
		  if(self.get('layoutDetails.TAB_RHS_CUSTOM_COMPONENT')!=null)self.set('layoutParams.TAB_RHS_CUSTOM_COMPONENT',self.get('layoutDetails.TAB_RHS_CUSTOM_COMPONENT'));
        }
      });
    }
  }.on('init').observes('data'),

  setDefaultDetails: function() {

    var referenceObject = {};
    referenceObject["COMPONENT"] = this;
    this.set('enableRHS', true);
    this.set('showRHS', true);
    this.set('referenceObject', referenceObject);

    var layoutDetails = {
      "RHSDATA": {
        "DATA": [
          [{
            "CONTAINER_ID": 1,
            "NAME": "ADManager Plus",
            "HEIGHT": 0,
            "MENUS": [],
            "PRIORITY_ID": 1,
            "OPTIONS": {
              "DURATION": {

              },
              "TYPE": {

              }
            },
            "LAYOUT_ID": 1,
            "WIDTH": "33",
            "CONTAINER_DATA": {
              "NAME": "dashboard/layout-quicklinks",
              "responseType": "JSON",
              "DATA": [{
                "DISPLAY_NAME": "AD Management",
                "IS_INTEGRATED": "true",
                "PROMOTION_URL": "http://www.manageengine.com/products/ad-manager/active-directory-management.html",
                "PRODUCT_NAME": "ManageEngine ADManager Plus",
                "TARGET": "admp",
                "PRODUCT_URL": "HTTP://maharajan-1531:8080/UserAdmin.do?selectedTab=admin"
              }, {
                "DISPLAY_NAME": "AD Reports",
                "IS_INTEGRATED": "true",
                "PROMOTION_URL": "http://www.manageengine.com/products/ad-manager/windows-active-directory-reports.html",
                "PRODUCT_NAME": "ManageEngine ADManager Plus",
                "TARGET": "admp",
                "PRODUCT_URL": "HTTP://maharajan-1531:8080/Report.do?selectedTab=reports&methodToCall=report&init=true"
              }, {
                "DISPLAY_NAME": "Helpdesk Delegation",
                "IS_INTEGRATED": "true",
                "PROMOTION_URL": "http://www.manageengine.com/products/ad-manager/windows-active-directory-helpdesk-delegation.html",
                "PRODUCT_NAME": "ManageEngine ADManager Plus",
                "TARGET": "admp",
                "PRODUCT_URL": "HTTP://maharajan-1531:8080/ADMPTechnicians.do?methodToCall=viewTechnicians&selectedTab=delegation&selectedTile=technicians&operation=view"
              }, {
                "DISPLAY_NAME": "Helpdesk Reset Password",
                "IS_INTEGRATED": "true",
                "PROMOTION_URL": "http://www.manageengine.com/products/ad-manager/active-directory-reset-password.html",
                "PRODUCT_NAME": "ManageEngine ADManager Plus",
                "TARGET": "admp",
                "PRODUCT_URL": "HTTP://maharajan-1531:8080/ModifySingleUser.do?selectedTab=admin&methodToCall=modifySingleUser&action=modifyPassword"
              }, {
                "DISPLAY_NAME": "Workflow",
                "IS_INTEGRATED": "true",
                "PROMOTION_URL": "http://www.manageengine.com/products/ad-manager/active-directory-workflow.html",
                "PRODUCT_NAME": "ManageEngine ADManager Plus",
                "TARGET": "admp",
                "PRODUCT_URL": "HTTP://maharajan-1531:8080/WorkFlowAdmin.do?selectedTab=workflow"
              }]
            }
          }, {
            "CONTAINER_ID": 2,
            "NAME": "ADAudit Plus",
            "HEIGHT": 0,
            "MENUS": [],
            "PRIORITY_ID": 2,
            "OPTIONS": {
              "DURATION": {

              },
              "TYPE": {

              }
            },
            "LAYOUT_ID": 1,
            "WIDTH": "33",
            "CONTAINER_DATA": {
              "NAME": "dashboard/layout-quicklinks",
              "responseType": "JSON",
              "DATA": [{
                "DISPLAY_NAME": "AD Management",
                "IS_INTEGRATED": "true",
                "PROMOTION_URL": "http://www.manageengine.com/products/ad-manager/active-directory-management.html",
                "PRODUCT_NAME": "ManageEngine ADManager Plus",
                "TARGET": "admp",
                "PRODUCT_URL": "HTTP://maharajan-1531:8080/UserAdmin.do?selectedTab=admin"
              }, {
                "DISPLAY_NAME": "AD Reports",
                "IS_INTEGRATED": "true",
                "PROMOTION_URL": "http://www.manageengine.com/products/ad-manager/windows-active-directory-reports.html",
                "PRODUCT_NAME": "ManageEngine ADManager Plus",
                "TARGET": "admp",
                "PRODUCT_URL": "HTTP://maharajan-1531:8080/Report.do?selectedTab=reports&methodToCall=report&init=true"
              }, {
                "DISPLAY_NAME": "Helpdesk Delegation",
                "IS_INTEGRATED": "true",
                "PROMOTION_URL": "http://www.manageengine.com/products/ad-manager/windows-active-directory-helpdesk-delegation.html",
                "PRODUCT_NAME": "ManageEngine ADManager Plus",
                "TARGET": "admp",
                "PRODUCT_URL": "HTTP://maharajan-1531:8080/ADMPTechnicians.do?methodToCall=viewTechnicians&selectedTab=delegation&selectedTile=technicians&operation=view"
              }, {
                "DISPLAY_NAME": "Helpdesk Reset Password",
                "IS_INTEGRATED": "true",
                "PROMOTION_URL": "http://www.manageengine.com/products/ad-manager/active-directory-reset-password.html",
                "PRODUCT_NAME": "ManageEngine ADManager Plus",
                "TARGET": "admp",
                "PRODUCT_URL": "HTTP://maharajan-1531:8080/ModifySingleUser.do?selectedTab=admin&methodToCall=modifySingleUser&action=modifyPassword"
              }, {
                "DISPLAY_NAME": "Workflow",
                "IS_INTEGRATED": "true",
                "PROMOTION_URL": "http://www.manageengine.com/products/ad-manager/active-directory-workflow.html",
                "PRODUCT_NAME": "ManageEngine ADManager Plus",
                "TARGET": "admp",
                "PRODUCT_URL": "HTTP://maharajan-1531:8080/WorkFlowAdmin.do?selectedTab=workflow"
              }]
            }
          }]
        ],
        "IS_CUSTOM": "false"
      },
      "LHSDATA": {
        "DATA": [
          [{
            "CONTAINER_ID": 1,
            "OPTIONS": {
              "TYPE": {

              },
              "DURATION": {
                "2": {
                  "TOOL_TIP_TEXT": "adap.home.layout.container.duration_last_x_days",
                  "CONTAINER_ID": 1,
                  "DURATION": "7",
                  "UNIQUE_ID": 2,
                  "ONCLICK_FUNC": "LayoutUtil.triggerFunction('ComponentDurationChange', this)",
                  "PRIORITY_ID": 2
                },
                "1": {
                  "TOOL_TIP_TEXT": "adap.home.layout.container.duration_last_x_days",
                  "CONTAINER_ID": 1,
                  "DURATION": "1",
                  "UNIQUE_ID": 1,
                  "ONCLICK_FUNC": "LayoutUtil.triggerFunction('ComponentDurationChange', this)",
                  "PRIORITY_ID": 1
                }
              }
            },
            "HEIGHT": 0,
            "TAB_ID": 1,
            "NAME": "Top User Logon Failures",
            "PRIORITY_ID": 1,
            "MENUS": [{
              "TOOL_TIP_TEXT": "Refresh Dashboard to view latest details.",
              "ICON_STYLE": "adsrefreshIcon",
              "ONCLICK_FUNC": "MenuAction.refreshComponent(this)",
              "NAME": "Refresh",
              "DESCRIPTION": "adap.home.tab.container.menu_refresh_desc",
              "DISPLAY_NAME": "adap.home.tab.container.menu_chart_refresh",
              "MENU_ID": 1
            }, {
              "ICON_STYLE": "adsmodifyIcon",
              "ONCLICK_FUNC": "CommonUtil.modifyComponent(this)",
              "NAME": "Modify",
              "DESCRIPTION": "adap.home.tab.container.menu_modify_desc",
              "DISPLAY_NAME": "adap.home.tab.container.menu_chart_modify",
              "MENU_ID": 2
            }, {
              "ICON_STYLE": "adsRemoveIcon",
              "ONCLICK_FUNC": "CommonUtil.removeComponent(this)",
              "NAME": "Remove",
              "DESCRIPTION": "adap.home.tab.container.menu_remove_desc",
              "DISPLAY_NAME": "adap.home.tab.container.menu_chart_remove",
              "MENU_ID": 3
            }],
            "WIDTH": "33",
            "CONTAINER_DATA": {
              "DATA": {
                "xAxis": {
                  "categories": ["00", "01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23"]
                },
                "legend": {
                  "layout": "vertical",
                  "verticalAlign": "bottom",
                  "align": "center"
                },
                "credits": {
                  "enabled": false
                },
                "title": {
                  "style": {
                    "display": "none"
                  }
                },
                "chart": {
                  "height": "250"
                },
                "yAxis": {
                  "lineWidth": 1,
                  "gridLineWidth": 0,
                  "min": 0,
                  "title": {
                    "text": "COUNT"
                  }
                },
                "series": [{
                  "data": [202, 287, 200, 202, 198, 200, 408, 198, 200, 90, 132, 132, 136, 133, 123, 136, 132, 317, 209, 198, 201, 202, 198, 200],
                  "name": "logonPeakUsage"
                }]
              },
              "NAME": "chart-component",
              "responseType": "JSON"
            }

          }, {
            "CONTAINER_ID": 2,
            "OPTIONS": {
              "TYPE": {

              },
              "DURATION": {
                "2": {
                  "TOOL_TIP_TEXT": "adap.home.layout.container.duration_last_x_days",
                  "CONTAINER_ID": 2,
                  "DURATION": "30",
                  "UNIQUE_ID": 4,
                  "ONCLICK_FUNC": "LayoutUtil.triggerFunction('ComponentDurationChange', this)",
                  "PRIORITY_ID": 2
                },
                "1": {
                  "TOOL_TIP_TEXT": "adap.home.layout.container.duration_last_x_days",
                  "CONTAINER_ID": 2,
                  "DURATION": "7",
                  "UNIQUE_ID": 3,
                  "ONCLICK_FUNC": "LayoutUtil.triggerFunction('ComponentDurationChange', this)",
                  "PRIORITY_ID": 1
                }
              }
            },
            "HEIGHT": 0,
            "TAB_ID": 1,
            "NAME": "Account Management",
            "PRIORITY_ID": 2,
            "MENUS": [{
              "TOOL_TIP_TEXT": "Refresh Dashboard to view latest details.",
              "ICON_STYLE": "adsrefreshIcon",
              "ONCLICK_FUNC": "MenuAction.refreshComponent(this)",
              "NAME": "Refresh",
              "DESCRIPTION": "adap.home.tab.container.menu_refresh_desc",
              "DISPLAY_NAME": "adap.home.tab.container.menu_chart_refresh",
              "MENU_ID": 1
            }, {
              "ICON_STYLE": "adsmodifyIcon",
              "ONCLICK_FUNC": "CommonUtil.modifyComponent(this)",
              "NAME": "Modify",
              "DESCRIPTION": "adap.home.tab.container.menu_modify_desc",
              "DISPLAY_NAME": "adap.home.tab.container.menu_chart_modify",
              "MENU_ID": 2
            }, {
              "ICON_STYLE": "adsRemoveIcon",
              "ONCLICK_FUNC": "CommonUtil.removeComponent(this)",
              "NAME": "Remove",
              "DESCRIPTION": "adap.home.tab.container.menu_remove_desc",
              "DISPLAY_NAME": "adap.home.tab.container.menu_chart_remove",
              "MENU_ID": 3
            }],
            "WIDTH": "33",
            "CONTAINER_DATA": {
              "DATA": {
                "xAxis": {
                  "categories": ["00", "01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23"]
                },
                "legend": {
                  "layout": "vertical",
                  "verticalAlign": "bottom",
                  "align": "center"
                },
                "credits": {
                  "enabled": false
                },
                "title": {
                  "style": {
                    "display": "none"
                  }
                },
                "chart": {
                  "height": "250"
                },
                "yAxis": {
                  "lineWidth": 1,
                  "gridLineWidth": 0,
                  "min": 0,
                  "title": {
                    "text": "COUNT"
                  }
                },
                "series": [{
                  "data": [202, 287, 200, 202, 198, 200, 408, 198, 200, 90, 132, 132, 136, 133, 123, 136, 132, 317, 209, 198, 201, 202, 198, 200],
                  "name": "logonPeakUsage"
                }]
              },
              "NAME": "chart-component",
              "responseType": "JSON"
            }
          }],

        ],
        "IS_CUSTOM": "false"
      },
      "LAYOUT": {
        "USER_ID": 1,
        "DESCRIPTION": "ads.home.layout.desc.default_layout",
        "LAYOUT_NAME": "ads.home.layout.name.default_layout",
        "LAYOUT_ID": 1
      },
      "TABS": [{
        "IS_CUSTOMIZABLE": true,
        "TAB_NAME": "ADManager Plus",
        "TAB_ID": 1,
        "LAYOUT_ID": 1
      }, {
        "IS_CUSTOMIZABLE": true,
        "TAB_NAME": "ADAudit Plus",
        "TAB_ID": 2,
        "LAYOUT_ID": 1
      }, {
        "IS_CUSTOMIZABLE": true,
        "TAB_NAME": "ADSelfService Plus",
        "TAB_ID": 3,
        "LAYOUT_ID": 1
      }, {
        "IS_CUSTOMIZABLE": true,
        "TAB_NAME": "Exchange Reporter Plus",
        "TAB_ID": 4,
        "LAYOUT_ID": 1
      }]
    };
    this.set('layoutDetails', layoutDetails);
  },
  actions: {
    refreshContainer: function(containerId) {
      var containerComponent = this.get('layoutComponents')['CONTAINERS']
        [containerId];
      containerComponent.send('refreshContainer');
    },
    updateParams: function(paramName, paramValue) {
      this.set('layoutParams.' + paramName, paramValue);
      this.send('changeTab', this.get('layoutParams.tabId'),true);
    },
    showAddQLPopup:function(qLContainerData){
      this.set('qLContainerData',qLContainerData);
      this.set('showAddQLPopup',true);
    },
    closeAddQLPopup:function(){
      this.set('qLContainerData',undefined);
      this.set('showAddQLPopup',undefined);
    },
    setRHSData:function(rhsData){
      var layoutDetails = this.get('layoutDetails');
      Ember.set(layoutDetails,'RHSDATA',rhsData);
    },
    toggleRHS: function() {
      this.set('showRHS', !this.get('showRHS'));
	  //To resize highcharts during toggleRHS 
	  var evt = document.createEvent('UIEvents');
      evt.initUIEvent('resize', true, false, window, 0);
      window.dispatchEvent(evt);
	  Ember.run.schedule('afterRender', this, function() 
	  {
		  if(this.get('showRHS'))
		  {
	              if(this.get("GLOBAL_DATA.IS_RHS_PROMOTION_ENABLED"))
	              {
	                  $('.fwdomain-strip').css('right','315px');
	              }
	              else
	              {
	                  $('.fwdomain-strip').css('right','251px');   
	              }
		  }
		  else
		  {
			   $('.fwdomain-strip').css('right','22px');
		  }
	  });
    },
  removeContainerConfirmMessage:function(params)
	{
		DialogUtil.confirm(this,I18NUtil.translate('ads.home.layout.dashboard.delete_widget.confirm_message'),'removeContainer','ads.home.layout.dashboard.yes',params,null);//No I18N
	},	
	removeContainer:function(params)
	{
		var self=this;
		AJAXUtil.ajax('/ADSLayoutCustomization.do?mTCall=removeComponent', params).then(function(result){
      if(params.SIDE=="LHS"){
			var tabId=self.get('GLOBAL_DATA.TAB_ID');
  		  Ember.run.schedule('afterRender', function(){self.send('changeTab',tabId,true);});
      }
      else if(params.SIDE=="RHS" && result.RHSDATA!=undefined){
        self.send('setRHSData',result.RHSDATA);
      }
		});
	},
    setActiveTab:function(tabId)
	{
		Ember.run.schedule('afterRender', this, function() 
		{
		   Ember.$("[TAB_ID]").removeClass("active");
		   Ember.$("[TAB_ID='" + tabId + "']").addClass("active");
		 });
		 
	},
    changeTab: function(tabId,isDomainChanged) {
     if(tabId!=undefined && tabId == this.get('GLOBAL_DATA.TAB_ID') && isDomainChanged == undefined){
       return;
     }
      var self = this;
      if(tabId!=null)
      {
        self.set('GLOBAL_DATA.TAB_ID',tabId);
      }
      else
      {
        tabId=self.get('GLOBAL_DATA.TAB_ID');
      }
      var tabParams = {};
      var layoutParams = this.get('layoutParams');
      this.set('layoutParams.tabId', tabId);
      for (var key in layoutParams) {
        tabParams[key] = layoutParams[key];
      }
      tabParams['tabId'] = tabId;
      tabParams['isEmber'] = true;
	  if(isDomainChanged != undefined)
	  {
		  tabParams['isHeaderChanged'] = isDomainChanged;
	  }
	  else
	  {
		   window.scrollTo(0,0); 
	  }
      var currentDomain = this.get('GLOBAL_DATA.TAB_ID_'+tabId);
      if(currentDomain!=null)
      {
        tabParams['domainName']= currentDomain;
      }
      else
      {
        this.set('GLOBAL_DATA.TAB_ID_'+tabId,this.get("GLOBAL_DATA.DEFAULT_DOMAIN"));
		    tabParams['domainName']= this.get("GLOBAL_DATA.DEFAULT_DOMAIN");
      }
      if(this.get('canTrack'))
      {
        tabParams['trackRequest'] = true;
      }
      else
      {
        this.set('canTrack', true);
      }
      Ember.$.ajax({
        url: self.get('contextPath') +
          "/ADSLayout.do?mTCall=loadContainers",
        type: 'POST',
        async: false,
        data: {
          params: JSON.stringify(tabParams)
        },
        success: function(responseData) {
          try 
		  {
			  self.set('layoutDetails.LHSDATA', Ember.$.parseJSON(responseData));
			  if(self.get('layoutDetails.ENABLE_EMBED_DASHBOARD') !== undefined && self.get('layoutDetails.ENABLE_EMBED_DASHBOARD'))
			  {
				  if(self.get("layoutDetails.LHSDATA.CONTAINER_NAME") !== undefined)
				  {
					  self.set('layoutParams.ENABLE_EMBED_DASHBOARD',false);
				  }
				  else if(self.get('layoutDetails.LHSDATA.DATA').length==0)
				  {
					  self.set('layoutParams.ENABLE_EMBED_DASHBOARD',false);
				  }
				  else
				  {
					  self.set('layoutParams.ENABLE_EMBED_DASHBOARD',true);
				  }
			  }
          } 
		  catch (e) 
		  {
			if(self.get('layoutDetails.ENABLE_EMBED_DASHBOARD') !== undefined && self.get('layoutDetails.ENABLE_EMBED_DASHBOARD'))
			{
				self.set('layoutParams.ENABLE_EMBED_DASHBOARD',true);
			}
            self.set('layoutDetails.LHSDATA', {});
            self.set('layoutDetails.LHSDATA.IS_CUSTOM', true);
            self.set('layoutDetails.LHSDATA.CONTAINER_NAME',
              "html-component");
            self.set('layoutDetails.LHSDATA.DATA', new Ember
              .Handlebars
              .SafeString(
                responseData));
          } finally {
            Ember.$("[TAB_ID]").removeClass("active");
            Ember.$("[TAB_ID='" + tabId + "']").addClass("active");
          }
        }

      });
	  Ember.run.schedule('afterRender', this, function() 
	  {
		  if(this.get('showRHS'))
		  {
			  if(this.get("GLOBAL_DATA.IS_RHS_PROMOTION_ENABLED"))
              {
                  $('.fwdomain-strip').css('right','315px');
              }
              else
              {
                  $('.fwdomain-strip').css('right','251px');   
              }
		  }
		  else
		  {
			   $('.fwdomain-strip').css('right','22px');
		  }
	  });
    }
  }

});

//ignorei18n_end
