/*
 * $Id$
 */

//ignorei18n_start
import Ember from 'ember';

export default Ember.Component.extend({
  classNames: ["fwdash-body-pane"],
  classNameBindings: ['enableRHS:fwdash-right-pane-active', 'enableRHS:open'],
  orderedContainers: null,
  params: null,
  customContainer: null,
  headerComponent: null,
  referenceObject: null,
  enableRHS: null,
  contextPath: '',
  arrangeContainers: function() {
    var self=this;
	self.set("showAddWidget",false);
	self.set('showAddWidgetMessage',false);
    this.set('contextPath', this.getAttr('contextPath'));
	this.set('params', this.getAttr('params'));
    var lhsData = this.getAttr("data");
    var tabId =self.get('GLOBAL_DATA.TAB_ID');
    if(tabId==undefined){
      tabId = lhsData['TAB_ID'];
      if(tabId!=undefined)
        this.set('GLOBAL_DATA.TAB_ID',tabId);
    }
    var result = [];
    self.set('lhsHeader',null);
    var defaultLhsHeader = this.getAttr("header"); 
    var lhsHeader=null;
    if(lhsData.HEADER!=null)
    {
      lhsHeader=lhsData.HEADER;
    }
    else if(defaultLhsHeader==null)
    {
      lhsHeader={};
    }
    else if(lhsData.CONTAINER_NAME!=null)
    {
      if(lhsData.CONTAINER_NAME=='dashboard-promotion')
      {
        lhsHeader={}; 
      }
      else if(lhsData.CONTAINER_NAME=='service-unavailable')
      {
        var errorMsg = lhsData.DATA['ERROR_MESSAGE']
        if(errorMsg!=null && errorMsg.indexOf("ads.restapi.error.domain_not_found")==-1 && errorMsg.indexOf("ads.restapi.error.user_not_authorized")==-1 && errorMsg.indexOf("ads.restapi.domain_disabled")==-1)
        {
          lhsHeader={};
        }
      }
    }
    
    if(lhsHeader==null)
    {
        lhsHeader=defaultLhsHeader;
    }

    Ember.set(lhsHeader,'tabId',tabId);
    self.set('lhsHeader', lhsHeader);
	var lhsFooter = this.getAttr('footer');
	if(lhsData.FOOTER!=undefined){
      lhsFooter=lhsData.FOOTER;
    }
	self.set('lhsFooter', lhsFooter);

    this.set('enableRHS', this.getAttr('enableRHS'));
    if (lhsData != undefined && lhsData.hasOwnProperty('IS_CUSTOM') && lhsData["IS_CUSTOM"] === "false") {
      this.set('customContainer', null);
      var containers = lhsData["DATA"];
	  if(containers.length==0)
	  {
		  this.set("showAddWidgetMessage",true);
	  }
      for (var i = 0; i < containers.length; i++) {
        var row = {};
        row["height"] = 275;
        for (var j = 0; j < containers[i].length; j++) {
          if (containers[i][j].HEIGHT > row["height"]) {
            row["height"] = containers[i][j].HEIGHT;
          }
          containers[i][j].WIDTH = 12 / containers[i].length;
        }
        row['containers'] = containers[i];
        result[result.length] = row;

      }
      this.set('orderedContainers', result);
    } else {
      this.set("customContainer", lhsData["CONTAINER_NAME"]);
      this.set("DATA", lhsData["DATA"]);
    }

    this.set('params', this.getAttr('params'));
    var currentDomain = this.get('GLOBAL_DATA.TAB_ID_'+tabId);
    //if(currentDomain!=null)
      this.set('params.domainName',currentDomain);
      this.set("isRHSDisabled",(self.get('params.DISABLE_RHS')));

    Ember.run.schedule('afterRender', this, function() {
      if (this.get('referenceObject') != undefined && this.get('referenceObject') != null)
      {
        if ('onLoadContainers' in this.get('referenceObject')) {
          this.get('referenceObject').onLoadContainers();
        }
      }
    });
  }.on('init').observes('data'),
  actions:
  {
	addWidget:function()
	{
		this.set('referenceObject', this.getAttr('referenceObject'));
		this.set("showAddWidget",true);
	},
	closeAddWidget:function()
	{
		this.set("showAddWidget",false);
	},
  }
});

//ignorei18n_end
