/*
 * $Id$
 */

//ignorei18n_start
import Ember from 'ember';
import I18NUtil from "../../utils/i18n-util"; //NO I18N
import AJAXUtil from '../../utils/ajax-util'; //NO I18N
import StatusUtil from "../../utils/status-util"; //NO I18N
export default Ember.Component.extend({
  classNames: ['fwdash-db-chart-container'],
  containerDurations: null,
  containerData: null,
  currentDuration: null,
  containerParams: null,
  containerComponent: null,
  referenceObject: null,
  showMenu: null,
  containerId: null,
  contextPath: '',
  currentContainer:'',
  showErrorMessage:false,
  didUpdateAttrs: function() {
    var layoutParams = this.getAttr("data");
    for (var key in layoutParams) {
      this.set('containerParams.' + key, layoutParams[key]);
    }
    this.loadContainer();
  },
  didInitAttrs: function() {
     var layoutParams = this.getAttr("data");
    this.set('containerParams', {});
	this.set('containerParams.type','Bar');
 	this.set('containerParams.duration', -1);
	this.set('layoutParams',layoutParams);
    this.set("style", "width:" + this.getAttr("container")["WIDTH"] + "%");
    for (var key in layoutParams) {
      this.set('containerParams.' + key, layoutParams[key]);
    }

    var durations = this.get('attrs.container.value.OPTIONS.DURATION');
    if (Object.keys(durations).length > 0) {
      var currentDurations = [];
      for (var i = 1; i <= Object.keys(durations).length; i++) {
        currentDurations[currentDurations.length] = durations[i];
      }
      this.set('containerParams.duration', currentDurations[0].DURATION);
      if (currentDurations.length > 1) {
        this.set('containerDurations', currentDurations);
      }
    }

    var type = this.get('attrs.container.value.OPTIONS.TYPE');
    if (Object.keys(type).length > 0) {
      var currentTypes = [];
      for (var j = 1; j <= Object.keys(type).length; j++) {
        currentTypes[currentTypes.length] = type[j];
      }
      this.set('containerParams.type', currentTypes[0].TYPE);
      this.set('containerTypes', currentTypes);
    }


    this.set('containerParams.containerId', this.get(
      'attrs.container.value.CONTAINER_ID'));
    this.set('containerId', this.get(
      'attrs.container.value.CONTAINER_ID'));
	this.set('CONTAINER_NAME', this.get(
      'attrs.container.value.NAME'));
    this.set('containerParams.IS_EMBER', true);
    this.set('containerParams.HEIGHT', this.get('containerHeight'));
    this.set('referenceObject', this.getAttr('referenceObject'));
  },
  didInsertElement: function() {
    this.setActiveDuration();
  },
  setActiveDuration: function() {
    Ember.$("[TYPE='CONTAINER_DURATION'][CONTAINER_ID=" + this.get(
      'containerId') + "]").removeClass("active");
    Ember.$("[TYPE='CONTAINER_DURATION'][CONTAINER_ID='" + this.get(
        'containerId') + "'][DURATION='" + this.get(
        'containerParams.duration') +
      "']").toggleClass("active");
  },
  mouseEnter: function() {
	if(this.get("attrs.container.value.PRODUCT_NAME")!= undefined)
	{
	  Ember.$('#TABS_AREA').find("li[TAB_ID='"+this.get('GLOBAL_DATA.TAB_ID')+"']").attr("title",this.get("attrs.container.value.PRODUCT_NAME"));
	}
    if(!this.get('IS_REFRESH'))
    {
      this.set('showMenu', true);  
    }
  },
  mouseLeave: function() {
	if(this.get("attrs.container.value.PRODUCT_NAME")!= undefined)
	{
		var tabName= Ember.$('#TABS_AREA').find("li[TAB_ID='"+this.get('GLOBAL_DATA.TAB_ID')+"']").attr("name");
		Ember.$('#TABS_AREA').find("li[TAB_ID='"+this.get('GLOBAL_DATA.TAB_ID')+"']").attr("title",tabName);
	} 
    this.set('showMenu', null);
  },
  checkRefreshCompletion:function(params,interval){
    if(this.isDestroyed)
      return;
  	var self = this;
  	AJAXUtil.ajaxNoScroll(self.get('contextPath')+'/ADSLayout.do?mTCall=checkRefreshCompletion',{params: JSON.stringify(params)}).then(function(responseData){
      if(responseData!=undefined && (typeof responseData == 'object')){
        if(responseData.CHECK_FOR_COMPLETION){
            Ember.run.later(self,'checkRefreshCompletion',params,interval,interval);
        }
        else{
  				  self.loadContainer();
  		  }
      }
      else{
    			self.set('containerComponent', {});
    			self.set('containerComponent.NAME',"html-component");
    			self.set('containerComponent.DATA', new Ember.Handlebars.SafeString(responseData));
    			self.set('IS_REFRESH', false);
  		}
  	});
  },
  loadContainer: function(forceLoad) {
      var self = this;
        this.set('IS_REFRESH',true);
	  if(this.get("attrs.container.value.PRODUCT_TYPE")!= undefined)
 	  {
 	    var tabId=this.get('GLOBAL_DATA.TAB_ID');
 	    var domainName=this.get('GLOBAL_DATA.TAB_ID_'+tabId+this.get("attrs.container.value.PRODUCT_TYPE"));
 	    if(domainName != undefined && domainName != null)
 	    {
 	        this.set('containerParams.domainName',domainName);
 	    }
 	  }
      var params=this.get('containerParams');
      var containerDetails = this.get('attrs.container.value');
      if (forceLoad == undefined || !forceLoad) {
        Ember.set(params,'isRefreshed',false);  
        if (containerDetails.hasOwnProperty('CONTAINER_DATA')) {
          self.set('containerComponent', containerDetails['CONTAINER_DATA']);
          self.set('containerParams.isRefreshed', false);
          self.set('IS_REFRESH',false);
          return;
        }
      }
      if(self.get('IS_REPORT_RUNNING')!=null){
        params.IS_REPORT_RUNNING=self.get('IS_REPORT_RUNNING');
      }

      Ember.$.ajax({
        url: this.getAttr('contextPath') +"/ADSLayout.do?mTCall=loadComponent",
        type: 'POST',
        async: true,
        data: {params: JSON.stringify(params)},
        success: function(responseData) {
          var isReportRunning = false;
          try {
            var componentData = Ember.$.parseJSON(responseData);
            var params = self.get('containerParams');
            if(componentData.IS_REPORT_RUNNING!=null)
            {
              isReportRunning=componentData.IS_REPORT_RUNNING;
            }
			if(componentData.CHECK_FOR_COMPLETION){
              var interval = componentData.CHECK_INTERVAL?componentData.CHECK_INTERVAL:500;
              var extraParams = componentData.CHECK_PARAMS?componentData.CHECK_PARAMS:{};
              var checkParams = {};
          		for(var key in params)
          			checkParams[key] = params[key];
              for(var key in extraParams)
          			checkParams[key] = extraParams[key];
        			Ember.run.later(self,'checkRefreshCompletion',checkParams,interval,interval);
              return;
      		  }
            self.set('containerComponent', {});
            self.set('containerComponent.NAME',componentData["NAME"]);
            self.set('containerComponent.DATA', componentData["DATA"]);
            if(componentData["NAME"] == "chart-component")
            {
                var height = self.get('containerDurations')==null ? params.HEIGHT : params.HEIGHT-40;
                self.set('containerComponent.DATA.HEIGHT', height);
            }
			self.set('IS_REFRESH', false);
          } catch (e) {
            try{
            self.set('containerComponent', {});
            self.set('containerComponent.NAME',"html-component");
            self.set('containerComponent.DATA', new Ember.Handlebars.SafeString(responseData));
			self.set('IS_REFRESH', false);
            }catch(e){ return; }
          } 
          finally {
            try{
              self.set('IS_REPORT_RUNNING',isReportRunning);
            }catch(e){
              return;
            }
          }
        }
      });
  }.on('init'),
  actions: {
    menuClicked: function(menu) {
	  this.set('containerParams.MENU_ID', menu.MENU_ID);
      this.get('referenceObject').onMenuSelected(this, menu);
    },
    changeDuration: function(durationValue) {
      this.set('containerParams.duration', durationValue);
      this.loadContainer(true);
      this.setActiveDuration();
    },
    refreshContainer: function() {
      this.set('containerParams.isRefreshed', true);
      this.set('containerParams.IS_EMBER', true);
      this.loadContainer(true);
    },
	loadContainer:function(forceLoad){
      this.loadContainer(forceLoad);
    },
	setErrorInfo:function(isSet, functionObject){
		if(isSet){
			this.set('showErrorIcon',true);
			this.set('showErrorFunction',functionObject);
		}
		else{
			this.set('showErrorIcon',false);
			this.set('showErrorFunction',undefined);
		}
	},
	showError:function(){
		var functionObject = this.get('showErrorFunction');
		if(functionObject!=undefined)
			functionObject();
    },
	closePopup:function()
	{
		this.set("showPopup",false);
	},
	embedGraph:function(id)
	{
		var self=this;
		this.set("showPopup",false);
		var tabId=this.get('GLOBAL_DATA.TAB_ID');
		var url="";
        var currentDomain = this.get('GLOBAL_DATA.TAB_ID_'+tabId);
		if(this.get("attrs.container.value.PRODUCT_TYPE")!= undefined)
 	    {
 	        var tabId=this.get('GLOBAL_DATA.TAB_ID');
 	        var domainName=this.get('GLOBAL_DATA.TAB_ID_'+tabId+this.get("attrs.container.value.PRODUCT_TYPE"));
 	        if(domainName != undefined && domainName != null)
 	        {
 	            currentDomain=domainName;
 	        }
 	    }
        if(currentDomain!=null)
        {
           this.set('containerParams.domainName',currentDomain);
        }
		var params=this.get('containerParams');
		params['name']=this.get('CONTAINER_NAME');
		var parameters={};
		parameters["params"]=JSON.stringify(params);
		var result=AJAXUtil.syncAjax('/RestAPI/WC/ADSLayout?mTCall=updateEmbedWidgetDetails', parameters);
		if(result.hasOwnProperty('eSTATUS'))
		{
			StatusUtil.showStatusWithMessage(self,'danger',result.eSTATUS,true);
		}
		else
		{
			self.set("uniqueId",result["ID"]);
			self.set("refreshInterval",result["REFRESH_INTERVAL"]);
			window.REFRESH_INTERVAL=result["REFRESH_INTERVAL"];
			url=document.location.protocol+"//"+document.location.host+"/RestAPI/EmbedGraph?mTCall=getDetails&id="+result["ID"];  
			this.set("showPopup",true);
			this.set("url",url);
		}
	},
	updateInterval:function(interval)
	{
		
		
		if(Number(window.REFRESH_INTERVAL)===Number(interval))
		{
			return;
		}
		var params={};
		
		params['UNIQUE_ID']=this.get("uniqueId");
		params['REFRESH_INTERVAL']=interval;
		var parameters={};
		parameters["params"]=JSON.stringify(params);
		AJAXUtil.ajax('/RestAPI/WC/ADSLayout?mTCall=updateEmbedWidgetDetails', parameters)
		.then(function() {
		});
		
	},
	removeContainer:function(id)
	{
    var params = {TAB_ID:this.get('GLOBAL_DATA.TAB_ID'),CONTAINER_ID:id,SIDE:"LHS"};
		this.get('referenceObject')["COMPONENT"].send('removeContainerConfirmMessage', params);
	},
	editContainer:function(container)
	{
    var params = {CONTAINER_DATA:container};
		var response=AJAXUtil.syncAjax('/ADSLayoutCustomization.do?mTCall=getWidgetOptions',{params:JSON.stringify(params)});
    this.set("widgetOptions",response);
		this.set("showErrorMessage",false);
		this.set("showEditPopup",true);	
		this.set("currentContainer",container);
		this.set("CONTAINER_NAME",container.NAME);
	},
	closeEditPopup:function()
	{
		this.set("showErrorMessage",false);
		this.set("showEditPopup",false);	
	},
	saveContainer:function()
	{
		var containerName=$('#CONTAINER_NAME').val();
	  if(Ember.$.trim(containerName) ===''){
			this.set("errorMessage",I18NUtil.translate("ads.home.layout.dashboard.tab_error"));
			this.set("showErrorMessage",true);
			return;
		}
		else if(containerName.length>250){
			this.set("errorMessage",I18NUtil.translate("ads.home.layout.dashboard.widget_name.limit_message"));
			this.set("showErrorMessage",true);
			return;
		}
		var container=this.get("currentContainer");
		var params={};
		params['CONTAINER_NAME']=containerName;
		params['CONTAINER_ID']=container.CONTAINER_ID;
		params['TAB_ID']=this.get('GLOBAL_DATA.TAB_ID');
		params['USER_ID']=this.get('layoutParams.userId');
    params['IS_UPDATE']=true;
    var widgetOptions = this.get('widgetOptions');
    if(widgetOptions!=undefined){
      for(var i=0;i<widgetOptions.length;i++){
        var optVal = null;
        if(widgetOptions[i].TYPE=='select'){
          optVal = $('#wd_opt_'+widgetOptions[i].ID).val();
        }
        params[widgetOptions[i].ID] = optVal;
      }
    }
		var response=AJAXUtil.syncAjax('/ADSLayoutCustomization.do?mTCall=addOrUpdateComponent',{params:JSON.stringify(params)});
		Ember.set(container,"NAME",containerName);
		this.set("CONTAINER_NAME",containerName);
	    this.set("showEditPopup",false);	
		this.set("currentContainer",null);
    this.loadContainer(true);
	}
}
});

//ignorei18n_end
