/*
 * $Id$
 */

//ignorei18n_start
import Ember from 'ember';

export default Ember.Component.extend({
  classNames: ["fwdash-right-pane fwdash-custom-scroll"],
  hideRHS: false,
  orderedContainers: null,
  params: null,
  customContainer: null,
  referenceObject: null,
  contextPath: '',
  showAddQLPopup:'showAddQLPopup',
  arrangeContainers: function() {
    var result = [];
    this.set('contextPath', this.getAttr('contextPath'));
    this.set('referenceObject', this.getAttr('referenceObject'));
    var rhsData = this.getAttr("rhsData");
    if ("IS_CUSTOM" in rhsData && rhsData["IS_CUSTOM"] === "true") {
      this.set("customContainer", rhsData["CONTAINER_NAME"]);
      this.set("DATA", rhsData["DATA"]);
    } else {
      this.set('customContainer', null);
      var containers = rhsData["DATA"];
      for (var i = 0; i < containers.length; i++) {
        var row = {};
        row["height"] = 206;
        for (var j = 0; j < containers[i].length; j++) {
          if (containers[i][j].HEIGHT > row["height"]) {
            row["height"] = containers[i][j].HEIGHT;
          }
          containers[i][j].WIDTH = 100 / containers[i].length;
        }
        row['containers'] = containers[i];
        result[result.length] = row;
      }
      this.set('orderedContainers', result);
    }
    this.set('params', this.getAttr('params'));
	Ember.run.schedule('afterRender', function() 
	{
		Ember.$(".fwdash-custom-scroll").each(function () 
		{
			$(this).mCustomScrollbar(
			{
				theme:"dark",//NO I18N
				autoHideScrollbar: true,
				scrollInertia: 500,
				callbacks:
				{
					onScroll: function (evt) 
					{
						return false;
					},
					onTotalScroll: function (evt) 
					{
						return false;
					},
					onTotalScrollBack: function (evt) 
					{
						return false;
					}
				}
			});
		});	
	});
			
  }.on('init').observes('rhsData'),
  actions: {
    toggleRHS: function() {
      this.set('hideRHS', !this.get('hideRHS'));
      this.get('referenceObject')["COMPONENT"].send('toggleRHS');
    },
    showAddQLPopup:function(containerData){
      this.sendAction('showAddQLPopup',containerData);
    }
  }
});

//ignorei18n_end
