/*
 * $Id$
 */

//ignorei18n_start
import Ember from 'ember';

export default Ember.Component.extend({
  classNames: ["fwdash-right-pane-box"],
  containerParams: null,
  containerComponent: null,
  showMenu: null,
  showAddQLPopup:'showAddQLPopup',
  didUpdateAttrs: function() {
    var layoutParams = this.getAttr("params");
    for (var key in layoutParams) {
      this.set('containerParams.' + key, layoutParams[key]);
    }
    this.loadContainer();
  },
  didInitAttrs: function() {
    this.set('containerParams', {});
    var layoutParams = this.getAttr("params");
    for (var key in layoutParams) {
      this.set('containerParams.' + key, layoutParams[key]);
    }
    this.set('containerParams.containerId', this.get(
      'attrs.container.value.CONTAINER_ID'));
    this.set('containerParams.IS_EMBER', true);
    this.set('containerParams.IS_RHS', true);
  },
  didInsertElement: function() {
    Ember.$("#" + this.get('containerParams.containerId') +
      "_" +
      this.get('containerParams.duration')).toggleClass(
      "active");
  },
  mouseEnter: function() {
	      this.set('showMenu', true);
  },
  mouseLeave: function() {
	      this.set('showMenu', null);
  },
  loadContainer: function(forceLoad) {
    var self = this;
    var containerDetails = this.get('attrs.container.value');

    var params = this.get('containerParams');
    if (forceLoad == undefined || !forceLoad) {
      if (containerDetails.hasOwnProperty('CONTAINER_DATA')) {
        self.set('containerComponent', containerDetails['CONTAINER_DATA']);
        self.set('containerParams.isRefreshed', false);
        return;
      }
    }
    Ember.$.ajax({
      url: this.getAttr('contextPath') +
        "/ADSLayout.do?mTCall=loadComponent",
      type: 'POST',
      async: true,
      data: {
        params: JSON.stringify(params)
      },
      success: function(responseData) {
        try {
            if (self.get('isDestroyed') || self.get('isDestroying')) {
            return;
            }
          var componentData = Ember.$.parseJSON(responseData);
          //  self.set('containerComponent', Ember.$.parseJSON(
          //    responseData));
          self.set('containerComponent', {});
          self.set(
            'containerComponent.NAME',
            componentData["NAME"]);
          self.set(
            'containerComponent.DATA', componentData["DATA"]);
        } catch (e) {
          self.set('containerComponent', {});
          self.set('containerComponent.NAME',
            "html-component");
          self.set('containerComponent.DATA', new Ember.Handlebars
            .SafeString(
              responseData));
        } finally {

        }
      }
    });
    self.set('containerParams.isRefreshed', false);
  }.on('init'),
  actions: {
    refreshContainer: function() {
      this.set('containerParams.isRefreshed', true);
      this.set('containerParams.IS_EMBER', true);
      this.loadContainer(true);
  },
    editContainer:function(container)
  	{
      container.CONTAINER_DATA =  this.get('containerComponent');
      this.sendAction('showAddQLPopup',container);
  	},
    removeContainer:function(id)
  	{
      var params = {CONTAINER_ID:id,SIDE:"RHS"};
  		this.get('referenceObject')["COMPONENT"].send('removeContainerConfirmMessage', params);
  	}
  }
});

//ignorei18n_end
