/*
 * $Id$
 */

//ignorei18n_start
import Ember from 'ember';
import DialogUtil from "../../utils/dialog-util"; //NO I18N
import I18NUtil from "../../utils/i18n-util"; //NO I18N
import AJAXUtil from '../../utils/ajax-util'; //NO I18N
import StatusUtil from "../../utils/status-util"; //NO I18N
export default Ember.Component.extend({
  showTabs: null,
  referenceObject: null,
  pageStatus:{},
  didUpdateAttrs: function()
  {
    if(this.get("layoutParams.ENABLE_EMBED_DASHBOARD") || this.get("layoutParams.ENABLE_MANAGE_DASHBOARD"))
	{
		this.set("showSettings",true);
	}
	else
	{
		this.set("showSettings",false);
	}
  },
  setShowTabs: function() {
      var self = this;
    var layoutParams = this.getAttr("params");
	this.set("layoutParams",layoutParams);
	var tabs = this.getAttr('data');
	this.set("tabs",tabs);
	this.set("GLOBAL_DATA.IS_DASHBOARD_CUSTOMIZABLE",false);
    	this.set("isRHSDisabled",self.get("layoutParams.DISABLE_RHS"));
	if(tabs.length > 1)
	{
		this.set("currentTab",tabs[0]);
    Ember.run.scheduleOnce('afterRender', function(){self.send('tabSliding', tabs[0]);});
	}
	if(this.get("layoutParams.ENABLE_EMBED_DASHBOARD") || this.get("layoutParams.ENABLE_MANAGE_DASHBOARD"))
	{
		this.set("showSettings",true);
	}
	if(this.get("layoutParams.TAB_RHS_CUSTOM_COMPONENT"))
  	{
  		this.set("tabRHSCustomComponent",this.get("layoutParams.TAB_RHS_CUSTOM_COMPONENT"));
	}
    if(this.getAttr('showSingleTab')==true)
    {
      this.set('showTabs',true); 
    }
    else
    {
      this.set('showTabs', (tabs!=undefined && tabs.length > 1) ? true : null);
    }
    this.set('referenceObject', this.getAttr('referenceObject'));
	this.set("tabChange",true);
    this.set('rhsTabWidth','right:42px');
  }.on('init'),
  didInsertElement: function() {
	var self=this;
    Ember.$("[TAB_ID]:first").addClass("active");
	$(window).resize(function() 
	{
		self.send("tabSliding", self.get("currentTab"));
	});
	$( "#TABS_AREA" ).dblclick(function()
	{
		var tabDetails=self.get("currentTab");
		if(tabDetails.IS_CUSTOMIZABLE && self.get("GLOBAL_DATA.IS_DASHBOARD_CUSTOMIZABLE"))
		{
		   self.set("currentTabId",self.get("currentTab.TAB_ID"));
	       self.set("popupTitle",I18NUtil.translate("ads.home.layout.dashboard.edit_tab"));
		   self.set("buttonName",I18NUtil.translate("ads.common.text.save"));
		   self.set("tabName",self.get("currentTab.TAB_NAME"));
		   self.set("showAddPopup",true);
		}
	});
     if(this.get("layoutParams.DISABLE_RHS"))
     {
         $('.fwdash-db-product-list-dd').css("right", "42px");
         $('.fwdash-db-top-strip-rhs').css("width", "42px");
     }
  },
  actions: {
    changeTab: function(tab,tabSliding) 
	{
		if(this.get("tabChange"))
		{
			this.get('referenceObject')["COMPONENT"].send('changeTab', tab.TAB_ID);
			this.set("currentTab",tab);
            this.send("setRHSMargin",tab);
			
			if(tabSliding === undefined)
			{
				this.send("tabSliding",tab);
			}
	    }
		this.set("tabChange",true);
    },
    setRHSMargin: function(tab)
    {
        var showButtons = this.get('showButtons');
        if(this.get("layoutParams.ENABLE_EMBED_DASHBOARD") || this.get("layoutParams.ENABLE_MANAGE_DASHBOARD"))
			{
				if(!this.get("showButtons"))
				{
					this.set("showSettings",true);
				}
			}
			else
			{
				this.set("showSettings",false);
				this.set("showButtons",false);
			}
			var self = this;
            Ember.run.schedule('afterRender', function()
            {
                if(self.get("layoutParams.DISABLE_RHS"))
                {
                    if(tab.IS_CUSTOMIZABLE && self.get("GLOBAL_DATA.IS_DASHBOARD_CUSTOMIZABLE"))
                    {	
                        var width="291px";
                        if(self.get("GLOBAL_DATA.generalDetails.LOCALE")=="ja_JP")
                        {
                            width="330px";
                            $('.fwdash-db-product-list-dd').css("right","295px");
                        }
                        else
                        {
                            $('.fwdash-db-product-list-dd').css("right","268px");
                        }
                        $('.fwdash-db-top-strip-rhs').css("width", width);
                        //this.set("isTabCustomizable",true);
                    }
                    else
                    {
                        //$('.fwdash-db-queue-list').css("padding-left","5px");
                        $('.fwdash-db-product-list-dd').css("right",(showButtons!=undefined && showButtons==true) ? "163.5px" : "42px");
                        $('.fwdash-db-top-strip-rhs').css("width",(showButtons!=undefined && showButtons==true) ? "186.5px" : "42px");
                        //this.set("isTabCustomizable",false);
                    }
                }
            });    
    },
    tabSliding:function(tab){
    var tabStripWidth = $('.fwdash-db-top-strip-lhs').width() -15 -43;
    var tabListItems = $('.fwdash-nav.fwdash-navbar-nav').children();
    var tabItemsWidth = 0;
    for(var i=0;i<tabListItems.length;i++)
      tabItemsWidth += $(tabListItems[i]).width();
    var showDropDown = tabItemsWidth>tabStripWidth;
    var prevShowDropDown = this.get('showDropDown');
    if(prevShowDropDown != showDropDown){
      this.set('showDropDown',showDropDown);
      var currentTab = this.get('currentTab');
      if(showDropDown){
        this.set('isAddTabMoved',true);
        if(currentTab!=undefined)
        Ember.run.schedule('afterRender', this,function(tabId){
          Ember.$('[TAB_ID="'+tabId+'"]').addClass('active');
          $('#dashboard_lhs_tabs_list').mCustomScrollbar({theme:"dark",autoHideScrollbar: true,scrollInertia: 500});
          this.send("setRHSMargin",tab);
            
        },currentTab.TAB_ID);
      }
    }

    if(tab!=null && tab.TAB_ID != null){
	  var toolPosition = Ember.$('.fwdash-db-product-list-dd').position(); 
      if(tab.TAB_ID != null)	
	  {		  
		  var productPosition = Ember.$('[TAB_ID='+tab.TAB_ID+']').position();
		  var productWidth = Ember.$('[TAB_ID='+tab.TAB_ID+']').width();
	  }
	  var tabPosition = parseInt(Ember.$('.fwdash-db-top-strip-lhs').css('margin-left'));
	  var left=0;
	  if(toolPosition !== undefined)
	  {
		  if((productPosition.left+productWidth)-tabPosition>toolPosition.left && toolPosition.left>0)
		  {
			  left=(productPosition.left+productWidth)-toolPosition.left;
			  left=left-(tabPosition);
		  }
	  }
	  Ember.$(".fwdash-db-top-strip-lhs").css({'margin-left':left*-1});
	  }
	},
	closePopup:function()
	{
		this.set("showPopup",false);
	},
	
	embedDashboard:function()
	{
		var self=this;
		this.set('showPopup',false);
		var tabId=this.get('GLOBAL_DATA.TAB_ID');
		var url="";
        var currentDomain = this.get('GLOBAL_DATA.TAB_ID_'+tabId);
        if(currentDomain!=null)
        {
           this.set('layoutParams.domainName',currentDomain);
        }
		if(this.get('GLOBAL_DATA.TAB_ID_MULTI_SELECT_'+tabId) != undefined && this.get('GLOBAL_DATA.TAB_ID_MULTI_SELECT_'+tabId) != null)
		{
			this.set('layoutParams.domainName',JSON.stringify(this.get('GLOBAL_DATA.TAB_ID_MULTI_SELECT_'+tabId)));
		}
		var params=this.get('layoutParams');
		var parameters={};
		parameters["params"]=JSON.stringify(params);
		var result=AJAXUtil.syncAjax('/RestAPI/WC/ADSLayout?mTCall=updateEmbedDashboardDetails', parameters);
		if(result.hasOwnProperty('eSTATUS'))
		{
			StatusUtil.showStatusWithMessage(self,'danger',result.eSTATUS,true);
		}
		else
		{
			self.set("uniqueId",result["ID"]);
			self.set("refreshInterval",result["REFRESH_INTERVAL"]);
			window.REFRESH_INTERVAL=result["REFRESH_INTERVAL"];
			url=document.location.protocol+"//"+document.location.host+"/RestAPI/EmbedDashboard?mTCall=getDetails&id="+result["ID"];
			this.set('showPopup',true);
			this.set("url",url);
		}
		
	},
	updateInterval:function(interval)
	{
		
		if(Number(window.REFRESH_INTERVAL)===Number(interval))
		{
			return;
		}
		var params={};
		params['UNIQUE_ID']=this.get("uniqueId");
		params['REFRESH_INTERVAL']=interval;
		var parameters={};
		parameters["params"]=JSON.stringify(params);
		AJAXUtil.ajax('/RestAPI/WC/ADSLayout?mTCall=updateEmbedDashboardDetails', parameters)
		.then(function() {
		});
	},
	manageDashboard:function()
	{
		var self=this;
		this.set("showIcons",false);
		this.set("showSettings",false);
		this.set("showButtons",true);
		this.set("GLOBAL_DATA.IS_DASHBOARD_CUSTOMIZABLE",true);	
		Ember.run.schedule('afterRender', function()
		{
			if(self.get('currentTab.IS_CUSTOMIZABLE'))
			{	
				var width="289px";
				if(self.get("GLOBAL_DATA.generalDetails.LOCALE")=="ja_JP")
				{
					width="301px";
                  		        $('.fwdash-db-product-list-dd').css("right",width);
				}
                
                if(self.get("layoutParams.DISABLE_RHS"))
                {
                    width="291px";
                    if(self.get("GLOBAL_DATA.generalDetails.LOCALE")=="ja_JP")
                    {
                        width="330px";
                        $('.fwdash-db-product-list-dd').css("right","295px");
                    }
                    else
                    {
                      $('.fwdash-db-product-list-dd').css("right","268px");   
                    }
                }
                $('.fwdash-db-top-strip-rhs').css("width",width);
			}
	        else if(self.get("GLOBAL_DATA.IS_RHS_PROMOTION_ENABLED"))
	        {
	            $('.fwdash-db-queue-list').css("padding-left","120px");
	        }
            else if(self.get("layoutParams.DISABLE_RHS"))
            {
                //$('.fwdash-db-queue-list').css("padding-left","5px");
                $('.fwdash-db-product-list-dd').css("right","163.5px");
                $('.fwdash-db-top-strip-rhs').css("width","186.5px");
            }
			self.send("tabSliding", self.get("currentTab"));
		});
	},
	addWidget:function()
	{
		this.set("showAddWidget",true);	
	},
	back:function()
	{
		var self=this;
		this.set("showSettings",true);
		this.set("showButtons",false);
		this.set("GLOBAL_DATA.IS_DASHBOARD_CUSTOMIZABLE",false);
		Ember.run.schedule('afterRender', function()
		{
            /*if(self.get("GLOBAL_DATA.IS_RHS_PROMOTION_ENABLED"))
            {
                $('.fwdash-db-product-list-dd').css("right", "289px");
                $('.fwdash-db-top-strip-rhs').css("width", "289px");
                self.send("tabSliding", self.get("currentTab"));
            }
            else
            {
	             //$('.fwdash-db-product-list-dd').css("right", "41.5px");
	             //$('.fwdash-db-top-strip-rhs').css("width", "41.5px");
	             self.send("tabSliding", self.get("currentTab"));   
            }*/
            if(self.get("layoutParams.DISABLE_RHS"))
            {
                 $('.fwdash-db-product-list-dd').css("right", "42px");
                 $('.fwdash-db-top-strip-rhs').css("width", "42px");
                 self.send("tabSliding", self.get("currentTab"));   
            }
		});
	},
	closeAddWidget:function()
	{
		this.set("showAddWidget",false);
	},
	showAddPopup:function()
	{
		this.set("tabName","");
		this.set("popupTitle",I18NUtil.translate("ads.home.layout.dashboard.add_tab"));
		this.set("buttonName",I18NUtil.translate("ads.home.layout.dashboard.add"));
		this.set("showTabError",false);
		this.set("showAddPopup",true);
		Ember.run.schedule('afterRender', function() 
		{
			$('#TAB_NAME').focus();
		});
	},
	closeAddPopup:function()
	{
		this.set("showTabError",false);
		this.set("showAddPopup",false);
	},
	addTab:function(tabId){
		var self=this;
		var params={};
		var tabName=$('#TAB_NAME').val();
		if(Ember.$.trim(tabName)===''){
			this.set("errorMessage",I18NUtil.translate("ads.home.layout.dashboard.tab_error"));
			this.set("showTabError",true);
			return;
		}
		else if(tabName.length>250){
			this.set("errorMessage",I18NUtil.translate("ads.home.layout.dashboard.tab_name.limit_message"));
			this.set("showTabError",true);
			return;
		}
		params["TAB_NAME"]=tabName;
		params['USER_ID']=this.get("layoutParams.userId");
    params['LAYOUT_ID']=this.get("layoutParams.LAYOUT_ID");
		if(tabId !==null && tabId !=="" && tabId !== undefined ){
			params["TAB_ID"]=tabId;
			AJAXUtil.ajax('/ADSLayoutCustomization.do?mTCall=updateTab', params).then(function(){
				self.set("currentTabId",null);
				var tab=self.get("currentTab");
				Ember.set(tab, 'TAB_NAME',tabName);
				self.set("showAddPopup",false);
			});
			return;
		}
		AJAXUtil.ajax('/ADSLayoutCustomization.do?mTCall=addTab', params).then(function(response){
				self.set('tabs',response);
        var switchToTab = null;
				for(var i=0;i<response.length;i++){
					var tab=response[i];
					/*if(tab.IS_CUSTOMIZABLE){
						self.set("showDropDown",true);
					}*/
          if(tab.IS_SELECTED){
            switchToTab = tab;
            break;
          }
					if(tab.TAB_NAME===tabName){
            switchToTab = tab;
					}
				}
        if(switchToTab!=null){
						self.send("changeTab",tab,false);
          Ember.run.schedule('afterRender', function(){self.send("tabSliding", switchToTab);});
						self.get('referenceObject')["COMPONENT"].send('setActiveTab', tab.TAB_ID);
					}
				self.set("showAddPopup",false);
			});
	},
	deleteTabConfirmMessage:function(tabId)
	{
		var self=this;
		this.set("tabChange",false);
		DialogUtil.confirm(self,'ads.home.layout.dashboard.delete_confirm_message','deleteTab','ads.home.layout.dashboard.yes',tabId,null);//No I18N
	},
	lockedTab:function()
	{
		this.set("tabChange",false);
	},
	deleteTab:function(tabId)
	{
		var self=this;
		//this.set("showDropDown",false);
		var currentTabId=this.get('GLOBAL_DATA.TAB_ID');
		var params={};
		params['TAB_ID']=tabId;
		params['USER_ID']=this.get("layoutParams.userId");
    params['LAYOUT_ID']=this.get("layoutParams.LAYOUT_ID");
		AJAXUtil.ajax('/ADSLayoutCustomization.do?mTCall=removeTab', params).then(function(response){
				self.set('tabs',response);
				var currentTab=self.get("currentTab");
				if(tabId === currentTabId){
					if(response.length>0){
						var currentTab=response[0];
						currentTabId=currentTab.TAB_ID;
						self.send("changeTab", currentTab,false);
					}
				}
				Ember.run.schedule('afterRender', function(){self.send("tabSliding", currentTab);});
				self.get('referenceObject')["COMPONENT"].send('setActiveTab', currentTabId);
		});
	}
  }
});

//ignorei18n_end	
