/* $Id: db-migration.js,v 1.24 2018/11/13 19:22:54 dineshbabu.k Exp $ */
	//ignorei18n_start
	import Ember from 'ember';											
	import $ from 'jquery';												
	import DialogUtil from "../utils/ads-dialog-util"; 			
	import I18NUtil from "../utils/i18n-util";					
	import ValidationUtil from "../utils/ads-validation-util"; 		
	import CommonUtil from "../utils/ads-common-util"; 			
	import AJAXUtil from '../utils/ads-ajax-util'; 				
	
	export default Ember.Component.extend
	({
		classNameBindings :['styleNameSpace'],
		styleNameSpace:'fw',
		pageStatus : {},
		RESTART_REQUIRED:false,
		MIGRATION:false,
		BCP_STATUS: [],
		limitReset:true,
		AUTH_MODE:'sql',
		useWindowsAuthentication:false,
		preventLink:false,
		getDBSettings:function()
		{
			var servers = [];
			var response=AJAXUtil.syncAjax('/RestAPI/WC/ChangeDBAPI?operation=getDBSettings',{});
			this.set('DB_SETTINGS',response['ACTIVEDB']);
			this.set('DEFAULT_SETTINGS',JSON.parse(JSON.stringify(response['ACTIVEDB'])));
			this.set('INTEGRATED_PRODUCTS',response['INTEGRATED_PRODUCTS']);
			servers.push({CLIENT_VALUE :I18NUtil.translate("ads.admin.dbmigration.db_postgres"), SERVER_VALUE :'postgres'},{CLIENT_VALUE :I18NUtil.translate("ads.admin.dbmigration.db_mssql"), SERVER_VALUE :'mssql'});
			this.set('SERVERS',servers);						
			if(this.get('DB_SETTINGS').SERVER=='mssql'){    	
				this.set('pgserver',false);						
				var instance=this.get('DB_SETTINGS').INSTANCES;
				if('sSTATUS' in instance){	
					var instances=instance['sSTATUS'];
					var temp=[];
					for(var i=0;i<instances.length;i++)
					{
						temp.push({CLIENT_VALUE:String(instances[i]),SERVER_VALUE:String(instances[i])});
					}
					this.set('MS_INSTANCES',temp);	}			
			}
			else{
				this.set('pgserver',true);
			}					
		}.on('init'),
		didInsertElement : function(){
					Ember.run.scheduleOnce('afterRender', this,function()
			{
				var server=this.get('DB_SETTINGS').SERVER;  
				if(server=='mssql')
				{	
					if((this.get('DB_SETTINGS').BCP))
					{
						$('#BCP_EXEs .file-upload-placeholder').val("bcp.exe");
						$('#BCP_RLLs .file-upload-placeholder').val("bcp.rll");
					}
					if(this.get('DB_SETTINGS').DOMAINNAME!=undefined||this.get('DB_SETTINGS').DOMAINNAME!=null){
						this.set('DB_SETTINGS.USERNAME',this.get('DB_SETTINGS.DOMAINNAME')+"\\"+this.get('DB_SETTINGS.USERNAME'));
						this.send('authentication','{"columnValue":"windows"}');
						this.set('useWindowsAuthentication',false);
						}
					else if(this.get('DB_SETTINGS').USERNAME!=undefined||this.get('DB_SETTINGS').USERNAME!=null){
						this.send('authentication','{"columnValue":"sql"}');
						} 
					else{
					this.send('authentication','{"columnValue":"windows"}');
						this.set('useWindowsAuthentication',true);
						}
						this.send("portChange");
				}
			});
			},
		
		getSQLInstances:function(param)
		{
			var self=this;
			var name=$('#HOST').val();
			if(param=='HOSTCHANGE')		 
			{
				if(name!="")
				{
				CommonUtil.showLoading();
				var data={};
				data['HOST_NAME']=name;															
				data['PRODUCTS']=JSON.stringify(self.get('INTEGRATED_PRODUCTS'));  
				var response=AJAXUtil.syncAjax('/RestAPI/WC/ChangeDBAPI?operation=getMSSQLSettings',data);
				CommonUtil.hideLoading();
					self.set('BCP_STATUS',response['BCP']);													
					if('eSTATUS' in response)
					{	
						var resp=String(response['eSTATUS']);
						DialogUtil.alert(self,resp);						
					}						
					else{
						var data=response['sSTATUS'];								
						self.set('INSTANCES',data);									
						var details=data[0].split(";");								
						self.set('DB_SETTINGS.HOST',details[0]);
						self.set('DB_SETTINGS.PORT',details[2]);
						var temp=[];
						for(var i=0;i<data.length;i++)
						{
							temp.push({CLIENT_VALUE:String(data[i]),SERVER_VALUE:String(data[i])});
						}
						self.set('MS_INSTANCES',temp); 
						if('eSTATUS' in response['BCP']){
							$('#BCP_EXEs .file-upload-placeholder').val("");
							$('#BCP_RLLs .file-upload-placeholder').val("");}
						else{$('#BCP_EXEs .file-upload-placeholder').val("bcp.exe");
							$('#BCP_RLLs .file-upload-placeholder').val("bcp.rll");}
					}
				}
			}
			else{
				var data=$('#INSTANCE').val();
				if(data!=null)
				{
				var details=data.split(";");
				self.set('DB_SETTINGS.HOST',details[0]);
				self.set('DB_SETTINGS.PORT',details[2]);
				}
			}
			if(param=='MS SQL Server'){
			if(this.get('DEFAULT_SETTINGS').SERVER==this.get('DB_SETTINGS').SERVER)
				{
					this.set('DB_SETTINGS',JSON.parse(JSON.stringify(this.get('DEFAULT_SETTINGS'))));
					if(this.get('DB_SETTINGS').DOMAINNAME!=undefined||this.get('DB_SETTINGS').DOMAINNAME!=null){
						this.set('DB_SETTINGS.USERNAME',this.get('DB_SETTINGS.DOMAINNAME')+"\\"+this.get('DB_SETTINGS.USERNAME'));
						this.set('limitReset',true);
						this.send('authentication','{"columnValue":"windows"}');
						this.set('useWindowsAuthentication',false);}
					else if(this.get('DB_SETTINGS').USERNAME!=undefined||this.get('DB_SETTINGS').USERNAME!=null){
						this.set('limitReset',true);
						this.send('authentication','{"columnValue":"sql"}');
					} 
						else{
							this.set('useWindowsAuthentication',true);
						}
				}
				else {
						this.resetServerDetails();
						this.set('useWindowsAuthentication',false);
						this.set('WIN_AUTH',false);
				}
			}
		},
		validation:function(configure)
		{
			var self=this;
			var products=this.get('INTEGRATED_PRODUCTS');
			$('#PRODUCTS').val(JSON.stringify(self.get('INTEGRATED_PRODUCTS')));
			var DBSettings=this.get('DB_SETTINGS');
			var count=this.get('INTEGRATED_PRODUCTS').filterBy('IS_ENABLED',true).get('length');
			if(count==0&&configure){
				DialogUtil.alert(self,I18NUtil.translate('ads.admin.dbmigration.product_select_alert'));return false;}   
			if(DBSettings.HOST==''||DBSettings.HOST==undefined||!ValidationUtil.isValidServerName(DBSettings.HOST)){
				DialogUtil.alert(self,I18NUtil.translate('ads.admin.dbmigration.host_alert'));return false;}     
			if(DBSettings.PORT==''||DBSettings.PORT==undefined||!ValidationUtil.isValidPort(DBSettings.PORT)){
				DialogUtil.alert(self,I18NUtil.translate('ads.system.changedb.alert_invalid_port'));return false;}
			if((DBSettings.PORT>=49152)&&DBSettings.SERVER=='mssql'){
				DialogUtil.alert(self,I18NUtil.translate('ads.system.changedb.alert_sql_dynamic_port'));return false;}
			for(var i=0;i<products.length;i++){	
				var product= products[i];							
				if(product.IS_ENABLED&&(product.DB==''||product.DB==undefined || product.DB.length>63)&&configure){
					DialogUtil.alert(self,I18NUtil.translate('ads.admin.dbmigration.dbname_alert'));return false;}   
				if(product.IS_ENABLED&&(!(/^[a-zA-Z0-9_]*$/.test(product.DB))||(/^\d/.test(product.DB)))){
					DialogUtil.alert(self,I18NUtil.translate('ads.admin.dbmigration.dbname_exception'));return false;}
			} 
			if(!this.get('useWindowsAuthentication')&&(DBSettings.USERNAME==''||DBSettings.USERNAME==undefined)){
				DialogUtil.alert(self,I18NUtil.translate('ads.admin.dbmigration.username_alert'));return false;}
			if(DBSettings.SERVER=='mssql'&&!this.get('useWindowsAuthentication')&&this.get('AUTH_MODE')=='windows'&&!ValidationUtil.isDomainAccountName(DBSettings.USERNAME)){
				DialogUtil.alert(self,I18NUtil.translate('ads_admin_product_settings_ha_userName_format_error'));return false;
				}  
			if(configure&&DBSettings.SERVER=='mssql'&&'eSTATUS' in this.get('BCP_STATUS') &&(($("#BCP_EXE").get(0).files.length==0)||$("#BCP_RLL").get(0).files.length==0)){
				DialogUtil.alert(self,this.get('BCP_STATUS')['eSTATUS']);return false;}     
			if(configure && $("#BCP_EXE").get(0).files.length!=0 && $("#BCP_RLL").get(0).files.length!=0 &&(($("#BCP_EXE").get(0).files[0].size/1000>2000)||($("#BCP_RLL").get(0).files[0].size/1000>2000))	)
			{
				DialogUtil.alert(self,I18NUtil.translate('ads.iam_security.error.file_size_more_than_allowed_size'));return false;
			}
			return true;
		},
		resetServerDetails:function()
		{
			this.set('DB_SETTINGS.HOST','');	
			this.set('DB_SETTINGS.PORT','');
			if(!this.get('pgserver')){
			this.set('MS_INSTANCES','');
			$('#BCP_EXEs .file-upload-placeholder').val("");
			$('#BCP_RLLs .file-upload-placeholder').val("");
			$('#BCP_EXE').val("");
			$('#BCP_RLL').val("");
			this.set('AUTH_MODE','sql');}
			this.resetCredentials();
		},
		resetCredentials:function()
		{
			this.set('DB_SETTINGS.USERNAME','');
			this.set('DB_SETTINGS.DOMAINNAME','');
			$('#PASSWORD').val('');	
		},
	
		actions:
		{	
		selectAll:function(value)
		{
			this.get("INTEGRATED_PRODUCTS").setEach('IS_ENABLED',value);		
		},
		enableDisable:function(value,index)
		{
			var products=this.get('INTEGRATED_PRODUCTS');     
			Ember.set(products.objectAt(index),'IS_ENABLED',value);					
			this.set('INTEGRATED_PRODUCTS',products);		
			
			var count=this.get('INTEGRATED_PRODUCTS').filterBy('IS_ENABLED',true).get('length');
			if(count==0)
			{
				DialogUtil.alert(this,I18NUtil.translate('ads.admin.dbmigration.product_select_alert'));
			}
			if(count==products.length){
			Ember.$('#FULL_SELECT').prop('checked', true);
					$('#FULL_SELECT').iCheck('update');}										
			if(!value){
			Ember.$('#FULL_SELECT').prop('checked', false);
					$('#FULL_SELECT').iCheck('update');}				
		},	
		fileUploadAction:function(param)
		 {
			 var self=this;
			 var val=$('[name="'+param+'"]').val().split('\\').pop();
			 if((param == "BCP_EXE" && val.indexOf("bcp.exe")==-1) || (param == "BCP_RLL" && val.indexOf("bcp.rll")==-1))
			 {
				 DialogUtil.alert(self,I18NUtil.translate('ads.admin.dbmigration.invalid_bcpfile_exception'));
				 $('#'+param+'s .file-upload-placeholder').val("");
				 $('#'+param).val("");
			 }
			 else{
			 $('#'+param+'s .file-upload-placeholder').val(val);
			 }
		},
		serverChange:function(param)
		{	
			if($('#FORM_STATUS')){
				$('#FORM_STATUS').hide();}
			if(this.get('DB_SETTINGS.SERVER')=='mssql')										
			{
				this.set('pgserver',false);					
				this.getSQLInstances(param);	
			}
			else{if(param!='HOSTCHANGE'){
				this.set('placeHolderText','');
				this.set('pgserver',true);		
				this.set('useWindowsAuthentication',false);
				if(this.get('DEFAULT_SETTINGS').SERVER==this.get('DB_SETTINGS').SERVER)
				{
					this.set('DB_SETTINGS',JSON.parse(JSON.stringify(this.get('DEFAULT_SETTINGS'))));}
				else {
					this.resetServerDetails();}
				}
			}
		},
	
		portChange()
		{
			if(this.get('DB_SETTINGS.SERVER')=='mssql' && Ember.$.trim(this.get('DB_SETTINGS.HOST'))!='')
			{
				let instances = this.get('MS_INSTANCES');
				let port = this.get('DB_SETTINGS.PORT');
				let selectInstance = instances.filter((instance)=>{ return instance.CLIENT_VALUE.indexOf(port) != -1; });
				if(selectInstance.length)
				{
					Ember.$('#INSTANCE').val(selectInstance[0].CLIENT_VALUE).change();
				}
			}
		},
	
		migrate:function(value)
		{
			this.set('MIGRATION',value);	
			if(value)
			{
				DialogUtil.confirm(this,I18NUtil.translate('ads.admin.dbmigration.migrate_alert'),null,null,null,null,'migrate',false);
			}
		 },
		 showModes:function(value)
		 {
			 this.set('useWindowsAuthentication',value);
			 if(value)
			 {
				 this.resetCredentials();
			 }
		 },
		 authentication:function(value)
			{
				var selectedAuthentication = JSON.parse(value).columnValue;
				if(selectedAuthentication == 'sql')
				{
					this.set('WIN_AUTH',false);
					this.set('useWindowsAuthentication',false);
					this.set('placeHolderText','');
				}
				else{
				this.set('useWindowsAuthentication',true);
					this.set('WIN_AUTH',true);
					this.set('placeHolderText', I18NUtil.translate('ads_admin_product_settings_ha_credentials_popup_user_placeholder'));
					Ember.$('#USERNAME').val('');
				}
				this.set('AUTH_MODE',selectedAuthentication);
				if(!this.get('limitReset')){			
					this.resetCredentials();	}	
				this.set('limitReset',false);
			},
		 testConnection:function()
		 {		
			if(this.get('preventLink')!=true)
			{
			var self=this;
			if(this.validation(false)){
			var DBSettings=this.get('DB_SETTINGS');	
			CommonUtil.showLoading();
			var data={};
			data['HOST']=DBSettings.HOST;
			data['PORT']=DBSettings.PORT;
			data['SERVER']=DBSettings.SERVER;
			data['AUTHENTICATION']=this.get('useWindowsAuthentication');
				data['USERNAME']=DBSettings.USERNAME;
				data['DOMAIN']=null;
				if(DBSettings.SERVER=='mssql'&&this.get('AUTH_MODE')=='windows'&&!(this.get('useWindowsAuthentication')))
				{
					data['AUTHENTICATION']=true;
					data['USERNAME']=DBSettings.USERNAME.split("\\")[1];
					data['DOMAIN']=DBSettings.USERNAME.split("\\")[0];
				}
				
				data['PASSWORD']=$('#PASSWORD').val();
				data['INSTANCE']=$('#INSTANCE').val();
			AJAXUtil.ajax('/RestAPI/WC/ChangeDBAPI?operation=testConnection',data).then(function(response) 
			{
				CommonUtil.hideLoading();
				if('eSTATUS' in response){
						var resp=String(response['eSTATUS']);
							if(resp.indexOf("\n")!=-1)
						{
						DialogUtil.alert(self,resp); 
						}
						else{
						self.sendAction('showStatus','danger',I18NUtil.translate(response['eSTATUS']),false);
					}	
				}
				else{
					self.sendAction('showStatus','success',I18NUtil.translate(response['sSTATUS']),true);
				}
			}); 
			}
			}
		},
		configureDB:function(value)
		{
			var self=this;
			var data={};
			var DBSettings=this.get('DB_SETTINGS');
			data['HOST']=DBSettings.HOST;
			data['PORT']=DBSettings.PORT;
			data['SERVER']=DBSettings.SERVER;
			data['USERNAME']=DBSettings.USERNAME;
			data['DOMAIN']=null;
				data['AUTHENTICATION']=this.get('useWindowsAuthentication');
				if((DBSettings.SERVER=='mssql')&&(!this.get('useWindowsAuthentication'))&&(this.get('AUTH_MODE')=='windows'))
				{
					data['AUTHENTICATION']=true;
					data['USERNAME']=DBSettings.USERNAME.split("\\")[1];
					data['DOMAIN']=DBSettings.USERNAME.split("\\")[0];
				}
			data['PASSWORD']=$('#PASSWORD').val();
			data['INSTANCE']=$('#INSTANCE').val();
			data['RESTART_REQUIRED']=value;
			data['PRODUCTS']=JSON.stringify(this.get('INTEGRATED_PRODUCTS'));
			var isParentProductEnabled=this.get('INTEGRATED_PRODUCTS').findBy('NAME','AD360').IS_ENABLED;
			CommonUtil.showLoading();
			AJAXUtil.ajax('/RestAPI/WC/ChangeDBAPI?operation=configureDB',data).then(function(response) 
			{
				CommonUtil.hideLoading();
				if('eSTATUS' in response){
						var resp=String(response['eSTATUS']);
						resp=resp.trim();
					if(resp.indexOf("\n")!=-1)
					{
						DialogUtil.alert(self,response.eSTATUS); 
					}
					else{
						 self.sendAction('showStatus','danger',I18NUtil.translate(response['eSTATUS']),false);
					}	
				}
				else{
					if(isParentProductEnabled){
						$("#save").prop( "disabled", true);
						$("#cancel").prop("disabled", true);
						self.set('preventLink',true);
					}
					self.sendAction('showStatus','success',I18NUtil.translate(response['sSTATUS']),true);
					}}); 
			},
			configPreCheck:function(value)
			{	
			var self=this;
			
			this.get("INTEGRATED_PRODUCTS").setEach('IS_ERROR',false);		
			var isParentProductEnabled=this.get('INTEGRATED_PRODUCTS').findBy('NAME','AD360').IS_ENABLED;
			if(this.validation(true))
			{ 
				CommonUtil.showLoading();
				$('[id="ChangeDBForm"]').submit();
					Ember.$('#MigrateDBIFrame').load(function(responseData) {
						CommonUtil.hideLoading();
						 var responseText =$("#MigrateDBIFrame").contents().find("body").text();
						 var responseHtml =$("#MigrateDBIFrame").contents().find("body").html();
						 try{
							var response=Ember.$.parseJSON(responseText);}
						 catch(e){
							 AJAXUtil.handleSessionTimeout("403", responseHtml);}
						if(response.hasOwnProperty('ERROR_CODE') && response.ERROR_CODE=='00000014'){
							self.sendAction('showStatus','danger',I18NUtil.translate('ads.common.error.demo_mode'),false);
							return;
						}
						if('eSTATUS' in response)
						{
						 var result=String(response['eSTATUS']);						
						 if(result.includes(I18NUtil.translate('ads.admin.text.db_exist')))					
						 {
							 var id=JSON.parse(response['ID']);
							 var products=self.get('INTEGRATED_PRODUCTS');				
							 for(var ii=0;ii<id.length;ii++)
							 {
								 Ember.set(products.findBy('ID',id[ii]),'IS_ERROR',true);			
							 } 
						 }
						 else{
							 var resp=String(response['eSTATUS']);
							 if(resp.indexOf("\n")!=-1)
							 {
								DialogUtil.alert(self,resp); 
							 }else{
								self.sendAction('showStatus','danger',I18NUtil.translate(response['eSTATUS']),false);
							}
							 } 
						}
						else{
						if(!self.get('MIGRATION')){
						 DialogUtil.confirm(self,I18NUtil.translate('ads.admin.dbmigration.confirm_restart'),'configureDB',I18NUtil.translate('ads.admin.dbmigration.product_restart_now'),true,null,'configureDB',false,I18NUtil.translate('ads.admin.dbmigration.product_restart_later'));}
						else{
							if(isParentProductEnabled){
								$("#save").prop( "disabled", true);
								$("#cancel").prop("disabled", true);
								self.set('preventLink',true);
							}
							self.sendAction('showStatus','success',I18NUtil.translate(response['sSTATUS']),true);
						}
						}
				});
			}},
			cancel:function()
			{	
			Ember.$('#FULL_SELECT').prop('checked', false);
					$('#FULL_SELECT').iCheck('update');
			this.set('MS_INSTANCES','');
			this.resetServerDetails();
			this.getDBSettings();	
			this.didInsertElement();
			this.set('limitReset',true);
			this.set('useWindowsAuthentication',false);	
			}
		}
	});
		//ignorei18n_end
	