/* $Id$ */
import Ember from 'ember';//NO I18N
import I18NUtil from "../utils/i18n-util"; //NO I18N

export default Ember.Component.extend
({
	classNameBindings :['styleNameSpace'],
	styleNameSpace:'fw',//No i18n
	openDialog : function() 
	{
		var self=this;
		var boxName = this.get('pageStatus.show');//NO I18N
		if(boxName !=null && boxName !='')
		{
			Ember.$(self.get('element')).find('.modal').modal();
			self.$('#'+boxName).css('display', 'block');

			//Auto Focus on Action Button
			setTimeout(function() {self.$('#'+boxName+' .btn-primary').focus()}, 700);			
		}
		else
		{
			Ember.$(self.get('element')).find('.modal').modal('hide');//NO I18N
		}

	}.observes('pageStatus.show'),//NO I18N

	willDestroyElement: function(){
		this.$().find('.modal').off('hidden');//No i18n
		this.$('[aria-controls]').off('click');//No i18n
	},

	actions:
	{
		closeDialog : function()
		{
			//This will again call openDialog and hide the modal
			this.set('pageStatus.show', '');//NO I18N
			this.set('pageStatus.CB_FUN_PARAMS', '');//NO I18N
			this.set('pageStatus.CANCEL_CB_FUN_PARAMS', ''); //No I18N

			if(this.$('#ALERT_BOX')!=undefined)
			{
				this.$('#ALERT_BOX').css('display', 'none');
			}
			if(this.$('#CONFIRM_BOX')!=undefined)
			{
				this.$('#CONFIRM_BOX').css('display', 'none');
			}
			if(this.$('#CREDENTIAL_BOX')!=undefined)
			{
				this.send('closeAlert');//NO I18N
				this.$('#CREDENTIAL_BOX').css('display', 'none');
			}
			Ember.$('body').removeClass('modal-open');
		},
		cancelCallBck:function()
		{
			var _this = this.get('pageStatus.CB_OBJ_NAME');//NO I18N
			if(_this==undefined) _this = this;
			if(this.get('pageStatus.CANCEL_CB_FUN_NAME')!=undefined)
			{
				_this.sendAction('pageStatus.CANCEL_CB_FUN_NAME', this.get('pageStatus.CANCEL_CB_FUN_PARAMS'));//NO I18N
			}
			this.send('closeDialog');//NO I18N
		},
		
		callBckFunc : function()
		{
			var status={};
			var _this = this.get('pageStatus.CB_OBJ_NAME');//NO I18N
			if(_this==undefined) _this = this;

			if(this.get('pageStatus.VALIDATE')!= undefined)
			{
				status = _this.validateCredentials(this.get('pageStatus.CB_FUN_PARAMS'));//NO I18N

				if(status.STATUS == 'eSTATUS')
				{
					this.send('showStatus', 'danger', status.MESSAGE);//NO I18N
					return;
				}
			}

			if(this.get('pageStatus.WAIT_FOR_RESPONSE')!=undefined)
			{
				status = _this.getResponse(this.get('pageStatus.CB_FUN_PARAMS'));//NO I18N

				if(status.eSTATUS)
				{
					this.send('showStatus', 'danger', I18NUtil.translate(status.eSTATUS));//NO I18N
					return;
				}	
			}
			else
			{
				_this.sendAction('pageStatus.CB_FUN_NAME', this.get('pageStatus.CB_FUN_PARAMS'));//NO I18N
			}

			this.send('closeDialog');//NO I18N
		},

		showStatus:function(alertType,message,id)
    	{
      		var self=this;
      		self.$(".mini-status-alert").hide();
      		self.set('configStatusMessage', message);//NO I18N
      		self.set('configStatusAlertType', alertType);//NO I18N
      		self.$(".mini-status-alert").delay(500).slideDown('slow');
      		if(alertType=='success')
      		{
        		self.$(".mini-status-alert").delay(500).slideUp('slow'); 
      		}
      		Ember.$('[aria-controls]').unbind('click');
      		Ember.$('[aria-controls]').on('click',function(){
        		if(Ember.$(this).attr('aria-controls')!=id)
        		{
          			self.$(".mini-status-alert").delay(50).slideUp('slow');   
        		}
      		});
    	},

    	closeAlert: function() 
    	{
      		this.$(".mini-status-alert").delay(50).slideUp('slow');
    	}
	},

	didInsertElement:function()
	{
		var self=this;
		Ember.run.scheduleOnce('afterRender',function() //NO I18N
		{	
			Ember.$(self.get('element')).find('.modal').on('hidden.bs.modal',function()//NO I18N
			{
				self.send('closeDialog'); //NO I18N
				self.sendAction();		
			});
		});
		
	}
});