/*
 $Id$
*/
import Ember from 'ember';//NO I18N
import AJAXUtil from 'webclient/utils/ajax-util'; //NO I18N
import CommonUtil from "webclient/utils/common-util"; //NO I18N
import DialogUtil from "webclient/utils/dialog-util"; //NO I18N
import I18NUtil from "webclient/utils/i18n-util"; //NO I18N
//ignorei18n_start
export default Ember.Component.extend
({
	
	searchBoxProps:'',
	pageStatus: {},
	searchEmp:true,
	showSearchBox:true,
	defaultTabHeight:'125px',
	getSearchBox:function(flag)
	{
		var params={};
		params['REQUEST_TYPE']='JSON';
		params['ISLOGGED']='AuthenticatedAccess';
		var response = AJAXUtil.syncAjax('/EmployeeSearch.do?mTCall=fetchEmployeeSearchBox', params);
	    this.set('showAlertMsg',false);
	    if(response.length)
		{ 
			this.set('showSearchBox',true);
			this.set('searchBoxProps',response);
			this.setTabHeight();
		}
		else
		{
			if(response.ERROR_MESSAGE !== undefined &&  response.ERROR_MESSAGE ==='ads.home.employee_search.component_notintegrated')
			{
				if(!flag)
				{
				  this.set('showSearchBox',false);
				}
				else
				{
				  this.set('showAlertMsg',true);	
				}
			}
			else 
			{  
			    this.set('showAlertMsg',true);	
			}
			
		}
		this.send('addTickIcon','employee-filters' ,'ALL_FIELDS');
		this.send('addTickIcon','employee-conditions' ,'contains');
		
	}.observes('status').on('init'),
	setTabHeight:function()
	{
		var searchProps=this.get('searchBoxProps');
		for(var i=0;i<searchProps.length;i++)
		{
			var tabDetails=searchProps[i];
			if(tabDetails.showTab)
			{
				tabDetails["tabHeight"]=((tabDetails.attrDetails.length>5?5:tabDetails.attrDetails.length)*25);
				searchProps[i]=tabDetails;
			}
		}
		this.set('searchBoxProps',searchProps);
	},
	getSearchOpts : function(container)
	{
			var selFields	="";
			var fields=document.getElementById(container).getElementsByTagName("li");
			for(var i=0; i<fields.length; i++)
	        {
				var fId = fields[i].id;
				if($("#"+fId).children().hasClass("fwemp-icn-tick") && $("#"+fId).children().hasClass("fwemp-icon"))
				{
					selFields += (selFields !="" ? ";;;"+fId : fId);
				}
			}
			return selFields;
	},
	actions:
	{
		openSearchBox : function()
		{
			var self=this;
			self.set('searchEmp',true);
			$(document).on("click",function(e)
			{
				  if($("#SearchString").val() === I18NUtil.translate('ads.home.employee_search.search_box.search'))
				  {
					  $("#SearchString").val("");
				  }
				  if(!$(e.target).closest("#employeeSearch").length)
				  {			
                      if($("#SearchString").val() === "")
					  {
						  $("#SearchString").val(I18NUtil.translate('ads.home.employee_search.search_box.search'));
					  }			  
					  $("#employeeSearch").removeClass("open");
					  $("#dropDownArrow").removeClass("open");
				  }
			});
			$( "#employeeSearch" ).keypress(function(event) {
		       if(event.which === 13 && self.get('searchEmp')&& $("#employeeSearch").hasClass("open") && !($("#dropDownArrow").hasClass("open")))
			   {
				   self.send('employeeSearch');
			   }
			});
			if(!($("#employeeSearch").hasClass("open")))
			{
			    this.getSearchBox(true);
			    if(this.get('showAlertMsg'))
			    {
					$("#SearchString").val(I18NUtil.translate('ads.home.employee_search.search_box.search'));	
					var errorMsg=[];
					errorMsg.push(I18NUtil.translate('ads.home.employee_search.product_down'));
					errorMsg.push(I18NUtil.translate('ads.home.employee_search.feature_disabled'));
					errorMsg.push(I18NUtil.translate('ads.home.employee_search.old_version'));
					var str="<div style=\"text-align:left\"><div style=\"padding-left:5px\">"+
					I18NUtil.translate('ads.home.employee_search.unable_to_search')+":</div><br><ul>";
					Ember.$.each(errorMsg,function(){
						str=str+"<li style=\"padding-left:10px\">"+this;
					});
					str=str+"</ul></div>";
				    self.send('showAlertBox',str);
			    }
				else
			    {
				    $("#employeeSearch").addClass("open");
			    }
			}
			$("#SearchString").focus(); 
			if($("#dropDownArrow").hasClass("open"))
			{
				$("#dropDownArrow").removeClass("open");
			}
		},
		
		openDropDown : function()
		{
			if(!($("#dropDownArrow").hasClass("open")) && $("#employeeSearch").hasClass("open"))
			{
			     $("#dropDownArrow").addClass("open");
			}
			else
			{
				 $("#dropDownArrow").removeClass("open");
			}
			
		},
		openAttributeDropDown : function(id,height)
		{
			 $("#"+id).toggleClass("open");
			 if($("#"+id).find('.fwemp-custom-scroll-hover').attr('data-height')===this.get('defaultTabHeight'))
			 {
				  $("#"+id).find('.fwemp-custom-scroll-hover').height($("#"+id).find('.fwemp-custom-scroll-hover').attr('data-height')).css({
 	                 "overflow": "hidden"
 	             }); 
			 }
 	         $("#"+id).find('.fwemp-custom-scroll-hover').mCustomScrollbar({
 	             theme: "dark",
 	             autoHideScrollbar: true,
 	             callbacks: {
 	                 onScroll: function (evt) {
 	                     return false;
 	                 },
 	                 onTotalScroll: function (evt) {
 	                     return false;
 	                 },
 	                 onTotalScrollBack: function (evt) {
 	                     return false;
 	                 }
 	 
 	             }
 	         });
		},
		addTickIcon : function(selId,id,tabId)
		{	
			if(tabId)
			{
				$("#"+tabId).find(".fwemp-icn-tick").removeClass("fwemp-icon");
				$("#ALL_FIELDS").children().removeClass("fwemp-icon");
				$("#"+id).children().addClass("fwemp-icon");
			}
			else
			{
				$("."+selId+" .fwemp-icn-tick").removeClass("fwemp-icon");
				$("#"+id).children().addClass("fwemp-icon");
				if(selId =='employee-filters')
			    {
					$(".attrTempClass").removeClass("open");
			    }
			}
			
		},
		employeeSearch: function()
		{
			var self=this;
			var params={};
			var val = $.trim($("#SearchString").val());
			params['REQUEST_TYPE']='JSON';
            params['searchString']=val;
			self.set('searchEmp',false);
			$("#SearchString").blur(); 
			$("#dropDownArrow").removeClass("open");
			if(val === '')
			{
			       self.send('showAlertBox','ads.home.employee_search.search_string.not_null');
			}
			else
			{
				 var searchType=this.getSearchOpts("SEARCH_TYPE");//NO I18N
				 var searchBy=this.getSearchOpts("SEARCH_BY");				 
				 params['searchType']=searchType;
				 params['searchBy']=searchBy;
				 params['actionId']='Search';
				 if(window.EMP_SEARCH_TOKEN === undefined)
				 {
					 window.EMP_SEARCH_TOKEN=1;
				 }
				 var searchToken=window.EMP_SEARCH_TOKEN+1;
				 window.EMP_SEARCH_TOKEN=searchToken;
                 CommonUtil.showTextLoading();			 
				 var loading={};
				 loading['isLoading']=true;
				 self.sendAction('searchResult',loading);
				 AJAXUtil.ajax('/EmployeeSearch.do?mTCall=fetchEmployeeSearchResult',params)
                 .then(function(response)
				 {	 
				    if(searchToken === window.EMP_SEARCH_TOKEN)
					{
						self.sendAction('searchResult',response);
					    CommonUtil.hideTextLoading();	
					}
				 });
			}
		},
		showAlertBox:function(msg)
		{
			 var self=this; 
			 var alertMessage={};
			 alertMessage['ALERT']=true;
			 alertMessage['MESSAGE']=msg;
			 self.sendAction('searchResult',alertMessage);
		},
		
	}
	
});
//ignorei18n_end