/*
 * $Id$
 */
import Ember from 'ember';//No I18N
import AJAXUtil from '../../utils/ajax-util'; //NO I18N
import ValidationUtil from "../../utils/validation-util";//No I18N
//ignorei18n_start
export default Ember.Component.extend({
    productDetails:{},
    
    didInsertElement : function(){
        this.set('adscomponentsObj',this);
        
        var self = this;
        self.set('productDetails.IS_INTEGRATED',{});
        self.set('feedbackForms' ,self.get('adscomponentsData.FEEDBACK_FORMS'));
        //Rendering tooltip display on hover
        $('[data-toggle="tooltip-component"]').tooltip({trigger:"manual"})
                    .on("mouseenter", function () {
                    var _this = this;
                    $(this).tooltip("show");
                    $('[role="tooltip"]:visible').on("mouseleave", function () {
                        $(_this).tooltip('hide');
                    });
                    }).on("mouseleave", function () {
                    var _this = this;
                    setTimeout(function () {
                        if (!$('[role="tooltip"]:hover').length) {
                            $(_this).tooltip("hide");
                        }
                    }, 300);
                });
		//Rendering custom scroll		
        Ember.run.schedule('afterRender', function() 
        {
            Ember.$(".fw-components-custom-scroll").each(function () 
            {
                $(this).mCustomScrollbar(
                {
                    theme:"dark",//NO I18N
                    autoHideScrollbar: true,
                    scrollInertia: 500,
                    callbacks:
                    {
                        onScroll: function (evt) 
                        {
                            return false;
                        },
                        onTotalScroll: function (evt) 
                        {
                            return false;
                        },
                        onTotalScrollBack: function (evt) 
                        {
                            return false;
                        }
                    }
                });
            });	
        });
    },
    refreshProductDetails : function(){
        var self = this;
        return new Ember.RSVP.Promise(function(resolve, reject){

            var params = {"GET_PRODUCT_DETAILS":true};
            AJAXUtil.ajax('/RestAPI/WC/FeedbackAction?mTCall=getFeedbackStatus',{feedbackDetails : JSON.stringify(params)}).then(function(json){
                var productSettings = json.PRODUCT_SETTINGS;
                self.setProductDetails(productSettings).then(function(value){
                    resolve(true);
                });
            });  
        });   
    },
    setProductDetails : function(productSettings){
        var self = this;
        return new Ember.RSVP.Promise(function(resolve, reject){
            var hasIntegration = false;
            Object.keys(productSettings).forEach(function(key){
                var value = productSettings[key];

                if(value.hasOwnProperty("IS_INTEGRATED")){
                    self.set('productDetails.IS_INTEGRATED.'+key,true);
                        hasIntegration = true;
                }
                else{
                    self.set('productDetails.IS_INTEGRATED.'+key,false);
                }
            });
        self.set('productDetails.HAS_INTEGRATION',hasIntegration);
        resolve(true);    
        });  
    },
    actions : {
        constructForm : function(currentForm){
            var self = this;
            $(currentForm).slideUp("slow",function(){
                self.refreshProductDetails().then(function(value){ //Check for current product integration status
                    if(self.get('productDetails.HAS_INTEGRATION')){
                        $('.adsComponents').slideDown("slow");
                    }
                    else{
                        self.set('adscomponentsData.INFO_STATUS','ads.feedback.form.error_status.integrate_components');
                        $('.getInfo').slideDown("slow");
                        setTimeout(function(){
                            $('.getInfo').slideUp("slow"); 
                        },5000);
                    }
                });
            });  
        },
        closeForm : function(className){
            var self=this;
            this.get('referenceObj').send('closeForm',className);
            setTimeout(function(){
                self.send('resetSecondaryFields',className);
				$('.getLicCount #COMPONENTS_COUNT_CONTAINER').children().hide(); //Hide fields in the event of closing intermittently
            },1000);
        },
        resetSecondaryFields : function(currentForm){
            var self=this;
            //COMPONENTS_QUOTE_LIST_FORM 
            if(currentForm=='.adsComponents'){
              self.set('adscomponentsData.SELECTED_ADS_COMPONENTS',0);
              $('.adsComponents .floating-modal-group').children().find('div').removeClass('checked');
              $('.adsComponents .floating-modal-group').children().find('input').prop('checked',false).iCheck('update');
              $('#adscomp-field-error').hide();   
            }
            //COMPONENTS_LIC_COUNT_FORM
            else if(currentForm=='.getLicCount'){
                $('.getLicCount #COMPONENTS_LIC_COUNT').children().each(function(){
                   $(this).find('input').parent().removeClass('has-error');
                   $(this).find('input').prop('value','');
                });
                $('#adscount-field-error').hide();
                $('#adscount-validation-error').hide();
            }
            
        },
        toggleLicComponents: function(key,val) //Getting parent license components
        {   
            var self = this;
            var selectedCount = self.get('adscomponentsData.SELECTED_ADS_COMPONENTS')==null ? 0 : self.get('adscomponentsData.SELECTED_ADS_COMPONENTS');
            if(key){
                self.get('adscomponentsData.adscomponents').push(JSON.parse(val).columnValue);
                $('.getLicCount #'+JSON.parse(val).toggleID).show(); //Display and hide values of COMPONENTS_LIC_COUNT_FORM
                self.set('adscomponentsData.SELECTED_ADS_COMPONENTS',selectedCount+1);
            }
            else{
                var index = self.get('adscomponentsData.adscomponents').indexOf(JSON.parse(val).columnValue);
                if (index > -1) {
                    self.get('adscomponentsData.adscomponents').splice(index, 1);
                    $('.getLicCount #'+JSON.parse(val).toggleID).hide();
                    self.set('adscomponentsData.SELECTED_ADS_COMPONENTS',selectedCount-1);
                }
            }
        },
        switchForm : function(formName,resetForm,currentForm){
            var self = this;
            //ADS Licnese Components form
            if(currentForm=='.adsComponents'){
                //field validation
                if(self.get('adscomponentsData.SELECTED_ADS_COMPONENTS')==0){
                    $("#adscomp-field-error").show();
                    setTimeout(function(){
                        $("#adscomp-field-error").hide();
                    },2000);
                    return;
                }
                //setting field value
                $('#COMPONENTS_LIC_COUNT :first-child').eq(0).show();
                $("#ads-components").val(this.get('adscomponentsData.adscomponents').toString());
            }
            //ADS License Count form
            if(currentForm=='.getLicCount'){
                //field validation
                var status = true;
                var valStatus = true;
                $('.getLicCount #COMPONENTS_COUNT_CONTAINER').children().filter(':visible').each(function(){
                    $(this).find('input').each(function(){
                        if($(this).val()==""){
                             status=false;
                             $(this).parent().addClass('has-error');
                        }
                        else if(!ValidationUtil.isValidNumber($(this).val())){
                            valStatus=false;
                            $(this).parent().addClass('has-error');
                        }
						else{
                           $(this).parent().removeClass('has-error'); 
                        }
                    });
                });
                if(!status){
                    $('#adscount-validation-error').hide();
                    $('#adscount-field-error').show();
                    return;
                }
                else if(!valStatus){
                    $('#adscount-field-error').hide();
                    $('#adscount-validation-error').show();
                    return;
                }
                //setting field value
                var content = $(".getLicCount #COMPONENTS_LIC_COUNT").clone();
                $(content).appendTo('.watchspace');
            }
            self.get('referenceObj').send('constructForm',formName,resetForm,false,currentForm);
            //reset values
            setTimeout(function(){
                self.send('resetSecondaryFields',currentForm);
            },1000);
        }
    }
});
//ignorei18n_end