/*
 * $Id$
 */
import Ember from 'ember'; //NO I18N
import AJAXUtil from '../../utils/ajax-util'; //NO I18N
import I18NUtil from "../../utils/i18n-util"; //NO I18N
import ValidationUtil from "../../utils/validation-util";//No I18N
import CommonUtil from "../../utils/common-util"; //NO I18N
//ignorei18n_start
export default Ember.Component.extend({
    feedbackParams:{},
    feedbackForms:{},
    licDetails:{},
    productDetails:{},
    referenceObject:{},
    CURRENT_FORM:'FEEDBACK_FORM',
    feedbackIcons:{DEMO_ALERT:"fw-icn-livedemo",QUOTE_ALERT:"fw-icn-getquote",HELP_ALERT:"fw-icn-imp-help",EXTEND_TRIAL_ALERT:"fw-icn-extend-trial",FEEDACK_ALERT:"fw-icn-feedback",RATEUS_ALERT:"fw-icn-rating",PROMOTION_ALERT:"fw-icn-free-subscr"},
    feedbackIconTitles:{DEMO_ALERT:I18NUtil.translate('ads.feedback.icon.tooltip.personalized_demo'),QUOTE_ALERT:I18NUtil.translate('ads.feedback.icon.tooltip.get_quote'),HELP_ALERT:I18NUtil.translate('ads.feedback.icon.tooltip.implementation_help'),EXTEND_TRIAL_ALERT:I18NUtil.translate('ads.feedback.icon.tooltip.extend_trial'),FEEDBACK_ALERT:I18NUtil.translate('ads.feedback.icon.tooltip.feedback'),RATEUS_ALERT:I18NUtil.translate('ads.feedback.icon.tooltip.rateus'),PROMOTION_ALERT:I18NUtil.translate('ads.feedback.icon.tooltip.free_subscription')},
    feedbackAlertTitles:{DEMO_ALERT:I18NUtil.translate('ads.feedback.alert_title.demo'),QUOTE_ALERT:I18NUtil.translate('ads.feedback.alert_title.quote'),HELP_ALERT:I18NUtil.translate('ads.feedback.alert_title.implementation_help'),EXTEND_TRIAL_ALERT:I18NUtil.translate('ads.feedback.alert_title.extend_trial')},
    isConsentChecked: true,
    showConsent: false,
    getStatus : function(){
        var response = null;
        var self = this;
        
        response = AJAXUtil.syncAjax('/RestAPI/WC/FeedbackAction?mTCall=getFeedbackStatus',{});
        var forms = response['FEEDBACK_FORMS'];
        this.set('feedbackForms' ,forms);
        this.set('feedbackParams',response);
        this.set('feedbackParams.SELECTED_ADS_COMPONENTS',0);
        this.set('feedbackParams.adscomponents',[]);
       
        //If no connectivity to site then no feedback
        if(!response.IS_CONNECTION_AVAILABLE){
            return;
        }
        
        //Check which alert must be shown
        if(response.SHOW_ALERT)
            {
                var alertName = response.ALERT_NAME;
                var icon = this.get('feedbackIcons')[alertName];
                this.set('feedbackParams.SHOW_ALERT',true);
                this.set('feedbackParams.ALERT_ICON',icon);
                this.set('feedbackParams.ICON_TITLE',this.get('feedbackIconTitles')[alertName]);
        
                this.set("ALERT_NAME","{\"columnValue\":\""+alertName+"\"}");
                this.set("ALERT_TITLE",this.get('feedbackAlertTitles')[alertName]);
                this.set("ALERT_VAL",alertName);
            }
        else{
            this.set('feedbackParams.ICON_TITLE',I18NUtil.translate('ads.feedback.icon.tooltip.feedback'));
        }
        
        //Setting Option Values
        this.set("COUNTRIES_LIST",response['COUNTRIES_LIST']);
        var timeSelector = [];
        timeSelector.push({CLIENT_VALUE : "00:00",SERVER_VALUE : "00:00"},{CLIENT_VALUE : "00:15",SERVER_VALUE : "00:15"},{CLIENT_VALUE : "00:30",SERVER_VALUE : "00:30"},{CLIENT_VALUE : "00:45",SERVER_VALUE : "00:45"},{CLIENT_VALUE : "01:00",SERVER_VALUE : "01:00"},{CLIENT_VALUE : "01:15",SERVER_VALUE : "01:15"},{CLIENT_VALUE : "01:30",SERVER_VALUE : "01:30"},{CLIENT_VALUE : "01:45",SERVER_VALUE : "01:45"},{CLIENT_VALUE : "02:00",SERVER_VALUE : "02:00"},{CLIENT_VALUE : "02:15",SERVER_VALUE : "02:15"},{CLIENT_VALUE : "02:30",SERVER_VALUE : "02:30"},{CLIENT_VALUE : "02:45",SERVER_VALUE : "02:45"},{CLIENT_VALUE : "03:00",SERVER_VALUE : "03:00"},{CLIENT_VALUE : "03:15",SERVER_VALUE : "05:15"},{CLIENT_VALUE : "03:30",SERVER_VALUE : "03:30"},{CLIENT_VALUE : "03:45",SERVER_VALUE : "03:45"},{CLIENT_VALUE : "04:00",SERVER_VALUE : "04:00"},{CLIENT_VALUE : "04:15",SERVER_VALUE : "04:15"},{CLIENT_VALUE : "04:30",SERVER_VALUE : "04:30"},{CLIENT_VALUE : "04:45",SERVER_VALUE : "04:45"},{CLIENT_VALUE : "05:00",SERVER_VALUE : "05:00"},{CLIENT_VALUE : "05:15",SERVER_VALUE : "05:15"},{CLIENT_VALUE : "05:30",SERVER_VALUE : "05:30"},{CLIENT_VALUE : "05:45",SERVER_VALUE : "05:45"},{CLIENT_VALUE : "06:00",SERVER_VALUE : "06:00"},{CLIENT_VALUE : "06:15",SERVER_VALUE : "06:15"},{CLIENT_VALUE : "06:30",SERVER_VALUE : "06:30"},{CLIENT_VALUE : "06:45",SERVER_VALUE : "06:45"},{CLIENT_VALUE : "07:00",SERVER_VALUE : "07:00"},{CLIENT_VALUE : "07:15",SERVER_VALUE : "07:15"},{CLIENT_VALUE : "07:30",SERVER_VALUE : "07:30"},{CLIENT_VALUE : "07:45",SERVER_VALUE : "07:45"},{CLIENT_VALUE : "08:00",SERVER_VALUE : "08:00"},{CLIENT_VALUE : "08:15",SERVER_VALUE : "08:15"},{CLIENT_VALUE : "08:30",SERVER_VALUE : "08:30"},{CLIENT_VALUE : "08:45",SERVER_VALUE : "08:45"},{CLIENT_VALUE : "09:00",SERVER_VALUE : "09:00"},{CLIENT_VALUE : "09:15",SERVER_VALUE : "09:15"},{CLIENT_VALUE : "09:30",SERVER_VALUE : "09:30"},{CLIENT_VALUE : "09:45",SERVER_VALUE : "09:45"},{CLIENT_VALUE : "10:00",SERVER_VALUE : "10:00"},{CLIENT_VALUE : "10:15",SERVER_VALUE : "10:15"},{CLIENT_VALUE : "10:30",SERVER_VALUE : "10:30"},{CLIENT_VALUE : "10:45",SERVER_VALUE : "10:45"},{CLIENT_VALUE : "11:00",SERVER_VALUE : "11:00"},{CLIENT_VALUE : "11:15",SERVER_VALUE : "11:15"},{CLIENT_VALUE : "11:30",SERVER_VALUE : "11:30"},{CLIENT_VALUE : "11:45",SERVER_VALUE : "11:45"},{CLIENT_VALUE : "12:00",SERVER_VALUE : "12:00"},{CLIENT_VALUE : "12:15",SERVER_VALUE : "12:15"},{CLIENT_VALUE : "12:30",SERVER_VALUE : "12:30"},{CLIENT_VALUE : "12:45",SERVER_VALUE : "12:45"},{CLIENT_VALUE : "13:00",SERVER_VALUE : "13:00"},{CLIENT_VALUE : "13:15",SERVER_VALUE : "13:15"},{CLIENT_VALUE : "13:30",SERVER_VALUE : "13:30"},{CLIENT_VALUE : "13:45",SERVER_VALUE : "13:45"},{CLIENT_VALUE : "14:00",SERVER_VALUE : "14:00"},{CLIENT_VALUE : "14:15",SERVER_VALUE : "14:15"},{CLIENT_VALUE : "14:30",SERVER_VALUE : "14:30"},{CLIENT_VALUE : "14:45",SERVER_VALUE : "14:45"},{CLIENT_VALUE : "15:00",SERVER_VALUE : "15:00"},{CLIENT_VALUE : "15:15",SERVER_VALUE : "15:15"},{CLIENT_VALUE : "15:30",SERVER_VALUE : "15:30"},{CLIENT_VALUE : "15:45",SERVER_VALUE : "15:45"},{CLIENT_VALUE : "16:00",SERVER_VALUE : "16:00"},{CLIENT_VALUE : "16:15",SERVER_VALUE : "16:15"},{CLIENT_VALUE : "16:30",SERVER_VALUE : "16:30"},{CLIENT_VALUE : "16:45",SERVER_VALUE : "16:45"},{CLIENT_VALUE : "17:00",SERVER_VALUE : "17:00"},{CLIENT_VALUE : "17:15",SERVER_VALUE : "17:15"},{CLIENT_VALUE : "17:30",SERVER_VALUE : "17:30"},{CLIENT_VALUE : "17:45",SERVER_VALUE : "17:45"},{CLIENT_VALUE : "18:00",SERVER_VALUE : "18:00"},{CLIENT_VALUE : "18:15",SERVER_VALUE : "18:15"},{CLIENT_VALUE : "18:30",SERVER_VALUE : "18:30"},{CLIENT_VALUE : "18:45",SERVER_VALUE : "18:45"},{CLIENT_VALUE : "19:00",SERVER_VALUE : "19:00"},{CLIENT_VALUE : "19:15",SERVER_VALUE : "19:15"},{CLIENT_VALUE : "19:30",SERVER_VALUE : "19:30"},{CLIENT_VALUE : "19:45",SERVER_VALUE : "19:45"},{CLIENT_VALUE : "20:00",SERVER_VALUE : "20:00"},{CLIENT_VALUE : "20:15",SERVER_VALUE : "20:15"},{CLIENT_VALUE : "20:30",SERVER_VALUE : "20:30"},{CLIENT_VALUE : "20:45",SERVER_VALUE : "20:45"},{CLIENT_VALUE : "21:00",SERVER_VALUE :


 "21:00"},{CLIENT_VALUE : "21:15",SERVER_VALUE : "21:15"},{CLIENT_VALUE : "21:30",SERVER_VALUE : "21:30"},{CLIENT_VALUE : "21:45",SERVER_VALUE : "21:45"},{CLIENT_VALUE : "22:00",SERVER_VALUE : "22:00"},{CLIENT_VALUE : "22:15",SERVER_VALUE : "22:15"},{CLIENT_VALUE : "22:30",SERVER_VALUE : "22:30"},{CLIENT_VALUE : "22:45",SERVER_VALUE : "22:45"},{CLIENT_VALUE : "23:00",SERVER_VALUE : "23:00"},{CLIENT_VALUE : "23:15",SERVER_VALUE : "23:15"},{CLIENT_VALUE : "23:30",SERVER_VALUE : "23:30"},{CLIENT_VALUE : "23:45",SERVER_VALUE : "23:45"});
        this.set("TIME_SELECTOR",timeSelector);
        
        var licenseCount = [];
        licenseCount.push({CLIENT_VALUE : I18NUtil.translate('ads.feedback.extend_trial.license_count_1'),SERVER_VALUE : I18NUtil.translate('ads.feedback.extend_trial.license_count_1')},{CLIENT_VALUE : I18NUtil.translate('ads.feedback.extend_trial.license_count_2'),SERVER_VALUE : I18NUtil.translate('ads.feedback.extend_trial.license_count_2')},{CLIENT_VALUE : I18NUtil.translate('ads.feedback.extend_trial.license_count_3'),SERVER_VALUE : I18NUtil.translate('ads.feedback.extend_trial.license_count_3')},{CLIENT_VALUE : I18NUtil.translate('ads.feedback.extend_trial.license_count_4'),SERVER_VALUE : I18NUtil.translate('ads.feedback.extend_trial.license_count_4')},{CLIENT_VALUE : I18NUtil.translate('ads.feedback.extend_trial.license_count_5'),SERVER_VALUE : I18NUtil.translate('ads.feedback.extend_trial.license_count_5')},{CLIENT_VALUE : I18NUtil.translate('ads.feedback.extend_trial.license_count_6'),SERVER_VALUE : I18NUtil.translate('ads.feedback.extend_trial.license_count_6')});
        this.set('licDetails.LICENSE_OPTIONS',licenseCount);
        
        var purchaseTime = [];
        purchaseTime.push({CLIENT_VALUE : I18NUtil.translate('ads.feedback.extend_trial.purchase_time_1'),SERVER_VALUE : I18NUtil.translate('ads.feedback.extend_trial.purchase_time_1')},{CLIENT_VALUE : I18NUtil.translate('ads.feedback.extend_trial.purchase_time_2'),SERVER_VALUE : I18NUtil.translate('ads.feedback.extend_trial.purchase_time_2')},{CLIENT_VALUE : I18NUtil.translate('ads.feedback.extend_trial.purchase_time_3'),SERVER_VALUE : I18NUtil.translate('ads.feedback.extend_trial.purchase_time_3')},{CLIENT_VALUE : I18NUtil.translate('ads.feedback.extend_trial.purchase_time_4'),SERVER_VALUE : I18NUtil.translate('ads.feedback.extend_trial.purchase_time_4')},{CLIENT_VALUE : I18NUtil.translate('ads.feedback.extend_trial.purchase_time_5'),SERVER_VALUE : I18NUtil.translate('ads.feedback.extend_trial.purchase_time_5')});
        this.set('licDetails.PURCHASE_TIME',purchaseTime);
        var licEdition = [];
        licEdition.push({CLIENT_VALUE : "Standard",SERVER_VALUE : "Standard"},{CLIENT_VALUE : "Professional",SERVER_VALUE : "Professional"},{CLIENT_VALUE : "Both",SERVER_VALUE : "Both"});
        this.set('licDetails.EDITION',licEdition);
        this.set('licDetails.LIC_NOT_CUSTOM',true);
        this.set('feedbackForms.MANDATORY_FIELDS',{});
        
    }.on('init'),
    validateForm : function(formName,currentForm){
        var fields =currentForm+" #dynamic-fields";
        var status = true;
        var valStatus = true;

        $(fields).children().filter(':visible .ismandatory').each(function(){
            var self = this;
            $(self).removeClass("has-error");
            if(self.firstElementChild.value == ""){
                status=false;
                $(self).addClass("has-error");
            }
        });
        //Validate date field
        if($('#DATE_FIELD :visible').length!=0 && this.get('feedbackParams.IS_DATE_FIELD_MANDATORY') && $('#DATE_FIELD').find('#DATE_PICKER').val()==""){
            $('#DATE_FIELD').addClass('has-error');
            status=false;
        }
        //Validate country field
        if($('#SELECT_COUNTRY :visible').length!=0 && this.get('feedbackForms.MANDATORY_FIELDS.SELECT_COUNTRY') && $('button[data-id="SELECT_COUNTRY"]').find('span:first').text().indexOf(I18NUtil.translate('ads.feedback.field_name.country'))!==-1){
            $('#SELECT_COUNTRY').addClass('has-error');
            status=false;
        }
        //Validate estimated purchase time field
        if($('#SELECT_PURCHASE_TIME :visible').length!=0 && this.get('feedbackForms.MANDATORY_FIELDS.SELECT_PURCHASE_TIME') && $('button[data-id="SELECT_TIME"]').find('span:first').text().indexOf(I18NUtil.translate('ads.feedback.field_name.estimated_time'))!==-1){
            $('#SELECT_PURCHASE_TIME').addClass('has-error');
            status=false;
        }
        //Validate license edition
        if($('#SELECT_EDITION :visible').length!=0 && this.get('feedbackForms.MANDATORY_FIELDS.SELECT_EDITION') && $('button[data-id="LIC_EDITION"]').find('span:first').text().indexOf(I18NUtil.translate('ads.feedback.field_name.license_edition'))!==-1){
            $('#SELECT_EDITION').addClass('has-error');
            status=false;
        }
        //Validate license count
        if($('#SELECT_LICENSE_COUNT :visible').length!=0 && this.get('feedbackForms.MANDATORY_FIELDS.SELECT_LICENSE_COUNT') && $('button[data-id="SELECT_LIC_COUNT"]').find('span:first').text().indexOf(I18NUtil.translate('ads.feedback.field_name.license_count'))!==-1){
            $('#SELECT_LICENSE_COUNT').addClass('has-error');
            status=false;
        }
        if(formName=="FEEDBACK_FORM"){
            $("#ATTACH_LOGS").parent().parent().css('visibility','hidden');
        }
        
        var fromAddress = $("#FEEDBACK_EMAIL").val();
        if(!status){
            $("#field-error").show()    
        }
        else if($("#FEEDBACK_EMAIL").val()!="" && !ValidationUtil.isValidEmail($("#FEEDBACK_EMAIL").val())){
            $("#EMAIL_FIELD").addClass("has-error");
            $("#field-mail-error").show();
            status=false;
        }
        return status;
    },
    actions: {
        openForm : function(){
            if(this.get('feedbackParams.SHOW_ALERT')){
                if(JSON.parse(this.get('ALERT_NAME')).columnValue=='PROMOTION_ALERT'){
                    $('.freesubscription').slideDown("slow");
                }
                else if(JSON.parse(this.get('ALERT_NAME')).columnValue=='RATEUS_ALERT'){
                    $('.fw-rating-form').slideDown("slow");
                }
                else{
                    $('.formAlert').slideDown("slow");   
                }
            }
            else{
                this.send('constructForm','FEEDBACK_FORM',false,false,null);
                $(".feedbackModal").slideDown("slow")
            }
		},
		closeForm : function(formClass){
            var self = this;
			$(formClass).slideUp("slow",function(){
                self.send('resetFields');
                //Clear watchspace
                $('.watchspace').html('');
                $('.feedback-fieldList').html('');
                //Reset volatile hidden fields
                $('.volatile-fields').children().val('');
            });
		},
        checkConnectionAndSend : function(formName,currentForm)
        {
          var self = this;
          self.set('feedbackParams.LOADING_STATUS','ads.feedback.form_status.submtting_form');
		  //Check for field errors
          if(currentForm!=null && !self.validateForm(formName,currentForm)){
                //Display error in case of invalid entries
                setTimeout(function(){
                    var fields =currentForm+" #dynamic-fields";
                    $(fields).children().filter(':visible').each(function(){
                        $(self).removeClass("has-error");
                    }); 
                    $("#field-error").hide();
                    $("#field-mail-error").hide();
                    
                    if(formName=="FEEDBACK_FORM"){
                        if(self.get('feedbackParams.SHOW_ATTACH_LOGS')==1){
                            $("#ATTACH_LOGS").parent().parent().css('visibility','visible');   
                        }
                    }
                },2000);
                return;
            }
          //Check for connectivity
          if(formName=="FEEDBACK_FORM"){
              $("#ATTACH_LOGS").parent().parent().css('visibility','hidden');
          }
          $('.floating-modal-loading').show();    
          AJAXUtil.ajax('/RestAPI/WC/FeedbackAction?mTCall=checkConnectivity',{"URL":self.get('feedbackParams.SUPPORT_FORM_URL')}).then(function(json){
            if('sSTATUS' in json){
				$('.floating-modal-loading').hide();
                self.send('sendTalkBack',formName,currentForm);
            }
            else{
                $('.floating-modal-loading').hide();
                self.send('showError');
            }
            if(formName=="FEEBACK_FORM" && self.get('feedbackParams.SHOW_ATTACH_LOGS')==1){
                $("#ATTACH_LOGS").parent().parent().css('visibility','visible');
            }
          });  
        },
        showError : function(){
			var self=this;
            $("#ATTACH_LOGS").parent().parent().css('visibility','hidden');
            $("#connection-error").show();
            
            setTimeout(function(){
                $("#connection-error").hide();
				if(self.get('feedbackParams.SHOW_ATTACH_LOGS')==1){
					$("#ATTACH_LOGS").parent().parent().css('visibility','visible');      
				}  
            },2000);  
        },
		sendTalkBack : function(formName,currentForm){
			var fromId=$('#FEEDBACK_EMAIL').val();
			var subject=$('#FEEDBACK_SUBJECT').val();
			var message=$('#FEEDBACK_CONTENT').val();
            var self = this;
            
            //Upload and send logs via bonitas
            if(formName=="FEEDBACK_FORM" && $('#ATTACH_LOGS').is(':checked')){
                $('#ATTACH_LOGS').parent().parent().css('visibility','hidden');
                self.set('feedbackParams.LOADING_STATUS','ads.feedback.form_status.upload_logs');
                $('.floating-modal-loading').show();
                AJAXUtil.ajax('/RestAPI/WC/FeedbackAction?mTCall=attachLogs', {"FROM_ADDRESS": fromId, "MAIL_CONTENT":message,"SUBJECT":subject})//No I18N 
                .then(function(json)
                {
                    if('sSTATUS' in json)
                    {
                        $("#uploaded-logs").val(json.logsURL);
                        self.send('submitForm',fromId,formName,currentForm);
                        $('#ATTACH_LOGS').parent().parent().css('visibility','visible');
                        $('.floating-modal-loading').hide();
                    }
                });					
            }
            else{
                self.send('submitForm',fromId,formName,currentForm);
            }
               
		},
        
        onCountryChange(text,value) {
            let gdpruncheck = ['AT', 'BE', 'BG', 'HR', 'CY', 'CZ', 'DK', 'EE', 'FI', 'FR', 'DE', 'GR', 'HU', 'IE', 'IT', 'LV', 'LT', 'LU', 'MT', 'NL', 'PL', 'PT', 'RO', 'SK', 'SI', 'ES', 'SE', 'GB', 'IS', 'NO', 'CH', 'AU', 'CA'];
            let cncode = Ember.$("#SELECT_COUNTRY").find('select :selected').data('name');
            let showConsent = gdpruncheck.indexOf(cncode) > -1;
            this.set("showConsent",showConsent);
            this.set("isConsentChecked", !showConsent);
        },

        toggleGDPRConsent(val){
            this.set('isConsentChecked',val);
        },

        submitForm : function(fromId,formName,currentForm){
                var self = this;
                $("#from-email").val(fromId);
                $("#subject").val(I18NUtil.translate(self.get('feedbackForms.'+formName+'.MAIL_SUBJECT')));
                $("#Requested_Date").val($(".fw-floating-modal-form input[id=DATE_PICKER]").val());
				//Removing reference datepicker values
                $(".fw-floating-modal-form input[name=daterangepicker_end]").val('');
                $(".fw-floating-modal-form input[name=daterangepicker_start]").val('');
                
                //Setting time
                if($(".fw-floating-modal-form input[id=DATE_PICKER]").val()!=""){
                  var time = $('button[data-id="PICK_TIME"]').find('span:first').text();
                  $("#Requested_Time").val(time);   
                }
                else{
                    $("#Requested_Time").val('');
                }
                
                //Setting country in form
                var country = $('button[data-id="SELECT_COUNTRY"]').find('span:first').text()!=I18NUtil.translate('ads.feedback.field_name.country') ? $('button[data-id="SELECT_COUNTRY"]').find('span:first').text() : '';
                $("#from-country").val(country);
                $('#SELECT_COUNTRY').find('ul').find('li').removeClass('hidden');

                //Setting license count in form
                if($('#license-count').val()==''){
                     var licCount = $('button[data-id="SELECT_LIC_COUNT"]').find('span:first').text()!=I18NUtil.translate('ads.feedback.field_name.license_count') ? $('button[data-id="SELECT_LIC_COUNT"]').find('span:first').text() : '';
                     $("#license-count").val(licCount);   
                }

                //Setting estimated time in form
                if($("#purchase-time").val()==''){
                    var estimatedTime = $('button[data-id="SELECT_TIME"]').find('span:first').text()!=I18NUtil.translate('ads.feedback.field_name.estimated_time') ? $('button[data-id="SELECT_TIME"]').find('span:first').text() : '';
                    $("#purchase-time").val(estimatedTime);      
                }             
                
                //Setting license edition
                var licEdition = $('button[data-id="LIC_EDITION"]').find('span:first').text()!=I18NUtil.translate('ads.feedback.field_name.license_edition') ? $('button[data-id="LIC_EDITION"]').find('span:first').text() : '';
                $("#purchase-edition").val(licEdition);
            	
				//Setting GDPR consent for receiving marketing mails
                $('#Consent').val(self.get('isConsentChecked') ? "Yes" : "No");

                //Setting all filled up fields
                var container = document.getElementById('contentform');
                var inputs = container.getElementsByTagName('input');
                for(var i=0 ;i < inputs.length; i++){
                    if(inputs[i].value!='' && inputs[i].value!=undefined){
                        var field = $(inputs[i]).clone();
                        $(field).appendTo('.feedback-fieldList');
                    }
                }
                var comments = document.getElementById('FEEDBACK_CONTENT');
                if(comments.value!='' && comments.value!=undefined){
                    $($(comments).clone()).appendTo('.feedback-fieldList');
                }
                //Submitting form    
                $('#talkbackform').submit();
                
                this.send('closeForm',currentForm);
            
            //Updating status in params to -1(accepted)
            if(formName!="FEEDBACK_FORM"){
                var alertName = formName.replace("FORM","ALERT");
                var params = {};
                
                params['UPDATE_REMINDER']=true;
                params['ALERT_NAME']=alertName;
                params['STATUS']=-1;
                this.send('updateSettings',params);
                
                //Reset feedback icon
                $("#FEEDBACK_BUTTON").removeClass (function (index, className) {
                    return (className.match (/\bfw-icn\S+/g) || []).join(' ');
                });
                $("#FEEDBACK_BUTTON").addClass('fw-icn-feedback');
                this.set('feedbackParams.SHOW_ALERT',false);
                this.set('feedbackParams.ICON_TITLE',I18NUtil.translate('ads.feedback.icon.tooltip.feedback'));
            }
            $("#FEEDBACK_CONTENT").val('');
            self.send('showSuccess',currentForm,self.get('feedbackForms.'+formName+'.SUCCESS_STATUS'));
            
        },
        showSuccess: function(currentForm,statusMsg)
        {
           var self = this;
            //Display Options 
           if(self.get('feedbackParams.DD_OPTIONS')!=0){
              $("#MODAL_DD").show();
              $("#MODAL_HEADER").removeClass("fw-pl-15");
           }
            
           self.set("feedbackParams.SUCCESS_STATUS",statusMsg);
           $(currentForm).slideUp("slow",function(){
                $('.getSuccess').slideDown("slow");
           }); 
           setTimeout(function(){
                $('.getSuccess').slideUp("slow"); 
           },5000);
        },
        toggleAttachLogs: function(key, val){},
        rejectAlert : function(){
            var alertName = JSON.parse(this.get('ALERT_NAME')).columnValue;
            var params={};
            params['UPDATE_REMINDER']=true;
            params['ALERT_NAME']=alertName;
            params['STATUS']=0;
            this.send("updateSettings", params);

            //Post reject changes
            $(".formAlert").slideUp("slow");
            //Reset feedback icon
            $("#FEEDBACK_BUTTON").removeClass (function (index, className) {
                return (className.match (/\bfw-icn\S+/g) || []).join(' ');
            });
            $("#FEEDBACK_BUTTON").addClass('fw-icn-feedback');
            this.set('feedbackParams.SHOW_ALERT',false);
            this.set('feedbackParams.ICON_TITLE',I18NUtil.translate('ads.feedback.icon.tooltip.feedback'));
            //Show Options
            $("#MODAL_DD").show();
            $("#MODAL_HEADER").removeClass("fw-pl-15");
        },
        updateSettings : function(params){
         AJAXUtil.ajax('/RestAPI/WC/FeedbackAction?mTCall=updateFeedbackSettings', { feedbackDetails : JSON.stringify(params) });
        },
        constructForm : function(formName,resetOrder,checkforNext,currentForm){
            var form = this.get('feedbackForms');
            var formDetails = this.get('feedbackForms.'+formName);
            var self = this;
            self.set('CURRENT_FORM',formName);
    
            currentForm = currentForm == null ? '.feedbackModal' : currentForm;
            
            if(formName!="FEEDBACK_FORM"){
                $("#ATTACH_LOGS").parent().parent().css('visibility','hidden');
                $(".floating-modal-rating").css('visibility','hidden');
                self.set('feedbackParams.FEEDBACK_TITLE','ads.feedback.form_title.fill_out');
            }
            else{
                if(self.get('feedbackParams.SHOW_ATTACH_LOGS')==1){
                    $("#ATTACH_LOGS").parent().parent().css('visibility','visible');   
                }
		if(self.get('feedbackParams.SHOW_RATING')){
                    $(".floating-modal-rating").css('visibility','visible');   
                }
                self.set('feedbackParams.FEEDBACK_TITLE','ads.feedback.form_title.write_to_us');
            }
            //Check order of appearance of the form
            if(resetOrder){
                $('.feedback-fieldList').html('');
                $('.watchspace').html('');
                $('#ads-components').prop('value','');
                self.set('feedbackParams.adscomponents',[]);
                
                if(form[formName].hasOwnProperty("FORM_ORDER")){
                    var order = form[formName].FORM_ORDER;
                    var previousForm = null;
                    for(var i=order.length-1; i>=0; i--){
                        if(previousForm!=null){
                            self.set('feedbackForms.'+order[i]+'.NEXT_FORM',previousForm);
                        }
                        previousForm = order[i];
                    }
                }   
            }
            
            if(checkforNext){
                for(var key in form){
                    if(form[key].NEXT_FORM==formName){
                        self.send('constructForm',key,false,true,null);
                        return;
                    }
                }   
            }  
            
            //Check for standalone forms
            if(formName=="PURCHASE_TIME_FORM") {
                self.get('referenceObject.PURCHASE_TIME').send('constructForm',currentForm);
                return;
            }
            else if(formName=="LICENSE_COUNT_FORM"){
                self.get('referenceObject.LIC_COUNT').send('constructForm',currentForm);
                return;
            }
            else if(formName=="COMPONENTS_QUOTE_LIST_FORM"){
                self.get('referenceObject.ADS_COMPONENTS').send('constructForm',currentForm);
                return;
            }
            else if(formName=="COMPONENTS_LIC_COUNT_FORM"){
                $(currentForm).slideUp("slow",function(){
                    $('.getLicCount').slideDown("slow");
                });
                return;
            }
            else if(formName=="SUCCESS_FORM"){
                $(currentForm).slideUp("slow",function(){
                   $('.getSuccess').slideDown("slow"); 
                });
                return;
            }
            
            var fieldCount = -1;
            var bodyHeight = 0;
            
            $(currentForm).slideUp("slow",function(){
                self.send('resetFields');
                if(formDetails.hasOwnProperty("FORM_FIELDS")){
                    formDetails.FORM_FIELDS.forEach(function(field){
                        ++fieldCount;
                        $('#'+field.FIELD_NAME).show();
                        if(field.IS_MANDATORY){
                           $('#'+field.FIELD_NAME).addClass('ismandatory');
                            self.set('feedbackForms.MANDATORY_FIELDS.'+field.FIELD_NAME,true);
                            //Adding * to the placeholder
                            var customFields = self.get('feedbackParams.CUSTOM_FIELDS.TEXT_FIELDS');
                            customFields.some(function(ele){
                               if(ele.FIELD_ID === field.FIELD_NAME){
                                   Ember.set(ele,"IS_MANDATORY",true);
                               } 
                            });
                            
                            if(field.FIELD_NAME=="SELECT_COUNTRY"){
                                $('button[data-id="SELECT_COUNTRY"]').find('span:first').text(I18NUtil.translate('ads.feedback.field_name.country')+'*');
                            }
                            else if(field.FIELD_NAME=="SELECT_LICENSE_COUNT"){
                                $('button[data-id="SELECT_LIC_COUNT"]').find('span:first').text(I18NUtil.translate('ads.feedback.field_name.license_count')+'*');
                            }
                            else if(field.FIELD_NAME=="SELECT_PURCHASE_TIME"){
                                $('button[data-id="SELECT_TIME"]').find('span:first').text(I18NUtil.translate('ads.feedback.field_name.estimated_time')+'*');   
                            }
                            else if(field.FIELD_NAME=="SELECT_EDITION"){
                                $('button[data-id="LIC_EDITION"]').find('span:first').text(I18NUtil.translate('ads.feedback.field_name.license_edition')+'*');   
                            }
                            else if(field.FIELD_NAME=="DATE_FIELD"){
                                self.set('feedbackParams.IS_DATE_FIELD_MANDATORY',true);
                            }
                        }
                    });   
                }
                //setting comments body height
                bodyHeight = 326 - fieldCount * 41;
                $(".floating-modal-body").height(bodyHeight);
                $('.feedbackModal').slideDown("slow");   
            });
        },
        sendForConstruction : function(params){ //Accepting alert and send details for form construction
            var nextForm = 'FEEDBACK_FORM';
            var currentForm = '.feedbackModal';
            var alertName = JSON.parse(params).columnValue;
            //Hiding options
            $("#MODAL_DD").hide();
            $("#MODAL_HEADER").addClass("fw-pl-15");
            //Match alert with its forms
            if(alertName=="DEMO_ALERT"){
                nextForm = 'DEMO_FORM';
                currentForm = '.formAlert';
            }
            else if(alertName=="QUOTE_ALERT"){
                nextForm = "QUOTE_FORM";
                currentForm = ".formAlert"
            }
            else if(alertName=="HELP_ALERT"){
                nextForm = "HELP_FORM";
                currentForm = ".formAlert"
            }
            else if(alertName=="EXTEND_TRIAL_ALERT"){
                nextForm = "EXTEND_TRIAL_FORM";
                currentForm = ".formAlert"
            }
            var self = this;
            $(currentForm).slideUp("slow",function(){
                self.send('constructForm',nextForm,true,true,currentForm); 
            });  
        },
        setValue : function(status){
            this.set('alertStatus',status);
        },
        resetFields : function(){
            //Hide all fields
            var self = this;
            $('#dynamic-fields').children().hide();
            //resetting mandatory field changes
            this.set('feedbackForms.MANDATORY_FIELDS',{});
            var customFields = self.get('feedbackParams.CUSTOM_FIELDS.TEXT_FIELDS');
            customFields.forEach(function(ele){
               if(ele.IS_MANDATORY){ 
                   Ember.set(ele,"IS_MANDATORY",false);
               } 
            });
            self.set('feedbackParams.IS_DATE_FIELD_MANDATORY',false);
            
            $('#dynamic-fields').children().removeClass('ismandatory');
            //Reset values of all text fields
            $('#dynamic-fields').children().each(function(){
               $(this).find('input').prop('value','');
               $(this).removeClass('has-error');
            });
            //Reset value of Country
			$('select[id="SELECT_COUNTRY"]').selectpicker('deselectAll');
            $('#SELECT_COUNTRY').prop('value','');
            $('button[data-id="SELECT_COUNTRY"]').find('span:first').text(I18NUtil.translate('ads.feedback.field_name.country'));
            $('button[data-id="SELECT_COUNTRY"]').find('span:first').css('color','#cbcbcb');
            $('#SELECT_COUNTRY').find('ul').find('li').removeClass('hidden')
            //Reset value of License Count
            $('#SELECT_LIC_COUNT').prop('value','');
            $('button[data-id="SELECT_LIC_COUNT"]').find('span:first').text(I18NUtil.translate('ads.feedback.field_name.license_count'));
            $('button[data-id="SELECT_LIC_COUNT"]').find('span:first').css('color','#cbcbcb');
            //Reset value of Estimated Time
            $('#SELECT_TIME').prop('value','');
            $('button[data-id="SELECT_TIME"]').find('span:first').text(I18NUtil.translate('ads.feedback.field_name.estimated_time'));
            $('button[data-id="SELECT_TIME"]').find('span:first').css('color','#cbcbcb');
            //Reset value of Edition
            $('#LIC_EDITION').prop('value','');
            $('button[data-id="LIC_EDITION"]').find('span:first').text(I18NUtil.translate('ads.feedback.field_name.license_edition'));
            $('button[data-id="LIC_EDITION"]').find('span:first').css('color','#cbcbcb');
            //Reset values of alert fields
            $("#ACCEPT_ALERT").prop('checked',false).iCheck('update');
            $('#ACCEPT_ALERT').parent().removeClass('checked');
            //Reset textarea
            $("#FEEDBACK_CONTENT").prop('value','');
            //Reset error fields
            $('#field-error').hide();
            $('#connection-error').hide();
            $("#field-mail-error").hide();
            //Reset attach logs
            $('#ATTACH_LOGS').parent().removeClass('checked');
            $('#ATTACH_LOGS').prop('checked',false).iCheck('update');
            //Hide liccount fields
            $('.getLicCount #COMPONENTS_LIC_COUNT').children().hide();
        },
        bounceEffect : function(){
            var self=this;
            setTimeout(function(){
                if(self.get('feedbackParams.SHOW_ALERT')){
                    $(".feedbackBtn").effect("bounce",{times : 5, distance : 60}, 2000);
                    self.send("bounceEffect");
                }
            }, 10000);
        },
    },
    didInsertElement:function()
	{
        var self = this;
        this.set('parentObj',this);
		Ember.run.scheduleOnce('afterRender', function() //NO I18N
		{
            //No feedback on no active connection
            if(!self.get('feedbackParams.IS_CONNECTION_AVAILABLE')){
                $('.feedbackBtn').hide();
                return;
            }
            //Set fields for default view
            var feedbackForm = self.get('feedbackForms.FEEDBACK_FORM.FORM_FIELDS');
            feedbackForm.forEach(function(field) {
                $('#'+field.FIELD_NAME).show();
                if(field.IS_MANDATORY){
                   $('#'+field.FIELD_NAME).addClass('ismandatory'); 
                }
            });
            //Hide other options at end of trial
            if(self.get('feedbackParams.DD_OPTIONS').length==0){
                $("#MODAL_DD").hide();
                $("#MODAL_HEADER").addClass("fw-pl-15");
            }
            //Set styles for selectpickers to blend in with fields
            $('button[data-id="SELECT_COUNTRY"]').find('span:first').css('color','#cbcbcb');
            $('button[data-id="SELECT_LIC_COUNT"]').find('span:first').css('color','#cbcbcb');
            $('button[data-id="SELECT_TIME"]').find('span:first').css('color','#cbcbcb');
            $('button[data-id="LIC_EDITION"]').find('span:first').css('color','#cbcbcb');
            
            //Replacing icon based on alert
            if(self.get('feedbackParams.SHOW_ALERT')){
                $("#FEEDBACK_BUTTON").removeClass (function (index, className) {
                        return (className.match (/\bfw-icn\S+/g) || []).join(' ');
                });
                $("#FEEDBACK_BUTTON").addClass(self.get('feedbackParams.ALERT_ICON'));
                //Type of pop up alert // 1 - slide open popup // 0 - icon bounce //2- both
                if(self.get('feedbackParams.POPUP_STATE')!="-1");
                {
                    if(self.get('feedbackParams.POPUP_STATE')!='0'){
                        setTimeout(function(){
                            self.send('openForm');
                        },5000);
                    }
                    if(self.get('feedbackParams.POPUP_STATE')!='1'){
                        self.send('bounceEffect');
                    }   
                }
            }
            //Show/Hide Attach Logs
            if(self.get('feedbackParams.SHOW_ATTACH_LOGS')==0){
                $("#ATTACH_LOGS").parent().parent().css('visibility','hidden');
            }
	    //Show/Hide Rate Us
            if(!self.get('feedbackParams.SHOW_RATING')){
                $('.floating-modal-rating').css('visibility','hidden');
            }
	    //Display configured DropDown Options
            if(self.get('feedbackParams.DD_OPTIONS').length!=0){
                var options = self.get('feedbackParams.DD_OPTIONS');
                options.forEach(function(option){
                    $('#MODAL_DD #'+option).show();
                });
            }
            CommonUtil.afterRender();
		});
      
        //Formatting styles for country selection
        $(".fw-floating-modal-form select[id=SELECT_COUNTRY]").on('changed.bs.select',function(e){//NO I18N
            setTimeout(function(){
                if($('button[data-id="SELECT_COUNTRY"]').find('span:first').text().indexOf(I18NUtil.translate('ads.feedback.field_name.country')) == -1){
                    $('button[data-id="SELECT_COUNTRY"]').find('span:first').css('color','#000000');
                }
                else{
                    $('button[data-id="SELECT_COUNTRY"]').find('span:first').css('color','#cbcbcb');
                }},100);
        });
        //Formatting styles for license count selection
        $(".fw-floating-modal-form select[id=SELECT_LIC_COUNT]").on('changed.bs.select',function(e){//NO I18N

            setTimeout(function(){
                if($('button[data-id="SELECT_LIC_COUNT"]').find('span:first').text() != I18NUtil.translate('ads.feedback.field_name.license_count')){
                    $('button[data-id="SELECT_LIC_COUNT"]').find('span:first').css('color','#000000');
                }
                else{
                    $('button[data-id="SELECT_LIC_COUNT"]').find('span:first').css('color','#cbcbcb');
                }},100);
        });
        //Formatting styles for estimated time
        $(".fw-floating-modal-form select[id=SELECT_TIME]").on('changed.bs.select',function(e){//NO I18N

            setTimeout(function(){
                if($('button[data-id="SELECT_TIME"]').find('span:first').text() != I18NUtil.translate('ads.feedback.field_name.estimated_time')){
                    $('button[data-id="SELECT_TIME"]').find('span:first').css('color','#000000');
                }
                else{
                    $('button[data-id="SELECT_TIME"]').find('span:first').css('color','#cbcbcb');
                }},100);
        });
        //Formatting styles for license edition
        $(".fw-floating-modal-form select[id=LIC_EDITION]").on('changed.bs.select',function(e){//NO I18N

            setTimeout(function(){
                if($('button[data-id="LIC_EDITION"]').find('span:first').text() != I18NUtil.translate('ads.feedback.field_name.license_edition')){
                    $('button[data-id="LIC_EDITION"]').find('span:first').css('color','#000000');
                }
                else{
                    $('button[data-id="LIC_EDITION"]').find('span:first').css('color','#cbcbcb');
                }},100);
        });
    }
});