/*
 * $Id$
 */
import Ember from 'ember';//No I18N
import AJAXUtil from '../../utils/ajax-util'; //NO I18N
import I18NUtil from "../../utils/i18n-util"; //NO I18N
import ValidationUtil from "../../utils/validation-util";//No I18N
//ignorei18n_start
export default Ember.Component.extend({
    didInsertElement : function(){
        var self = this;
        
        $(".floating-modal-rating-sep").on("click", function()
        {
            $(".feedbackModal").slideUp("slow", function()
            {
                $(this).removeClass("minimize");
                $(".fw-rating-form").slideDown("slow");
            });
        });

        $(".fw-rating-form .stars i").on("mouseover",function()
        {
            var i=$(".fw-rating-form .stars i").index(this);
            $(".fw-rating-form .stars i").each(function(li)
            {
                if(li<=i){$(this).addClass("active");}
            });
            i=0;
            setRating();
        });

        $(".fw-rating-form .stars i").on("mouseout",function()
        {
            var i=$("i").index(this)-1;
            $(".fw-rating-form .stars i").each(function(li)
            {
                if(li<=i && !$(this).hasClass("clicked")){$(this).removeClass("active");}
            });
            setRating();
        });	

        $(".fw-rating-form .stars i").on("click",function()
        {
            if($(this).hasClass('clicked'))
            {
                $(".fw-rating-form .stars i").removeClass("active clicked")
                var i=$(".fw-rating-form .stars i").index(this);

                $(".fw-rating-form .stars i").each(function(li)
                {
                    if(li<=i){$(this).addClass("active").addClass('clicked');}
                });
            }
            else
            {
                var i=$(".fw-rating-form .stars i").index(this);
                $(".fw-rating-form .stars i").each(function(li)
                {
                    if(li<=i){$(this).addClass("active").addClass('clicked');}
                })
            }
            setRating();
        });
        
        function setRating()
        {
            var len = $(".fw-rating-form .stars i.active").length;

            var clientVal = "", serverVal = "";
            if(len==1){clientVal = I18NUtil.translate('ads.footer.rating.terrible'), serverVal = "TERRIBLE";}
            else if(len==2){clientVal = I18NUtil.translate('ads.footer.rating.poor'), serverVal = "POOR";}
            else if(len==3){clientVal = I18NUtil.translate('ads.footer.rating.fair'), serverVal = "FAIR";}
            else if(len==4){clientVal = I18NUtil.translate('ads.footer.rating.good'), serverVal = "GOOD";}
            else if(len==5){clientVal = I18NUtil.translate('ads.footer.rating.great'), serverVal = "GREAT";}
            else{clientVal = "";}

            $(".fw-rating-form .ratings").text(clientVal);//No I18N
            $('#RATING').val(serverVal);
        }
    },
    actions : {
        closeRating : function(){
            $(".fw-rating-form").slideUp("slow");
			this.send('resetRating');
        },
        askMeLater : function()
		{
            var self=this;
            var params = {ASK_ME_LATER:true};
			AJAXUtil.ajax('/RestAPI/WC/FeedbackAction?mTCall=updateFeedbackSettings',{feedbackDetails : JSON.stringify(params)}); //NO I18N
			$(".fw-rating-form").slideUp("slow",function()
			{
                //$(".floating-modal-rating").hide();
                self.set('rateusData.IS_RATED',true);
			});
            if(self.get('rateusData.ALERT_NAME')=='RATEUS_ALERT'){
                //Reset feedback icon
                $("#FEEDBACK_BUTTON").removeClass (function (index, className) {
                    return (className.match (/\bfw-icn\S+/g) || []).join(' ');
                });
                $("#FEEDBACK_BUTTON").addClass('fw-icn-feedback');
                self.set('rateusData.SHOW_ALERT',false); 
                self.set('rateusData.ICON_TITLE',I18NUtil.translate('ads.feedback.icon.tooltip.feedback'));
            }
		},
        sendRating : function()
		{
			var fromAddress = $('#RATING_FROM_ADDRESS').val();
			var rating = $('#RATING').val();
			var content = $('#RATING_CONTENT').val();
			
			if(rating == '' || content == '')
			{
                $('#rating-error').show();
                $('.rating-ask-later').hide();
                setTimeout(function(){
                    $('#rating-error').hide();
                    $('.rating-ask-later').show();
                },2000);   
			}
			else if(!ValidationUtil.isValidEmail(fromAddress))
			{	
                $('#rating-email-error').show();
                $('.rating-ask-later').hide();
                setTimeout(function(){
                    $('#rating-email-error').hide();
                    $('.rating-ask-later').show();
                },2000);
			}
			else
			{
				//Close Form
				$(".fw-rating-form").slideUp("slow",function(){});

				//Appending Product Rating Text for Mailer
				$('#RATING').val("PRODUCT RATING - "+rating); //No I18N
                
                //Setting Subject
                $('#subject').val("ManageEngine AD360 - Product Rating");//No I18N

				//Form submit will send mail to support
				$('#RATING_FORM').submit();

				//Updating Rating in DB for METrack Purpose
				var ratingDataModel = {};
				ratingDataModel['RATING'] = rating;
				ratingDataModel['FROM_ADDRESS'] = fromAddress;
				ratingDataModel['MAIL_CONTENT'] = content;
                var params = {"UPDATE_RATING":true, "SET_RATING":JSON.stringify(ratingDataModel)};

				var self = this;
				AJAXUtil.ajax('/RestAPI/WC/FeedbackAction?mTCall=updateFeedbackSettings', {feedbackDetails: JSON.stringify(params)})//No I18N 
				.then(function(json)
				{	
					//This will remove the 'Rate Us' link from feedback popup
                    //$(".floating-modal-rating").css('visibility','hidden');
					self.set('rateusData.IS_RATED', true);
                    
                    $('.fw-rating-form').slideUp("slow",function(){
                        if(!Ember.isBlank(json.sSTATUS)){
                             self.set("rateusData.SUCCESS_STATUS",json.sSTATUS);
                             $('.getSuccess').slideDown("slow"); 
                             setTimeout(function(){
                                $('.getSuccess').slideUp("slow"); 
                             },5000); //$(".floating-modal-rating").css('visibility','hidden');
                        }
                    });
                    //Reset feedback icon
                    $("#FEEDBACK_BUTTON").removeClass (function (index, className) {
                        return (className.match (/\bfw-icn\S+/g) || []).join(' ');
                    });
                    $("#FEEDBACK_BUTTON").addClass('fw-icn-feedback');
                    self.set('rateusData.SHOW_ALERT',false);
                    self.set('rateusData.ICON_TITLE',I18NUtil.translate('ads.feedback.icon.tooltip.feedback'));
					
					self.send('resetRating');
				});
			}
		},
		resetRating: function() {
				$("#RATING_FROM_ADDRESS").val("");
				$("#RATING").val("");
				$("#RATING_CONTENT").val("");
				$(".fw-rating-form .ratings").text("");
				$(".fw-rating-form .stars i").removeClass("active clicked");
		}//Rating actions end
    }
});
//ignorei18n_end