/*$Id$ */
/**
 * Usage :
 *        {{ha-config cancel='cancel' saveSettings='onSaveSettings'
    restartLater='onRestartLater' restartServer='onRestartServer' showStatus='showStatus'}} 
 */
//ignorei18n_start
import Ember from 'ember';
import I18NUtil from "../utils/i18n-util"; //NO I18N
import DialogUtil from "../utils/ads-dialog-util"; //NO I18N
import ValidationUtil from "../utils/ads-validation-util";//No I18N
import CommonUtil from "../utils/ads-common-util"; //NO I18N
import AJAXUtil from "../utils/ads-ajax-util";//No i18n

export default Ember.Component.extend({
    init: function () {
        this._super();
        this.set('doGetSettings', false);
        this.set('pageStatus', {});
        // this.send('sendSettings');
    },
    didReceiveAttrs : function(){
        if(!this.hasOwnProperty('haSettings')){
        this.send('initializeData');
        }
    },
    validateSettings: function () {
        var statusMessage = "";
        var returnValue = true;

        var serverName = Ember.$.trim(this.$('#HA_SERVER').val()); //No I18N
        var adminName = Ember.$.trim(this.$('#HA_USER').val()); //No I18N
        var adminPassword = Ember.$.trim(this.$('#HA_PASSWORD').val()); //No I18N
        var publicIp = Ember.$.trim(this.$('#HA_PUBLIC_IP').val()); //No I18N
        var publicName = Ember.$.trim(this.$('#HA_PUBLIC_NAME').val()); //No I18N

        if (serverName == '' || adminName == '' || adminPassword == '' || publicIp == '') {
            statusMessage = I18NUtil.translate('ads_admin_product_settings_ha_entries_not_null');
            returnValue = false;
        }
        else if (!/^(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/.test(publicIp) || publicIp == '0.0.0.0' || publicIp == '127.0.0.1') {
            statusMessage = I18NUtil.translate('ads_admin_product_settings_ha_public_ip_not_valid');
            returnValue = false;
        }
        else if (publicName != '' && !/^(([a-zA-Z]|[a-zA-Z][a-zA-Z0-9\-]*[a-zA-Z0-9])\.)*([A-Za-z]|[A-Za-z][A-Za-z0-9\-]*[A-Za-z0-9])$/.test(publicName)) {
            statusMessage = I18NUtil.translate('ads_admin_product_settings_ha_public_name_not_valid');
            returnValue = false;
        }

        if (returnValue == false) {
            DialogUtil.alert(this, statusMessage);//No I18N  
        }

        return returnValue;
    },
    setComponentData(component, key, value)
    {
      var components = this.get('COMPONENTS');
      Ember.set(components.find(function(currentComponent){
        return currentComponent.PRODUCT_ID == component.PRODUCT_ID
      }), key, value);
    },
    showSaveStatus: function (status) {
        var statusMsg = I18NUtil.translate(status.MESSAGE);
        var autoClose = false;
        var retVal = false;
        if (status.hasOwnProperty('CLUSTER_STATUS') && status.hasOwnProperty('CLUSTER_MESSAGE')) {
            statusMsg += ' ' + I18NUtil.translate(status.CLUSTER_MESSAGE);
        }

        if (status.MESSAGE == 'ads_admin_product_settings_ha_settings_configured') {
            this.send('cancelSettings');
            // this.send('getSettings', null, this.get('haSettings.settings.HA_PRODUCT'));
            // this.toggleProperty('doGetSettings');
            statusMsg = I18NUtil.translate(status.CLUSTER_MESSAGE);
            statusMsg += this.$('#restartMsgDiv').html();
            retVal = true;
        }
        if (status.MESSAGE == 'ads_admin_product_settings_ha_not_running_as_service') {
        //   this.send('getSettings', null, this.get('settings.HA_PRODUCT'));
          statusMsg = I18NUtil.translate(status.CLUSTER_MESSAGE);
        } 
        if (status.CLUSTER_MESSAGE == 'ads_admin_product_settings_ha_master_service_not_installed') {
            statusMsg = I18NUtil.translate(status.CLUSTER_MESSAGE);
            statusMsg += this.$('#HAServiceInstallDiv').html();
            this.set('SERVER_TYPE', 'master');
        }
        if (status.CLUSTER_MESSAGE == 'ads_admin_product_settings_ha_slave_service_not_installed') {
            statusMsg = I18NUtil.translate(status.CLUSTER_MESSAGE);
            statusMsg += this.$('#HAServiceInstallDiv').html();
            this.set('SERVER_TYPE', 'slave');
        }
        if (status.CLUSTER_MESSAGE == 'ads_admin_product_settings_ha_service_not_installed') {
            statusMsg = I18NUtil.translate(status.CLUSTER_MESSAGE);
            statusMsg += this.$('#HAServiceInstallDiv').html();
            this.set('SERVER_TYPE', 'both');
        }
        if (status.MESSAGE == 'ads_admin_product_settings_ha_settings_disabled') {
            // this.send('getSettings', null, this.get('haSettings.settings.HA_PRODUCT'));
            statusMsg = I18NUtil.translate(status.CLUSTER_MESSAGE);
        }
        if (status.hasOwnProperty('NOTIFY_STATUS') && status.hasOwnProperty('NOTIFY_MESSAGE')) {
            statusMsg += '<br><br>' + I18NUtil.translate(status.NOTIFY_MESSAGE);
        }
        if (status.MESSAGE == 'ads_admin_product_settings_ha_settings_not_disabled' && status.CLUSTER_MESSAGE == 'ads_admin_product_settings_ha_slave_down') {
            statusMsg = I18NUtil.translate('ads_admin_product_settings_ha_restart_slave'); //No I18N
        }
        if (status.CLUSTER_MESSAGE == 'ads_admin_product_settings_ha_service_not_privileged') 
        {
          statusMsg = I18NUtil.translate(status.CLUSTER_MESSAGE);
          statusMsg += this.$('#HAServiceUpdateDiv').html();
          this.set('OPERATION_TYPE', 'UPDATE');
          this.set('SERVER_TYPE', 'both');
        }
        if (status.CLUSTER_MESSAGE == 'ads_admin_product_settings_ha_master_service_not_privileged') 
        {
          statusMsg = I18NUtil.translate(status.CLUSTER_MESSAGE);
          statusMsg += this.$('#HAServiceUpdateDiv').html();
          this.set('OPERATION_TYPE', 'UPDATE')
          this.set('SERVER_TYPE', 'master');
        }
        if (status.CLUSTER_MESSAGE == 'ads_admin_product_settings_ha_slave_service_not_privileged') 
        {
          statusMsg = I18NUtil.translate(status.CLUSTER_MESSAGE);
          statusMsg += this.$('#HAServiceUpdateDiv').html();
          this.set('OPERATION_TYPE', 'UPDATE')
          this.set('SERVER_TYPE', 'slave');
        }
        var haProduct = this.get('haSettings.settings.HA_PRODUCT').replace("ManageEngine ", ""); //No I18N
        statusMsg = statusMsg.replace("{0}", haProduct);
        this.sendAction('showStatus', (status.STATUS == "error" ? 'danger' : 'success'), statusMsg, autoClose);
        return retVal;
    },
    modifyMasterSettings: function (masterSettings, settings) {
        masterSettings.ICON_STYLE = masterSettings.TAG_NAME.toLowerCase();
        masterSettings.MASTER_URL = this.haMasterURL(masterSettings, settings);
        masterSettings.SLAVE_URL = this.haSlaveURL(masterSettings, settings);
        return masterSettings;
    },

    modifySettings: function (settings) {
        settings.STATUS = settings.STATUS == 'true';
        return settings;
    },

    haMasterURL: function (masterSettings, settings) {
        if (masterSettings != null) {
            var host = settings.STATUS ? settings.MASTER_SERVER_NAME : masterSettings.HOST;
            return this.constructURL(masterSettings.PROTOCOL.toLowerCase(), host, masterSettings.PORT);
        }
        else {
            return null;
        }
    },

    haSlaveURL: function (masterSettings, settings) {
        if (settings.SLAVE_SERVER_NAME != null) {

            return this.constructURL(masterSettings.PROTOCOL.toLowerCase(), settings.SLAVE_SERVER_NAME, masterSettings.PORT);
        }
        else {
            return null;
        }
    },
    
    testConnection : function(url)
    {
      var status = AJAXUtil.syncAjax('/RestAPI/WC/JumpToAction?mTCall=testConnection', {"URL": url}, true, 'text');
      return Ember.$.trim(status) == 'success' ? true : false;
    },

    constructURL: function (protocol, host, port) {
        return protocol + "://" + host + ":" + port;
    },

    installCallBack:function(credential)
    {
      var self=this;
      var userName = credential.userName;
      var params={};
      params['HA_PRODUCT']=credential.HA_PRODUCT;
      params['SLAVE_SERVER_NAME']=credential.SLAVE_SERVER_NAME;
      params['ACCOUNT_NAME']=userName.split("\\")[1];
      params['DOMAIN']=userName.split("\\")[0];
      params['PASSWORD']=credential.password;
      params['SERVER_TYPE']=credential.SERVER_TYPE;
      CommonUtil.showLoading();
      
      var response;
      var operationType = credential.OPERATION_TYPE !=undefined ? credential.OPERATION_TYPE : "INSTALL" ;
      if (operationType == 'INSTALL')
      {
        response = AJAXUtil.syncAjax('/RestAPI/WC/HASettings?mTCall=installService', params);
      }
      else
      {
        response = AJAXUtil.syncAjax('/RestAPI/WC/HASettings?mTCall=updateServiceCredentials', params);
      }
                   
      if(response.hasOwnProperty('sSTATUS'))
      {
          if(self.get('notificationService')){
            self.get('notificationService').checkStatus('SERVICE_NOTIFIER');
          }
        self.sendAction('showStatus','success', I18NUtil.translate(response.sSTATUS), true);
      }
  
      CommonUtil.hideLoading();
      return response;
    },
    
    validateNTAccountDetails:function(credential)
    {
      var userName = credential.userName;
      var pwd = credential.password;
      var retObj = {'STATUS':'eSTATUS'};
      var message = null;
  
      if(pwd == null || userName == null)
      {
        message = I18NUtil.translate('ads.common.alert.mandatory_fields');
      }
      else if(!ValidationUtil.isDomainAccountName(userName))
      {
        message = I18NUtil.translate('ads_admin_product_settings_ha_userName_format_error');
      }
      else
      {
        return retObj['STATUS'] = "sSTATUS";
      }
  
      retObj['MESSAGE'] = message;
      return retObj;
    },

    actions: {
        getSettings: function(){
            var self =this;
            this.sendAction('beforeLoading');
            Ember.run.schedule('afterRender',function() {
                AJAXUtil.ajax('/RestAPI/WC/HASettings?mTCall=getHADetails',{}).then(function(response){
                    try{
                    if(response.eSTATUS){
                        //do handle
                    }else{
                        self.set('haSettings',{});
                        self.set('haSettings.settings',self.modifySettings(response.HA_SETTINGS));
                        self.set('haSettings.masterSettings', self.modifyMasterSettings(response.HA_MASTER_SETTINGS,self.get('haSettings.settings')));
                        var haSettings = self.get('haSettings');
                        var component = { DISPLAY_NAME: haSettings.masterSettings.DISPLAY_NAME, TAG_NAME: haSettings.masterSettings.TAG_NAME, PRODUCT_NAME: haSettings.settings.HA_PRODUCT, PRODUCT_ID: haSettings.settings.PRODUCT_ID, MASTER_SERVER_NAME: haSettings.settings.STATUS ? haSettings.settings.MASTER_SERVER_NAME : haSettings.masterSettings.HOST, SLAVE_SERVER_NAME: haSettings.settings.SLAVE_SERVER_NAME, MASTER_URL: haSettings.masterSettings.MASTER_URL, SLAVE_URL: haSettings.masterSettings.SLAVE_URL, VIRTUAL_HOST_NAME: haSettings.settings.VIRTUAL_HOST_NAME, PUBLIC_IP: haSettings.settings.PUBLIC_IP, STATUS: haSettings.settings.STATUS };
                        var key = component.STATUS ? component.TAG_NAME + "_MASTER_URL" : component.TAG_NAME;
                        var masterStatus = self.testConnection(component.MASTER_URL);//self.get('GLOBAL_DATA.productStatus')[key] == 'true' ? true : false;
                        Ember.set(component, 'SERVER_STATUS', masterStatus);
            
                        if (component.STATUS) {
                            var masterStatus = (masterStatus)?(masterStatus):self.testConnection(component.MASTER_URL);
                            var slaveStatus = self.testConnection(component.SLAVE_URL);
                            Ember.set(component, 'SERVER_STATUS', masterStatus);
                            Ember.set(component, 'SLAVE_SERVER_STATUS', slaveStatus);
            
                            if (slaveStatus && masterStatus && !component.hasOwnProperty('RESTART_REQUIRED')) {
                                Ember.set(component, 'RESTART_REQUIRED', true);
                            }
                        }
                        self.set('haSettings.selectedComponent',component);
                        self.set('isDisabled', !self.get('haSettings.settings.STATUS'));
                    }
                    self.sendAction('afterLoading');
                }catch(err){
                }
                });
            });
        },
        toggleHASettings(isEnabled){
            this.set('haSettings.settings.STATUS', isEnabled);
            this.set('isDisabled', !isEnabled);
        },  
        initializeData: function(){
            //initilize data to be shown
            // if(this.get('showEnableCheckBox')){
               this.send('getSettings');
            // this.set('isHAEnabled', false);
            // }
        },
        clearFormData: function () {
            this.set('haSettings.settings.SLAVE_SERVER_NAME', '');
            this.set('haSettings.settings.SLAVE_ADMIN_NAME', '');
            this.set('haSettings.settings.SLAVE_ADMIN_PASSWORD', '');
            this.set('haSettings.settings.PUBLIC_IP', '');
            this.set('haSettings.settings.VIRTUAL_HOST_NAME', '');
        },
        saveSettings: function (enableHA) {
            var self = this;
            if (!enableHA || this.validateSettings()) {
                CommonUtil.showLoading();
                var data = {};
                var settingsData = this.get('haSettings.settings');
                for (var key in settingsData) {
                    data[key] = settingsData[key];
                }
                data['STATUS'] = enableHA;
                AJAXUtil.ajax('/RestAPI/WC/HASettings?mTCall=save', data).then(function (response) {
                    CommonUtil.hideLoading();
                    if (response.hasOwnProperty("eSTATUS")) {
                        self.sendAction('showStatus', 'danger', response.eSTATUS, false);
                    }
                    else {
                        // var currentComponent = self.get('haSettings.selectedComponent');
                        if (enableHA) {
                            // self.setComponentData(currentComponent, 'RESTART_REQUIRED', true);
                            self.set('haSettings.selectedComponent.RESTART_REQUIRED', true);
                        }
                        if(self.showSaveStatus(response)){
                        self.sendAction('saveSettings');
                        }
                    }
                });
            }
        },

        cancelSettings: function () {
            Ember.$(".status-alert-danger").slideUp('fast');
            this.send('clearFormData');
            if(this.get('enableSaveOptions')){
                this.send('initializeData');
            }
            this.sendAction('cancel');
        },

        restartServer: function (component) {
            // this.setComponentData(component != null ? component : this.get('haSettings.selectedComponent'), 'RESTART_REQUIRED', false);
            this.set('haSettings.selectedComponent.RESTART_REQUIRED', false);
            var data = {};
            data['HA_PRODUCT'] = component != null ? component.PRODUCT_NAME : this.get('haSettings.settings.HA_PRODUCT');
            var response = AJAXUtil.syncAjax('/RestAPI/WC/HASettings?mTCall=restartServer', data);
            var status = response.status;
            if(status==undefined) // Status will not be obtained if the server is succesfully restarted
            {
              status = 'success';
            }
            var statusMsg = I18NUtil.translate('ads_admin_product_settings_ha_server_restart_' + status, [data.HA_PRODUCT]);    
            window.WindowHandler.sendRequest(parent, 'reloadAppsPane', '[]');
            this.sendAction('restartServer',{statusMsg,response});
            this.sendAction('showStatus', (status == "error" ? 'danger' : 'success'), statusMsg, false);
        },

        restartLater: function () {
            // this.setComponentData(this.get('haSettings.selectedComponent'), 'RESTART_REQUIRED', true);
            this.set('haSettings.selectedComponent.RESTART_REQUIRED', true);
            this.sendAction('restartLater','info', I18NUtil.translate('ads_admin_product_settings_ha_server_restart_later_note'));
            this.sendAction('showStatus', 'info', I18NUtil.translate('ads_admin_product_settings_ha_server_restart_later_note'), false);
        },

        ShowInstallDialog:function()
        {
            var serverType = this.get('SERVER_TYPE');
            var params = {};
            var callBckFuncKeys = {};
            var operationType = this.get('OPERATION_TYPE')!=undefined ? this.get('OPERATION_TYPE') : "INSTALL" ;
            callBckFuncKeys['HA_PRODUCT'] = this.get('haSettings.selectedComponent.PRODUCT_NAME');
            callBckFuncKeys['SLAVE_SERVER_NAME'] = this.get('haSettings.settings.SLAVE_SERVER_NAME');
            callBckFuncKeys['SERVER_TYPE'] = serverType;
            callBckFuncKeys.OPERATION_TYPE = operationType;

            if(serverType == 'both')
            {
                params = {"title":operationType == "INSTALL" ? "ads_admin_product_settings_ha_credentials_popup_title" : "ads_admin_product_settings_ha_update_credentials_popup_title","userNameText":"ads_admin_product_settings_ha_credentials_popup_userName","buttonName":operationType == "INSTALL" ? "ads_admin_product_settings_ha_credentials_popup_install_button_text" : "ads_admin_product_settings_ha_credentials_popup_update_button_text","waitForResponse":true,"validate":true,"callBckFuncKeys":callBckFuncKeys};
            }
            else if(serverType == 'master')
            {
                params = {"title":operationType == "INSTALL" ? "ads_admin_product_settings_ha_credentials_popup_title_primary" : "ads_admin_product_settings_ha_update_credentials_popup_title_primary","userNameText":"ads_admin_product_settings_ha_credentials_popup_userName","buttonName":operationType == "INSTALL" ? "ads_admin_product_settings_ha_credentials_popup_install_button_text" : "ads_admin_product_settings_ha_credentials_popup_update_button_text","waitForResponse":true,"validate":true,"callBckFuncKeys":callBckFuncKeys};
            }
            else
            {
                params = {"title":operationType === "INSTALL" ? "ads_admin_product_settings_ha_credentials_popup_title_secondary" : "ads_admin_product_settings_ha_update_credentials_popup_title_secondary","userNameText":"ads_admin_product_settings_ha_credentials_popup_userName","buttonName":operationType === "INSTALL" ? "ads_admin_product_settings_ha_credentials_popup_install_button_text" : "ads_admin_product_settings_ha_credentials_popup_update_button_text","waitForResponse":true,"validate":true,"callBckFuncKeys":callBckFuncKeys};
            }
    
            params['userPlaceHolder'] = I18NUtil.translate('ads_admin_product_settings_ha_credentials_popup_user_placeholder');
            DialogUtil.credential(this,params);
            CommonUtil.afterRender();
        },
        showStatus: function(level,message,autoClose){
            this.sendAction('showStatus',level,message,autoClose);
        }
    }
});
//ignorei18n_end