/*$Id$*/
/**
 *   {{ha-view configure='configure' haSettings=haSettings showStatus='showStatus'}}
 */
//ignorei18n_start
import Ember from 'ember';
import I18NUtil from "../utils/i18n-util"; //NO I18N
import DialogUtil from "../utils/ads-dialog-util"; //NO I18N
import CommonUtil from "../utils/ads-common-util"; //NO I18N
import AJAXUtil from "../utils/ads-ajax-util";//No i18n
export default Ember.Component.extend({
    init: function () {
        this._super();
        this.set('pageStatus', {});
        this.set('products', {});
        this.set('COMPONENTS', []);
        this.set('application',Ember.inject.controller('application'));
        this.send('getSettings');//No i18n
    },
    // setServerStatusObserver: function(){
    //     this.send('setServerStatus');
    // }.observes('doSetServerStatus'),    

    setComponentDataChange: function(){
        var restartRequired = this.get('haSettings.selectedComponent.RESTART_REQUIRED');
        this.setComponentData(this.get('haSettings.selectedComponent'),"RESTART_REQUIRED",restartRequired);
    },
    
    // getSettingsObserver: function(){
    //     this.send('getSettings');//No i18n
    // }.observes('doGetSettings'),//No i18n
    
    ProductDataObserver: function () {
        var components = [];
        for (var key in this.products) {
            var product = this.products[key];
            if (key == "2" || key == "6" || product.IS_FEATURE_ENABLED == 'true') {
                var settings = this.modifySettings(product.HA_SETTINGS);
                var masterSettings = this.modifyMasterSettings(product.HA_MASTER_SETTINGS, settings);
                this.set('products.' + key + '.HA_SETTINGS', settings);
                this.set('products.' + key + '.HA_MASTER_SETTINGS', masterSettings);
                components.pushObject({ DISPLAY_NAME: product.DISPLAY_NAME, TAG_NAME: product.TAG_NAME, PRODUCT_NAME: settings.HA_PRODUCT, PRODUCT_ID: product.PRODUCT_ID, MASTER_SERVER_NAME: settings.STATUS ? settings.MASTER_SERVER_NAME : masterSettings.HOST, SLAVE_SERVER_NAME: settings.SLAVE_SERVER_NAME, MASTER_URL: masterSettings.MASTER_URL, SLAVE_URL: masterSettings.SLAVE_URL, VIRTUAL_HOST_NAME: settings.VIRTUAL_HOST_NAME, PUBLIC_IP: settings.PUBLIC_IP, STATUS: settings.STATUS });
            }
        }
        this.set('COMPONENTS', components);
    }.observes('products'),

    setServerStatus: function () {
        var self = this;
        var components = this.get('COMPONENTS');
        components.forEach(function (component, index) {

            var currentComponent = self.get('COMPONENTS').objectAt(index);
            var key = component.STATUS ? component.TAG_NAME + "_MASTER_URL" : component.TAG_NAME;
            // var masterStatus = self.get('GLOBAL_DATA.productStatus')[key] == 'true' ? true : false;
            // Ember.set(currentComponent, 'SERVER_STATUS', masterStatus);
            var masterStatus = self.testConnection(component.MASTER_URL);
            Ember.set(currentComponent, 'SERVER_STATUS', masterStatus);

            if (component.STATUS) {
                var slaveStatus = self.testConnection(component.SLAVE_URL);
                Ember.set(currentComponent, 'SLAVE_SERVER_STATUS', slaveStatus);

                if (slaveStatus && masterStatus && !currentComponent.hasOwnProperty('RESTART_REQUIRED')) {
                    Ember.set(currentComponent, 'RESTART_REQUIRED', true);
                }
            }
        }, self);
    }.observes('COMPONENTS'),

    modifyMasterSettings: function (masterSettings, settings) {
        masterSettings.ICON_STYLE = masterSettings.TAG_NAME.toLowerCase();
        masterSettings.MASTER_URL = this.haMasterURL(masterSettings, settings);
        masterSettings.SLAVE_URL = this.haSlaveURL(masterSettings, settings);
        return masterSettings;
    },

    modifySettings: function (settings) {
        settings.STATUS = settings.STATUS == 'true';
        return settings;
    },

    haMasterURL: function (masterSettings, settings) {
        if (masterSettings != null) {
            var host = settings.STATUS ? settings.MASTER_SERVER_NAME : masterSettings.HOST;
            return this.constructURL(masterSettings.PROTOCOL.toLowerCase(), host, masterSettings.PORT);
        }
        else {
            return null;
        }
    },

    haSlaveURL: function (masterSettings, settings) {
        if (settings.SLAVE_SERVER_NAME != null) {

            return this.constructURL(masterSettings.PROTOCOL.toLowerCase(), settings.SLAVE_SERVER_NAME, masterSettings.PORT);
        }
        else {
            return null;
        }
    },

    constructURL: function (protocol, host, port) {
        return protocol + "://" + host + ":" + port;
    },

    showSaveStatus: function (status) {
        var statusMsg = I18NUtil.translate(status.MESSAGE);
        var autoClose = false;
        if (status.hasOwnProperty('CLUSTER_STATUS') && status.hasOwnProperty('CLUSTER_MESSAGE')) {
            statusMsg += ' ' + I18NUtil.translate(status.CLUSTER_MESSAGE);
        }

        if (status.MESSAGE == 'ads_admin_product_settings_ha_settings_disabled') {

            this.send('getSettings');//, null, this.get('settings.HA_PRODUCT'));
            statusMsg = I18NUtil.translate(status.CLUSTER_MESSAGE);
        }
        if (status.hasOwnProperty('NOTIFY_STATUS') && status.hasOwnProperty('NOTIFY_MESSAGE')) {
            statusMsg += '<br><br>' + I18NUtil.translate(status.NOTIFY_MESSAGE);
        }
        if (status.MESSAGE == 'ads_admin_product_settings_ha_settings_not_disabled' && status.CLUSTER_MESSAGE == 'ads_admin_product_settings_ha_slave_down') {
            statusMsg = I18NUtil.translate('ads_admin_product_settings_ha_restart_slave'); //No I18N
        }

        var haProduct = this.get('haSettings.settings.HA_PRODUCT').replace("ManageEngine ", ""); //No I18N
        statusMsg = statusMsg.replace("{0}", haProduct);
        this.sendAction('showStatus', (status.STATUS == "error" ? 'danger' : 'success'), statusMsg, autoClose);
    },
    setComponentData(component, key, value)
    {
      var components = this.get('COMPONENTS');
      Ember.set(components.find(function(currentComponent){
        return currentComponent.PRODUCT_ID == component.PRODUCT_ID
      }), key, value);
    },
    testConnection : function(url)
    {
      var status = AJAXUtil.syncAjax('/RestAPI/WC/JumpToAction?mTCall=testConnection', {"URL": url}, true, 'text');
      return Ember.$.trim(status) == 'success' ? true : false;
    },
    validateSettings: function () {
        var statusMessage = "";
        var returnValue = true;

        var serverName = adsjQuery.trim(adsjQuery('#HA_SERVER').val()); //No I18N
        var adminName = adsjQuery.trim(adsjQuery('#HA_USER').val()); //No I18N
        var adminPassword = adsjQuery.trim(adsjQuery('#HA_PASSWORD').val()); //No I18N
        var publicIp = adsjQuery.trim(adsjQuery('#HA_PUBLIC_IP').val()); //No I18N
        var publicName = adsjQuery.trim(adsjQuery('#HA_PUBLIC_NAME').val()); //No I18N

        if (serverName == '' || adminName == '' || adminPassword == '' || publicIp == '') {
            statusMessage = I18NUtil.translate('ads_admin_product_settings_ha_entries_not_null');
            returnValue = false;
        }
        else if (!/^(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/.test(publicIp) || publicIp == '0.0.0.0' || publicIp == '127.0.0.1') {
            statusMessage = I18NUtil.translate('ads_admin_product_settings_ha_public_ip_not_valid');
            returnValue = false;
        }
        else if (publicName != '' && !/^(([a-zA-Z]|[a-zA-Z][a-zA-Z0-9\-]*[a-zA-Z0-9])\.)*([A-Za-z]|[A-Za-z][A-Za-z0-9\-]*[A-Za-z0-9])$/.test(publicName)) {
            statusMessage = I18NUtil.translate('ads_admin_product_settings_ha_public_name_not_valid');
            returnValue = false;
        }

        if (returnValue == false) {
            DialogUtil.alert(this, statusMessage);//No I18N  
        }

        return returnValue;
    },
    actions: {
        getSettings: function () {
            var self = this;
            // this.get('application').getStatus();
            this.sendAction('beforeLoading');
            Ember.run.schedule('afterRender',function(){
                AJAXUtil.ajax('/RestAPI/WC/HASettings?mTCall=getHASettings', {}).then(function (response) {
                    try {                        
                        self.set('products', response);
                        self.sendAction('afterLoading');
                    } catch (error) {
                    }
                });
            });            
        },
        removeConfirm: function (component) {
            DialogUtil.confirm(this, 'ads_admin_product_settings_ha_remove_confirm_message', 'remove', 'ads.admin.product_settings.ha.remove_configuration', component);
        },
        remove: function (component) {
            this.send('loadComponentData', component);
            this.send('saveSettings', false);
            window.WindowHandler.sendRequest(parent, 'reloadAppsPane', '[]');
        },
        saveSettings: function (enableHA) {
            var self = this;
            if (!enableHA || this.validateSettings()) {
                CommonUtil.showLoading();
                var data = {};
                var settingsData = this.get('haSettings.settings');
                for (var key in settingsData) {
                    data[key] = settingsData[key];
                }
                data['STATUS'] = enableHA;
                AJAXUtil.ajax('/RestAPI/WC/HASettings?mTCall=save', data).then(function (response) {
                    CommonUtil.hideLoading();
                    if (response.hasOwnProperty("eSTATUS")) {
                        self.sendAction('showStatus', 'danger', response.eSTATUS, false);
                    }
                    else {
                        var currentComponent = self.get('haSettings.selectedComponent');
                        if (enableHA) {
                            self.setComponentData(currentComponent, 'RESTART_REQUIRED', true);
                        }
                        self.showSaveStatus(response);
                    }
                });
            }
        },

        loadComponentData: function (component) {
            var selectedComponent = this.products[component.PRODUCT_ID];
            // this.set('masterSettings', selectedComponent.HA_MASTER_SETTINGS);
            // this.set('settings', selectedComponent.HA_SETTINGS);
            this.set('haSettings',{});
            this.set('haSettings.masterSettings',selectedComponent.HA_MASTER_SETTINGS);
            this.set('haSettings.settings', selectedComponent.HA_SETTINGS);
            this.set('haSettings.selectedComponent', component);
        },
        configure: function(component){
            this.send('loadComponentData',component);
            this.$('#HA_CONFIG').show(); //No i18n
            this.$('#HA_VIEW').hide(); //No i18n
            // this.set('showConfigForm',true);
            // this.sendAction('configure',this.get('haSettings'));
        },
        restartServer: function (component) {
            this.setComponentData(component != null ? component : this.get('selectedComponent'), 'RESTART_REQUIRED', false);
            var data = {};
            data['HA_PRODUCT'] = component != null ? component.PRODUCT_NAME : this.get('haSettings.settings.HA_PRODUCT');
            var response = AJAXUtil.syncAjax('/RestAPI/WC/HASettings?mTCall=restartServer', data);
            var statusMsg = I18NUtil.translate('ads_admin_product_settings_ha_server_restart_' + response.status, [data['HA_PRODUCT']]);
            window.WindowHandler.sendRequest(parent, 'reloadAppsPane', '[]');
            this.sendAction('showStatus', (response.status == "error" ? 'danger' : 'success'), statusMsg, false);
        },
        onRestartServer: function() {
            // this.toggleProperty('doSetComponentData');
            this.setComponentDataChange();
        },
        onRestartLater: function() {
            // this.toggleProperty('doSetComponentData');
            this.setComponentDataChange();
        },
        cancel: function(){
            this.$('#HA_CONFIG').hide(); //No i18n
            this.$('#HA_VIEW').show(); //No i18n
        },
        onSaveSettings: function(){
            this.$('#HA_CONFIG').hide(); //No i18n
            this.$('#HA_VIEW').show(); //No i18n
            this.send('getSettings');
            this.setComponentDataChange();
            // this.toggleProperty('doGetSettings');
            // this.toggleProperty('doSetComponentData');

        },
        showStatus : function(level,message,autoClose){
            this.sendAction('showStatus',level,message,autoClose);
        }
    }
});
//ignorei18n_end