/* $Id$ */
import Ember from 'ember'; // No I18N
import AJAXUtil from '../../utils/ads-ajax-util'; // No I18N
import DialogUtil from "../../utils/ads-dialog-util"; // No I18N
import I18NUtil from '../../utils/i18n-util'; // No I18N
import CommonUtil from '../../utils/ads-common-util'; // No I18N
import ValidationUtil from '../../utils/ads-validation-util';//No i18n
/*
 * Usage : 
 *
 *	{{logforward/logforward-config currentConfig=currentConfig cancelEdit='cancelEdit' callCancel=callCancel saveConfig='saveLogForwardConfig'}}
 * 
 */
export default Ember.Component.extend({
    pageStatus: {},
    syslogAdvanced: false,
    facility: -1,
    severity: -1,
    postURLEndPoint: '/services/collector/event',//No I18N
    cefDeviceEventClassId: Ember.computed('currentConfig.TAG_NAME', 'currentConfig.cefDeviceVersion', function () { //No I18N
        var self = this;
        var temp = self.get('currentConfig.TAG_NAME') + self.get('currentConfig.cefDeviceVersion'); // No I18N
        return temp;
    }),
    cefEventDescription: Ember.computed('currentConfig.TAG_NAME', function () { // No I18N
        var self = this;
        var temp = self.get('currentConfig.TAG_NAME') + ' Event'; // No I18N
        return temp;
    }),
    syslogHelpText: Ember.computed('currentConfig.PARAMS.version', function () { // No I18N
        var self = this;
        if (self.get('currentConfig.PARAMS.version') == '5424') { // No I18N
            return I18NUtil.translate('ads.admin.logforwarderconfig.help.5424'); //No I18N
        } else if (self.get('currentConfig.PARAMS.version') == '3164') { // No I18N
            return I18NUtil.translate('ads.admin.logforwarderconfig.help.3164'); //No I18N
        } else if (self.get('currentConfig.PARAMS.version') == 'rawlog') { // No I18N
            return I18NUtil.translate('ads.admin.logforwarderconfig.help.rawlog'); //No I18N
        } else if (self.get('currentConfig.PARAMS.version') == 'CEF') { //No I18N
            return I18NUtil.translate('ads.admin.logforwarderconfig.help.cef'); //No I18N
        }
    }),
    /*	syslogDataFormat:Ember.computed('currentConfig.version',function(){// No I18N
    		var data;
    		var self=this;
    		if(self.get('currentConfig.version')=='5424'){// No I18N
    			data='---';
    		}else if (value=='3164'){
    			data=':';
    		}
    		return data;
    	}),*/
    severityChanged: Ember.observer('currentConfig.PARAMS.severity', function () { // No I18N
        var self = this;
        self.send('setSyslogFacilityAndPriority'); // No I18N
    }),
    serverNameChanged: Ember.observer('currentConfig.HOST', function () { // No I18N
        if (this.get('currentConfig.FORWARDER_NAME') == 'splunkForward' && !this.get('isSyslog')) {
            this.set('currentConfig.PARAMS.postURL', this.get('postURLProtocol') + '://' + this.get('currentConfig.HOST') + ':' + this.get('currentConfig.PORT') + this.get('postURLEndPoint')); // No I18N
        }
    }),
    portChanged: Ember.observer('currentConfig.PORT', function () { // No I18N
        if (this.get('currentConfig.FORWARDER_NAME') == 'splunkForward' && !this.get('isSyslog')) {
            this.set('currentConfig.PARAMS.postURL', this.get('postURLProtocol') + '://' + this.get('currentConfig.HOST') + ':' + this.get('currentConfig.PORT') + this.get('postURLEndPoint')); // No I18N
        }
    }),
    postURLProtocolChanged: Ember.observer('postURLProtocol', function () { // No I18N
        if (this.get('currentConfig.FORWARDER_NAME') == 'splunkForward' && !this.get('isSyslog')) {
            this.set('currentConfig.PARAMS.postURL', this.get('postURLProtocol') + '://' + this.get('currentConfig.HOST') + ':' + this.get('currentConfig.PORT') + this.get('postURLEndPoint')); // No I18N
        }
    }),
    callCancelEdit: Ember.observer('callCancel', function () {//No I18N
        if (this.get('callCancel')) {
            this.send('cancelEdit');//No I18N
        }
    }),
    willDestroy: function () {
        this.set('callCancel', false);//No I18N
    },
    isValidSeverity: function (severity) {
        var isValid = true;
        severity = (severity === 0 || severity === '0') ? '0' : (severity = severity * 1);
        if (!severity || severity != severity || severity < 0 || severity > 191) {
            isValid = false;
        }
        return isValid;
    },
    calculatePriority: function () {
        var self = this;
        var sev = (self.get('currentConfig.priority') * 1) + (self.get('currentConfig.facility') * 8); //as in RFC 3164// No I18N
        self.set('currentConfig.PARAMS.severity', sev); // No I18N
    },
    init: function () {
        this._super.apply(this, arguments);
        var defaultValues = {};
        var forwarderNames = ['syslogForward', 'splunkForward']; // No I18N
        var forwarderDisplayNames = ['Syslog', 'Splunk']; // No I18N
        this.set('FORWARDER_NAMES', CommonUtil.setDropDownValues(forwarderDisplayNames, forwarderNames)); // No I18N

        var versions = Ember.A([{
            "CLIENT_VALUE": "RFC 3164",//No I18N
            "SERVER_VALUE": "3164"//No I18N
        },{
            "CLIENT_VALUE": "RFC 5424",//No I18N
            "SERVER_VALUE": "5424"//No I18N
        }]); //No I18N
        this.set('VERSIONS', versions); // No I18N

        var facilityValues = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23];
        var facilityDisplayNames = ['Kernel', 'User', 'Mail', 'Daemons', 'Auth', 'Syslog', 'Lpr', 'NEWS', 'UUCP', 'Clock Daemon', 'AuthPriv', 'FTP', // No I18N
            'NTP subsystem', 'Log Audit', 'Log Alert', 'Cron', 'Local 0', 'Local 1', 'Local 2', 'Local 3', 'Local 4', 'Local 5', // No I18N
            'Local 6', 'Local 7'//No I18N
        ]; // No I18N
        this.set('FACILITIES', CommonUtil.setDropDownValues(facilityDisplayNames, facilityValues)); // No I18N

        var severityValues = [0, 1, 2, 3, 4, 5, 6, 7];
        var severityDisplayNames = ['Emergency', 'Alert', 'Critical', 'Error', 'Warning', 'Notice', 'Information', 'Debug']; // No I18N

        this.set('SEVERITIES', CommonUtil.setDropDownValues(severityDisplayNames, severityValues)); // No I18N

        var protocolNames = ['udp', 'tcp']; // No I18N
        var protocolDisplayNames = ['UDP', 'TCP']; // No I18N
        this.set('PROTOCOLS', CommonUtil.setDropDownValues(protocolDisplayNames, protocolNames)); // No I18N

        var sslStatus = ['true', 'false']; //No I18N
        var sslStatusDisplayNames = ["Enabled", "Disabled"]; //No I18N
        this.set('SSLSTATUS', CommonUtil.setDropDownValues(sslStatusDisplayNames, sslStatus)); //No I18N

        var cefSeverityValues = ['Low', 'Medium', 'High', 'Very High']; //No I18N
        var cefSeverityDisplayNames = ['Low', 'Medium', 'High', 'Very High']; //No I18N
        this.set('CEF_SEVERITY', CommonUtil.setDropDownValues(cefSeverityDisplayNames, cefSeverityValues)); //No I18N
        this.send('setConfig', false);//No I18N
    },
    actions: {
        setConfig: function (isForwarderChange) {
            var self = this;
            var currentConfig = self.get('currentConfig');//No I18N
            self.set('productName', currentConfig.PRODUCT_NAME); // No I18N
            self.set('productTagName', currentConfig.TAG_NAME); //No I18N
            if (currentConfig.hasOwnProperty('sStatus')) {
                if (currentConfig.isCEFSupported && currentConfig.isCEFSupported == 'true' && !self.get('isCEFEnabled')) { // No I18N
                    self.send('addToSyslogVersions', 'CEF', 'CEF'); // No I18N
                    self.set('isCEFEnabled', true); //No I18N
                } else if (currentConfig.isCEFSupported && currentConfig.isCEFSupported == 'false' && self.get('isCEFEnabled')) { // No I18N
                    self.send('removeFromSyslogVersions', 'CEF'); // No I18N
                    self.set('isCEFEnabled', false); // No I18N
                }
                if (currentConfig.isRawLogSupported && currentConfig.isRawLogSupported == 'true' && !self.get('isRawLogEnabled')) { // No I18N
                    self.send('addToSyslogVersions', 'RawLog', 'rawlog'); // No I18N
                    self.set('isRawLogEnabled', true); // No I18N
                } else if (currentConfig.isRawLogSupported && currentConfig.isRawLogSupported == 'false' && self.get('isRawLogEnabled')) {//No I18N
                    self.send('removeFromSyslogVersions', 'rawlog'); // No I18N
                    self.set('isRawLogEnabled', false); // No I18N
                }
                if (currentConfig.PARAMS == undefined) {
                    self.set('currentConfig.PARAMS', {}); //No I18N
                }
                self.set('currentConfig.HOST', currentConfig.HOST ? currentConfig.HOST : '');//No I18N
                self.set('currentConfig.PORT', currentConfig.PORT ? currentConfig.PORT : '');//No I18N
                if (!currentConfig.isConfigured) {
                    self.set('currentConfig.FORWARDER_NAME', self.get('currentConfig.FORWARDER_NAME') ? self.get('currentConfig.FORWARDER_NAME') : 'syslogForward'); //No I18N
                    if (self.get('currentConfig.FORWARDER_NAME') == 'syslogForward') { //No i18n
                        self.send('resetSyslogVersion'); //No I18N
                    }
                }
                if (self.get('currentConfig.FORWARDER_NAME')) {
                    if (!isForwarderChange) {
                        self.set('currentForwarder', self.get('currentConfig.FORWARDER_NAME')); // No I18N
                    }
                    if (self.get('currentConfig.FORWARDER_NAME') === 'syslogForward') {
                        self.set('isSyslog', true); //No I18N
                        self.send('setSyslogStandardDataFormat'); //No I18N
                        self.send('setSyslogDataFormatVersion', '', currentConfig.PARAMS.version); //No I18N
                    } else if (self.get('currentConfig.FORWARDER_NAME') === 'splunkForward') { //No I18N
                        self.set('isSyslog', false); //No I18N
                        self.set('currentConfig.PARAMS.authenticationToken', '');//No I18N
                        self.send('setSplunkPostURL'); //No I18N
                    }
                }
                if (currentConfig.hasOwnProperty('logCategories')) { //No I18N
                    self.set('isLogCategoriesAvailable', true); //No I18N
                } else {
                    self.set('currentConfig.logCategories', []); //No I18N
                    self.set('isLogCategoriesAvailable', false); //No I18N
                }
            }
        },
        setSyslogStandardDataFormat: function () {
            this.set('severityPrefix', '<'); //No I18N
            this.set('severitySuffix', '>'); //No I18N
            this.set('sampleTimeStamp', '2018-01-01T00:00:00:00Z'); //No I18N
        },
        setSyslogStandardFormatParams: function (isDataFormatChanged) {
            if (!isDataFormatChanged) {
                this.set('currentConfig.PARAMS.protocol', this.get('currentConfig.PARAMS.protocol') ? this.get('currentConfig.PARAMS.protocol') : 'udp'); //No I18N
            }
            this.set('currentConfig.PARAMS.hostNameSeparator', this.get('currentConfig.PARAMS.hostNameSeparator') ? this.get('currentConfig.PARAMS.hostNameSeparator') : ''); // No I18N
            this.set('currentConfig.PARAMS.valueSuffix', this.get('currentConfig.PARAMS.valueSuffix') ? this.get('currentConfig.PARAMS.valueSuffix') : ']'); // No I18N
            this.set('currentConfig.PARAMS.keyPrefix', this.get('currentConfig.PARAMS.keyPrefix') ? this.get('currentConfig.PARAMS.keyPrefix') : '['); // No I18N
            this.set('currentConfig.PARAMS.keyValueSeparator', this.get('currentConfig.PARAMS.keyValueSeparator') ? this.get('currentConfig.PARAMS.keyValueSeparator') : '='); //No I18N
            if (!this.get('currentConfig.PARAMS').hasOwnProperty('severity')) { //No I18N
                this.set('facility', 13); // No I18N
                this.set('priority', 6); // No I18N
                this.send('calculatePriority'); //No I18N
            } else {
                this.send('setSyslogFacilityAndPriority'); //No I18N
            }
        },
        setSyslogCEFParams: function () {
            var self = this;
            self.set('currentConfig.PARAMS.cefVersion', this.get('currentConfig.PARAMS.cefVersion') ? this.get('currentConfig.PARAMS.cefVersion') : 'CEF:0'); //No I18N
            self.set('currentConfig.PARAMS.cefDeviceVendor', this.get('currentConfig.PARAMS.cefDeviceVendor') ? this.get('currentConfig.PARAMS.cefDeviceVendor') : 'ManageEngine'); //No I18N
            self.set('currentConfig.PARAMS.cefDeviceVersion', this.get('currentConfig.PARAMS.cefDeviceVersion') ? this.get('currentConfig.PARAMS.cefDeviceVersion') : '1'); //No I18N
            self.set('currentConfig.PARAMS.cefDeviceEventClassId', self.get('currentConfig.TAG_NAME') + '1'); //No I18N
            self.set('currentConfig.PARAMS.cefSeverity', this.get('currentConfig.PARAMS.cefSeverity') ? this.get('currentConfig.PARAMS.cefSeverity') : 'Medium'); //No I18N
            this.set('currentConfig.PARAMS.valueSuffix', this.get('currentConfig.PARAMS.valueSuffix') ? this.get('currentConfig.PARAMS.valueSuffix') : ']'); // No I18N
            this.set('currentConfig.PARAMS.keyPrefix', this.get('currentConfig.PARAMS.keyPrefix') ? this.get('currentConfig.PARAMS.keyPrefix') : '['); // No I18N            
            this.set('currentConfig.PARAMS.keyValueSeparator', this.get('currentConfig.PARAMS.keyValueSeparator') ? this.get('currentConfig.PARAMS.keyValueSeparator') : '='); //No I18N
            this.set('cefSampleTimeStamp', 'Feb 06 2018 11:36:49.625 IST'); //No I18N            
            self.send('setSyslogCEFDefaults'); //No I18N
        },
        setSyslogCEFDefaults: function () {
            this.set('cefSeparator', '|'); //No I18N
            this.set('currentConfig.PARAMS.cefEventDescription', this.get('currentConfig.TAG_NAME') + ' Event'); //No I18N
        },
        resetSyslogVersion: function (argument) {
            var self = this;
            var versions = self.get('VERSIONS');//No I18N
            if (versions.length > 0) {
                let temp = versions.objectAt(0);
                self.send('setSyslogDataFormatVersion', temp.CLIENT_VALUE, temp.SERVER_VALUE); //No I18N
            }
        },
        syslogDataFormatChange: function (text, value) {
            this.send('setSyslogDataFormatVersion', text, value, true);//No I18N
        },
        setSyslogDataFormatVersion: function (text, value, isDataFormatChanged) {
            var PARAMS = this.get('currentConfig.PARAMS');//No I18N
            if (isDataFormatChanged) {
                this.set('currentConfig.PARAMS', {});//No I18N
            }
            this.set('currentConfig.PARAMS.protocol', PARAMS.protocol); //No I18N
            this.set('currentConfig.PARAMS.version', value); // No I18N
            this.set('syslogDataFormat', ''); //No I18N
            if (value == '5424') { // No I18N
                this.set('versionIndicator', 1); // No I18N
                this.set('syslogDataFormat', '---'); //No I18N
                this.send('setSyslogStandardFormatParams', isDataFormatChanged); //No I18N
            } else if (value == '3164') { // No I18N
                this.set('versionIndicator', ''); // No I18N
                this.set('syslogDataFormat', ':'); //No I18N
                this.send('setSyslogStandardFormatParams', isDataFormatChanged); //No I18N
            } else if (value == 'rawlog') { // No I18N
                this.set('isRawLog', true); // No I18N
            } else if (value == 'CEF') { //No I18N
                this.set('isSyslogStandardFormat', false); // No I18N
                this.send('setSyslogCEFParams'); //No I18N
                this.set('isCEFFormat', true); // No I18N
            }
            if (value != 'CEF') { //No I18N
                this.set('isSyslogStandardFormat', true); // No I18N
                this.set('isCEFFormat', false); // No I18N
            }
            if (value != 'rawlog') { //No I18N
                this.set('isRawLog', false); // No I18N
            }
        },
        setSplunkPostURL: function () {
            var protocol;
            if (this.get('currentConfig.PARAMS.SSLEnabled') == 'true') {
                protocol = 'https'; //No I18N
            } else {
                protocol = 'http'; //No I18N
                this.set('currentConfig.PARAMS.SSLEnabled', 'false');//No I18N
            }
            this.set('postURLProtocol', protocol); //No I18N
            this.set('currentConfig.PARAMS.postURL', this.get('postURLProtocol') + '://' + this.get('currentConfig.HOST') + ':' + this.get('currentConfig.PORT') + this.get('postURLEndPoint')); //No I18N
        },
        onForwarderChange: function (text, value) {
            this.send('changeForwarder', value, { setConfig: true }); //No I18N
        },
        changeForwarder: function (forwarderName, otherParams) {
            var self = this;
            var params = {};
            self.set('syslogAdvanced', false); //No I18N
            // if (forwarderName == 'syslogForward') { // No I18N
            //     self.set('isSyslog', true); // No I18N
            // } else if (forwarderName == 'splunkForward') { // No I18N
            //     self.set('isSyslog', false); // No I18N
            // }
            CommonUtil.showLoading();
            params.FORWARDER_NAME = forwarderName;
            params.PRODUCT_NAME = self.get('productName'); // No I18N
            AJAXUtil.ajax('/RestAPI/WC/LogForwardConfig?mTCall=fetchConfig', params).then(function (result) { // No I18N
                if (result.hasOwnProperty('sStatus')) { //No I18N
                    let config = result.config[0];
                    config.PRODUCT_NAME = self.get('productName'); //No I18N
                    config.TAG_NAME = self.get('productTagName'); //No I18N
                    config.DISPLAY_NAME = self.get('currentConfig.DISPLAY_NAME');//No I18N
                    config.isMultipleConfigEnabled = self.get('currentConfig.isMultipleConfigEnabled');//No I18N
                    config.FORWARDER_NAME = forwarderName;
                    self.set('currentConfig', config); //No I18N
                } else if (result.hasOwnProperty('eStatus')) { //No I18N
                    // StatusUtil.showStatusWithMessage(self, 'danger', result.eStatus, false); //No I18N
                    self.sendAction('showStatus', 'danger', result.eStatus, false);//No i18n
                }else if(result.hasOwnProperty('eSTATUS')){//No i18n
                    self.sendAction('showStatus', 'danger', result.eSTATUS, false);//No i18n
                }
                CommonUtil.hideLoading();
                if (otherParams.setConfig === true) {
                    self.send('setConfig', true); //No I18N            
                }
                if (otherParams.cancelEdit === true) {
                    self.sendAction('cancelEdit'); // No I18N
                }
            });
        },
        setSyslogFacilityAndPriority: function () {
            var severity = this.get('currentConfig.PARAMS.severity'); // No I18N
            var priority;
            var facility;
            if (this.isValidSeverity(severity)) {
                //Calculating priority and facility
                priority = severity % 8;
                facility = (severity - priority) / 8;
                Ember.set(this, 'priority', priority); // No I18N
                Ember.set(this, 'facility', facility); // No I18N
            } else {
                Ember.set(this, 'priority', -1); // No I18N
                Ember.set(this, 'facility', -1); // No I18N
            }
        },
        cancelEdit: function () {
            var forwarderName = this.get('currentForwarder'); //No I18N
            this.send('changeForwarder', forwarderName, { cancelEdit: true }); //No I18N
        },
        saveLogForwardConfig: function (closeConfig) {
            var self = this;
            var config = {};
            var forwarderName = self.get('currentConfig.FORWARDER_NAME'); // No I18N
            var configParams = {};

            let host = self.get('currentConfig.HOST'); // No I18N
            let port = self.get('currentConfig.PORT') + ''; // No I18N
            host = host.trim();
            port = port.trim();
            if (!host || !port) {
                DialogUtil.alert(self, I18NUtil.translate('ads.common.alert.mandatory_fields')); // No I18N
                return;
            }
            //Numeric Check
            if (!ValidationUtil.isValidPort(port)) {
                DialogUtil.alert(self, I18NUtil.translate('ads.admin.logforwarderconfig.status.port_warning')); // No I18N
                return;
            }

            if (!self.get('isSyslog')) { // No I18N
                if (!self.get('currentConfig.PARAMS.authenticationToken')) { // No I18N
                    DialogUtil.alert(self, I18NUtil.translate('ads.common.alert.mandatory_fields')); // No I18N
                    return;
                }

                if (self.get('currentConfig.PARAMS.authenticationToken')) { // No I18N
                    let authToken = self.get('currentConfig.PARAMS.authenticationToken'); // No I18N
                    authToken = authToken.trim();
                    if (authToken.length != 36) {
                        DialogUtil.alert(self, I18NUtil.translate('ads.admin.logforwarderconfig.status.illegal_token')); //No I18N
                        return;
                    }
                }
            } else if (self.get('isSyslog') && !self.get('isRawLog') && !(self.get('currentConfig.PARAMS.version') == 'CEF')) { //No I18N
                let severity = self.get('currentConfig.PARAMS.severity'); //No I18N
                if (!this.isValidSeverity(severity)) {
                    DialogUtil.alert(self, I18NUtil.translate('ads.admin.logforwarderconfig.status.invalid_priority', [0, 191])); //No I18N
                    return;
                }
            }
            if (self.get('isSyslog')) { // No I18N
                self.set('currentConfig.TYPE', 'syslog'); //No I18N
            } else {
                self.set('currentConfig.TYPE', 'splunk'); //No I18N
            }
            if (self.get('isLogCategoriesAvailable')) { // No I18N
                self.set('currentConfig.CATEGORIES', JSON.stringify(self.get('currentConfig.logCategories'))); // No I18N
                self.set('currentConfig.logCategories', null); //No I18N
            }
            self.set('syslogAdvanced', false); // No I18N
            CommonUtil.showLoading();
            var config = self.get('currentConfig');//No I18N
            var temp = self.get('currentConfig.PARAMS'); //No I18N
            Ember.set(config, 'PARAMS', JSON.stringify(temp));//No I18N
            self.set('currentConfig.IS_ENABLED', true); //No I18N
            AJAXUtil.ajax("/RestAPI/WC/LogForwardConfig?mTCall=saveConfig", {PARAMS:config}).then( // No I18N
                function (result) {
                    if (result.hasOwnProperty('sStatus')) {
                        // StatusUtil.showStatusWithMessage(self, 'success', result.sStatus, true); // No I18N
                        self.sendAction('showStatus', 'success', result.sStatus, true);//No i18n
                        self.sendAction('saveConfig', closeConfig); // No I18N
                        self.set('currentConfig.isConfigured', true);//No I18N			
                    }else if(result.hasOwnProperty('eSTATUS')){//No i18n
                        self.sendAction('showStatus', 'danger', result.eSTATUS, false);//No i18n
                    } else {
                        // StatusUtil.showStatusWithMessage(self, 'danger', result.eStatus, true); // No I18N
                        self.sendAction('showStatus', 'danger', result.eStatus, false);//No i18n
                        self.set('currentConfig.PARAMS', temp);//No I18N
                    }
                    CommonUtil.hideLoading();
                });
        },
        saveLogCategories: function () {
            var self = this;
            self.send('saveLogForwardConfig', true, true); //No I18N
        },
        showLogCategories: function () {
            $('#LOG_CATEGORIES').modal(); //No I18N
        },
        toggleCategory: function (isEnabled, category) {
            var self = this;
            Ember.set(category, 'isEnabled', isEnabled); //No I18N
        },
        setSyslogProtocol: function (text, value) {
            this.set('currentConfig.PARAMS.protocol', value); // No I18N
        },
        setSyslogDataFormatFacility: function (text, value) {
            this.set('facility', value); // No I18N
            this.send('calculatePriority'); // No I18N
        },
        setSyslogDataFormatPriority: function (text, value) {
            this.set('priority', value); // No I18N
            this.send('calculatePriority'); // No I18N
        },
        calculatePriority: function () {
            // console.log('calculatePriority');
            var self = this;
            var priority = self.get('priority') == -1 ? self.get('SEVERITIES')[0].SERVER_VALUE : self.get('priority'); //NO I18N
            var facility = self.get('facility') == -1 ? self.get('FACILITIES')[0].SERVER_VALUE : self.get('facility'); //NO I18N

            var sev = (priority * 1) + (facility * 8); //as in RFC 3164// No I18N
            self.set('currentConfig.PARAMS.severity', sev); // No I18N
        },
        toggleSSL: function (text, value) {
            var self = this;
            self.set('currentConfig.PARAMS.SSLEnabled', value); // No I18N
            if (value == 'true') { // No I18N
                self.set('postURLProtocol', 'https'); //No I18N
            } else {
                self.set('postURLProtocol', 'http'); //No I18N
            }
        },
        addToSyslogVersions: function (clientValue, serverValue) {
            let versions = this.get("VERSIONS"); // No I18N
            let cefDropDownValues = {
                "CLIENT_VALUE": clientValue,//No I18N
                "SERVER_VALUE": serverValue//No I18N
            }; // No I18N
            let newVersions = [];
            for (var i = 0; i < versions.length; i++) {
                newVersions.push(versions.objectAt(i));
            }
            newVersions.push(Ember.A(cefDropDownValues));
            Ember.set(this, 'VERSIONS', newVersions); // No I18N
        },
        removeFromSyslogVersions: function (serverValue) {
            let versions = this.get("VERSIONS"); // No I18N
            let newVersions = [];
            for (var i = 0; i < versions.length; i++) {
                let temp = versions.objectAt(i);
                if (versions[i].SERVER_VALUE != serverValue) {
                    newVersions.push(versions[i]);
                }
            }
            Ember.set(this, 'VERSIONS', newVersions); // No I18N    
        },
        toggleAdvanced: function () {
            this.toggleProperty('syslogAdvanced'); //No I18N
        },
    }
});
