/* $Id$ */
import Ember from 'ember'; //No I18N
import CommonUtil from '../../utils/ads-common-util'; // No I18N
import AJAXUtil from '../../utils/ads-ajax-util'; // No I18N
/*
*
*{{logforward/logforward-view editConfig='editConfig' currentConfig=currentConfig isCurrentConfigChanged=isCurrentConfigChanged}}
*
*/
export default Ember.Component.extend({
    getProductConfigIndex: function (config) {
        var allConfigs = this.get('allProductEnabledConfig');//No I18N
        var index = -1;
        for (var i = 0; i < allConfigs.length; i++) {
            let isSameForwarder = true;
            if (allConfigs.objectAt(i).isMultipleConfigEnabled) {
                isSameForwarder = (allConfigs.objectAt(i).FORWARDER_NAME == config.FORWARDER_NAME);
            }
            if (allConfigs.objectAt(i).PRODUCT_NAME === config.PRODUCT_NAME && isSameForwarder) {
                index = i;
                break;
            }
        }
        return index;
    },
    init: function () {
        this._super.apply(this, arguments)
        this.send('getAllProductEnabledConfig');//No I18N
    },
    onConfigChange: Ember.observer('isCurrentConfigChanged', function () {//No I18N
        var index = this.getProductConfigIndex(this.get('currentConfig'));//No I18N
        if (!this.get('currentConfig.isConfigured')) {
            this.set('currentConfig.FORWARDER_NAME', null);//No I18N
        }
        var configs = this.get('allProductEnabledConfig'); //No I18N
        configs.removeAt(index);
        configs.insertAt(index, this.get('currentConfig'));//No I18N
        this.set('allProductEnabledConfig', configs); // No I18N      
        this.set('isCurrentConfigChanged', false); //No I18N
    }),
    actions: {
        getAllProductEnabledConfig: function () {
            var self = this;
            CommonUtil.showLoading();
            AJAXUtil.ajax("/RestAPI/WC/LogForwardConfig?mTCall=getAllProductEnabledConfig").then( // No I18N
                function (result) {
                    if (result.hasOwnProperty('configs')) { // No I18N
                        self.set('isUnsupported', result.isUnsupported); //No I18N
                        self.set('allProductEnabledConfig', Ember.A(result.configs)); // No I18N
                    }
                    CommonUtil.hideLoading();
                    if (result.hasOwnProperty('eStatus')) { // No I18N
                        // StatusUtil.showStatusWithMessage(self, 'danger', result.eStatus, true); // No I18N
                        self.sendAction('showStatus', 'danger', result.eStatus, false);//No i18n
                        self.set('allProductEnabledConfig', Ember.A()); //No I18N
                    }else if(result.hasOwnProperty('eSTATUS')){//No i18n
                        self.sendAction('showStatus', 'danger', result.eSTATUS, false);//No i18n
                    }
                });
        },
        editConfig: function (config) {
            var self = this;
            let newConfig;
            let params = {};
            let configs;
            params.PRODUCT_NAME = config.PRODUCT_NAME;
            if (!config.isMultipleConfigEnabled) {
                params.GET_ENABLED_ONLY = true;
            } else {
                params.FORWARDER_NAME = config.FORWARDER_NAME;
            }
            configs = self.get('allProductEnabledConfig'); // No I18N
            CommonUtil.showLoading();
            AJAXUtil.ajax('/RestAPI/WC/LogForwardConfig?mTCall=fetchConfig', params).then(function (result) { // No I18N
                if (result.hasOwnProperty('sStatus')) { //No I18N
                    let tempConfig = result.config[0];
                    let index = self.getProductConfigIndex(config);
                    tempConfig.PRODUCT_NAME = config.PRODUCT_NAME;
                    tempConfig.DISPLAY_NAME = configs[index].DISPLAY_NAME;
                    tempConfig.TAG_NAME = configs[index].TAG_NAME;
                    tempConfig.isMultipleConfigEnabled = config.isMultipleConfigEnabled;
                    configs.removeAt(index);
                    configs.insertAt(index, tempConfig);
                    self.set('isUnsupported', false);//No I18N
                    self.set('allProductEnabledConfig', configs); // No I18N
                    newConfig = configs[index];
                } else if (result.hasOwnProperty('eStatus')) { //No I18N
                    if(result.hasOwnProperty("ERROR_CODE") && result.ERROR_CODE==parseInt('00000003',8)){
                        result.eStatus = result.DESCRIPTION;
                    }
                    self.sendAction('showStatus', 'danger', result.eStatus, false);//No i18n
                    CommonUtil.hideLoading();
                    return;
                }else if(result.hasOwnProperty('eSTATUS')){//No i18n
                    self.sendAction('showStatus', 'danger', result.eSTATUS, false);//No i18n
                }
                CommonUtil.hideLoading();
                // self.set('currentConfig', newConfig); //No I18N
                self.set('showConfigForm', true); //No I18N
                self.set('syslogAdvanced', false); //No I18N
                CommonUtil.afterRender();
                self.sendAction('editConfig', newConfig);//No I18N
            });
        },
        doEnableDisable: function (FORWARDER_NAME, PRODUCT_NAME, isConfigured) {
            var self = this;
            var params = {};
            var index;
            var configs = self.get('allProductEnabledConfig'); // No I18N
            var config = null;
            index = self.getProductConfigIndex({
                FORWARDER_NAME,
                PRODUCT_NAME
            });
            config = configs.objectAt(index);
            if (isConfigured) {
                params.FORWARDER_NAME = FORWARDER_NAME ? FORWARDER_NAME : self.get('currentConfig.FORWARDER_NAME'); // No I18N
                params.PRODUCT_NAME = PRODUCT_NAME;
                params.DO_ENABLE = config.IS_ENABLED ? false : true;
                CommonUtil.showLoading();
                AJAXUtil.ajax('/RestAPI/WC/LogForwardConfig?mTCall=doEnableDisable', params).then( // No I18N
                    function (result) {
                        if (result.hasOwnProperty('sStatus')) { // No I18N
                            if (config.IS_ENABLED) {
                                Ember.set(configs[index], 'IS_ENABLED', false); // No I18N
                            } else {
                                Ember.set(configs[index], 'IS_ENABLED', true); // No I18N
                            }
                            self.set('allProductEnabledConfig', configs); // No I18N
                        }else if(result.hasOwnProperty('eSTATUS')){//No i18n
                            self.sendAction('showStatus', 'danger', result.eSTATUS, false);//No i18n
                        } else {
                            // StatusUtil.showStatusWithMessage(self, 'danger', result.eStatus, true); // No I18N
                            self.sendAction('showStatus', 'danger', result.eStatus, false);//No i18n
                        }
                    });
                CommonUtil.hideLoading();
            } else {
                self.send("editConfig", config); //No I18N
            }
        },
    }
});