/* $Id$*/
/**
 * {{mail-settings showStatus='showStatus'}}
 */
//ignorei18n_start
import Ember from 'ember';
import I18NUtil from "../utils/i18n-util"; //NO I18N
import ValidationUtil from "../utils/ads-validation-util"; //NO I18N
import AJAXUtil from '../utils/ads-ajax-util'; //NO I18N
import DialogUtil from "../utils/ads-dialog-util"; //NO I18N
import CommonUtil from "../utils/ads-common-util"; //NO I18N

export default Ember.Component.extend({
	previousInstaNotifyStatus : null,
	updatedInstaNotifyStatus : null,
	pageStatus : {},
	init : function()
	{
		this._super();
		var conSecurities = [];
		conSecurities.push({CLIENT_VALUE : "NONE", SERVER_VALUE : "0"}, {CLIENT_VALUE : "SSL", SERVER_VALUE : "1"}, {CLIENT_VALUE : "TLS", SERVER_VALUE : "2"});//No I18N
		this.set('CONNECTION_SECURITIES', conSecurities);//No I18N
	},
	didReceiveAttrs: function() {
		if(!this.hasOwnProperty('mailSettings')){
				this.send('getMailSettings');
		}
	},
	doUpdate: Ember.observer('options.doUpdate',function() {
		this.send('updateSettings');
	}),
	doRefresh: Ember.observer('options.doRefresh',function() {
		this.send('getMailSettings');
	}),
	doCheckChanges: Ember.observer('options.doCheckChanges',function(){
		this.set('options.isServerDetailsChanged', this.isServerDetailsModified());
	}),
	// conSecurityChanged : function(){
	// 	if(this.get('mailSettings.CONNECTION_SECURITY_ID'))
	// 	this.set('mailSettings.CONNECTION_SECURITY', this.get('CONNECTION_SECURITIES')[this.get('mailSettings.CONNECTION_SECURITY_ID')].CLIENT_VALUE);
	// }.observes('mailSettings.CONNECTION_SECURITY_ID'),
	isServerDetailsModified:function()
	{
		var isChanged = false;

		var conSecurity = this.$('#CONNECTION_SECURITY').val();
		conSecurity = conSecurity > 0 ? conSecurity : "";
		if(this.serverSettings['CONNECTION_SECURITY_ID']!=conSecurity)
		{
				isChanged = true;
				if(!this.serverSettings.hasOwnProperty('CONNECTION_SECURITY_ID') && conSecurity == 0)
				{
					isChanged = false;
				}
		}
		
		if((this.serverSettings.getWithDefault('SERVER_NAME','')!=this.$('#SERVER_NAME').val())
		|| (this.serverSettings['PORT']!=this.$('#SERVER_PORT').val())
		|| (this.serverSettings['FROM_MAIL_ID']!=this.$('#FROM_MAIL_ID').val())
		|| (this.serverSettings.getWithDefault('ADMIN_MAIL_ID','')!=this.$('#ADMIN_MAIL_ID').val()))
		{
			isChanged = true;
		}

		if(this.$('#IS_AUTHENTICATION_REQUIRED').is(':checked')!=this.serverSettings.getWithDefault('IS_AUTHENTICATION_REQUIRED', false))
				{
					isChanged = true;
				}

		if(this.$('#SERVER_USERNAME').val()!=this.serverSettings.getWithDefault('USER_NAME',''))
		{
			isChanged = true;
		}

		return isChanged;
	},

    checkIsValid:function()
    {
			var serverName = this.$('#SERVER_NAME').val();
			var serverPort = this.$('#SERVER_PORT').val();
			var fromId = this.$('#FROM_MAIL_ID').val();
			var adminId = this.$('#ADMIN_MAIL_ID').val();
			var authentication =  this.$('#IS_AUTHENTICATION_REQUIRED').is(':checked');
			var serverUserName = this.$('#SERVER_USERNAME').val();
			var serverPassword = this.$('#SERVER_PASSWORD').val();
			 if(serverName =='' || serverPort=='' || fromId=='' ||adminId=='' )
			{	
				DialogUtil.alert(this, I18NUtil.translate('ads.common.alert.mandatory_fields'));//No I18N
				return false;
			}
			else if(!ValidationUtil.isValidPort(serverPort))
			{
				 DialogUtil.alert(this, I18NUtil.translate('ads.admin.product_settings.connection.select_protocol.http_range'));//No I18N
				 return false;
			}
			else if(!ValidationUtil.isValidEmail(fromId))
			{
				 DialogUtil.alert(this, I18NUtil.translate('ads.admin.server_settings.alert.invalid_fromaddress')+" : "+fromId);//No I18N
				 return false;
			}
			var array=adminId.split(",");
			for(var i=0;i<array.length;i++)
	        {
				if(!ValidationUtil.isValidEmail(array[i]))
			    {
					if(Ember.$.trim(array[i])=="")
					{	
						DialogUtil.alert(this,I18NUtil.translate('ads.admin.server_settings.alert.invalid_toaddress'));
						return false;
					}
					else
					{	
						DialogUtil.alert(this,I18NUtil.translate('ads.admin.server_settings.alert.invalid_toaddress')+" : "+array[i]);
						return false;
					}
				}
				
			}
		    for(var i=0;i<array.length-1;i++)
	        {
				for(var j=i+1;j<array.length;j++)
				{
					
					if(Ember.$.trim(array[i])==Ember.$.trim(array[j]))//Check for same to addressess
					{	
						DialogUtil.alert(this,I18NUtil.translate('ads.admin.server_settings.alert.sameaddress'));
						return false;
					}
				}
			}
			if(authentication && serverUserName == '' && serverPassword == '')
			{
				DialogUtil.alert(this, I18NUtil.translate('ads.common.alert.mandatory_username_password'));//No I18N
				return false;
			}
			else if(authentication && serverUserName == '')
			{	
				DialogUtil.alert(this, I18NUtil.translate('ads.common.alert.mandatory_username'));//No I18N
				return false;
			}
			else if(authentication && serverPassword == '')
			{
				DialogUtil.alert(this, I18NUtil.translate('ads.common.alert.mandatory_password'));//No I18N
				return false;
			}
			return true;		 
    },
	actions: 
	{
		getMailSettings:function()
		{
			 var self=this;
			 var mailDetails = AJAXUtil.syncAjax('/RestAPI/WC/MailSettings?mTCall=getMailSettings', {});
			 var mailData = mailDetails.MAIL_SETTINGS;
			 self.set('mailSettings',mailDetails.MAIL_SETTINGS);
			 self.set('serverSettings', Ember.$.extend(true, [], mailDetails.MAIL_SETTINGS));
			 self.send('setDropDownValues','CONNECTION_SECURITY',mailData.CONNECTION_SECURITY_ID);					 
		},
		setDropDownValues:function(option,dropDownValue)
	       	{
       			if(dropDownValue==null)
       			{
					   dropDownValue=0;
				}
				Ember.run.scheduleOnce('afterRender',this,function(){
					this.$('#'+option).val(dropDownValue);
					dropDownValue = this.$('#'+option + ' [value='+ dropDownValue + ']').text();
					this.$('[data-id='+option+'] .pull-left').text(dropDownValue);
				});
       		},
	    setCheckBoxValue:function(enableSetting,status)
       		{
       			if(status=='true')
	       		{
       				this.$(enableSetting).parent('div').addClass('checked');
       			}
	       		else
       			{
       				this.$(enableSetting).parent('div').removeClass('checked');	
       			}
	       		this.$(enableSetting).prop('checked',(status=='true'));
	       	},
		updateSettings: function()
		{
			var params={};
			var serverName = this.$('#SERVER_NAME').val();
			var serverPort = this.$('#SERVER_PORT').val();
			var fromId = this.$('#FROM_MAIL_ID').val();
			var adminId = this.$('#ADMIN_MAIL_ID').val();
			var conSecurity = this.$('#CONNECTION_SECURITY').val();
			var conSecurityName = "";
			var conSecurities = this.get('CONNECTION_SECURITIES');
			for(var i=0;i<conSecurities.length;i++)
			{
				if(conSecurity==conSecurities[i].SERVER_VALUE)
				{
					conSecurityName = conSecurities[i].CLIENT_VALUE;
				}
			}
			var authentication =  this.$('#IS_AUTHENTICATION_REQUIRED').is(':checked');
			var serverUserName = this.$('#SERVER_USERNAME').val();
			var serverPassword = this.$('#SERVER_PASSWORD').val();
			var enableHtmlFormat = true;


			if(this.checkIsValid())
			{
				 var self = this;
				 if(!authentication)
				 {
					 this.$('#SERVER_USERNAME').val('');
					 this.$('#SERVER_PASSWORD').val('');	
					 serverUserName='';
					 serverPassword='';
				 }
				 params['SERVER_NAME']=serverName;
				 params['PORT']=serverPort;
				 params['FROM_MAIL_ID']=fromId;
				 params['ADMIN_MAIL_ID']=adminId;
				 params['CONNECTION_SECURITY_ID']=(conSecurity > 0 ? conSecurity : "");
				 params['CONNECTION_SECURITY']=(conSecurity > 0 ? conSecurityName : "");
				 params['USER_NAME']=serverUserName;
				 params['PASSWORD']=serverPassword;
			     params['ENABLE_HTML_FORMAT']=enableHtmlFormat;
				 params.IS_TEST_MAIL="false";
				 CommonUtil.showLoading();
					AJAXUtil.ajax('/RestAPI/WC/MailSettings?mTCall=sendTestMail',params).then(function(testMailResponse){
					
		                if(testMailResponse.hasOwnProperty('sSTATUS'))
		                {
		                	AJAXUtil.ajax('/RestAPI/WC/MailSettings?mTCall=saveMailSettings',params).then(function(response){
		                		CommonUtil.hideLoading();
		                		self.send('getMailSettings');
		                		if(response.hasOwnProperty('sSTATUS'))
								{
									if(self.get('notificationService')){
										self.get('notificationService').checkStatus('MAIL_SERVER_NOTIFIER');
									}
								}
								self.sendAction('showStatus', 1,'success',response.sSTATUS,true);
						    });
		                }
		                else
		                {
					CommonUtil.hideLoading();
					if(testMailResponse.eSTATUS==I18NUtil.translate("ads.common.error.demo_mode"))
					{
						self.sendAction('showStatus',1,'danger',testMailResponse.eSTATUS,false);	
					}
					else
					{
							var modifiedResponse = testMailResponse.eSTATUS.split(I18NUtil.translate('ads.admin.server_settings.mail_settings.send_fail')).pop();
							self.sendAction('showStatus',1,'danger', I18NUtil.translate('ads.admin.server_settings.mail_settings.fail').concat(" ",modifiedResponse),false);
					}
				}				 
	            });
			}	
		}, 
		
		sendTestMail: function()
		{
			var params={};
			var serverName = this.$('#SERVER_NAME').val();
			var serverPort = this.$('#SERVER_PORT').val();
			var fromId = this.$('#FROM_MAIL_ID').val();
			var adminId = this.$('#ADMIN_MAIL_ID').val();
			var conSecurity = this.$('#CONNECTION_SECURITY').val();
			var conSecurityName = "";
			var conSecurities = this.get('CONNECTION_SECURITIES');
			for(var i=0;i<conSecurities.length;i++)
			{
				if(conSecurity==conSecurities[i].SERVER_VALUE)
				{
					conSecurityName = conSecurities[i].CLIENT_VALUE;
				}
			}
			var authentication =  this.$('#IS_AUTHENTICATION_REQUIRED').is(':checked');
			var serverUserName = this.$('#SERVER_USERNAME').val();
			var serverPassword = this.$('#SERVER_PASSWORD').val();
			var enableHtmlFormat = true;
            		if(this.checkIsValid())
			{
				var self = this;
				if(!authentication)
				{
					this.$('#SERVER_USERNAME').val('');
					this.$('#SERVER_PASSWORD').val('');	
					serverUserName='';
					serverPassword='';
				}
				params['SERVER_NAME']=serverName;
				params['PORT']=serverPort;
				params['FROM_MAIL_ID']=fromId;
				params['ADMIN_MAIL_ID']=adminId;
				params['CONNECTION_SECURITY_ID']=(conSecurity > 0 ? conSecurity : "");
				params['CONNECTION_SECURITY']=(conSecurity > 0 ? conSecurityName : "");
				params['USER_NAME']=serverUserName;
				params['PASSWORD']=serverPassword;
				params['ENABLE_HTML_FORMAT']=enableHtmlFormat;
				params.IS_TEST_MAIL="true";
                CommonUtil.showLoading();
                AJAXUtil.ajax('/RestAPI/WC/MailSettings?mTCall=sendTestMail',params).then(function(response) {
					CommonUtil.hideLoading();
					if(response.hasOwnProperty('sSTATUS')){
						self.sendAction('showStatus',1,'success',response.sSTATUS,true);
					}else{
						self.sendAction('showStatus',1,'danger',response.eSTATUS,false);
					}
				});
			}
		},

		authenticationToggle: function(val)
		{
			this.$('#SERVER_CREDENTIALS').slideToggle(800);
			this.set('mailSettings.IS_AUTHENTICATION_REQUIRED',val);
			if(!val){
				this.set('mailSettings.USER_NAME','');
				this.set('mailSettings.PASSWORD','');
			}
		},

		connSecurityChanged: function(text,value) {
			this.set('mailSettings.CONNECTION_SECURITY', text);
			this.set('mailSettings.CONNECTION_SECURITY_ID', value);
		},

		toggleCheckBox: function(val, key){},
		cancel:function()
		{
			this.send('getMailSettings');
		}
	}

});
//ignorei18n_end