/*
 * $Id$
 */
//ignorei18n_start
import Ember from 'ember';
import I18NUtil from "../utils/i18n-util"; //NO I18N
import CommonUtil from "../utils/common-util"; //NO I18N
export default Ember.Component.extend({
  defaultText: I18NUtil.translate('ads.common.text.selected_none'),
  dataLiveSearch: false,
  isEnabled: true,
  id: 'multipleSelectList',
  getSettings: function() {
    var itemsList = this.get('itemsList');
    if (itemsList != undefined && itemsList.length > 5) {
      this.set('dataLiveSearch', true);
    } else {
      this.set('dataLiveSearch', false);
    }
  }.on('init'),
  didInsertElement: function() {
    this.enableDisable();
    var self = this;
    this.$("select.bs-custom-scroll").on("show.bs.select", function() {
      var $this = Ember.$(this).closest('div');
      if (self.$("ul.dropdown-menu.inner", $this).length && self.$("option", $this).length > 5) {
        var $height = (Ember.$(this).attr("data-scroll-height")) ? Ember.$(this).attr("data-scroll-height") : '145px';
        self.$("ul.dropdown-menu.inner", $this).height($height);
        self.$("ul.dropdown-menu.inner", $this).mCustomScrollbar();
        self.$(".mCSB_dragger_bar,.mCSB_2_dragger_vertical,.mCSB_draggerContainer").on("click", function(e) {
          return false;
        });
      }
    });
  },
  willDestroyElement: function() {
     this.$('select.bs-custom-scroll').off('show');//No i18n
     this.$('.mCSB_dragger_bar,.mCSB_2_dragger_vertical,.mCSB_draggerContainer').off('click');//No i18n
  },
  enableDisable: function() {
    var isEnabled = this.get('isEnabled');
    var id = this.get('id');
    if (isEnabled === true) {
      this.$('#' + id).prop('disabled', false); //Enable Dropdown button
      this.$('#' + id).selectpicker('refresh');
    } else {
      this.$('#' + id).prop('disabled', true); //Disable Dropdown button
      this.$('#' + id).selectpicker('refresh');
      this.$('.bs-custom-scroll').removeClass('open'); //CLosing Dropdown list
    }
  }.observes('isEnabled'),
  refreshMultiSelect: function() {
    Ember.run.schedule('afterRender', this, function() {
      var id = this.get('id');
      this.$('#' + id).find("ul.dropdown-menu.inner").mCustomScrollbar("destroy"); //Destory at each rendering of itemsList
      CommonUtil.afterRender();
      this.enableDisable();
    });
  }.observes('itemsList'),
  actions: {
    onChange: function() {
      var id = this.get('id');
      var selectedValues = this.$('#' + id).val();
      var itemsList = this.get('itemsList');
      for (var i = 0; i < itemsList.length; i++) {
        var item = itemsList[i];
        var id = item.ID;
        if (selectedValues != null && selectedValues.contains(id)) {
          Ember.set(item, 'IS_ENABLED', true);
        } else {
          Ember.set(item, 'IS_ENABLED', false);
        }
      }
    }
  },
});
//ignorei18n_end
