/* $Id: notification-center.js,v 1.11.4.3 2018/12/22 23:42:44 kamalraj.d Exp $ */
import Ember from 'ember'; //NO I18N
import AJAXUtil from '../utils/ads-ajax-util'; //NO I18N
import I18NUtil from "../utils/i18n-util";	//NO I18N
//ignorei18n_start
var notificationComponent = Ember.Component.extend({
	tagName: '',
	notificationService: Ember.inject.service(),
	notifications: [],
	initService: Ember.on('init', function () {
		notificationService: Ember.inject.service();
		Ember.run.bind(this, this.initNotifications);
	}),
	initNotifications: Ember.on('init', function () {
		this.set('notifications', this.get('notificationService.notifications'));
	}),
	actions: {
		dismissNotification: function (notificationName, notificationId) {
			this.get('notificationService').disableNotification(notificationName, notificationId);
			this.sendAction('dismissAction', notificationName);
		},
		toggleDropDown: function () {
			Ember.$('.top-notification').toggleClass('open');
		},
		toggleDropDownClose: function () {
			Ember.$('.top-notification').removeClass('open');
		},
		dismissAllCurrentActiveNotificatons: function () {
			var self = this;
			self.notifications.forEach(function (notification) {
				if (notification.isDismissable && notification.canShow) {
					self.send('dismissNotification', notification.notificationName, notification.notificationId);
				}
			});
		},
		filterNotification: function (notifyType) {
			var self = this;
			if (notifyType === "ALL") {
				self.notifications.forEach(function (notification) {
					if (notification.isEnabled) {
						self.get('notificationService').showNotificationById(notification.notificationName, notification.notificationId);
					}
					else {
						self.get('notificationService').hideNotificationById(notification.notificationName, notification.notificationId);
					}
				});
			}
			else {
				self.notifications.forEach(function (notification) {
					if ((notification.icon === notifyType) && (notification.isEnabled)) {
						self.get('notificationService').showNotificationById(notification.notificationName, notification.notificationId);
					}
					else {
						self.get('notificationService').hideNotificationById(notification.notificationName, notification.notificationId);
					}
				});
			}
			if (notifyType === "ALL") {
				Ember.$('#notifyType').html(I18NUtil.translate('ads.notification_center.all'));
			} else if (notifyType === "CRITICAL") {
				Ember.$('#notifyType').html(I18NUtil.translate('ads.notification_center.critical'));
			} else if (notifyType === "WARNING") {
				Ember.$('#notifyType').html(I18NUtil.translate('ads.notification_center.warning'));
			} else if (notifyType === "NORMAL") {
				Ember.$('#notifyType').html(I18NUtil.translate('ads.notification_center.info'));
			}
		},
        dropDownEvent: function () {
            let $notificationCenter = Ember.$('.top-notification');
            $notificationCenter.mouseleave(function () {
                Ember.$('div.dropdown-menu-right').attr('data-toggle', 'dropdown');
            });
            $notificationCenter.mouseenter(function () {
                Ember.$('div.dropdown-menu-right').removeAttr('data-toggle');
            });
        },
		notificationAction: function(actionName) {
			this.send('toggleDropDownClose');
			this.sendAction(actionName);
		},
	}
});

export default notificationComponent;
//ignorei18n_end