/**
 * $Id$
 */
//the parent Component/template should have "fillValue()" to fetch data from if data['domains'] is not present
import Ember from 'ember';		 //NO I18N
import AJAXUTIL from "../utils/ads-ajax-util";		//NO I18N
import ESCUTIL from "../utils/escape-util"; //NO I18N
import I18N from "../utils/i18n-util"; //NO I18N

export default Ember.Component.extend({
	popup : false,
	popupTab: {},
	popupDetails: {},
	params : {},
	summarySelectedList:Ember.A([]),
	typingTimer : 0,
	selectList : Ember.A([]),
	resetPageNavig : true,
	isVisible: false,
	clearPopupData(){
		this.set('popupTab', {});						//NO I18N
		this.set('summarySelectedList', Ember.A([]));						//NO I18N
		this.set('resetPageNavig', true);					//NO I18N
		this.set('popup', false);	//NO I18N
		$('#popupTitle').html(I18N.translate('ads.ou_selection.text.popup_title'));		//NO I18N
	},
	didReceiveAttrs :function() {
		this._super(...arguments);
		this.set("showFilter", false);	//NO I18N
		this.set('IS_ALL', true);	//NO I18N
		this.set('selectedList',{});		//NO I18N
		this.set('excludedList',{});		//NO I18N
		this.set('isExcludeChild',false);		//NO I18N
		Ember.$('#ouSelText').val(I18N.translate("ads.ou_selection.text.all"));		//NO I18N
		var parentComponent = this.get('parentComponent');//NO I18N
		Ember.set(parentComponent, 'OU_FILTER', this);//NO I18N
		this.getPopupData(this.get('ID'));//NO I18N
	},
	setIsOUFilterVisible : function() {
		var parentComponent = this.get('parentComponent');//NO I18N
		if(this.popupData.length>0) {//If no popupData are present then we should not show the filter
			if(parentComponent.SHOW_TABLE) {//Check is for null
				this.set('isVisible',true);	//No I18N
				$('#applyFilterDiv').css('display','block');
				$('#filterDiv').css('display','none');	//NO I18N
				this.set("showFilter", false);	//No I18N
			}
			else {
				$('#filterDiv').css('display','block');	//NO I18N
				$('#applyFilterDiv').css('display','none');
				this.set("showFilter", true);	//No I18N
				this.set('isVisible',false);	//No I18N
			}
		} else {
			this.set('isVisible',false);	//No I18N
		}
	}.observes('parentComponent.SHOW_TABLE'),//NO I18N
	onPopupLoad(viewSummary){
		$('#PopupDiv').modal({ show : true });

		this.set('popup', true);	//NO I18N
		this.set('viewSummary', viewSummary);	//NO I18N
		this.updateDefaultPopupData()
		this.updateNavigation();
		this.getDataModelUIDesign();
	},
	getPopupData(id){
		this.set("ID", id);//NO I18N
		var popupDetails = this.get("popupDetails");//NO I18N
		if(popupDetails[id]==null) {
			this.set('popupData', AJAXUTIL.syncAjax("/api/json/getPopupDetails", {"O365_ACCOUNT_ID": id}));		//NO I18N
		} else {
			this.set('popupData', popupDetails[id]);
		}
		var popupData = this.get('popupData');	//NO I18N
		var parentList = [];
		var selectList = [];
		this.setIsOUFilterVisible();
		if(this.popupData.length>0) {
			popupDetails[id] = popupData;
			for(var i=0;i<popupData.length; i++){
				var selectObj = {};
				Ember.set(selectObj, "CLIENT_VALUE", popupData[i].CLIENT_VALUE);				//NO I18N
				Ember.set(selectObj, "SERVER_VALUE", popupData[i].SERVER_VALUE);				//NO I18N
				selectList.pushObject(selectObj);
				parentList.push(popupData[i].CLIENT_VALUE);
			}
			this.set('selectList', selectList);	//NO I18N
			this.set('currentSelection', selectList[0].SERVER_VALUE);	//NO I18N
			this.set("parentList", parentList);	//NO I18N
		} else {
			popupDetails[id] = {};
		}
	},
	clearOUSelection(){
		this.selectedList = {};
		this.excludedList = {};
		this.updateOUDiv();
	},
	updateDefaultPopupData(){
		var popupTab = this.get('popupTab');	//NO I18N
		Ember.set(popupTab, 'tabType', 'tree');	//NO I18N
		var isLoaded = {};
		Ember.set(isLoaded, 'tree', false);	//NO I18N
		Ember.set(isLoaded, 'table', false);	//NO I18N
		Ember.set(popupTab, 'isLoaded', isLoaded);	//NO I18N
		var pageNavigateData = {};
		Ember.set(pageNavigateData, 'startIndex', 1);		//No I18N
		Ember.set(pageNavigateData, 'toIndex', 25);			//NO I18N
		Ember.set(pageNavigateData, 'range', 25);			//NO I18N
		var rangeList = [25,50,75,100];
		Ember.set(pageNavigateData, 'rangeList', rangeList);			//NO I18N
		Ember.set(pageNavigateData, 'totalCount', 0);			//NO I18N
		this.set('pageNavigateData', pageNavigateData);	//NO I18N
		var dataModelObject = {};
		Ember.set(dataModelObject, 'tree', {});		//No I18N
		Ember.set(dataModelObject, 'table', {});			//NO I18N
		Ember.set(popupTab, 'dataModelObject', dataModelObject);			//NO I18N
	},
	updateNavigation: function() {
		this.processNavigationImages();
		this.updateSelectedRange();
		this.updateIndexes();
	},
	updateSelectedRange : function(){
		$('#SelectRange').val(this.get('pageNavigateData.range'));
	}.observes('pageNavigateData.range'),		//NO I18N
	updateIndexes : function(){
		var startIndex = parseInt(this.get('pageNavigateData.startIndex'));	//NO I18N
		var endIndex = parseInt(this.get('pageNavigateData.toIndex'));	//NO I18N
		var totalCount = parseInt(this.get('pageNavigateData.totalCount'));	//NO I18N
		var range = parseInt(this.get('pageNavigateData.range')); 	//NO I18N
		if(endIndex === 0 && totalCount > 0){
			if(range > totalCount){
				this.set('pageNavigateData.toIndex', totalCount);	//NO I18N
			}else{
				this.set('pageNavigateData.toIndex', range);	//NO I18N
			}
		}
		if(endIndex > totalCount){
			this.set('pageNavigateData.toIndex', totalCount);	//NO I18N
		}
		if(endIndex < range && range < totalCount){
			this.set('pageNavigateData.toIndex', range);	//NO I18N
		}
		if(totalCount == 0){
			this.set('pageNavigateData.startIndex', 0);	//NO I18N
		}else if(startIndex == 0 && totalCount > 0){
			this.set('pageNavigateData.startIndex', 1);	//NO I18N
		}
	}.observes('pageNavigateData.totalCount'),	//NO I18N
	processNavigationImages : function(){
		if(this.get('pageNavigateData.startIndex') < this.get('pageNavigateData.range')){
			$('#Prev').find('i').addClass('fw-icn-disable');
		}else{
			$('#Prev').find('i').removeClass('fw-icn-disable');
		}
		if(this.get('pageNavigateData.toIndex') === this.get('pageNavigateData.totalCount')){
			$('#Next').find('i').addClass('fw-icn-disable');
		}else{
			$('#Next').find('i').removeClass('fw-icn-disable');
		}

	}.observes('pageNavigateData.startIndex','pageNavigateData.toIndex','pageNavigateData.totalCount','pageNavigateData.range'),	//NO I18N
	updateParams(){
		var params = this.get('params');		//NO I18N
		var popupTab = this.get('popupTab');	//NO I18N
		var tabType = popupTab['tabType'];
		if(tabType=='table'){
			Ember.set(params, "searchText", ESCUTIL.getJSONEscapeString($('#SearchBox').val()));		//NO I18N
			var pageNavigateData = this.get('pageNavigateData');	//NO I18N
			if(this.resetPageNavig){
				Ember.set(params,'start', 1);		//NO I18N
				Ember.set(params, 'end', pageNavigateData['range']);			//NO I18N
				Ember.set(pageNavigateData, 'startIndex', 1);		//No I18N
				Ember.set(pageNavigateData, 'toIndex', pageNavigateData['range']);			//NO I18N
				Ember.set(pageNavigateData, 'totalCount', 0);			//NO I18N
				this.set('resetPageNavig', false);	//NO I18N
			}else{
				Ember.set(params,'start', pageNavigateData['startIndex']);		//NO I18N
				Ember.set(params, 'end', pageNavigateData['toIndex']);			//NO I18N
			}
			Ember.set(params, 'range', pageNavigateData['range']);		//NO I18N
			Ember.set(params, 'rangeChange', pageNavigateData['isNavigate']);		//NO I18N
		}
		Ember.set(params,'currentSelection', this.get('currentSelection'));			//NO I18N
		Ember.set(params,'isExcludeChild', this.get('isExcludeChild'));			//NO I18N
		Ember.set(params, 'prevSelItems', this.selectedList);		//NO I18N
		Ember.set(params, 'prevUnSelItems', this.excludedList);		//NO I18N
	},
	showTab() {
		var popupTab = this.get('popupTab');	//NO I18N
		if(!jQuery.isEmptyObject(this.selectedList)){
			$('#popupSelectedCountDiv').css('display', 'block');
			$('#selectedCount').html(this.selectedList.length);		//NO I18N
		}
		$('#PopupDataModel_'+popupTab['tabType']).css('display','block');
		$('#pdmlinkDiv_'+popupTab['tabType']).hide();
		$('#PdmDiv_'+popupTab['tabType']).removeClass('tab-content');
	},
	getDataModelUIDesign(){
		this.updateParams();
		var params = this.get('params');		//NO I18N
		var self = this;
		$('#loadingDiv').css('display','block');
		AJAXUTIL.ajaxNoScroll("/api/json/getPopupData", {"params":JSON.stringify(params), "type":this.popupTab.tabType}).then(function(jsonData){	//NO I18N
			var popupTab = self.get('popupTab');	//NO I18N
			var isLoaded = popupTab['isLoaded'];
			Ember.set(isLoaded,popupTab['tabType'], true);		//NO I18N
			if(jsonData['totalResultCount']){
				var pageNavigateData = self.get('pageNavigateData');	//NO I18N
				Ember.set(pageNavigateData, 'totalCount', jsonData['totalResultCount']);		//NO I18N
			}
			var dataModelObject = popupTab.dataModelObject;
			Ember.set(dataModelObject, popupTab.tabType, jsonData);		//NO I18N
			self.set('params', {});		//NO I18N
			self.showTab();
			$('#loadingDiv').css('display','none');		//NO I18N
			Ember.run.scheduleOnce('afterRender', this, function(){		//NO I18N
					$('#isExcludeChild_'+popupTab.tabType).show();	//NO I18N
					$('.modal-content').addClass('excl-childOU-popup');
					if($('.fw-padding-box-10').hasClass('fw-p-0')){
						$('.fw-padding-box-10').removeClass('fw-p-0');
				}

				if(popupTab.tabType == 'tree'){

					$("#maintree").jstree({
						"checkbox" : {"three_state" : false},								//NO I18N
						types: {
							"ou": {					//NO I18N
							  "icon" : "jstree-themeicon addOu"		//NO I18N
							},
							"container": {					//NO I18N
							  "icon" : "jstree-themeicon addContainer"		//NO I18N
							},
							"default" : {				//NO I18N
							}
						},
						"plugins" : ["checkbox","search", "themes", "types"],							//NO I18N
						"core" : {								//NO I18N
							//"multiple" : false,
							"animation" : 0, // No I18N
							"data" : function (obj, cb) {						//NO I18N
								self.onNodeClicked(obj.id, cb);
							},
							//"force_text" : true		//NO I18N
						}
					});
				}else{
					self.updateListToUI();
				}
				if(popupTab.tabType == 'table'){
					var tablediv = "#ResultRows";	//No I18N
					if($(tablediv).length != 0) {
						if($(tablediv).hasClass('mCustomScrollbar')){
							$(tablediv).mCustomScrollbar('destroy');
						}
						$(tablediv).mCustomScrollbar();
					}
				}
				$('#pdmLinkId_'+popupTab.tabType).addClass('active');
				if(self.get('viewSummary')) {
					self.enableSummaryView();
					self.set('viewSummary', false);	//NO I18N
				}
			});
		});
	},
	updateListToUI(){
		var popupTab = this.get('popupTab');	//NO I18N
		if(popupTab.tabType == 'tree'){
			for(var key in this.selectedList){
				var node = $('#maintree').jstree(true).get_node(key);
				$('#maintree').jstree(true).check_node(node);
			}
			for(var key in this.excludedList){
				var node = $('#maintree').jstree(true).get_node(key);
				$('#maintree').jstree(true).uncheck_node(node);
			}
		}else {
			for(var key in this.selectedList){
				var id = "Checkbox_"+ESCUTIL.escapeSelectorId(key);		//NO I18N
				if($("[id='"+id+"']") !== undefined){
					$("[id='"+id+"']").iCheck('check');
				}
			}
		}
		this.updateCount();
	},
	updateCount(){
			var selectedCount = 0;
			for(var key in this.selectedList){
				selectedCount++;
			}
			if(selectedCount>0){
				$('#popupSelectedCountDiv').css('display','block');
				$('#selectedCount').html(selectedCount);			//NO I18N
			}else{
				$('#popupSelectedCountDiv').css('display','none');
			}
	},
	onNodeClicked(nodeId, cb){
		var params = this.get('params');			//NO I18N
		this.updateParams();
		if(nodeId =='#'){Ember.set(params, 'nodeClicked', params.currentSelection);}
		else{Ember.set(params, 'nodeClicked', nodeId);}	//NO I18N
		var self = this;
		var loaded = false;
		AJAXUTIL.ajaxNoScroll("/api/json/getPopupData", {"params":JSON.stringify(params), "type":this.popupTab.tabType}).then(function(jsonData){	//NO I18N
			var rootNode = jsonData['rootNode'];
			var childObjects = rootNode['children'];
			self.set('params', {});		//NO I18N
			if(childObjects == true){cb([]);}
			else{cb(childObjects);}
			if(nodeId != '#'){
				$('#maintree').on('after_open.jstree', function(e, data) {
					self.updateToSelectedList(data.node.id, $('#maintree').jstree(true).get_node(data.node.id));
				});
			}else{
				$('#maintree').on('load_node.jstree', function(e, data) {
					for(var key in self.selectedList){
						var id = ESCUTIL.escapeSelectorId(key);		//NO I18N
						if(key == self.get('currentSelection')){
							$("[id='"+id+"']").parent().addClass('checked');
						}else{
							if($("[id='"+id+"']") !== undefined){
								$("[id='"+id+"_anchor"+"']").addClass('jstree-clicked');
							}
						}
						self.updateCount();
					}
				});
			}
		});
	},
	enableSummaryView(){
		var summarySelectedList = Ember.A([]);
		for(var key in this.selectedList){
			var prop = {};
			Ember.set(prop, 'uniqueColumn', key);		//NO I18N
			Ember.set(prop, 'uniqueDisplayColumn', this.selectedList[key]);	//NO I18N
			summarySelectedList.pushObject(prop);
		}
		this.set('summarySelectedList', summarySelectedList);		//NO I18N
		Ember.run.scheduleOnce('afterRender', this, function(){this.showSummaryView();});//NO I18N
	},
	updateToUnSelectedList(id, node){
		var popupTab = this.get('popupTab');	//NO I18N
		var jElement = '#'+ESCUTIL.escapeSelectorId(id);	//NO I18N
		var val = node.id;
		var displayVal = node.text;
		if(popupTab.tabType=='tree' && !this.isExcludeChild){
			var self = this;
			var childDivId = ESCUTIL.escapeSelectorId(val);	//NO I18N
			$("[id='"+childDivId+"']").find('.jstree-node').each(function(){
				var cval = $(this).attr('id');
				var cdisplayVal = $(this).prop('innerText');
				var cnode = $('#maintree').jstree(true).get_node(cval);
				if($('#maintree').jstree(true).is_selected(node)){
					$('#maintree').jstree(true).check_node(cnode);
					delete self.excludedList[cval];
				}else{
					$('#maintree').jstree(true).uncheck_node(cnode);
					//Ember.set(unselectedList, cval, cdisplayVal);
					self.excludedList[cval] = cdisplayVal;
				}
			});
		}
		if($('#maintree').jstree(true).is_selected(node)){
			delete this.excludedList[val];
		}else{
			//Ember.set(unselectedList, val, displayVal);
			this.excludedList[val] = displayVal;
		}
	},
	showSummaryView(){
		$('#popupTitle').html(I18N.translate('ads.ou_selection.text.summary_view'));		//NO I18N
		$('#PopupViewDiv').css('display', 'none');
		$('#PopupViewFooter').css('display', 'none');
		$('#SummaryViewDiv').css('display', 'block');
		$('#SummaryViewFooter').css('display','block');
		$('#enableSummaryViewLink').css('display', 'none');
		$('#summaryAllSelect').iCheck('check');
	},
	updateOUDiv(){
		var ouSelText = '';
		var i = 0;
		for(var key in this.selectedList){
			var ouName = this.selectedList[key];
			if(i!=0)
				ouSelText += ', '
			ouSelText = ouSelText + ouName;
			++i;
		}
		if(ouSelText.length>50){ouSelText = ouSelText.substring(0,50);}
		if(i==0){ouSelText = I18N.translate("ads.ou_selection.text.all");this.set('IS_ALL', true);}
		else{this.set('IS_ALL', false);}	//NO I18N
		//ouSelText = ESCUTIL.htmlEncode(ouSelText);
		Ember.$('#ouSelText').val(ouSelText);
	},
	refreshResultData() {
		var configJSON = {};
		var parentList = this.get('parentList');	//NO I18N
		configJSON.PARENT_LIST = parentList;
		var selectedList = [];
		var unSelectedList = [];
		for(var key in this.selectedList) {
			selectedList.push(key);
		}
		for(var key in this.excludedList) {
			unSelectedList.push(key);
		}
		configJSON.SPL_FILTER_CHANGED = true;
		configJSON.SELECTED_LIST = selectedList;
		configJSON.UNSELECTED_LIST = unSelectedList;
		configJSON.IS_EXCLUDE_CHILD = this.isExcludeChild;
		configJSON.CURRENT_SELECTION = this.get('currentSelection');	//NO I18N
		configJSON.SHOW_SPL_FILTER = this.get('showFilter');	//NO I18N
		configJSON.IS_ALL = this.get('IS_ALL');	//NO I18N
		var parentComponent = this.get('parentComponent');	//NO I18N
		parentComponent.reportTableComponent.refreshTable(configJSON);
	},
	updateToSelectedList(id, node){
		var jElement = "[id='"+ESCUTIL.escapeSelectorId(id)+"']";		//No I18N
			if(this.popupTab['tabType']=='tree' && node == undefined){
				var self = this;
				var val = $(jElement).attr('uniqueColumn');
				var displayVal = $(jElement).attr('uniqueDisplayColumn');
				$('#maintree').find('.jstree-node').each(function(){
					var cval = $(this).attr('id');
					var cdisplayVal = $(this).prop('innerText');
					var cnode = $('#maintree').jstree(true).get_node(cval);
					if(!self.isExcludeChild){
						if($(jElement).prop('checked')){
							$('#maintree').jstree(true).check_node(cnode);
							self.selectedList[cval]=cdisplayVal;
						}else{
							$('#maintree').jstree(true).uncheck_node(cnode);
							delete self.selectedList[cval];
						}
					}else{
						if($(jElement).prop('checked')){
							delete self.excludedList[cval];
						}else{
							//Ember.set(unselectedList, cval, cdisplayVal);
							self.excludedList[cval]=cdisplayVal;
						}
					}
				});
				if($(jElement).prop('checked')){
					//Ember.set(selectedList, val, displayVal);
					this.selectedList[val] = displayVal;
				}else{
					delete this.selectedList[val];
				}
			}else if(this.popupTab.tabType=='tree' && node != undefined){		//NO I18N
				var val=node.id;
				var displayVal = node.text;
				this.updateToUnSelectedList(id, node);
				var self = this;
				var childDivId = ESCUTIL.escapeSelectorId(val);	//NO I18N
				$("[id='"+childDivId+"']").find('.jstree-node').each(function(){
					var cval = $(this).attr('id');
					var cdisplayVal = $(this).prop('innerText');
					var cnode = $('#maintree').jstree(true).get_node(cval);
					if(!self.isExcludeChild){
						if($('#maintree').jstree(true).is_selected(node)){
							$('#maintree').jstree(true).check_node(cnode);
							//Ember.set(selectedList, cval, cdisplayVal);
							self.selectedList[cval] = cdisplayVal;
						}else{
							$('#maintree').jstree(true).uncheck_node(cnode);
							delete self.selectedList[cval];
						}
					}else{
						if($('#maintree').jstree(true).is_selected(node)){
							delete self.excludedList[cval];
						}else{
							//Ember.set(unselectedList, cval, cdisplayVal);
							self.excludedList[cval] = cdisplayVal;
						}
					}
				});
				if($('#maintree').jstree(true).is_selected(node)){
					//Ember.set(selectedList, ESCUTIL.scriptEscape(val), ESCUTIL.scriptEscape(displayVal));
					this.selectedList[val] = displayVal;
				}else{
					delete this.selectedList[val];
				}
			}else{
				var val = $(jElement).attr('uniqueColumn');
				var displayVal = $(jElement).attr('uniqueDisplayColumn');
				if($(jElement).prop('checked')){
					//Ember.set(selectedList, val, displayVal);
					this.selectedList[val] = displayVal;
				}else{
					delete this.selectedList[val];
				}
			}
			this.updateCount();
	},
	updateSummarySelectedAll(){
		var all = $('#SummaryResultRows :checkbox').length;
		var checked = $('#SummaryResultRows :checkbox:checked').length;
		if (all == checked){
			$('#SummarySelectAll').parent().addClass('checked');
			$('#SummarySelectAll').prop('checked', true);
		}else{
			$('#SummarySelectAll').parent().removeClass('checked');
			$('#SummarySelectAll').prop('checked', false);
		}
	},
	actions : {
		toggleOUFilter() {
			var showFilter = this.get("showFilter");	//NO I18N
			this.set("showFilter", !showFilter);	//NO I18N
			if(showFilter) {
				$('#filterDiv').css('display','none');
				$('#applyFilterDiv').css('display','block');
			}
			else {
				$('#applyFilterDiv').css('display','none');
				$('#filterDiv').css('display','block');
			}
			this.refreshResultData();
		},
		updateToSelectedList(id, node){
			this.updateToSelectedList(id,node);
		},

		closePopup(){
			$('#PopupDiv').modal('hide');		//NO I18N
			this.clearPopupData();
		},
		onPopupOk(){
			$('#PopupDiv').modal('hide');		//NO I18N
			this.updateOUDiv();
			this.refreshResultData();
			this.clearPopupData();
		},
		openPopup(){
			this.onPopupLoad(false);
		},
		openPopupWithSummary(){
			if(!jQuery.isEmptyObject(this.selectedList))
				this.onPopupLoad(true);
			else
				this.onPopupLoad(false);
		},
		changeSelection(clientValue, serverValue){
			var popupTab = this.get('popupTab');	//NO I18N
			this.set('currentSelection', serverValue);	//NO I18N
			this.set('resetPageNavig', true);		//NO I18N
			var isLoaded = 	{};
			isLoaded.table = false;
			isLoaded.tree= false;
			popupTab.isLoaded = isLoaded;
			if ($("#searchIcn").hasClass('fw-icn-search-clear')) {
				$("#searchIcn").removeClass("fw-icn-search-clear").addClass("fw-icn-search");
				$("#search").toggle();
				$('#SearchBox').val('');
			}
			if($("#maintree").length!=0)
			{
				$('#maintree').jstree("destroy").empty();
			}
			this.selectedList = {};
			this.excludedList = {};
			popupTab.dataModelObject.tree={};
			popupTab.dataModelObject.table={};
			this.updateCount();
			this.getDataModelUIDesign();
		},
		onTabClicked(tabType){
			var popupTab = this.get('popupTab');	//NO I18N
			var popupTabType = popupTab['tabType'];
			$('#PopupDataModel_'+popupTabType).css('display', 'none');
			$('#pdmLinkId_'+popupTabType).removeClass('active');
			Ember.set(popupTab, 'tabType', tabType);		//NO I18N
			var isLoaded = popupTab['isLoaded'];
			if(!isLoaded[tabType]){
				this.getDataModelUIDesign();
			}else{
				this.showTab();
			}
		},
		onExcludeChildChange(value){
			this.isExcludeChild = value;		//NO I18N
		},
		updateToSelectedListFromSummary(value, key){
			var popupTab = this.get('popupTab');	//NO I18N
			var id='';
			if(popupTab.tabType == 'tree'){
				id = ESCUTIL.escapeSelectorId(key);		//NO I18N
				if(key == this.get('currentSelection')){
					if(value){
						$("[id='"+id+"']").parent().addClass('checked');
						$("[id='"+id+"']").prop('checked', true);
						//Ember.set(selectedList, key, $("[id='"+"SummaryViewCheckBox_"+id+"']").attr('uniqueDisplayColumn'));		//NO I18N
						this.selectedList[key] = $("[id='"+"SummaryViewCheckBox_"+id+"']").attr('uniqueDisplayColumn');
					}else{
						$("[id='"+id+"']").parent().removeClass('checked');
						$("[id='"+id+"']").prop('checked', false);
						delete this.selectedList[key];
					}
				}else{
					if(value){
						$("[id='"+id+"_anchor"+"']").addClass('jstree-clicked');
						$("[id='"+id+"']").prop('checked', true);
						//Ember.set(selectedList, key, $("[id='"+"SummaryViewCheckBox_"+id+"']").attr('uniqueDisplayColumn'));		//NO I18N
						this.selectedList[key] = $("[id='"+"SummaryViewCheckBox_"+id+"']").attr('uniqueDisplayColumn');
					}else{
						$("[id='"+id+"_anchor"+"']").removeClass('jstree-clicked');
						$("[id='"+id+"']").prop('checked', false);
						delete this.selectedList[key];
					}
				}
				this.updateSummarySelectedAll();
				this.updateCount();
			}else{
				id = 'Checkbox_'+ESCUTIL.escapeSelectorId(key);							//NO I18N
				if(value){
					if($("[id='"+id+"']") !== undefined){
						$("[id='"+id+"']").iCheck('check');
					}else{
						//Ember.set(selectedList, key, $("[id='SummaryViewCheckBox_"+ESCUTIL.escapeSelectorId(key)+"']").attr('uniqueDisplayColumn'));							//NO I18N
						this.selectedList[key] = $("[id='SummaryViewCheckBox_"+ESCUTIL.escapeSelectorId(key)+"']").attr('uniqueDisplayColumn');	//NO I18N
					}
				}else{
					if($("[id='"+id+"']") !== undefined){
						$("[id='"+id+"']").iCheck('uncheck');
					}else{
						delete this.selectedList[key];
					}
				}
				this.updateSummarySelectedAll();
				this.updateCount();
			}
		},
		updateAllToSelectedListFromSummary(value){
			$('#SummaryResultRows'+' :checkbox').each(function(){
				if(value){
					$(this).iCheck('check');
				}else{
					$(this).iCheck('uncheck');
				}
			});
		},
		toggleSearch(){

			if ($("#searchIcn").hasClass('fw-icn-popup-search')) {
				$("#searchIcn").removeClass("fw-icn-popup-search").addClass("fw-icn-popup-search-clear");
				$("#search").toggle();
				$('#SearchBox').focus();
			}else {
				$("#searchIcn").removeClass("fw-icn-popup-search-clear").addClass("fw-icn-popup-search");
				$("#search").toggle();
				var searchVal = $('#SearchBox').val();
				if(searchVal != ''){
					$('#SearchBox').val('');
					this.set('resetPageNavig', true);	//NO I18N
					this.getDataModelUIDesign();
				}
			}
		},
		doRefresh(){
			var params = this.get('params');		//NO I18N
			Ember.set(params, 'refresh', true);		//NO I18N
			this.set('resetPageNavig', true);	//NO I18N
			this.getDataModelUIDesign();
		},
		onSearch(event){
			var searchText = $('#SearchBox').val();
			var keyCodes = Ember.A([16,17,18,20,35,36,37,38,39,40,45]);
			var self = this;
			if (!keyCodes.contains(event.keyCode) && !event.ctrlKey) {
				clearTimeout(this.typingTimer);
				this.typingTimer = setTimeout(function() {
					self.set('resetPageNavig', true);	//NO I18N
					self.getDataModelUIDesign();
				}, 1000);
			}

		},
		enableSummaryView(){
			this.enableSummaryView();
		},
		hideSummaryView(){
			$('#popupTitle').html(I18N.translate("ads.ou_selection.text.popup_title"));		//NO I18N
			$('#PopupViewDiv').css('display', 'block');
			$('#PopupViewFooter').css('display', 'block');
			$('#SummaryViewDiv').css('display', 'none');
			$('#SummaryViewFooter').css('display','none');
			$('#enableSummaryViewLink').css('display','inline-block');
			this.updateListToUI();
		},
		onRangeChange : function(range){
			this.set('pageNavigateData.range',parseInt(range));	//NO I18N
			this.set('pageNavigateData.startIndex',1);	//NO I18N
			var endIndex = parseInt(range);
			var totalCount = parseInt(this.get('pageNavigateData.totalCount'));	//NO I18N
			if(endIndex > totalCount){
				endIndex = totalCount;
			}
			this.set('pageNavigateData.toIndex',endIndex);	//NO I18N
			this.set('pageNavigateData.isNavigate',true);	//NO I18N
			this.getDataModelUIDesign();
		},
		navigate : function(direction){
			if($('#'+direction).find('i').hasClass('fw-icn-disable')){return;}
			var startIndex = parseInt(this.get('pageNavigateData.startIndex')) + parseInt(this.get('pageNavigateData.range'));	//NO I18N
			if(direction=='Prev')
				startIndex = parseInt(this.get('pageNavigateData.startIndex')) - parseInt(this.get('pageNavigateData.range'));	//NO I18N
			this.set('pageNavigateData.startIndex',startIndex);	//NO I18N
			var endIndex = (parseInt(this.get('pageNavigateData.startIndex')) + parseInt(this.get('pageNavigateData.range')) ) - 1;	//NO I18N
			var totalCount = parseInt(this.get('pageNavigateData.totalCount'));	//NO I18N
			if(endIndex > totalCount){
				endIndex = totalCount;
			}
			this.set('pageNavigateData.toIndex',endIndex);	//NO I18N
			this.set('pageNavigateData.isNavigate',false);	//NO I18N
			this.getDataModelUIDesign();			//NO I18N
		},
	}
});
