/*$Id$*/
/**
 * {{personalize-settings showStatus='showStatus'}}
 */
//ignorei18n_start
import Ember from 'ember';
import I18NUtil from "../utils/i18n-util"; //NO I18N
import AJAXUtil from '../utils/ads-ajax-util'; //NO I18N
import DialogUtil from "../utils/ads-dialog-util"; //NO I18N
import CommonUtil from "../utils/ads-common-util"; //NO I18N

export default Ember.Component.extend({
    init: function(){
        this._super();
        this.send('getSettings');
	},
	pageStatus : {},
	didInsertElement: function(){
		this.$(".texttype").on('keydown',function(event){
			if(event.which==13 && event.shiftKey){
				event.preventDefault();
			}
		});
	},
	willDestroyElement : function() {
		this.$(".texttype").off('keydown');
	},	
    actions:{
        getSettings:function()
		{
			window.scrollTo(0,0); 
			var self=this;
			  var responseData = AJAXUtil.syncAjax("/RestAPI/WC/ADSPersonalize?mTCall=getPersonalizeSettings",{});
			  self.set('personalizeData',responseData);
			  self.set('currentPersonalizeData', Ember.$.extend(true, [], responseData));
			  CommonUtil.afterRender();
			  Ember.run.scheduleOnce('afterRender',this,function(){
				  this.$('#LOGO_PATH .file-upload-placeholder').val("");
				  this.$('[name="LOGO_PATH"]').val("");
				  this.$('#FAVICON_PATH .file-upload-placeholder').val("");
				  this.$('[name="FAVICON_PATH"]').val("");			  
			  });
		},
		setCheckBoxValue:function(enableSetting,status)
        	{
        	if(status)
       		{
       			this.$(enableSetting).parent('div').addClass('checked');
       		}
       		else
       		{
       			this.$(enableSetting).parent('div').removeClass('checked');	
       		}
       		this.$(enableSetting).prop('checked',status);
        },
		updateLogo:function()
		{
			var logoPath=this.$('[name="LOGO_PATH"]').val().split('\\').pop();
			if(logoPath.length>20)
			{
				logoPath=logoPath.substring(0,20)+"...";
			}
			this.$('#LOGO_PATH .file-upload-placeholder').val(logoPath);
		},
		updateIcon:function()
		{
			var favIconPath=this.$('[name="FAVICON_PATH"]').val().split('\\').pop();
			if(favIconPath.length>20)
			{
				favIconPath=favIconPath.substring(0,20)+"...";
			}
			this.$('#FAVICON_PATH .file-upload-placeholder').val(favIconPath);
		},
		
		updateSettings:function()
		{   
		    window.scrollTo(0,0); 
		    var self=this;

		    self.set('isReloadRequired',null);

		    this.$('#SELECT_LANGUAGE').val(this.$('#LANGUAGE').val());
			this.$('#TIME_ZONE').val(this.$('#SELECT_TIME_ZONE').val());
			this.$('#DATE_TIME_FORMAT').val(this.$('#SELECT_DATE_TIME_FORMAT').val());

			var currentPersonalizeData = self.get('currentPersonalizeData');

			if(this.$('#LANGUAGE').val()!=currentPersonalizeData.SELECTED_LANGUAGE)
			{
				self.set('isReloadRequired',true);
			}

			if(this.$('#SELECT_TIME_ZONE').val()!=currentPersonalizeData.TIME_ZONE)
			{
				self.set('isReloadRequired',true);
			}

			if(this.$('#SELECT_DATE_TIME_FORMAT').val()!=currentPersonalizeData.DATE_TIME_FORMAT)
			{
				self.set('isReloadRequired',true);
			}
			
			var browserTitle=Ember.$.trim(this.$('#PersonalizeForm [name="BROWSER_TITLE"]').val());
			if(browserTitle!=currentPersonalizeData.BROWSER_TITLE)
			{
				self.set('isReloadRequired',true);
			}

			if(this.$('[name="FAVICON_PATH"]').val()!="" || this.$('[name="LOGO_PATH"]').val()!="")
			{
				self.set('isReloadRequired',true);	
			}

			if(browserTitle == '')
			{
				DialogUtil.alert(this, I18NUtil.translate('ads.admin.personalize.browser_tilte.empty'));//No I18N
			}
			// else if (this.get('GLOBAL_DATA.generalDetails.IS_DEMO')) 
			// {
			// 	self.sendAction('showStatus','danger',I18NUtil.translate('ads.common.error.demo_mode'),false);
			// }
			else if(browserTitle.length>250)
			{	
				DialogUtil.alert(this, I18NUtil.translate('ads.admin.personalize.browser_title.long'));//No I18N
			}
			else 
			{
				var faviconStr=Ember.$.trim(this.$('#PersonalizeForm [name="FAVICON_PATH"]').val().toUpperCase());
				var suffix=".ICO";	//No I18N

				var logoStr=Ember.$.trim(this.$('#PersonalizeForm [name="LOGO_PATH"]').val().toUpperCase());
				var ext = logoStr.substring(logoStr.lastIndexOf('.') + 1).toUpperCase();

				var favIconFileName = faviconStr.substring(faviconStr.lastIndexOf("\\")+1,faviconStr.lastIndexOf('.'));
				var logoFileName = logoStr.substring(logoStr.lastIndexOf("\\")+1,logoStr.lastIndexOf('.'));

				if(faviconStr!='' && !(faviconStr.indexOf(suffix, faviconStr.length - suffix.length) != -1))
				{
					DialogUtil.alert(this, I18NUtil.translate('ads.admin.personalize.alert_favicon_filetype'));//No I18N
				}
				else if(favIconFileName.match('^[a-zA-Z0-9-_ ]{0,255}$')==null) 
				{
					DialogUtil.alert(this, I18NUtil.translate('ads.admin.personalize.invalid_filename'));//No I18N
				}
				else if(logoStr!='' && !(ext == "GIF" || ext == "JPEG" || ext == "JPG" || ext == "PNG" || ext == "BMP"))
				{
					DialogUtil.alert(this, I18NUtil.translate('ads.admin.personalize.alert_image_filetype'));//No I18N
				}
				else if(logoFileName.match('^[a-zA-Z0-9-_ ]{0,255}$')==null)
				{
					DialogUtil.alert(this, I18NUtil.translate('ads.admin.personalize.invalid_filename'));//No I18N
				}
				else
				{
                    this.$('#PersonalizeIFrame').unbind();
                    this.$('#PersonalizeIFrame').on("load",function()
                  {
                      var responseHtml = self.$("#PersonalizeIFrame").contents().find("body").html();
                      try
                      {
                          var response = Ember.$.parseJSON(responseHtml);
                          if('sSTATUS' in response)
                          {
                              if(self.get('isReloadRequired'))
                              {
                                  DialogUtil.confirm(self,'ads.admin.personalize.save.refresh_alert','refresh','ads.common.text.reload');//No I18N
                              }
                              else
                              {
								self.sendAction('showStatus','success',I18NUtil.translate(response.sSTATUS),true);
                              }
                              self.set('isReloadRequired',null);
                              self.set('currentPersonalizeData', Ember.$.extend(true, [], self.get('personalizeData')));
                          }
                          else if('eSTATUS' in response)
                          {
							self.sendAction('showStatus','danger',I18NUtil.translate(response.eSTATUS),false);
                          }else if(response.hasOwnProperty('ERROR_CODE') && response.ERROR_CODE=='00000014'){
								self.sendAction('showStatus','danger',I18NUtil.translate('ads.common.error.demo_mode'),false);
						  }
                      }
                      catch(e)
                      {
                          AJAXUtil.handleSessionTimeout("403", responseHtml);
                      }
                  });
				   this.$('[id="PersonalizeForm"]').submit();
				}
			}
		},
		refresh:function()
		{
            try
            {
                if(window.location.host==top.location.host)
                {
                    window.parent.location.reload();
                }
            }
            catch(e)
            {
				//add this action to application route to refresh the app or any own handling
                this.sendAction('refreshRoute');
            }
		},
		
		
	    hide:function(){}
    },
});
//ignorei18n_end