/*$Id$*/
/**
 * {{product-settings showStatus='showStatus' connSettings=connSettings saveSettings='updateSettings' options=options}} 
 */
//ignorei18n_start
import Ember from 'ember';
import I18NUtil from "../utils/i18n-util"; //NO I18N
import ValidationUtil from "../utils/ads-validation-util"; //NO I18N
import AJAXUtil from '../utils/ads-ajax-util'; //NO I18N
import DialogUtil from "../utils/ads-dialog-util"; //NO I18N
import CommonUtil from "../utils/ads-common-util"; //NO I18N

export default Ember.Component.extend({
  pageStatus: {},
  init: function () {
    this._super();
    var expiryTimes = [];
    expiryTimes.push({
      CLIENT_VALUE: "15" + I18NUtil.translate('ads.common.text.mins'),
      SERVER_VALUE: 15
    }, {
      CLIENT_VALUE: "30" + I18NUtil.translate('ads.common.text.mins'),
      SERVER_VALUE: 30
    }, {
      CLIENT_VALUE: "45" + I18NUtil.translate('ads.common.text.mins'),
      SERVER_VALUE: 45
    }, {
      CLIENT_VALUE: "1" + I18NUtil.translate('ads.common.text.hrs'),
      SERVER_VALUE: 60
    }, {
      CLIENT_VALUE: "2" + I18NUtil.translate('ads.common.text.hrs'),
      SERVER_VALUE: 120
    }, {
      CLIENT_VALUE: "3" + I18NUtil.translate('ads.common.text.hrs'),
      SERVER_VALUE: 180
    }, {
      CLIENT_VALUE: I18NUtil.translate('ads.admin.product_settings.general.session_expiry.never'),
      SERVER_VALUE: -1
    });
    this.set('EXPIRY_TIMES', expiryTimes); //No I18N
    this.set('isPasswordMasked', false);
    var protocols = [];
    protocols.push({
      CLIENT_VALUE: "HTTP",
      SERVER_VALUE: "HTTP"
    }, {
      CLIENT_VALUE: "HTTPS",
      SERVER_VALUE: "HTTPS"
    });
    this.set('PROTOCOLS', protocols); //No I18N
    var self = this;
    // console.log("end of init");
  },
  didReceiveAttrs: function () {
        this.send('getSettings');
  },
  doUpdate: Ember.observer('options.doUpdate',function(){
    this.send('updateSettingsWithConfirmation');
  }),
  doRefresh: Ember.observer('options.doRefresh',function(){
    this.send('getSettings');    
  }),  
  changePort: function () {
      var protocol = this.get('connSettings.SELECTED_PROTOCOL');
      var http = this.get('connSettings.HTTP');
      var old_http = this.get('connSettings.old_http');
      if (old_http != http && protocol == 'HTTP') {
        this.set('connSettings.http_changed', true); //Once the value is editied its set to true 
      }

    }.observes('connSettings.HTTP'),
    changeHTTPS: function () {
      var https = this.get('connSettings.HTTPS');
      if (this.get('connSettings.SELECTED_PROTOCOL') === 'HTTPS' && this.get('connSettings.http_changed') === false) {
        var http = Number(https) - (8443 - 8080);
        if (http < 1 || http > 65535 || isNaN(http)) {
          http = 8082;
        }
        this.set('connSettings.HTTP', http);
      }
    }.observes('connSettings.HTTPS'),

  showKeytoreConfig(status) {
    var $IS_KEYSTORE_ENCRYPTION_ENABLED = this.$('#IS_KEYSTORE_ENCRYPTION_ENABLED');
    var $KEYSTORE_PASS = this.$('#KEYSTORE_PASS');
    if (status) {
      $IS_KEYSTORE_ENCRYPTION_ENABLED.attr('disabled', false);
    } else {
      $IS_KEYSTORE_ENCRYPTION_ENABLED.attr('disabled', true);
      $KEYSTORE_PASS.attr('disabled', 'disabled');
      this.set('connSettings.KEYSTORE_PASS', undefined);
    }
    // this.set('connSettings.isKeystoreEncryptionEnabled', this.get('connSettings.KEYSTORE_ENCRYPTION'));
  },

  actions: {
    getSettings: function () {
      var self = this;
        // console.log('here in pdt settngs component');
        var params = {};
        if(this.get('options.showSessionExpiry')){
          params = {INCLUDE_SESSION_EXPIRY:true};
        }
        var productDetails = AJAXUtil.syncAjax('/RestAPI/WC/ConnectionSettings?mTCall=getSettings', params);
        this.set('connSettings', productDetails);
      self.set('connSettings.old_http', self.get('connSettings.HTTP'));
      self.set('connSettings.old_https', self.get('connSettings.HTTPS'));
      if (self.get('connSettings.KEYSTORE_ENCRYPTION')) {
        Ember.run.schedule('afterRender', function () { //No I18N
          self.showKeytoreConfig(true);
          // $('#KEYSTORE_PASS').val('********');
          self.set('connSettings.KEYSTORE_PASS','********');
          self.set('connSettings.isPasswordMasked', true);
        });
      } else {
        Ember.run.schedule('afterRender', function () { //No I18N
          self.showKeytoreConfig(false);
          self.$('#KEYSTORE_ENCRYPTION_DIV').hide();
        });
      }
      if (self.get('connSettings.SSL') == 'TRUE') {
        self.set('connSettings.SELECTED_PROTOCOL', 'HTTPS'); //No I18N
        Ember.run.schedule('afterRender', function () //NO I18N
        {
            self.$('#HTTP_PORT').val(self.get('connSettings.HTTP')); //No I18N
            self.$('#HTTPS_PORT').attr('disabled', false); //No I18N
            self.$('#HTTP_PORT').attr('disabled', true); //No I18N
            self.$('#IS_KEYSTORE_ENCRYPTION_ENABLED').attr('disabled', false);
            self.$('#KEYSTORE_ENCRYPTION_DIV').show();
          }
        );
      } else {
        // console.log("SSL is FALSE");
        var x = Number(self.get('connSettings.HTTP'));
        var https_value = x + (8443 - 8080);
        if (https_value > 65535) {
          https_value = 8445;
        }
        self.set('connSettings.old_https', https_value);
        self.set('connSettings.HTTPS', https_value);
        self.set('connSettings.SELECTED_PROTOCOL', 'HTTP'); //No I18N
        Ember.run.schedule('afterRender', function () //NO I18N
        {
            self.$('#HTTPS_PORT').val(self.get('connSettings.HTTPS')); //No I18N
            self.$('#HTTP_PORT').attr('disabled', false); //No I18N
            self.$('#HTTPS_PORT').attr('disabled', true); //No I18N
            self.$('#IS_KEYSTORE_ENCRYPTION_ENABLED').attr('disabled', true);
          }
        );
      }
      self.set('connSettings.http_changed', false); //Resetting the value 
    },
    setCheckBoxValue: function (enableSetting, status) {
      if (status == 'true') {
        this.$(enableSetting).parent('div').addClass('checked');
      } else {
        this.$(enableSetting).parent('div').removeClass('checked');
      }
      this.$(enableSetting).prop('checked', (status == 'true'));
    },
    updateSettingsWithConfirmation: function () {
      var self = this;
      var params = {};
      var isKeystoreEncryptionEnabled = this.get('connSettings.KEYSTORE_ENCRYPTION');
      var http = this.get('connSettings.HTTP');
      var https = this.get('connSettings.HTTPS');
      var keystorePass;
      var ssl = (this.get('connSettings.SELECTED_PROTOCOL') == 'HTTPS');
      var port = 0;
      if (ssl) {
        port = https;
        if (isKeystoreEncryptionEnabled) {
          keystorePass = this.get('connSettings.KEYSTORE_PASS');
          if (keystorePass==undefined||keystorePass.length < 6) {
            DialogUtil.alert(this, I18NUtil.translate('ads.admin.product_settings.invalid_keystore_password_length'));
            return;
          }
        }
      } else {
        port = http;
        params.IS_KEYSTORE_ENCRYPT_ENABLED = false;
      }
      if (Ember.isNone(port) || Ember.isEmpty(port) || !ValidationUtil.isValidPort(String(port))) {
        DialogUtil.alert(this, I18NUtil.translate('ads.admin.product_settings.connection.select_protocol.http_range')); //No I18N			
        return;
      }
      params.SSL = ssl;
      params.OLD_HTTPS = self.get('connSettings.old_https');
      params.OLD_HTTP = self.get('connSettings.old_http');
      params.HTTP = http;
      params.HTTPS = https;
      if(this.get('options.showSessionExpiry') && this.get('connSettings.SESSION_EXPIRY_TIME')){
        params.SESSION_EXPIRY_TIME = this.get('connSettings.SESSION_EXPIRY_TIME');
      }
      if (!this.get('connSettings.isPasswordMasked')) params.KEYSTORE_PASS = keystorePass;
      params.IS_KEYSTORE_ENCRYPT_ENABLED = this.get('connSettings.KEYSTORE_ENCRYPTION') ? this.get('connSettings.KEYSTORE_ENCRYPTION') : false;
      if(this.get('connSettings.IS_HA_ENABLED')) {
        DialogUtil.confirm(this,'ads.common.ha.port_alert_message','updateSettings','ads.common.text.translation.yes',params,null,null,null,'ads.common.text.translation.no');//No I18N
        return;
      }else{
        this.send('updateSettings',params);//No i18n
      }
    },
    updateSettings: function(params){
      var self =this;
      CommonUtil.showLoading();
      AJAXUtil.ajax('/RestAPI/WC/ConnectionSettings?mTCall=updateSettings', params)
        .then(function (response) {
          CommonUtil.hideLoading();
          var errorStatus = response["eSTATUS"];
          if (errorStatus == undefined) {
            self.send('getSettings');
          }
          self.sendAction('showStatus', response);
        });
    },    
    toggleProtocol: function (params) {
      var selectedProtocol = JSON.parse(params).columnValue;
      if (selectedProtocol == 'HTTP') {
        this.$('#HTTP_PORT').attr('disabled', false); //No I18N
        this.$('#HTTPS_PORT').attr('disabled', true); //No I18N
        this.$('#IS_KEYSTORE_ENCRYPTION_ENABLED').parent('div').removeClass('checked');
        this.showKeytoreConfig(false);
        this.$('#KEYSTORE_PASS').val('');
        this.$('#KEYSTORE_ENCRYPTION_DIV').hide();
      } else {
        this.$('#HTTP_PORT').attr('disabled', true); //No I18N
        this.$('#HTTPS_PORT').attr('disabled', false); //No I18N
        this.showKeytoreConfig(true);
        this.$('#KEYSTORE_ENCRYPTION_DIV').show();
      }
      this.set('connSettings.KEYSTORE_ENCRYPTION', false);
      this.set('connSettings.KEYSTORE_PASS', undefined);
      this.set('connSettings.SELECTED_PROTOCOL', selectedProtocol); //No I18N
    },
    toggleCheckBox: function (val, key) {},
    clearText: function () {
      if (this.get('connSettings.isPasswordMasked')) { //Clear text on focus if password mask is present.
        this.$('#KEYSTORE_PASS').val('');
        this.set('connSettings.isPasswordMasked', false);
      }
    },
    togglePwdTextBox: function () {
      if (!this.$('#IS_KEYSTORE_ENCRYPTION_ENABLED').is(':checked')) {
        this.$('#KEYSTORE_PASS').attr('disabled', 'disabled');
        this.$('#KEYSTORE_PASS').val('');
        this.set('connSettings.KEYSTORE_ENCRYPTION', false);
        this.set('connSettings.KEYSTORE_PASS', undefined);
      } else {
        this.$('#KEYSTORE_PASS').removeAttr('disabled');
        this.set('connSettings.KEYSTORE_ENCRYPTION', true);
      }
    },
    sessionExpiryChanged: function(text,value){
      this.set('connSettings.SESSION_EXPIRY_TIME', value);
    }
  }
});
//ignorei18n_end
