/*
 * $Id: proxy-settings.js,v 1.9.4.4 2018/12/06 05:46:54 ganesh.venkatraman Exp $
 */
import Ember from 'ember'; //NO I18N
import AJAXUtil from '../utils/ads-ajax-util'; //NO I18N
import I18NUtil from "../utils/i18n-util"; //NO I18N
import CommonUtil from "../utils/ads-common-util"; //NO I18N
import ValidationUtil from "../utils/ads-validation-util"; //NO I18N

//ignorei18n_start

export default Ember.Component.extend({
  pageStatus:{},
  proxyData:null,
  proxyEnabledCheck:false,
  showProxyInputBox: function() {
    return !(this.get('proxyEnabledCheck'));
  }.property('proxyEnabledCheck'),
  constraints:{servername:{maxlength:255},username:{maxlength:250},password:{maxlength:128}},
  getProxySettings:function(){
      var self=this;
      if(self.get('refresh')==false)
      {
        return;
      }
      var proxyDetails = AJAXUtil.syncAjax('/RestAPI/WC/ProxySettings?mTCall=getProxySettings', {});
      if(proxyDetails!= undefined && proxyDetails!=null && proxyDetails.ENABLE_PROXY===true){
        proxyDetails.PASSWORD="";
      }
      self.set('proxyData',proxyDetails);
      self.set('proxyEnabledCheck',proxyDetails.ENABLE_PROXY);
      if(proxyDetails.ENABLE_PROXY)
      {
        this.getFirstElement('SETTINGS_ENABLE_PROXY').parent('div').addClass('checked');
      }
      else
      {
        this.getFirstElement('SETTINGS_ENABLE_PROXY').parent('div').removeClass('checked');
      }
      this.getFirstElement('SETTINGS_ENABLE_PROXY').prop('checked',proxyDetails.ENABLE_PROXY);
      self.send('toggleProxySettings',proxyDetails.ENABLE_PROXY);
  }.on('didInsertElement').observes('refresh'),
  getFirstElement: function(className){
    return this.$(this.$("."+className)[0]);
  },
  willDestroyElement(){
           this.$('#FORM_STATUS').css('display','none');//No I18N
        },
  actions: {
    saveProxySettings:function(){
      var self=this;
      var params={};
      var SERVER_NAME=this.$('#SETTINGS_SERVER_NAME').val();
      var PORT=this.$('#SETTINGS_SERVER_PORT').val();
      var USER_NAME=this.$('#SETTINGS_SERVER_USERNAME').val();
      var PASSWORD=this.$('#SETTINGS_SERVER_PASSWORD').val();
      var enableProxy =  this.$('#SETTINGS_ENABLE_PROXY').is(':checked');
      if(enableProxy && ((SERVER_NAME===null || SERVER_NAME==="" ||SERVER_NAME === "no" ) ||PORT===""))
      {
        self.sendAction('showStatus','warning', I18NUtil.translate('ads.common.alert.mandatory_fields'),'proxySettings');
      }
      else if(enableProxy && !ValidationUtil.isValidPort(PORT))
      {
          self.sendAction('showStatus','warning', I18NUtil.translate('ads.admin.product_settings.connection.select_protocol.http_range'),'proxySettings');
      }
      else if(enableProxy && ((PASSWORD!==null && PASSWORD!=="") && (USER_NAME===null || USER_NAME ===""))){
          self.sendAction('showStatus','warning', I18NUtil.translate('ads.admin.server_settings.proxy_settings.invalid_username'),'proxySettings');
      }
      else if(enableProxy && ((USER_NAME!==null && USER_NAME!=="") && (PASSWORD===null || PASSWORD ===""))){
          self.sendAction('showStatus','warning', I18NUtil.translate('ads.admin.server_settings.proxy_settings.invalid_password'),'proxySettings');
      }
      else
      {
        //CommonUtil.showLoading();
        if(!enableProxy)
        {
          SERVER_NAME='';
          PORT='';
          USER_NAME='';
          PASSWORD='';
        }
        params['SERVER_NAME']=SERVER_NAME;
        params['PORT']=PORT;
        params['USER_NAME']=USER_NAME;
        params['PASSWORD']=PASSWORD;
        if (enableProxy) {
            self.sendAction('onAction', 'beforeSave');
          AJAXUtil.ajax('/RestAPI/WC/ProxySettings?mTCall=testConnection', params).then(function (testProxyDetails) {
           // CommonUtil.hideLoading();
            if (testProxyDetails.hasOwnProperty('eSTATUS')) {
                     // CommonUtil.hideLoading();
                      self.sendAction('showStatus', 'danger', testProxyDetails.eSTATUS, false);
                     self.sendAction('onAction', 'afterSave');
                  } else {
                      self.send('save', params);
                  }
                });
        } else {
          //  CommonUtil.hideLoading();
            self.send('save', params);
        }
      }
    },
    save : function(params){
      var self = this;
      this.sendAction('onAction','beforeSave');
      AJAXUtil.ajax('/RestAPI/WC/ProxySettings?mTCall=proxySettings', params).then(function(proxyDetails) {
      if(proxyDetails.hasOwnProperty('sSTATUS'))
      {
        self.sendAction('showStatus','success', proxyDetails.sSTATUS,true);
      }
      else
      {
        self.sendAction('showStatus','danger', proxyDetails.eSTATUS,false);
      }
     self.sendAction('onAction','afterSave');
    });
    },    
    testProxyConnection:function(){
      var self=this;

      var params={};
      var SERVER_NAME=this.$('#SETTINGS_SERVER_NAME').val();
      var PORT=this.$('#SETTINGS_SERVER_PORT').val();
      var USER_NAME=this.$('#SETTINGS_SERVER_USERNAME').val();
      var PASSWORD=this.$('#SETTINGS_SERVER_PASSWORD').val();
      var enableProxy =  this.$('#SETTINGS_ENABLE_PROXY').is(':checked');
      if(enableProxy&&((SERVER_NAME==null || SERVER_NAME=="" ||SERVER_NAME == "no" ) || PORT==""))
      {
        self.sendAction('showStatus','warning', I18NUtil.translate('ads.common.alert.mandatory_fields'),'proxySettings');
      }
      else if(enableProxy&& !ValidationUtil.isValidPort(PORT))
      {
        self.sendAction('showStatus','warning', I18NUtil.translate('ads.admin.product_settings.connection.select_protocol.http_range'),'proxySettings');
      }
      else if(enableProxy)
      {
      //  CommonUtil.showLoading();
      self.sendAction('onAction', 'beforeSave');
        params['SERVER_NAME']=SERVER_NAME;
        params['PORT']=PORT;
        params['USER_NAME']=USER_NAME;
        params['PASSWORD']=PASSWORD;
        AJAXUtil.ajax('/RestAPI/WC/ProxySettings?mTCall=testConnection', params)
            .then(function(response) {
              //CommonUtil.hideLoading();
              self.sendAction('onAction','afterSave');
              if(response.sSTATUS!=null)
              {
                self.sendAction('showStatus','success', response.sSTATUS,'proxySettings');
              }
              else
              {
                self.sendAction('showStatus','danger', response.eSTATUS,'proxySettings');
              }
        });
      }
    },
    toggleProxySettings:function(val){
      if(val)
      {
        this.getFirstElement('settings_test').removeClass('disabled');
        this.set('proxyEnabledCheck',true);
      }
      else
      {
        this.getFirstElement('settings_test').addClass('disabled');
        this.set('proxyEnabledCheck',false);
      }
    },

  },
});

//ignorei18n_end
