/*
 $Id: radio-button.js,v 1.5.4.2 2018/12/03 17:58:41 ganesh.venkatraman Exp $
*/
/*
	Sample Usage :
	{{radio-button className='severity' actionName='severityChanged' params='{"columnValue":"1"}' selectedItem=selectedSeverity}}

	className : for grouping
	actionName : action to be called
	selectedItem :
	params :
*/
import Ember from 'ember';//NO I18N

export default Ember.Component.extend({

	tagName : 'input', //NO I18N
	attributeBindings : ['type','disabled','className'], //NO I18N
	classNameBindings : ['className'],
	type : 'radio', //NO I18N
	params : {},
	didInsertElement : function(){
		var thisComp = this;
		var thisEle = this.get('element'); //NO I18N
		Ember.$(thisEle).iCheck({
			radioClass: 'iradio iradio_minimal ', //NO I18N
			increaseArea: '20%'
		});
		Ember.$(thisEle).on('ifChecked',function(){
			Ember.run.next(this,function(){
				Ember.$('.'+thisComp.get('className')).prop("checked", false).iCheck('update'); //NO I18N
				Ember.$(thisEle).prop("checked", true).iCheck('update');
			});
			thisComp.sendAction('actionName',thisComp.get('params'),thisComp.get('parent')); //NO I18N
			//event.stopPropagation();
		});
		if(this.get('selectedItem') && this.get('selectedItem') == JSON.parse(this.get('params')).columnValue){
			Ember.$('.'+thisComp.get('className')).prop("checked", false).iCheck('update'); //NO I18N
			Ember.$(thisEle).prop("checked", true).iCheck('update');
		}
		if(this.get('selectedList') && this.get('selectedList').contains(thisComp.get('params.columnValue'))){
			Ember.$('.'+thisComp.get('className')).prop("checked", false).iCheck('update'); //NO I18N
			Ember.$(thisEle).prop("checked", true).iCheck('update');
		}
	},
	willDestroyElement: function(){
		Ember.$(this.get('element')).iCheck('destroy');//No i18n
		Ember.$(this.get('element')).off('ifChecked');//No i18n
	},	
	selectedItemChanged : function(){
		var thisEle = this.get('element'); //NO I18N
		if(this.get('selectedItem') && this.get('selectedItem') == JSON.parse(this.get('params')).columnValue){
			Ember.$('.'+this.get('className')).prop("checked", false).iCheck('update'); //NO I18N
			Ember.$(thisEle).prop("checked", true).iCheck('update');
		}
		else
		{
			Ember.$('.'+this.get('className')).prop("checked", true).iCheck('update'); //NO I18N
			Ember.$(thisEle).prop("checked", false).iCheck('update');
		}
	}.observes('selectedItem'), //NO I18N
	disabledChanged : function(){
		if(this.get('disabled')){
			Ember.$(this.get('element')).iCheck('disable'); //NO I18N
		}else{
			Ember.$(this.get('element')).iCheck('enable'); //NO I18N
		}
	}.observes('disabled') //NO I18N
});