/*
 * $Id: add-reports.js,v 1.6 2018/12/13 15:32:26 gomathi.sri Exp $
 */

//ignorei18n_start
import Ember from 'ember';
import AJAXUtil from 'webclient/utils/ajax-util'; //NO I18N
import I18NUtil from "webclient/utils/i18n-util"; //NO I18N
import CommonUtil from "webclient/utils/common-util"; // NO I18N
import StatusUtil from "webclient/utils/status-util"; // NO I18N
export default Ember.Component.extend({
showReportsList:null,
errorData:'',
reportsList:[],
productsList:'',
currentCategoryId:'',
categoriesList:'',
fullcategoriesList:'',
selectedReports:[],
selectedProducts:[],
noSelectedReports:true,
dropDown:true,
searchResultArray:'',
productReports:{},
isFirst:true,
selectComponentText:I18NUtil.translate('ads.reports.select_category'),
selectCategoryText:I18NUtil.translate('ads.reports.select_category_text'),
createNewCategory:I18NUtil.translate('ads.reports.create_new_category_text'),
getProductsList:function()
{
		this.set('reportsList',[]);
		this.set('selectedReports',[]);
		this.set('noSelectedReports',true);
		this.set('productReports',{});
		
}.on('init'),
didInsertElement:function(){
	
	var self=this;

	 AJAXUtil.ajax('/RestAPI/WC/Reports?mTCall=getProductsList',{})
	.then(function(list)
	{ 

	var productsList=[];
	for (var i=0;i<list.length;i++)
	{
		var details=list[i];
		productsList.push({CLIENT_VALUE :details.DISPLAY_NAME,SERVER_VALUE : details.PRODUCT_ID});  
	}
		Ember.run.later((function()
		{ 
		self.set('defaultProduct',productsList[0].SERVER_VALUE);
		self.set('productsList',productsList);
		self.send('getReportsList');
		}),250);
		$(".modal-footer").addClass('relative');
		$("#FREEZE_AREA").addClass('freeze white');
	});
},

highLightSearchText:function(reportName,substrRegex)
{
	return reportName.replace(substrRegex,function(str){ return '<span>'+str+'</span>'});
},
actions:
{
	closeAddReportsPopup:function(data)
	{
		var self=this;
		this.set('selectedReports',[]);
		this.set('noSelectedReports',true);
		this.set('productReports',{});
		if(self.reportsList.length>0)
		{
			self.reportsList.forEach(function(reports)
			{
				reports.LIST.forEach(function(reportDetails)
				{
					Ember.set(reportDetails,'IS_SELECTED',false);
				});
				Ember.set(reports,'CHECK_ALL',false);
			});
		}
		CommonUtil.afterRender();
		Ember.run.scheduleOnce('afterRender', function() //NO I18N
		{
		self.get('closeAddReportsPopup')(data);
		});
	},
	getReportsList:function()
	{
		var self=this;
		if(!this.get('isFirst'))
		{
		this.set('isReports',true);
		}
		else{
			this.set('isFirst',false);
		}
		this.send('clearSearch');
		var list={};
		var productId=this.get('defaultProduct');
		var params={};
		params.PRODUCT_ID=productId;
		params.TAB_ID=this.getAttr('tabId');
		var productReports=this.get('productReports');
		if(productReports[productId]==undefined )
		{
			AJAXUtil.ajax('/RestAPI/WC/Reports?mTCall=getReportsForCustomization',params).then(function(responseData){	
			self.send('setData',responseData,productReports,productId);
			});
		}
		else{
			var reportsList=productReports[productId];
			for(var i=0;i<reportsList.length;i++)
			{
				var report =reportsList[i].LIST.filterBy('IS_SELECTED',true);
				if(report.length==0)
				{
					Ember.set(reportsList[i],'CHECK_ALL',false);
				}
				else if(report.length==reportsList[i].LIST.length)
				{
					Ember.set(reportsList[i],'CHECK_ALL',true);
				}
				else
				{
					Ember.set(reportsList[i],'CHECK_ALL','indeterminate');
				}
			}
			list.LIST=reportsList;
			this.send('setData',list,productReports,productId);
		}
		
	},
	setData:function(list,productReports,productId)
	{	
		$(".modal-footer").removeClass('relative');
		$("#FREEZE_AREA").removeClass('freeze white');
		var self=this;
		if(!self.get('isFirst'))
		{
		Ember.run.later((function() //NO I18N
		{
		if(list.ERROR_DATA != undefined)
		{
			self.set('errorData', I18NUtil.translate(list.ERROR_DATA.STATUS_MESSAGE + '_description'));
			$("#ADD_BUTTON").addClass('disabled');
			self.set('showReportsList',null);
		}
		else if(list.LIST != undefined)
		{
			self.set('showReportsList',true);
			self.set('reportsList', Ember.$.extend(true, [], list.LIST));
			self.send('getselectedReportsList',Ember.$.extend(true, [],self.get('reportsList')));
			self.send('getCategoriesList');
			productReports[productId]=list.LIST;
		}
		self.set('productReports',productReports);
		self.set('showProducts',productReports);
		CommonUtil.afterRender();
		
		self.set('isReports',false);
		}),100);
		}
		var self=this;
		Ember.run.later((function()
		{
		  CommonUtil.hideLoading();
		}),100);
	},
	getCategoriesList:function()
	{
		var self=this;
		var categoriesList=[];
		var fullcategoriesList=[];
		var params={};
		params.TAB_ID=this.getAttr('tabId');
		var list=[];
		list=AJAXUtil.syncAjax('/RestAPI/WC/Reports?mTCall=getCategoriesList', params);
		categoriesList.push(I18NUtil.translate('ads.reports.general_reports'),I18NUtil.translate('ads.reports.system_reports'),I18NUtil.translate('ads.reports.security_reports'));
		for (var i=0;i<list.length;i++)
		{
			var details=list[i];
			if(categoriesList.indexOf(details.NAME)==-1)
			{
				categoriesList.push(details.NAME);
			}
			fullcategoriesList.push({CLIENT_VALUE :details.NAME,SERVER_VALUE : details.CATEGORY_ID,COMPARE_VALUE:details.NAME.toLowerCase() });  
		}
		categoriesList.sort(function(a,b) {
			a = a.toLowerCase();
			b = b.toLowerCase();
			if( a == b) return 0;
				return a < b ? -1 : 1;
		});
		
		self.set('categoriesList',categoriesList);
		self.set('fullcategoriesList',fullcategoriesList);
		self.get('scrollBar')();
	},
	addCategory:function(val)
	{
		var self=this;
		if(val == null || val == '')
		{
	    self.send('showAlert', I18NUtil.translate('ads.reports.empty_category_name'));
		  return false;
		}
		else if(val.length > 50)
    {
      self.send('showAlert', I18NUtil.translate('ads.reports.category_name.limit_message'));
      return false;
    }

		var fullcategoriesList=self.get('fullcategoriesList');
		if(!this.get('noSelectedReports'))
		{
			$("#ADD_BUTTON").removeClass('disabled');
		}
		var categoryDetails= self.fullcategoriesList.filterBy('COMPARE_VALUE', val.toLowerCase());
		if(categoryDetails.length>0)
		{
			self.set('currentCategoryId',categoryDetails[0].SERVER_VALUE);
			self.set('currentCategoryName',categoryDetails[0].CLIENT_VALUE);
			return;
		}
		else
		{
			var params={};
			params.CATEGORY_NAME=val;
			params.TAB_ID=self.getAttr('tabId');
			AJAXUtil.ajax('/RestAPI/WC/Reports?mTCall=addCategory',params, false,'text')
			.then(function(response)
			{
				self.set('currentCategoryId',response);
				self.set('currentCategoryName',val);
				fullcategoriesList.push({CLIENT_VALUE :val, SERVER_VALUE :response , COMPARE_VALUE:val.toLowerCase()});
			});
			self.set('fullcategoriesList',fullcategoriesList);
		}
	},
	toggleCategory:function(val,reports){
		Ember.set(reports,'CHECK_ALL',val);
		
		var params=reports.LIST;
	
		for (var i = 0; i < params.length; i++) 
		{
			Ember.set(params[i],'IS_SELECTED',val);
		}
		var selectedReports=this.get('selectedReports');
		selectedReports.forEach(function(data){
			Ember.set(data,'CurrentRhsMenu',false);
				});
		this.send('getselectedReportsList', Ember.$.extend(true, [],this.get('reportsList')));
	},
	toggleCheckBox: function(val,params)
	{

		Ember.set(params,'IS_SELECTED',val);

		var selectedReports=this.get('selectedReports');
		
			var reportsList=this.get('reportsList');
			for(var i=0;i<reportsList.length;i++)
			{
			var reportDetails=reportsList[i].LIST.filterBy('REPORT_ID',params.REPORT_ID);
			if(params.hasOwnProperty('MENU_ID'))
			{
				reportDetails=reportsList[i].LIST.filterBy('MENU_ID',params.MENU_ID);
			}
			if(reportDetails.length>0)
			{
				var reports=reportsList[i].LIST.filterBy('IS_SELECTED',val);
				if(reportsList[i].LIST.length==reports.length)
				{
					Ember.set(reportsList[i],'CHECK_ALL',val);
				}
				else{
				Ember.set(reportsList[i],'CHECK_ALL','indeterminate');
				}
				selectedReports.forEach(function(data){
				 if(data.NAME==reportsList[i].NAME)
				{
						Ember.set(data,'CurrentRhsMenu',true);
				}
				else{
					Ember.set(data,'CurrentRhsMenu',false);
				}});  
				break;
			}
			
			}				
		this.send('getselectedReportsList', Ember.$.extend(true, [],this.get('reportsList')));
	},
	deleteSelectedReport:function(params)
	{
		var reportsList=this.get('productReports')[params.PRODUCT_ID];
		var currentReportsList=this.get('reportsList');
		var selectedReports=this.get('selectedReports');
		var count=0;

		for(var i=0;i<reportsList.length;i++)
		{
			var reportDetails=reportsList[i].LIST.filterBy('REPORT_ID',params.REPORT_ID);
			var leftReports=currentReportsList[i].LIST.filterBy('REPORT_ID',params.REPORT_ID);
			if(params.hasOwnProperty('MENU_ID'))
			{
				reportDetails=reportDetails.filterBy('MENU_ID',params.MENU_ID);
				leftReports=leftReports.filterBy('MENU_ID',params.MENU_ID);
			}
			if(reportDetails.length>0)
			{
				var reportArray=reportsList[i].LIST.filterBy('IS_SELECTED',true);
				count=i;
				Ember.set(reportsList[i],'CHECK_ALL','indeterminate');
				selectedReports.forEach(function(data,index){
				if(data.NAME==reportsList[i].NAME)
				{
					Ember.set(data,'CurrentRhsMenu',true);
				}
				else{
					Ember.set(data,'CurrentRhsMenu',false);
				}});
				break;
			}			
		}
		selectedReports.forEach(function(data,index){
			var index2=0;
			data.LIST.some(function(obj, i) {
				if ((obj.REPORT_ID == params.REPORT_ID)&& obj.PRODUCT_ID == params.PRODUCT_ID) {
						index2 = i;
						return true;
					}
			});
			if(index2>0 )
			{
				data.LIST.splice(index2,1);
				if(!data.LIST.length>0)
				{
					selectedReports.splice(index,1)
				}
			}
		});
		var flag=0;
		this.set('selectedReports',selectedReports);
		if(reportDetails.length>0){
		Ember.set(reportDetails[0],'CurrentRhsMenu',true);
		Ember.set(reportDetails[0],'IS_SELECTED',false);
		}
		if(leftReports.length>0){
			Ember.set(leftReports[0],'CurrentRhsMenu',true);
			Ember.set(leftReports[0],'IS_SELECTED',false);
			flag=1;
		}

		if(reportArray.length==1)
		{
			Ember.set(reportsList[count],'CHECK_ALL',false);
		}
		if(flag==1 && reportArray.length==1)
		{
			Ember.set(currentReportsList[count],'CHECK_ALL',false);
		}
	
		this.send('getselectedReportsList', Ember.$.extend(true, [],reportsList));
	},
	getselectedReportsList:function(reportsList)
	{
		var self=this;
		$("#ADD_BUTTON").removeClass('disabled');
		var isEmpty=true;
		var selectedReports=this.get('selectedReports');
		var count=selectedReports.length;
		var changesMade=false;
		for(var i=0;i<reportsList.length;i++)
		{
			var flag=1;
			reportsList[i].LIST=reportsList[i].LIST.filterBy('IS_SELECTED',true);
			if(reportsList[i].LIST.length>0)
			{				
				for(var j=0; j<selectedReports.length;j++)
				{
					if(selectedReports[j].NAME==reportsList[i].NAME)
					{
						Ember.set(selectedReports[j],'LIST',reportsList[i].LIST);
						flag=0;
					} 
					
				}
				
				if(flag!=0)
				{
					changesMade=true;
					selectedReports[count]=reportsList[i];
					count++;
				}
				
				isEmpty=false;
			}
			else{
					selectedReports.forEach(function(data,index){
					if(data.NAME==reportsList[i].NAME)
					{
						changesMade=true;
						selectedReports.splice(index,1);
					}});
			}
		}
			
		if(isEmpty || this.get('currentCategoryId')=='')
		{
			$("#ADD_BUTTON").addClass('disabled');
		}
		var reinitialize=[];
		self.set("selectedReports",reinitialize);
		if(selectedReports.length!=0)
		{
			isEmpty=false;
		}
		
		this.set("noSelectedReports",isEmpty);
		CommonUtil.afterRender();
		Ember.run.scheduleOnce('afterRender', function() //NO I18N
		{
			
			self.set("selectedReports",selectedReports);
		});
		if(changesMade)
		{
		var productId=$('#COMPONENTS').val();
		var productReports=this.get('productReports');
		
		productReports[productId]=this.get('reportsList');
		this.set('productReports',productReports);
		}
	},
	
	addReports:function()
	{
		if($("#ADD_BUTTON").hasClass('disabled'))
		{
			return;
		}
		var self=this;
		var requestData = {};
		requestData.reportDetails = JSON.stringify(this.get('selectedReports'));
		requestData.CATEGORY_ID=this.get('currentCategoryId');
		requestData.CATEGORY_NAME=this.get('currentCategoryName');
		requestData.TAB_ID=this.getAttr('tabId');
		 AJAXUtil.ajax('/RestAPI/WC/Reports?mTCall=addReportsToCustomView', requestData, false, 'text')
		.then(function(responseData) 
		{
			try{
				var response=Ember.$.parseJSON(responseData);
			}
			catch(e)
			{
				AJAXUtil.handleSessionTimeout("403", responseData);	
			}
			self.send('closeAddReportsPopup',JSON.parse(responseData)); 	
		});
				
	},
	cancel:function()
	{
		var self=this;
		var reportsList=self.get('reportsList');
		if(reportsList.length>0)
		{
			reportsList.forEach(function(reports)
			{
				reports.LIST.forEach(function(reportDetails)
				{
					Ember.set(reportDetails,'IS_SELECTED',false);
				});
				Ember.set(reports,'CHECK_ALL',false);
			});
		}
		$('.panel-group').find('.panel-collapse').removeClass("in");
		$('.panel-group').find('.panel-collapse').addClass("collapse");
		$('.panel-group').find("a").addClass("collapsed");
		this.send('clearSearch');
		var selected=[];
		self.set('selectedReports',selected);
		self.set('noSelectedReports',true);
		var empty={};
		this.set('productReports',empty);
	},
	openSearch:function()
	{
		var self=this;
		$(".dcl-search input").val("");
		$(".dcl-header i").toggleClass('hide');
		$(".dcl-header i").prev().toggleClass('hide');
		var searchResult=[];
		$(".dcl-search input").on("keyup", function(e)
		{
				searchResult=[];
				var searchTextUI=$(".dcl-search input").val();
				if(Ember.$.trim(searchTextUI) =='')
				{
					$(".noSearchResult").addClass('hide');
		            $(".dcl-search-result").addClass('hide');
					$("#dcl-lhs-acd").removeClass('hide');
					return;
				}
				var searchText=searchTextUI.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&");
				var substrRegex = new RegExp(searchText, 'gi');
				var reportsList=self.get('reportsList');
				var count=0;
				for(var i=0;i<reportsList.length;i++)
				{
					var firstLevelReports=reportsList[i].LIST;
					var tempArray=[];
					for(var j=0;j<firstLevelReports.length;j++)
					{
						if(substrRegex.test(firstLevelReports[j].NAME))
						{
							var highLightedName=self.highLightSearchText(firstLevelReports[j].NAME,substrRegex);
						    Ember.set(firstLevelReports[j],'SEARCH_NAME',highLightedName);
							tempArray[tempArray.length]=firstLevelReports[j];
							count++;
						}
					}
					if(tempArray.length>0)
					{
						Ember.set(reportsList[i],'SEARCH_LIST',tempArray);
						searchResult[searchResult.length]=reportsList[i];
					}
				}
				if(count==0)
				{
					$(".noSearchResult").removeClass('hide');
					$(".dcl-search-result").addClass('hide');
					$("#dcl-lhs-acd").addClass('hide');
				}
				else
				{
					self.set("searchResultArray",searchResult);
					$(".noSearchResult").addClass('hide');
					$(".dcl-search-result").removeClass('hide');
					$("#dcl-lhs-acd").addClass('hide');
				}
		});
	},
	clearSearch:function()
	{
		$(".noSearchResult").addClass('hide');
		$(".dcl-search-result").addClass('hide');
		$("#dcl-lhs-acd").removeClass('hide');
		$(".dcl-header i").removeClass('hide');
		$(".dcl-header i").prev().addClass('hide');
	},

	showAlert: function(message, alertType)
	{
    alertType = alertType != null ? alertType : 'danger';
    if(message != null)
    {
      this.set('configStatusAlertType', alertType);
      this.set('configStatusMessage', message);
      this.$('.mini-status-alert').delay(500).slideDown('slow');
    }
  },

  closeAlert: function() {
   this.$('.mini-status-alert').delay(50).slideUp('slow');
  }

}
});
//ignorei18n_end
