/*
 * $Id$
 */

//ignorei18n_start
import Ember from 'ember';
import AJAXUtil from 'webclient/utils/ajax-util'; //NO I18N
import I18NUtil from "webclient/utils/i18n-util"; //NO I18N
import CommonUtil from "webclient/utils/common-util"; // NO I18N
import DialogUtil from "webclient/utils/dialog-util"; //NO I18N
export default Ember.Component.extend({
	router: Ember.inject.service('-routing'),
	rightTreeReports: '',
	showSaveButton: true,
	pageStatus: {},
	showAddView:false,
	showAddReportsMsg:null,
	customViewData:null,
	showAddReports:null,
	currentTabDetails:null,
	enableFreeze:null,
	showButtons:false,
	configure: function() 
		{
			CommonUtil.showLoading();
			this.set('rightTreeReports','');
			this.set('showAddReportsMsg',null);
			this.set('errorData', null);
			this.set('customViewData',null);
			var reportsList = AJAXUtil.syncAjax('/RestAPI/WC/Reports?mTCall=getReportDetailsForModification');
			this.set('reportDetails', reportsList);
			this.send('setTabData', reportsList);
			this.send('showButtons');	
		}.on('init'),
	 	didInsertElement:function(){
		CommonUtil.hideLoading();
			var self=this;
			var reportsList=this.get('reportDetails');
			 Ember.run.scheduleOnce('afterRender', function() //NO I18N
			{ 
			$("[REPORT_TAB_ID='" + reportsList[0].TAB_ID + "']").addClass('active');
				$(".report-tab-header > ul ").sortable(
				{ 
					items: "li:not(.sortable-disabled)", 
					placeholder: "ui-state-highlight", 
					axis: "x"
				});
				$(".report-list-menu").sortable({items: "li:not(.sortable-disabled)", placeholder: "ui-state-highlight", axis: "y" });
				self.send('changeTab',self.get('currentTabDetails'));		
				
			});
		}, 
	setCurrentTab(reportsList) 
	{
		var tabDetails = reportsList;
		var reports = tabDetails.LIST;
		for (var i = 0; i < reports.length; i++) {
			var firstLevelCount=0;
			var firstLevelIndeterminate=false;
			var firstLevelReports = reports[i];
			if (firstLevelReports != null && firstLevelReports.LIST != undefined && firstLevelReports.LIST.length > 0) {
				firstLevelReports['menuType'] = 'category';
				var secondLevelReports = firstLevelReports.LIST;
				
				for (var j = 0; j < secondLevelReports.length; j++) {
					var secondLevelCount=0;
					var secondLevelIndeterminate=false;
					var secondLevelReportsList = secondLevelReports[j];
					if (secondLevelReportsList != null && secondLevelReportsList.LIST != undefined && secondLevelReportsList.LIST.length > 0) {
						secondLevelReportsList['menuType'] = 'category';
						firstLevelReports['leftTree'] = true;
						var thirdLevelReports = secondLevelReportsList.LIST;
						for (var k = 0; k < thirdLevelReports.length; k++) {
							var thirdLevelCount=0;
							var thirdLevelReportsList = thirdLevelReports[k];
							if (thirdLevelReportsList != null && thirdLevelReportsList.LIST != undefined && thirdLevelReportsList.LIST.length > 0) {
								thirdLevelReportsList['menuType'] = 'category';
								var fourthLevelReports = thirdLevelReportsList.LIST;
								for (var l = 0; l < fourthLevelReports.length; l++) {
									var fourthLevelReportsList = fourthLevelReports[l];
									var fourthLevelData = {};
									var fourthLevelparentNames = [];
									fourthLevelparentNames[3] = tabDetails;
									fourthLevelparentNames[2] = firstLevelReports;
									fourthLevelparentNames[1] = secondLevelReportsList;
									fourthLevelparentNames[0] = thirdLevelReportsList;
									fourthLevelData['parentName'] = fourthLevelparentNames;
									fourthLevelData['childReports'] = fourthLevelReportsList;
									fourthLevelReportsList['params'] = fourthLevelData;
									fourthLevelReports[l] = fourthLevelReportsList;
									if(fourthLevelReportsList.IS_SELECTED == undefined)
									{
										fourthLevelReportsList.IS_SELECTED= false;
									}
									if(fourthLevelReportsList.IS_SELECTED)
									{
										thirdLevelCount++;
									}
								}
								thirdLevelReportsList['LIST'] = fourthLevelReports;
								if(fourthLevelReports.length != thirdLevelCount && thirdLevelCount != 0)
								{
									thirdLevelReportsList.IS_SELECTED="indeterminate";
								}
							} else {
								thirdLevelReportsList['menuType'] = 'report';
								firstLevelReports['leftTree'] = false;
							}
							if(thirdLevelReportsList.IS_SELECTED==undefined)
							{
								thirdLevelReportsList.IS_SELECTED=false;
							}
							var thirdLevelData = {};
							var thirdLevelparentNames = [];
							thirdLevelparentNames[2] = tabDetails;
							thirdLevelparentNames[1] = firstLevelReports;
							thirdLevelparentNames[0] = secondLevelReportsList;
							thirdLevelData['parentName'] = thirdLevelparentNames;
							thirdLevelData['childReports'] = thirdLevelReportsList;
							thirdLevelReportsList['params'] = thirdLevelData;
							thirdLevelReports[k] = thirdLevelReportsList;
							if(thirdLevelReportsList.IS_SELECTED==true)
							{
								secondLevelCount++;
							}
							else if(thirdLevelReportsList.IS_SELECTED=="indeterminate")
							{
								secondLevelIndeterminate=true;
							}
						}
						
						secondLevelReportsList['LIST'] = thirdLevelReports;
						if(thirdLevelReports.length != secondLevelCount && secondLevelCount != 0)
						{
							secondLevelReportsList.IS_SELECTED="indeterminate";
						}
						else if(secondLevelIndeterminate)
						{
							secondLevelReportsList.IS_SELECTED="indeterminate";
						}
						else if(secondLevelReportsList.IS_SELECTED== undefined)
						{
							secondLevelReportsList.IS_SELECTED=false;
						}
						if (i == 0 && j == 0 && firstLevelReports.leftTree) {
							this.set('rightTreeReports', thirdLevelReports);
						}
					} else {
						firstLevelReports['leftTree'] = false;
						secondLevelReportsList['menuType'] = 'report';
					}
					var secondLevelData = {};
					var secondLevelparentNames = [];
					secondLevelparentNames[1] = tabDetails;
					secondLevelparentNames[0] = firstLevelReports;
					secondLevelData['parentName'] = secondLevelparentNames;
					secondLevelData['childReports'] = secondLevelReportsList;
					if (firstLevelReports.leftTree) {
						secondLevelData.showReports= tabDetails.IS_CUSTOM_TAB?false:true;
					}
					if (i == 0 && j == 0 && firstLevelReports.leftTree) {
						secondLevelReportsList['default_select'] = true;
					}
					secondLevelReportsList['params'] = secondLevelData;
					secondLevelReports[j] = secondLevelReportsList;
					if(secondLevelReportsList.IS_SELECTED==true)
					{
						firstLevelCount++;
					}
					else if(secondLevelReportsList.IS_SELECTED=="indeterminate")
					{
						firstLevelIndeterminate=true;
					}
				}
				if (i == 0 && !firstLevelReports.leftTree) {
					this.set('rightTreeReports', secondLevelReports);
				}
				
				firstLevelReports['LIST'] = secondLevelReports;
				if(secondLevelReports.length != firstLevelCount && firstLevelCount != 0)
				{
					firstLevelReports.IS_SELECTED="indeterminate";
				}
				else if(firstLevelIndeterminate)
				{
					firstLevelReports.IS_SELECTED="indeterminate";
				}
			} else {
				firstLevelReports['menuType'] = 'report';
			}
			if(firstLevelReports.IS_SELECTED==undefined)
			{
					firstLevelReports.IS_SELECTED= false;
			}
			var firstLevelData = {};
			var firstLevelparentNames = [];
			firstLevelparentNames[0] = tabDetails;
			firstLevelData['parentName'] = firstLevelparentNames;
			firstLevelData['childReports'] = firstLevelReports;
			if (!firstLevelReports.leftTree) {
				firstLevelData.showReports=tabDetails.IS_CUSTOM_TAB?false:true;
			}
			if (i == 0 && !firstLevelReports.leftTree) {
				firstLevelReports['default_select'] = true;
			}
			firstLevelReports['params'] = firstLevelData;
			reports[i] = firstLevelReports;
		}
		var tabData = {};
		tabData['parentName'] = null;
		tabData['childReports'] = tabDetails;
		tabData[''] = tabDetails;
		tabDetails['params'] = tabData;
		tabDetails['LIST'] = reports;
		tabDetails['rightTreeReportsList'] = this.get('rightTreeReports');
		return tabDetails;
	},
	saveUpdatedName:function(tabDetails,updatedName)
	{
			var self=this;
			var flag=1;
			var params={};
			params.TAB_NAME=updatedName;
			params.TAB_ID=tabDetails.TAB_ID;
			var requestData = {};
			requestData.customViewDetails = JSON.stringify(params);
			var responseData=AJAXUtil.syncAjax('/RestAPI/WC/Reports?mTCall=updateCustomView',requestData, false, 'text');
				if(responseData==-1)
				{
					DialogUtil.alert(self,I18NUtil.translate('ads.reports.view_name.exist_msg'));
					return -1;
				}	
				else{
					Ember.set(tabDetails,'NAME',updatedName);
				}				
	},

	actions:
	{	
		
		setTabData: function(reportsList) 
		{
			var count = 0;
			this.set('dataHeight', $(window).height() / 1.6);
			this.set('showSaveButton', true);
			for (var v = 0; v < reportsList.length; v++)
			{
				var tabDetails = [];
				if (reportsList[v].LIST !== undefined) 
				{
					tabDetails = this.setCurrentTab(reportsList[v]);
				} 
				else 
				{
					count++;
					tabDetails = reportsList[v];
					tabDetails.IS_DISABLED=true;
				}
				if (v == 0) 
				{
					tabDetails['showTab'] = true;
					if (tabDetails.LIST !== undefined) 
					{
						this.set('reportList', tabDetails.LIST);
						this.send('subReports', tabDetails.rightTreeReportsList);
						this.set('enableFreeze',tabDetails.IS_SELECTED);
						this.send('scrollBar');
					} 
					else if (tabDetails.ERROR_DATA !== undefined) 
					{
						this.send('setErrorMessage', tabDetails.ERROR_DATA);
					}
				}
				reportsList[v] = tabDetails;
				reportsList[v].INDEX=v;
			}
			if (reportsList.length === count) {
				this.set('showSaveButton', false);
			}
			this.set('tabDetails', reportsList);
			this.set('currentTabDetails',reportsList[0]);
		},

		save: function()
		{
			var self = this;
			var reportDetails=self.get('tabDetails');
			var updatedReportDetails=[];
			var showErrorMessage=false;
			var count=0;
			for(var i=0;i<reportDetails.length;i++)
			{
				updatedReportDetails.push(reportDetails[i]);
				if(updatedReportDetails[i].IS_SELECTED && updatedReportDetails[i].LIST != undefined)
				{
					showErrorMessage=true;
					for(var j=0;j<updatedReportDetails[i].LIST.length;j++)
					{
						if(updatedReportDetails[i].LIST[j].IS_SELECTED)
						{
							count++;
							break;
						}
					}
					
				}
			}
			if(!showErrorMessage)
			{
				DialogUtil.alert(self,I18NUtil.translate('ads.reports.addreports.save_view_alert'));//No I18N
			}
			else if(count ===0)
			{
				DialogUtil.alert(self,I18NUtil.translate('ads.reports.addreports.save_alert'));//No I18N
			}
			else
			{
				self.send('setTabsOrder',"TABS_AREA");
				var requestData = {};
				requestData.reportDetails= JSON.stringify(updatedReportDetails, function(key, value) {
					if (key == 'params') 
					{
						return null;
					} 
					else
					{
						return value;
					}
				});
					CommonUtil.showLoading();
 AJAXUtil.ajax('/RestAPI/WC/Reports?mTCall=saveReportsDetails', requestData,false,'text')
        .then(function(response) {
				CommonUtil.hideLoading();
						if (response == 'true') {
							self.sendAction('showStatus', 'success', I18NUtil.translate('ads.reports.save.message.success'), false);
							self.configure();
							self.didInsertElement();
							self.rerender(); 
						} else {
							self.sendAction('showStatus', 'danger', I18NUtil.translate('ads.reports.save.message.failure'), false);
						}
						});
				self.set('isChanged', false);
			}
		},
		subReports: function(list) 
		{
			$("[href=#leftMenu] .icheckbox_minimal").on("ifChecked ifUnchecked", function() 
			{
				$(this).closest("ul").find("li.active").removeClass("active");
				$(this).closest("li").addClass("active");

			});
			window.scrollTo(0, 0);
			if (list[0].LIST !== undefined && list[0].LIST.length > 0) 
			{
				this.set('rightTreeSecondLevel', true);
			}
			else 
			{
				this.set('rightTreeSecondLevel', false);
			}
			this.set('rightTreeReportsList', list);
			this.send('scrollBar', true);
		},
		toggleCheckBox: function(val, params) 
		{
			this.set('isChanged', true);
			Ember.set(params.childReports, 'IS_SELECTED', val);
			if (params.childReports.LIST !== undefined) 
			{
				this.send('checkAll', val, params.childReports.LIST);
			}
			if (params.parentName != null) 
			{
				
				var paramsList = params.parentName;
				for (var i = 0; i < paramsList.length; i++) 
				{
						var childReports = paramsList[i].LIST;
						var count = 0;
						for (var k = 0; k < childReports.length; k++) 
						{
							if (Ember.get(childReports[k], 'IS_SELECTED')== val) 
							{
								count++;
							}
						}
						if (childReports.length === count) 
						{
							if(!paramsList[i].hasOwnProperty('INDEX'))
							{
								Ember.set(paramsList[i], 'IS_SELECTED', val);
							}
						}
						else
						{
							if(!paramsList[i].hasOwnProperty('INDEX'))
							{
								Ember.set(paramsList[i], 'IS_SELECTED',"indeterminate");
							}
						}
				}
			}
			if (params.showReports !== undefined && params.showReports && params.childReports.LIST !== undefined) 
			{
				this.send('subReports', params.childReports.LIST);
			}
		},
		checkAll: function(val, params) 
		{
			for (var i = 0; i < params.length; i++) 
			{
				Ember.set(params[i], 'IS_SELECTED', val);
				if (params[i] != null && params[i].LIST != undefined && params[i].LIST.length > 0) 
				{
					this.send('checkAll', val, params[i].LIST);
				}

			}
		},
		toggleTabCheckBox: function(val, tabDetails) 
		{
			this.set('isChanged', true);
			this.send('changeTab', tabDetails);
			Ember.set(tabDetails,'IS_SELECTED',val);
			this.set('enableFreeze',val);
			if (this.get('errorData') === null && tabDetails.ERROR_DATA != undefined) 
			{
				this.send('setErrorMessage', tabDetails.ERROR_DATA);
			}
		},
		changeTab: function(tabDetails,newReport) 
		{
			this.set('enableFreeze',tabDetails.IS_SELECTED);
			this.set('currentTabId',tabDetails.TAB_ID);
			this.set('currentTabDetails',tabDetails);
			var toolPosition = Ember.$('.tab-tool-set').position();
			var latestToolPosition=(toolPosition.left+Ember.$('.tab-tool-set').width())-75;
			var productPosition = Ember.$('[REPORT_TAB_ID='+tabDetails.TAB_ID+']').position();
			if(productPosition==null)
			{
				return;
			}
			var productWidth = Ember.$('[REPORT_TAB_ID='+tabDetails.TAB_ID+']').width();
			var tabPosition = parseInt(Ember.$('.slider-tab').css('margin-left'));
			var calc;
			if(productPosition.left<0)
			{
				calc= tabPosition - productPosition.left;
				Ember.$('.slider-tab').animate({'margin-left':calc});
			}
			else
			{
				calc = productWidth - ((latestToolPosition) - productPosition.left);
				if(calc>0)
				{
					calc+=Math.abs(tabPosition);
					Ember.$('.slider-tab').animate({'margin-left':calc*-1});
				}
			}
			if($("[REPORT_TAB_ID='" + tabDetails.TAB_ID + "']").hasClass('active') && !newReport)
			{
				return;
			}
			else
			{
				this.set('errorData', null);
				this.set('showAddReportsMsg',null);
				this.set('customViewData',null);
				$("[REPORT_TAB_ID]").removeClass('active');
				$("[REPORT_TAB_ID='" + tabDetails.TAB_ID + "']").addClass('active');
			}
			if (tabDetails.LIST !== undefined ) 
			{
				
				if(tabDetails.IS_CUSTOM_TAB !== undefined && tabDetails.IS_CUSTOM_TAB)
				{
					this.send('subReports',tabDetails.LIST);
					this.set('customViewData',true);
				}
				else
				{
					this.set('reportList', tabDetails.LIST);
				    this.send('subReports', tabDetails.rightTreeReportsList);
				}
				this.send('scrollBar');
			} 
			else if (tabDetails.ERROR_DATA !== undefined) 
			{
				this.send('setErrorMessage', tabDetails.ERROR_DATA);
			}
			else
			{
				this.set('showAddReportsMsg',true);
			}
			
		},
		setErrorMessage: function(errorData) 
		{
			if (errorData != null && errorData != undefined) 
			{
				if (errorData.hasOwnProperty('STATUS_MESSAGE')) 
				{
					errorData['ERROR_MESSAGE'] = errorData['STATUS_MESSAGE'];
				}
				this.set('errorData', errorData);
			} 
			else 
			{
				this.set('errorData', {});
			}
		},
		back: function() 
		{
			if (this.get('isChanged') !== undefined && this.get('isChanged')) 
			{
				DialogUtil.confirm(this, 'ads.reports.addreports.back.without_save_alert', 'backToReports', I18NUtil.translate('ads.common.text.proceed')); //No I18N
			} 
			else 
			{
				this.send('backToReports');
			}

		},
		backToReports: function() 
		{
			this.get('router').transitionTo('reports');
			this.set('isChanged', false);
		},
		scrollBar: function(param) 
		{
			var self = this;
			Ember.run.scheduleOnce('afterRender', function() //NO I18N
			{
				$(window).resize(function() {
					self.set('dataHeight', $(window).height() / 1.6);
					$(".fw-custom-scroll-hover").height($(window).height() / 1.6);
					$(".fw-custom-scroll").height(($(window).height() /1.6) + 10);
				})
				$(".fw-custom-scroll").each(function() {
					if ($(this).attr('data-height')) {
						$(this).height(($(window).height()/1.6)+10).css({});
					}
					var theme = ($(this).attr("data-theme")) ? $(this).attr("data-theme") : "light";
					var sPosition = ($(this).attr("data-scrollbar-position")) ? $(this).attr("data-scrollbar-position") : "inside";
					if ((param && sPosition === "outside") || param === undefined) {
						$(this).mCustomScrollbar('scrollTo', 'top');
					}
					$(this).mCustomScrollbar({
						theme: theme,
						autoHideScrollbar: true,
						scrollbarPosition: sPosition,
						callbacks: {
							onScroll: function(evt) {
								return false;
							},
							onTotalScroll: function(evt) {
								return false;
							},
							onTotalScrollBack: function(evt) {
								return false;
							}
						}
					});
				});
				$(".fw-custom-scroll-hover").each(function() {
					if ($(this).attr('data-height')) {
						$(this).height($(this).attr('data-height')).css({});
					}
					var theme = ($(this).attr("data-theme")) ? $(this).attr("data-theme") : "light";
					var sPosition = ($(this).attr("data-scrollbar-position")) ? $(this).attr("data-scrollbar-position") : "inside";
					if ((param && sPosition === "inside") || param === undefined) {
						$(this).mCustomScrollbar('scrollTo', 'top');
					}
					$(this).mCustomScrollbar({
						theme: theme,
						autoHideScrollbar: true,
						scrollbarPosition: sPosition,
						callbacks: {
							onScroll: function(evt) {
								return false;
							},
							onTotalScroll: function(evt) {
								return false;
							},
							onTotalScrollBack: function(evt) {
								return false;
							}
						}
					});
				});
			});
		},
		//Custom Reports related changes
		addView:function()
		{
			var self=this;
			var params={};
			var viewName=$('#VIEW_NAME').val();
			if(Ember.$.trim(viewName)==='')
			{
				this.set("errorMessage",I18NUtil.translate("ads.home.layout.dashboard.tab_error"));
				this.set("showTabError",true);
				return;
			}
			else if(viewName.length>50)
			{
				this.set("errorMessage",I18NUtil.translate("ads.reports.view_name.limit_message"));
				this.set("showTabError",true);
				return;
			}
			params.TAB_NAME=viewName;
			var requestData = {};
			requestData.customViewDetails = JSON.stringify(params),
			AJAXUtil.ajax('/RestAPI/WC/Reports?mTCall=updateCustomView',requestData, false, 'text')
			.then(function(responseData)
			{
				if(responseData==-1)
				{
					self.set("errorMessage",I18NUtil.translate("ads.reports.view_name.exist_msg"));
					self.set("showTabError",true);
					return;
				}
				var tabDetailsLength=self.get('tabDetails').length;
				var customtab=
				{
					"IS_DISABLED" :true,
					"IS_SELECTED" : false,
					"TAB_ID" :responseData,
					"IS_CUSTOM_TAB":true,
					"NAME" :viewName,
					"INDEX":tabDetailsLength
				};
				var tab = new Ember.Set();
				tab.addEach(self.get('tabDetails'));
				tab.add(customtab);
				self.set("tabDetails",tab);
				Ember.run.scheduleOnce('afterRender', function() //NO I18N
				{
					self.send("changeTab",customtab);
					self.send('showButtons');
				});
				self.set("showAddView",false);
			});
		},
		openAddView:function()
		{
			this.set("showTabError",false);
			this.set('showAddView',true);
		},
		closeAddView:function()
		{
			this.set('showAddView',false);
		},
		openAddReportsPopup:function()
		{
			CommonUtil.showLoading();
			this.set('showAddReports',true);
		},
		closeAddReportsPopup:function(responseData)
		{
			var self=this;
			var categoryId=self.currentCategoryId;
			if(responseData !== undefined)
			{
				
				this.set('isChanged',false);
				var newData=self.setCurrentTab(responseData[0]);
				var tabDetails=self.get('tabDetails');
				var tab = new Ember.Set();
				for(var i=0;i<tabDetails.length;i++)
				{
					if(tabDetails[i].TAB_ID==newData.TAB_ID)
					{
						newData.INDEX=i;
						tab.add(newData);
					}
					else
					{
						tab.add(tabDetails[i]);
					}
				}
				self.set("tabDetails",tab);
				Ember.run.scheduleOnce('afterRender', function() //NO I18N
				{
					self.send('changeTab',newData,true);
				});
			}
		    this.set('showAddReports',false);			
		},
		deleteViewConfirmMessage:function(tab)
		{
		var self = this;
			var selectedTabId=0;
			var reportDetails=self.get('tabDetails');
			var updatedReportDetails=[];
			var showErrorMessage=false;
			var count=0;
			for(var i=0;i<reportDetails.length;i++)
			{
				updatedReportDetails.push(reportDetails[i]);
				if(updatedReportDetails[i].IS_SELECTED && updatedReportDetails[i].LIST != undefined)
				{
					showErrorMessage=true;
					for(var j=0;j<updatedReportDetails[i].LIST.length;j++)
					{
						if(updatedReportDetails[i].LIST[j].IS_SELECTED)
						{
							selectedTabId=reportDetails[i].TAB_ID;
							count++;
							break;
						}
					}
					
				}
			}
			if(!showErrorMessage)
			{
				DialogUtil.alert(self,I18NUtil.translate('ads.reports.addreports.delete_view_alert'));//No I18N
			}
			else if(count ===1 && selectedTabId==tab.TAB_ID)
			{
				DialogUtil.alert(self,I18NUtil.translate('ads.reports.addreports.delete_view_alert'));//No I18N
				return false;
			}
			else{
			var self=this;
			DialogUtil.confirm(self,'ads.reports.delete.view.confirm_msg','deleteView','ads.common.text.ok',tab);
		}
		},
		deleteView:function(tab)
		{
			var self=this;
			this.set('currentView',null);
			var params={};
			var diff=0;
			params.TAB_ID=tab.TAB_ID;
			AJAXUtil.ajax('/RestAPI/WC/Reports?mTCall=removeCustomTab',params, false, 'text')
			.then(function(responseData)
			{
				var tabDetails=self.get('tabDetails');
				var tabData = new Ember.Set();
				for(var i=0;i<tabDetails.length;i++)
				{
					if(tabDetails[i].TAB_ID !==tab.TAB_ID)
					{
						tabDetails[i].INDEX=i-diff;
						tabData.add(tabDetails[i]);
					}
					else
					{
						diff=1;
					}
				}
				self.set("tabDetails",tabData);
				Ember.run.scheduleOnce('afterRender', function() //NO I18N
				{
					self.send('changeTab', tabData[0]);
					self.send('showButtons');
					
				});
			});
		},
		deleteCategoryConfirmMessage:function(list)
		{
			var self=this;
			DialogUtil.confirm(self,'ads.reports.delete.category.confirm_msg','deleteCategory','ads.common.text.ok',list);//No I18N		
		},
		deleteCategory:function(list)
		{
			var self=this;
			var params={};
			params.CATEGORY_ID=list.SUB_CATEGORY_ID;
			params.TAB_ID=self.get('currentTabId');
			AJAXUtil.ajax('/RestAPI/WC/Reports?mTCall=removeCategory',params, false, 'text')
			.then(function(responseData)
			{
				self.send('updateTabData',responseData);
			});
		},
		showButtons:function()
		{
			var self=this;
			var tabDetails=self.get('tabDetails');
			Ember.run.scheduleOnce('afterRender', function() //NO I18N
			{
				var productPosition=Ember.$("[REPORT_TAB_ID='" + tabDetails[tabDetails.length-1].TAB_ID + "']").position();
				var productWidth=Ember.$('[REPORT_TAB_ID='+tabDetails[tabDetails.length-1].TAB_ID+']').width();
				var toolPosition = Ember.$('.tab-tool-set').position();
				var latestToolPosition=(toolPosition.left+Ember.$('.tab-tool-set').width())-75;
				if(latestToolPosition<productPosition.left+productWidth)
				{
					self.set('showButtons',true);
				}
				else
				{
					self.set('showButtons',false);
				}
			});
			},
			checkTabName:function(tabDetails)
		{
			var updatedTabName=$("[TAB_ID='" + tabDetails.TAB_ID + "']").val();
			if(updatedTabName=='')
			{
				DialogUtil.alert(this,I18NUtil.translate('ads.reports.view_name.empty_msg'));
				$("[TAB_ID='" + tabDetails.TAB_ID + "']").val(tabDetails.NAME);
			}
			else{
			var self=this;
				if(updatedTabName.length>50)
				{
					DialogUtil.alert(self,I18NUtil.translate("ads.reports.view_name.limit_message"));
					$("[TAB_ID='" + tabDetails.TAB_ID + "']").val(tabDetails.NAME);
					return;
				}
				if(updatedTabName!=undefined && updatedTabName!='')
				{
					updatedTabName=updatedTabName.substring(0,50);
					if(tabDetails.NAME==updatedTabName)
					{
						return;
					}
					
					if(Ember.$.trim(updatedTabName) != null && Ember.$.trim(updatedTabName)!='')
					{
						var tabs=self.get('tabDetails');
						var check=updatedTabName.toLowerCase();
						var flag=0;
						for(var i=0;i<tabs.length;i++)
						{
							var tabName=tabs[i].NAME.toLowerCase();
							if(check==tabName)
							{
								flag=1;
								break;
							}
						}
						if(flag!=0)
						{
							DialogUtil.alert(self,I18NUtil.translate('ads.reports.view_name.exist_msg'));
							$("[TAB_ID='" + tabDetails.TAB_ID + "']").val(tabDetails.NAME);
						}	
						else{
							self.set('isChanged', true);
							Ember.set(tabDetails,'NAME',updatedTabName);
							Ember.set(tabDetails,'TAB_NAME_UPDATED',true);
						}	
					}
					else
					{
						$("[TAB_ID='" + tabDetails.TAB_ID + "']").val(tabDetails.NAME);
					}
				}
				else {
					$("[TAB_ID='" + tabDetails.TAB_ID + "']").val(tabDetails.NAME);
				}
			}
		},

		
		editCategoryName:function(categoryDetails)
		{
			var self=this;
				var updatedCategoryName=$("[CATEGORY_ID='" + categoryDetails.SUB_CATEGORY_ID + "']").val();
				if(updatedCategoryName.length>50)
				{
					DialogUtil.alert(self,I18NUtil.translate("ads.reports.category_name.limit_message"));
					$("[CATEGORY_ID='" + categoryDetails.SUB_CATEGORY_ID + "']").val(categoryDetails.NAME);
					return;
				}
				if(updatedCategoryName!=undefined )
				{
					updatedCategoryName=updatedCategoryName.substring(0,50);
					if(categoryDetails.NAME==updatedCategoryName)
					{
						return;
					}
					if(Ember.$.trim(updatedCategoryName) != null && Ember.$.trim(updatedCategoryName) !='')
					{
						var cats=self.get('rightTreeReportsList');
							var check=updatedCategoryName.toLowerCase();
						var flag=0;
						for(var i=0;i<cats.length;i++)
						{
							var catName=cats[i].NAME.toLowerCase();
							if(check==catName)
							{
								flag=1;
								break;
							}
						}						
							if(flag!=0)
							{
								DialogUtil.alert(self,I18NUtil.translate('ads.reports.category_exists'));
								$("[CATEGORY_ID='" + categoryDetails.SUB_CATEGORY_ID + "']").val(categoryDetails.NAME);
							}
							else{
								self.set('isChanged', true);
								Ember.set(categoryDetails,'NAME',updatedCategoryName);
								Ember.set(categoryDetails,'CATEGORY_UPDATED',true);
							}
					}
					else
					{
						$("[CATEGORY_ID='" + categoryDetails.SUB_CATEGORY_ID + "']").val(categoryDetails.NAME);
				}
				}
		},
		changeSideTab:function(val)
		{
			var currentTabIndex=this.get('currentTabDetails').INDEX;
			var tabs = this.get('tabDetails');
			var nextIndex = null;
			if (val)
			{
				nextIndex = currentTabIndex - 1;
			} 
			else 
			{
				nextIndex = currentTabIndex + 1;
			}
			var tabDetails=this.get('tabDetails');
			var currentTab = tabDetails.filter(function(currentValue)
			{
				return currentValue.INDEX==nextIndex;
			});
			if(currentTab.length) 
			{
				this.send('changeTab', currentTab[0]);
			}
		},
		setTabsOrder:function(id)
		{   
			var self=this;
		    id=id != undefined? id :"TABS_AREA_DROPDOWN";
			var tabs=$("#"+id).find("li");
			var tabsPriority=[]; var priority=100;  // for custom tabs priority is maintained from 100
			for(var i=0;i<tabs.length;i++)
			{
				if(id != undefined)
				{
					this.send('setTabIndex',tabs[i],i);
				}
				if(!$(tabs[i]).hasClass("sortable-disabled"))
				{
					var tabId=tabs[i].id;
					tabsPriority.push({PRIORITY_ID:priority,TAB_ID:tabId});
					priority++;
				}
			}
			var requestData = {};
			requestData.tabDetails = JSON.stringify(tabsPriority);
			var response=AJAXUtil.syncAjax('/RestAPI/WC/Reports?mTCall=setTabsOrder',requestData);
				if(id=='TABS_AREA_DROPDOWN')
				{
					CommonUtil.showLoading();
					self.configure();
					self.sendAction('showStatus', 'success', I18NUtil.translate('ads.reports.save.message.success'), false);
					CommonUtil.hideLoading();
				}
		},
		deleteReportConfirmMessage:function(list)
		{
			var self=this;
			DialogUtil.confirm(self,'ads.reports.delete.report.confirm_msg','deleteReport','ads.common.text.ok',list);//No I18N		
		},
		deleteReport:function(list)
		{
			var self=this;
			var reportDetails={};
			reportDetails.PRODUCT_ID=list.PRODUCT_ID;
			reportDetails.REPORT_ID=list.REPORT_ID;
			reportDetails.CATEGORY_ID=list.params.parentName[0].SUB_CATEGORY_ID;
			reportDetails.TAB_ID=self.get('currentTabId');
			if(list.MENU_ID != undefined)
			{
				reportDetails.MENU_ID=list.MENU_ID;
			}
			var requestData = {};
			requestData.reportDetails = JSON.stringify(reportDetails),
			AJAXUtil.ajax('/RestAPI/WC/Reports?mTCall=removeReport',requestData, false,'text')
			.then(function(responseData)
			{
				self.send('updateTabData',responseData);
			});
		},
		setTabIndex:function(tabs,index)
		{
			var self=this;
			var tabDetails=self.get('tabDetails');
			var currentTab = tabDetails.filter(function(currentValue)
			{
				return currentValue.TAB_ID==tabs.id;
			});
			Ember.set(currentTab[0],'INDEX',index);
		},
		updateTabData:function(responseData)
		{
			var self=this;
			responseData=Ember.$.parseJSON(responseData);
			var newData=responseData[0];
			if(responseData[0].LIST != undefined)
			{
				 newData=self.setCurrentTab(responseData[0]);
			}
			var tabDetails=self.get('tabDetails');
			var tab = new Ember.Set();
			for(var i=0;i<tabDetails.length;i++)
			{
				if(tabDetails[i].TAB_ID===newData.TAB_ID)
				{
					newData.INDEX=i;
					tab.add(newData);
				}
				else
				{
					tab.add(tabDetails[i]);
				}
			}
			self.set("tabDetails",tab);
			Ember.run.scheduleOnce('afterRender', function() //NO I18N
			{
				self.send('changeTab',newData);
			});
		},
		cancelSettings:function()
		{
			CommonUtil.showLoading();
			this.set('isChanged', false);
			this.configure();
			this.didInsertElement();
			this.rerender(); 
			CommonUtil.hideLoading();
		},
		setSortableIcon:function()
		{
			$(".report-list-menu").sortable({items: "li:not(.sortable-disabled)", placeholder: "ui-state-highlight", axis: "y" });
		}
	}
});
//ignorei18n_end
