/*$Id: robo-update.js,v 1.3 2018/11/13 17:18:46 dineshbabu.k Exp $*/
//ignorei18n_start
import Ember from 'ember';
import I18NUtil from "../utils/i18n-util"; //NO I18N
import CommonUtil from "../utils/ads-common-util"; //NO I18N
import AJAXUtil from '../utils/ads-ajax-util'; //NO I18N
import DialogUtil from "../utils/ads-dialog-util"; //NO I18N

export default Ember.Component.extend({
    pageStatus : {},
	mailconfig:false,
	showDayOfWeek:false,
	showDateOfMonth:false,
	updateSchedulerData:null,
	updateCalendarData:null,
	disableEnableNotificationCheckBox:null,
	disableEnableCheckBox:null,
	enbleRoboupdateCheck:false,
	configuredProducts:null,
	productDetails:{},
	routingService:Ember.inject.service('-routing'),
	showRoboUpdateInputBox: function() {
		return !(this.get('enbleRoboupdateCheck'));
	}.property('enbleRoboupdateCheck'),
	
	init : function()
	{
        this._super();
		var clientValuesForRepeatFrequencies = [I18NUtil.translate('ads.support.roboupdate.repeat.daily'),I18NUtil.translate('ads.support.roboupdate.repeat.weekly'),I18NUtil.translate('ads.support.roboupdate.repeat.monthly')];
		var serverValuesForRepeatFrequencies = ["Daily","Weekly","Monthly"];
		var dropDownValuesForRepeatFrequencies=CommonUtil.setDropDownValues(clientValuesForRepeatFrequencies,serverValuesForRepeatFrequencies);
		this.set('REPEAT_FREQUENCIES', dropDownValuesForRepeatFrequencies);//No I18N
		var clientValuesForDayOfWeek = [I18NUtil.translate('ads.support.roboupdate.day.sunday'),I18NUtil.translate('ads.support.roboupdate.day.monday'),I18NUtil.translate('ads.support.roboupdate.day.tuesday'),I18NUtil.translate('ads.support.roboupdate.day.wednesday'),I18NUtil.translate('ads.support.roboupdate.day.thursday'),I18NUtil.translate('ads.support.roboupdate.day.friday'),I18NUtil.translate('ads.support.roboupdate.day.saturday')];
		var serverValuesForDayOfWeek = ["1","2","3","4","5","6","7"];
	    var dropDownValuesForDayOfWeek=CommonUtil.setDropDownValues(clientValuesForDayOfWeek,serverValuesForDayOfWeek);
		this.set('DAYS', dropDownValuesForDayOfWeek);//No I18N
		var months=["01","02","03","04","05","06","07","08","09","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25","26","27","28","29","30","31"];
		var dropDownValuesForMonths=CommonUtil.setDropDownValues(months,months);
		this.set('MONTHS', dropDownValuesForMonths);//No I18N
		var hours=["00","01","02","03","04","05","06","07","08","09","10","11","12","13","14","15","16","17","18","19","20","21","22","23"];
		var dropDownValuesForHours=CommonUtil.setDropDownValues(hours,hours);
		this.set('HOURS', dropDownValuesForHours);//No I18N
		var minutes=["00","05","10","15","20","25","30","35","40","45","50","55"];
		var dropDownValuesForMinutes=CommonUtil.setDropDownValues(minutes,minutes);
        this.set('MINUTES', dropDownValuesForMinutes);//No I18N
        this.send('getUpdateDetails');//No i18n
	},
	 didRender:function(){
         CommonUtil.renderTooltip();
        },
	actions:
	{
		 getRoboUpdateSettings:function(productDetails,status)
		 {
			var self=this;
			if(productDetails.SCHEDULER_SETTINGS==null)
			{
				this.$('#failureMsgDiv').text(I18NUtil.translate(productDetails.STATUS));
				Ember.$('#globalFailureMsg').html(this.$('#failureMsgDiv').html());
				self.sendAction('showStatus','danger',Ember.$('#globalFailureMsg').html(),false);
			}
			else
			{
				self.set('productDetails',JSON.stringify(productDetails));
				self.set('updateSchedulerData', Ember.$.extend(true, [], productDetails.SCHEDULER_SETTINGS));
				self.set('updateCalendarData', Ember.$.extend(true, [], productDetails.CALENDAR_SETTINGS));
				self.set('mailconfig',productDetails.MAIL_CONFIG);
				self.set('updateSchedulerData.CONFIGURED_PRODUCT',productDetails.TAG_NAME);
				self.set('configuredProducts',productDetails.PRODUCT_NAME);

				if(status!=null)
				{
					if(status)
					{
						self.set('updateSchedulerData.ENABLE_UPDATE','false');
					}
					else
					{
						self.set('updateSchedulerData.ENABLE_UPDATE','true');
						if((self.get('updateCalendarData.DAY_OF_WEEK')==-1)?self.set('updateCalendarData.DAY_OF_WEEK',"1"):"");
						if((self.get('updateCalendarData.DATE_OF_MONTH')==-1)?self.set('updateCalendarData.DATE_OF_MONTH',"01"):"");
						if((self.get('updateCalendarData.HOURS')==-1)?self.set('updateCalendarData.HOURS',"00"):"");
						if((self.get('updateCalendarData.MINUTES')==-1)?self.set('updateCalendarData.MINUTES',"00"):"");
						self.send('setRoboUpdateValues');
					}
					self.set("HIDE_SETTINGS",true);
					self.send('saveUpdateSettings');
					return;
				}

				if((self.get('updateCalendarData.DAY_OF_WEEK')==-1)?self.set('updateCalendarData.DAY_OF_WEEK',"1"):"");
				if((self.get('updateCalendarData.DATE_OF_MONTH')==-1)?self.set('updateCalendarData.DATE_OF_MONTH',"01"):"");
				if((self.get('updateCalendarData.HOURS')==-1)?self.set('updateCalendarData.HOURS',"00"):"");
				if((self.get('updateCalendarData.MINUTES')==-1)?self.set('updateCalendarData.MINUTES',"00"):"");

				self.set('updateSchedulerData.ENABLE_UPDATE','true');

				self.set('enbleRoboupdateCheck',true);
				self.set('disableEnableCheckBox',null);
				var autoDownload = self.get('updateSchedulerData.UPDATE_MY_SELF');
				self.send('enableDisableNotification',(autoDownload=='true'));

  		   		if(self.get('updateCalendarData.REPEAT_FREQUENCY')=='Weekly')
				{
				    self.set('showDayOfWeek',true);
				}
				else
		   	 	{
				  	self.set('showDayOfWeek',false);	
				}

  		   	 	if(self.get('updateCalendarData.REPEAT_FREQUENCY')=='Monthly')
 	 	    	{
 			   	 	self.set('showDateOfMonth',true);
				}
				else
				{
					self.set('showDateOfMonth',false);
				}
				self.send('setRoboUpdateValues');
				self.$('#ROBOUPDATE_SETTINGS').show();
			}
	    },
	    enableDisableNotification:function(val)
	   	{
		    if(val)
		    {
		       this.set('disableEnableNotificationCheckBox',null);
			}
			else
			{
			 	this.set('disableEnableNotificationCheckBox','disabled');
			}
	   	},
	    setRoboUpdateValues:function()
       	{
			this.send('setDropDownValues','HOUR',this.get('updateCalendarData.HOURS'));
       		this.send('setDropDownValues','MINUTE',this.get('updateCalendarData.MINUTES'));
       		
       		if(this.get('showDayOfWeek'))
       		{
       			this.send('setDropDownValues','DAY_OF_WEEK',this.get('updateCalendarData.DAY_OF_WEEK'));
       		}
       		if(this.get('showDateOfMonth'))
       		{
       			this.send('setDropDownValues','DATE_OF_MONTH',this.get('updateCalendarData.DATE_OF_MONTH'));
       		}
       		this.send('setCheckBoxValue','#AUTO_DOWNLOAD',this.get('updateSchedulerData.UPDATE_MY_SELF'));
       		this.send('setCheckBoxValue','#UPDATES_AVAILABLE',this.get('updateSchedulerData.NOTIFY_ADMIN'));
       		this.send('setCheckBoxValue','#NOTIFY_ME_AFTER_UPGRADE',this.get('updateSchedulerData.NOTIFY_AFTER_UPGRADE'));
       	}, 
       	setDropDownValues:function(calendarSetting,dropDownValue)
       	{
       		this.$('#'+calendarSetting).val(dropDownValue);
       		if(calendarSetting=='DAY_OF_WEEK')
       		{
       			dropDownValue = this.$('#'+calendarSetting + ' [value='+ dropDownValue + ']').text();
       		}
  			this.$('[data-id='+calendarSetting+'] .pull-left').text(dropDownValue);
       	},
       	setCheckBoxValue:function(enableSetting,status)
       	{
       		if(status=='true')
       		{
       			this.$(enableSetting).parent('div').addClass('checked');
       		}
       		else
       		{
       			this.$(enableSetting).parent('div').removeClass('checked');	
       		}
       		this.$(enableSetting).prop('checked',(status=='true'));
       	},
		repeatFrequencyChanged:function(text,value)
		{
			  var self=this;
			  if(value=='Weekly')
			  {
				  self.set('showDayOfWeek',true);
				  self.set('showDateOfMonth',false);
			  }
			  else if(value=='Monthly')
			  {
				  self.set('showDateOfMonth',true);
				  self.set('showDayOfWeek',false);
				
			  }
			  else
			  {
				  self.set('showDateOfMonth',false);
				  self.set('showDayOfWeek',false);
			  }
			  CommonUtil.afterRender();
		},
		redirect: function(path)
		{
		    this.get('routingService').transitionTo(path);
		},
		
      	saveUpdateSettings:function(){
		    var self=this;
			var params={};
			var hideSettings = self.set('HIDE_SETTINGS');
			var selectedProduct = this.get('updateSchedulerData.CONFIGURED_PRODUCT');
			params[selectedProduct]=true;

			var repeatFrequency= (hideSettings)?self.get('updateCalendarData.REPEAT_FREQUENCY'):this.$('#REPEAT_FREQUENCY').val();
			var dayOfWeek = (hideSettings)?self.get('updateCalendarData.DAY_OF_WEEK'):this.$('#DAY_OF_WEEK').val();
			if(typeof dayOfWeek === 'undefined')
			{
				dayOfWeek="-1";
			}
			var dateOfMonth= (hideSettings)?self.get('updateCalendarData.DATE_OF_MONTH'):this.$('#DATE_OF_MONTH').val();
			if(typeof dateOfMonth === 'undefined')
			{
				dateOfMonth="-1";
			}
			var hours= (hideSettings)?self.get('updateCalendarData.HOURS'):this.$('#HOUR').val();
			var minutes= (hideSettings)?self.get('updateCalendarData.MINUTES'):this.$('#MINUTE').val();
			var enableUpdate=this.get('updateSchedulerData.ENABLE_UPDATE');
			var autoDownload =  this.$('#AUTO_DOWNLOAD').is(':checked');
			var updateAvailable =  this.$('#UPDATES_AVAILABLE').is(':checked') && !this.$('#UPDATES_AVAILABLE').is(':disabled');
			var notifyAfterUpgrade =  this.$('#NOTIFY_ME_AFTER_UPGRADE').is(':checked') && !this.$('#NOTIFY_ME_AFTER_UPGRADE').is(':disabled');

			if(enableUpdate=="true" && !self.get('mailconfig') &&(updateAvailable || notifyAfterUpgrade))
			{
				DialogUtil.alert(this, I18NUtil.translate('ads.support.roboupdate.configure_mail'));//No I18N
				return;
			}
			else
		    {
                params['REPEAT_FREQUENCY']=repeatFrequency;
				params['DATE_OF_MONTH']=dateOfMonth;
				params['DAY_OF_WEEK']=dayOfWeek;
				params['HOURS']=hours;
				params['MINUTES']=minutes;
				params['ENABLE_UPDATE']=enableUpdate;
				params['UPDATE_MY_SELF']=autoDownload;
				params['NOTIFY_ADMIN']=updateAvailable;
				params['NOTIFY_AFTER_UPGRADE']=notifyAfterUpgrade;
				params['IS_EMBER']=true;
				self.set("HIDE_SETTINGS",false);
				CommonUtil.showLoading();
				var roboUpdateDetails = AJAXUtil.syncAjax('/RestAPI/WC/RoboUpdateAction?mTCall=saveSchedulerSettings',params);
				var isSuccess = true;
				var reason = null;
				var message = I18NUtil.translate('ads.admin.personalize.message.success');
				if(roboUpdateDetails.hasOwnProperty("eSTATUS"))
				{
					self.sendAction('showStatus','danger', roboUpdateDetails.eSTATUS, false);
				}
				else if (roboUpdateDetails === 'Failure') {
					  isSuccess = false;
				} 
				else {
					var status = roboUpdateDetails[0];
					for (var key in status) {
						if (key === 'EXCEPTION') {
							isSuccess = false;
							reason = {};
							reason['key'] = status['PRODUCT_NAME'];
							reason['value'] = status[key];
						}
					}
					if (isSuccess) 
					{
						self.sendAction('showStatus','success',message,true);
					} 
					else
					{
						self.$('#failureMsgDiv').text(reason.value);
						Ember.$('#globalFailureMsg').html(self.$('#failureMsgDiv').html());
						self.sendAction('showStatus','danger',Ember.$('#globalFailureMsg').html(),false);
					}
				}
			}
			this.send('getUpdateDetails');
	   	},

	    getUpdateDetails:function(){
			var self=this;
			this.sendAction('afterLoading');
			Ember.run.schedule('afterRender',this,function(){
				this.$('#ROBOUPDATE_SETTINGS').hide();
				AJAXUtil.ajax("/RestAPI/WC/RoboUpdateAction?mTCall=getUpdateHistory",{	IS_EMBER:"true",PRODUCT_DETAILS:self.get('productDetails')}).then(function(responseData) {
				   self.send('setupUpdateDetails',responseData);	
				   self.sendAction('beforeLoading');			 
				});
			});
	    },
	    setupUpdateDetails:function(responseData)
	    {
	   		var self=this;
	   		var timeFormat = self.get('userDateTimeFormat.TIME_FORMAT').replace(/d/g,'D').replace(/y/g,'Y').replace(/a/g,'A');
	   		var timeZone = self.get('userDateTimeFormat.TIME_ZONE');
	   		var isTimeZone = false;
	   		var isSeconds = false;
	   		if(timeFormat.indexOf('z')>0)
	   		{
	   			isTimeZone=true;
	   		}
	   		if(timeFormat.indexOf('ss')>0)
	   		{
	   			isSeconds=true;
	   		}
	   		
	   		var updateDetails=[];
	   		var productName =null;
	   		var len = responseData.length-1;
	   		if(self.get('productDetails').length>0)
	   		{
	   			len=1;
	   		}
	   		for(var i=0;i<len;i++) {
	   			var update = responseData[i];
	   			if(update.SCHEDULE_TIME!=null)
	   			{
	   				var scheduleTime =  moment(update.SCHEDULE_TIME).format(timeFormat);
	   				if(isSeconds)
	   				{
	   					scheduleTime = scheduleTime.substring(0,scheduleTime.lastIndexOf(':')+1) + '00';
	   				}
	   				if(isTimeZone)
	   				{
	   					scheduleTime = scheduleTime + " " + timeZone;
	   				}
	   				update.SCHEDULE_TIME=scheduleTime;
	   			}
	   			if(update.UPDATE_TIME!=null)
	   			{
	   				var updateTime =  moment(update.UPDATE_TIME).format(timeFormat);
	   				if(isTimeZone)
	   				{
	   					updateTime = updateTime + " " + timeZone;
	   				}
	   				update.UPDATE_TIME=updateTime;
	   			}
	   			if(update.PRODUCT_NAME!="")
	   			{
	   				productName=update.PRODUCT_NAME;
	   			}
	   			update.PRODUCT = productName.replace(new RegExp(" ", 'g'),"");
	   			if(update.SCHEDULER_SETTINGS!=null && update.SCHEDULER_SETTINGS.ENABLE_UPDATE=="true")
	   			{
	   				update.ICON_STATUS="fw-icn-ok";
	   				update.ENABLE_STATUS=true;
	   			}
	   			else
	   			{
	   				update.ICON_STATUS="fw-icn-cancel";	
	   				update.ENABLE_STATUS=false;
	   			}

    			updateDetails.push(update);
  			}
  			self.send('setupUpdateHistory',updateDetails);
	    },
	    setupUpdateHistory:function(responseData)
	    {
	   		var self=this;
	   		var updateDetails=[];
	   		var productName =null;
	   		var k=0;
	   		for(var i=0;i<responseData.length;i++) {
	   			var updateHistory = [];
	   			var update = responseData[i];
	   			if(update.PRODUCT_NAME=="")
	   			{
	   				continue;
	   			}
	   			update.INDEX=k;
	   			k++;
	   			for(var j=i+1;j<responseData.length;j++) {
	   				var product = responseData[j];
	   				if(product.PRODUCT==update.PRODUCT)
	   				{
	   					updateHistory.push(product);
	   				}
	   			}
	   			if(updateHistory.length>0)
	   			{
	   				update.HISTORY = updateHistory;
	   				update.IS_HISTORY=true;
	   			}
	   			updateDetails.push(update);
  			}
  			
  			if(self.get('productDetails').length>0)
  			{
  				var productDetails = Ember.$.parseJSON(self.get('productDetails'));
  				var index=productDetails.INDEX;
  				var refreshedProduct=updateDetails[0];
  				updateDetails=self.get('UPDATE_DETAILS_LIST');
  				refreshedProduct.INDEX=index;
		   		updateDetails[index]=refreshedProduct;
		   		self.set('UPDATE_DETAILS_LIST',[]);
  			}
  			self.set('productDetails',{});
  			CommonUtil.hideLoading();
			self.set('UPDATE_DETAILS_LIST',updateDetails);
	    },
	    cancel:function()
	    {
	    	this.send('getUpdateDetails');
	    },	
	    ToggleCheckBox: function(val, key){},
	}
});
//ignorei18n_end
