/* $Id: rt-editor.js,v 1.19 2018/12/24 13:48:50 jagadesh.manickamurthy Exp $ */
import $ from 'jquery';//NO I18N

import Ember from 'ember'; //NO I18N
import DialogUtil from "../utils/ads-dialog-util"; //NO I18N
import AjaxUtil from "../utils/ads-ajax-util"; //No I18N
import I18NUtil from "../utils/i18n-util"; //No I18N
import StatusUtil from "../utils/ads-status-util"; //NO I18N
import ValidationUtil from "../utils/ads-validation-util"; //NO I18N

export default Ember.Component.extend({
    pageStatus: {},
    FORM_STATUS_MODEL: {},
    attachSize: 0,
    defaultIconHeight: 36,
    uploadedFile: null,
    attachFileNames: [],
    removedFileNames: [],
    clientPriority: [],
    adsService: Ember.inject.service(),
    isMacro:false,
    defaultPriority: [{
        "CLIENT_VALUE": "ads.rteditor.mail.high_priority", //NO I18N
        "SERVER_VALUE": 2,//NO I18N
        "ICON": "rteditor-icn-priority-high"//NO I18N
    }, {
        "CLIENT_VALUE": "ads.rteditor.mail.medium_priority",//NO I18N
        "SERVER_VALUE": 1,//NO I18N
        "ICON": "rteditor-icn-priority-mid"//NO I18N
    }, {
        "CLIENT_VALUE": "ads.rteditor.mail.low_priority",//NO I18N //NO I18N
        "SERVER_VALUE": 0, //NO I18N
        "ICON": "rteditor-icn-priority-low" //NO I18N
    }],
    editorModes: [{
      "CLIENT_VALUE": "ads.rteditor.editor.rt_mode", //NO I18N
      "SERVER_VALUE": 1//NO I18N
    }, {
      "CLIENT_VALUE": "ads.rteditor.editor.plain_txt_mode",//NO I18N
      "SERVER_VALUE": 0//NO I18N
    }],
    filteredResultsComponent: function() {
        // Added as ember can't inster/remove li's due to custom scroll's additional div's. So, destroying custom scroll at the beginning.
        Ember.$(".rteditor-custom-scroll").each(function() 
        {
            Ember.$(this).mCustomScrollbar('destroy');
        });
        var self = this;
        var filter = this.get('filterTextComponent'); //NO I18N
        if(filter != undefined){
            filter= filter.toLowerCase();
        }
        if(self.get("macroHasHeader"))
        {
          var filteredMacros = [];
           this.get("macro").forEach(function(HEADERS) { //NO I18N
              var filteredChildMacros =  HEADERS.CHILD_MACROS.filter(function (macro) {
                return (I18NUtil.translate(macro.CLIENT_VALUE)).toLowerCase().indexOf(filter) !== -1;
              });
               if(filteredChildMacros.length > 0)
               {
                 var filteredMacro = {};
                 filteredMacro.MACRO_HEADER = HEADERS.MACRO_HEADER;
                 filteredMacro.CHILD_MACROS = filteredChildMacros;
                 filteredMacros.push(filteredMacro);
               }
            });
           return filteredMacros;
        }
        else
        {
          return (this.get("macro")).filter(function(MACROS) { //NO I18N
            return (I18NUtil.translate(MACROS.CLIENT_VALUE)).toLowerCase().indexOf(filter) !== -1;
          });
        }
    }.property('filterTextComponent','macro'), //No I18N
    didRender: function() {
      
       Ember.$('.no-collapsable').on('click', function (e) {
            if(e.target.tagName.toLowerCase() === "button")
            {
                return;
            }
            else
            {
                e.stopPropagation();
            }
        });

        Ember.$(".rteditor-search-input").on("click", function(e) 
        {
            e.stopPropagation();
        });

        Ember.$(".mCSB_dragger_bar,.mCSB_draggerContainer").off("click").on("click", function(evt) 
        {
            evt.stopPropagation();
        });

        Ember.$(".rteditor-custom-scroll").each(function() 
        {
            if (Ember.$(this).attr('data-height')) 
            {
                Ember.$(this).height($(this).attr('data-height')).css({
                    "overflow": "hidden" //NO I18N
                }); //NO I18N
            }

            Ember.$(this).mCustomScrollbar({
                theme: "dark", //NO I18N
                autoHideScrollbar: false,
                snapAmount: 28,
                autoScrollOnFocus: false,
                keyboard: false,
                callbacks: {
                    // onScroll: function(evt) {
                    //     return false;
                    // },
                    // onTotalScroll: function(evt) {
                    //     return false;
                    // },
                    // onTotalScrollBack: function(evt) {
                    //     return false;
                    // }
                }
            });
        });
         Ember.$('.rteditor-list-dropdown.dropdown-menu').on("click", function (e) {
                $('.rteditor-list-dropdown.dropdown-menu li').each(function(e,obj){
                    $(obj).removeClass("active"); 
                });
                $(e.target).closest('li').addClass("active");
              });
    },
    didInsertElement: function() {
        var self = this;
        self.set("CSRF_PARAM_NAME",this.get("adsService").getGlobalDataValue("csrfParamName"));//NO I18N 
        self.set("CSRF_COOKIE_VAL",this.get("adsService").getGlobalDataValue("csrfCookieVal"));//NO I18N 
        ZE_Init.I18N_DATA_MODEL = I18NUtil.getI18NDataModel();
        ZE_Init.imgAction = this.get("imageApi"); //NO I18N             
        ZE_Init.cssPath = 'vendor/css/rteditor.css'; //NO I18N
        ZE_Init.csrfParamVal = self.get("CSRF_PARAM_NAME");//NO I18N 
        ZE_Init.csrfCookieVal = self.get("CSRF_COOKIE_VAL");//NO I18N 
        ZE_Init.jQuery=(self.get("CUSTOM_JQUERY")!==undefined)?self.get("CUSTOM_JQUERY"):Ember.$; //No I18N
        if(!Ember.isEmpty(self.get('fontSize')))
        {
            ZE_Init.defaultFontSize = self.get('fontSize'); //No I18N
        }        
        if(!Ember.isEmpty(self.get('fontFamily')))
        {
            ZE_Init.defaultFontFamily = self.get('fontFamily'); //No I18N
        }
        if(!Ember.isEmpty(self.get('resizeTableAllowed')))
        {
            ZE_Init.resizeTableAllowed = self.get('resizeTableAllowed'); //No I18N
        }
        if(!Ember.isEmpty(self.get('allowTableEditorOptions')))
        {
            ZE_Init.allowTableEditorOptions = self.get('allowTableEditorOptions'); //No I18N
        }
        if(typeof this.get('customParams')!=="undefined")
        {
            this.get('customParams').forEach(function(param)//No I18N
            {
                Ember.set(ZE_Init,param.key,param.value);
            });
        }
        if (this.$("#" + self.get("editorId")).hasClass("editor-added"))
            {
                this.$("#" + self.get("editorId") + "_ATTACHMENT").remove(); //NO I18N
            }
        self.set("attachFileNames", []); //NO I18N
        self.set("attachSize", 0); //NO I18N
        this.set("ZE_OBJECT",ZE_Init.apply(self.get("editorId"), self.get("editorBody"), self.get("toolbarsOption"),self.get('mode'))); //NO I18N
        this.$("#" + self.get("editorId")).addClass("editor-added"); //NO I18N
        if(self.get('mode')=="plaintext")
        {
            this.$("#" + self.get("editorId")).css("padding","1px");
        }
        this.$('[data-toggle="tooltip"]').tooltip();
        // Response send after image upload in the server
        ZE_Init.jQuery('#ze_img_request').unbind('load').load(function(responseData) //NO I18N 
        {
            if(!Ember.isEmpty(ZE_Init.jQuery("#ze_img_request").contents().find("body").html()))
			{
	            var response =jQuery.parseJSON(ZE_Init.jQuery("#ze_img_request").contents().find("body").html());//NO I18N 
	            ZE.prototype.previewImage(response.FILE_URL);
            }
        });
        this.$('#' + self.get("editorId") + '_iFrame').load(function(responseData)  //NO I18N
        {
            var editorId = '#'+self.get("editorId")+"_iFrame"; //NO I18N
            if(!Ember.isEmpty(self.$(editorId).contents().find("body").html()))
			{
            var response = jQuery.parseJSON(self.$(editorId).contents().find("body").html());
            if ('eSTATUS' in response) 
            {
                StatusUtil.showStatus(self, { responseData}); //No I18N
                return;
            }
            var fileName = response.FILE_NAME;
            var clientFileName = self.uploadedFile.files[0].name
            var fileSize = self.uploadedFile.files[0].size;
            var editorName = self.get("editorId"); //No I18N
            var attach = [];
            var obj = {};
            obj["SERVER_FILE_NAME"] = fileName;
            obj["CLIENT_FILE_NAME"] = clientFileName;
            obj["ATTACHMENT_SIZE"] = fileSize;
            if(response.FOLDER_NAME!=null)
            {
                var folderName = response.FOLDER_NAME;
                obj["FOLDER_NAME"] = folderName;
                self.set(editorName+"_FOLDER",folderName); //NO I18N
            }
            
            attach.push(obj);
            self.send("addAttachMent", self.get("editorId"), attach) //NO I18N
            }
        });
        this.$("#" + self.get("editorId")).off("click").on("click", "i.close-btn", function()  //NO I18N
        {
            var _this = this;
            var indexToRemove = Ember.$(this).closest("div.file-que").index();
            var editorId = Ember.$(this).closest("div.file-que").parent().parent().attr("id"); //No I18N
            var attach = self.get("attachFileNames"); //NO I18N
            var size = self.get("attachSize"); //NO I18N
            var fileToRemove = [];
            fileToRemove[0] = attach[indexToRemove]["SERVER_FILE_NAME"];
            var isEdit = false;
            var isRemoveAttach = true;
            var folderName = self.get('folderName')!="" ? self.get("folderName"): self.get(editorId+"_FOLDER"); //NO I18N
            if(self.get("isEdit")!=undefined && self.get("isEdit")!=null)
            {
                isEdit = self.get("isEdit"); // No I18N
            }
            if(!isEdit)
            {
                AjaxUtil.ajaxNoScroll(self.get("attachRemoveApi"), { //NO I18N
                    "REMOVE_FILE_NAME": JSON.stringify(fileToRemove), //NO I18N
                    "FOLDER_NAME": folderName //NO I18N
                }) //No I18N
                .then(function(json) { //No I18N
                    if ('eSTATUS' in json) 
                    {
                        StatusUtil.showStatus(self, json); //No I18N
                        isRemoveAttach = false;                        
                    } 
                });
            }
            else
            {
                self.removedFileNames.push(fileToRemove[0]);
                self.set("removedFileNames",self.removedFileNames); // No I18N
            }
            if(isRemoveAttach)
            {
                        size = size - attach[indexToRemove].ATTACHMENT_SIZE;
                        attach.splice(indexToRemove, 1);
                        self.set("attachFileNames", attach); //NO I18N
                        self.set("attachments", attach); //NO I18N
                        self.set("attachSize",size); //No I18N
                        if (Ember.$(_this).closest("div.uploaded-file").find("div.file-que").length == 1)
                        {
                            Ember.$(_this).closest("div.rteditor").removeClass("open");
                            Ember.$(_this).closest("div.file-que").remove();
                            self.$("#"+self.get("editorId")).css('padding-bottom', 0);
                        }
                        else 
                        {
                            Ember.$(_this).closest("div .file-que").remove();
                        }
            }
            if(!Ember.isEmpty("editorHeight"))
                {
                    var editorHeight =  self.get("editorHeight");
                    var toolBarHeight = (self.get("hideToolBar"))? 0 :self.get("defaultIconHeight");
                    var uploadFileDivHeight =  Ember.isEmpty(self.get("attachments")) ? 0 : self.$("#"+self.get("editorId")+" .uploaded-file").height();
                    var zeAreaHeight = editorHeight - toolBarHeight - uploadFileDivHeight;
                    self.$("#"+self.get("editorId")).find(".ze_area").css('height',zeAreaHeight); //No I18N
                }
        });
        if (self.get("isPriority") == true && (self.get("mailPriority") == null || self.get("mailPriority") == undefined)) 
        {
            if ((self.get("mailPriority") == null || self.get("mailPriority") == undefined)) 
            {
                self.set("mailPriority", self.defaultPriority); //NO I18N
            }
            if (self.get("selectedPriority") == null || self.get("selectedPriority") == undefined) 
            {
                self.set("selectedPriority", 1); //NO I18N
                self.set("selectedPriorityIcon","rteditor-icn-priority-mid");//NO I18N
            }
        }
        if(self.get("isPriority") == true) //NO I18N
        {
            var pri = [];
            var selPri = self.get("selectedPriority"); //NO I18N
            for (var i = 0; i < self.get("mailPriority").length; i++) 
            {
                var obj = {};
                obj["SERVER_VALUE"] = self.get("mailPriority")[i].SERVER_VALUE; //NO I18N
                obj["CLIENT_VALUE"] = I18NUtil.translate(self.get("mailPriority")[i].CLIENT_VALUE); //NO I18N
                obj.ICON = self.get("mailPriority")[i].ICON; //NO I18N
                obj["IS_SELECTED"] = false; //NO I18N
                if (obj.SERVER_VALUE == selPri) 
                {
                    obj["IS_SELECTED"] = true; 
                    self.set("selectedCliPriority", obj.CLIENT_VALUE); //NO I18N
                    self.set("selectedPriorityIcon", obj.ICON); //NO I18N
                }
                pri.push(obj);
            }
           self.set("clientPriority", pri); //NO I18N
        }
 	if(self.get("showEditorModes"))
        {
          self.set("selectedEditorMode",self.get('mode')=='plaintext' ? 0 : 1);// No I18N
          var selEditorMode = self.get("selectedEditorMode");// No I18N
          self.get("editorModes").forEach(function (mode) {// No I18N
            Ember.set(mode, "IS_SELECTED", mode.SERVER_VALUE == selEditorMode );// No I18N
          });
        }
        this.$("#" + self.get("editorId")).bind('contentchanged', function() //NO I18N
        {
            if(self.get('mode')=="plaintext")
            {
                self.set("editorBody", self.$("#" + self.get("editorId")).find('textarea').val()); //NO I18N
            }
            else
            {
                self.set("editorBody", self.$("#" + self.get("editorId")).find('iframe').contents().find("body").html()); //NO I18N
            }
        });
        if (self.get("attachments") != null && self.get("attachments") != undefined && self.get("attachments").length > 0) 
        {
            self.send("addAttachMent", self.get("editorId"), self.get("attachments")); //NO I18N
        }
        this.$('#' + self.get("editorId") + '_ATTACHMENT').change(function(fileDet)  //NO I18N
        { 
            if (self.$("#UPLOADED_FILE").length > 0)
            {
                self.send("attachmentHandler", self.get("editorId"), fileDet); //NO I18N
            }
        });
        if (self.get("hideToolBar") == true) 
        {
            this.$(".ze_SCmb", this.$("#" + self.get("editorId"))).css("display", "none");
        }
        self.set("isMacro",!Ember.isEmpty(self.get("macro"))); //NO I18N
		if(self.get("isAccessUrl") == true)
        {
            //Set the data from Component property to Editor Property & its backUP data property
            self.set('ACCESS_URL_PROPS',JSON.parse(JSON.stringify(self.get("accUrlProps"))));//No I18N
            self.set('ACCESS_URL_PROPS_BACKUP', JSON.parse(JSON.stringify(self.get("accUrlProps"))));//No I18N
            self.set('PRODUCT_NAME',self.get("productName")); //NO I18N
            
        }
        if(Ember.isEmpty(this.get("attachments")))
        {
            this.$("#"+this.get("editorId")).css('padding-bottom', 0);
        }
        if(!Ember.isEmpty("editorHeight"))
        {
            this.$("#"+this.get("editorId")).find(".ze_area").css('height', (self.get("editorHeight") - ((self.get("hideToolBar") != true)? self.get("defaultIconHeight"):0)- ((Ember.isEmpty(this.get("attachments")) ? 0 : this.$("#"+this.get("editorId")+" .uploaded-file").height())))); //No I18N
            this.$("#"+this.get("editorId")+"_ATTACHMENT").find(".rteditor").css('height',self.get("editorHeight")); //No I18N
            this.$("#"+this.get("editorId")+"_ATTACHMENT").find(".rteditor").css('min-height',1);//No I18N
        }
    },
    //Observes the value for the component property change to update the editor property for all editor view.
    changeURLAccess:function()
    {
        var self = this;
        this.set("ACCESS_URL_PROPS",this.get("accUrlProps")); //NO I18N
    }.observes('accUrlProps'), //NO I18N
    willDestroyElement: function() {
        Ember.$(this.get('element')).find("*").each(function() {//No i18n
            Ember.$(this).off();
        });
        this.$('#ze_img_request').off('load');//No i18n
        Ember.$(this.get('element')).find(".rteditor-custom-scroll").each(function()//No i18n
        {
            Ember.$(this).mCustomScrollbar('destroy');//No i18n
        });
        this.$(".mCSB_dragger_bar,.mCSB_draggerContainer").off("click");//No i18n
        Ember.$(this.get('element')).find(".rteditor-search-input").off('click');//No i18n
    }, 
    changeContent: function() 
    {
        this.$("#" + this.get("editorId")).find(".ze_area").contents().find('body').html(this.get("editorBody")); //NO I18N
        this.set("attachSize", 0); //NO I18N
        this.set("attachFileNames", []); //NO I18N
        
        this.$("#"+this.get("editorId")+"_ATTACHMENT").find("div.rteditor").removeClass("open"); //No I18N
        this.$("#"+this.get("editorId")+"_ATTACHMENT").find("div.file-que").remove(); //No I18N
        this.$("#"+this.get("editorId")).css('padding-bottom', 0);
        
        if (this.get("attachments") != null && this.get("attachments") != undefined && this.get("attachments").length > 0) 
        {
            this.send("addAttachMent", this.get("editorId"), this.get("attachments")); //NO I18N
        }
        this.send('changePriority',(this.get('selectedPriority') || 1));//NO I18N
        this.set("isMacro",!Ember.isEmpty(this.get("macro"))); //NO I18N
    }.observes('isRefresh'), //NO I18N
    actions: 
    {
        changePriority: function(selPri) 
        {
            this.set("selectedPriority", selPri); //NO I18N
            var pri = [];
            for (var i = 0; i < this.get("clientPriority").length; i++) {
                var obj = {};
                obj["SERVER_VALUE"] = this.get("clientPriority")[i].SERVER_VALUE;
                obj["CLIENT_VALUE"] = this.get("clientPriority")[i].CLIENT_VALUE;
                obj.ICON = this.get("clientPriority")[i].ICON;
                obj["IS_SELECTED"] = false;
                if (obj.SERVER_VALUE == selPri) {
                    obj["IS_SELECTED"] = true;
                    this.set("selectedCliPriority", obj.CLIENT_VALUE); //NO I18N
                    this.set("selectedPriorityIcon", obj.ICON); //NO I18N
                }
                pri.push(obj);
            }
            this.set("clientPriority", pri); //NO I18N
        },
        changeEditorMode: function(selEditorMode)
        {
          var self=this;
          var zeObject = this.get("ZE_OBJECT");//No I18N
          var editorBody=self.get('mode')==="plaintext" ?  self.$("#" + self.get("editorId")).find('textarea').val() : self.$("#" + self.get("editorId")).find('iframe').contents().find("body").html();//No I18N
          ZE.prototype.setMode(selEditorMode === 0 ? 'plaintext' : 'richtext',editorBody,zeObject);//No I18N
          self.set("selectedEditorMode", selEditorMode); //NO I18N
          self.set("mode",selEditorMode === 0 ? 'plaintext' : 'richtext');// No I18N
          self.get("editorModes").forEach(function (mode) {// No I18N
            Ember.set(mode, "IS_SELECTED", mode.SERVER_VALUE == selEditorMode );// No I18N
          });
        },
        attachmentHandler : function(editorId,fileDet)
        {
          //Reading file for actual mime type
          var filereader = new FileReader();
          var mimeType;
          var file = fileDet.target.files[0];
          var self =this;
          filereader.readAsArrayBuffer(file.slice(0, 4));
          filereader.onloadend = function(evt) {
            if (evt.target.readyState === FileReader.DONE) {
              var uint = new Uint8Array(evt.target.result);
              let bytes = [];
                for(var index=0;index<uint.length;index++)
                {
                  bytes.push(uint[index].toString(16));
                }
              mimeType =  bytes.join('').toUpperCase();
              self.send('attachmentHandlerCallBack',editorId,fileDet,mimeType);//No I18N
            }
          };
        },
        attachmentHandlerCallBack: function(editorId, fileDet,mimeType)
        {
            var restrictedFileType = ['ADE', 'ADP', 'BAT', 'CHM', 'CMD', 'COM', 'CPL', 'EXE', 'HTA', 'INS', 'ISP', 'JAR', 'JS', 'JSE', 'LIB', 'LNK', 'MDE', 'MSC', 'MSI', 'MSP', 'MST', 'NSH', 'PIF', 'SCR', 'SCT', 'SHB', 'SYS', 'VB', 'VBE', 'VBS', 'VXD', 'WSC', 'WSF', 'WSH']; //No I18N
            // restrictedMimeTypePatterns = [exe,jar,msi]
            var restrictedMimeTypePatterns = [/4D5A([A-F0-9])*/,/504B([A-F0-9])*/,/D0CF([A-F0-9])*/];//No I18N
            var file = fileDet.target.files[0];
            var size = this.get("attachSize"); //NO I18N
            var fileExtension = file.name.substr((file.name.lastIndexOf('.') + 1));

            if (size == undefined || size == null)
            {
                size = 0;
            }
            var hasValidMimeType = true;
            for(var index = 0 ;index < restrictedMimeTypePatterns.length ; index++ )
            {
              var regex = restrictedMimeTypePatterns[index];
              if(regex.test(mimeType))
              {
                hasValidMimeType = false;
                break;
              }
            }
            if (!hasValidMimeType || restrictedFileType.contains(fileExtension.toUpperCase()))
            {
                DialogUtil.alert(this, 'ads.rteditor.editorpop.attach_restrict_file'); //NO I18N
                jQuery('#UPLOADED_FILE').remove(); //No I18N

            }
            else if(!ValidationUtil.isValidFileName(file.name))
            {
                DialogUtil.alert(this, I18NUtil.translate('ads.rteditor.editorpop.invalid_file_name', ['', ValidationUtil.fileNameRegEx])); //NO I18N
                jQuery('#UPLOADED_FILE').remove(); //No I18N
            } 
            else if (size + file.size > 26214400) 
            {
                DialogUtil.alert(this, 'ads.rteditor.editorpop.attach_size_exceed'); //NO I18N
                jQuery('#UPLOADED_FILE').remove(); //No I18N
            }
            else
            {
				        var currentFolderName = Ember.$("#" + editorId + "_FOLDER_NAME").val();
                var folderName = currentFolderName == ""? this.get(editorId+"_FOLDER")!=null ? this.get(editorId+"_FOLDER") : "" : currentFolderName; //NO I18N
                Ember.$("#" + editorId + "_FOLDER_NAME").val(folderName);
                Ember.$("#" + editorId + "_ATTACHMENT").submit();
                this.set("uploadedFile", Ember.$("#UPLOADED_FILE")[0]);
                jQuery('#UPLOADED_FILE').remove(); //No I18N
            }
            $(".modal-backdrop").eq(2).remove();
            if(Ember.$(".modal-backdrop").length>2){
               Ember. $(".modal-backdrop").eq(1).remove();
            }   
        },
        toggleMacro: function() 
        {
            this.set("filterTextComponent", ''); //NO I18N
        },
        addMacro: function(macro) 
        {
            var self = this;
            (Ember.$("#" + self.get("editorId")).find('iframe').contents().find('body')[0]).focus();
            ZE.insertMacro("&nbsp;%" + macro + "%&nbsp;"); //NO I18N
        },
        addAttachMent: function(editor, attachmentDet) 
        {
            var self = this; 
            var attachMent = this.get("attachFileNames"); //NO I18N
            var size = this.get("attachSize"); //NO I18N
            this.$("#"+this.get("editorId")).css('padding-bottom', 22);
            Ember.$.each(attachmentDet, function(index, value)
            {
                attachMent.push(value);
                size = size + value.ATTACHMENT_SIZE;
                var meditor = self.$("#" + editor);
                var template = '<div class="file-que">' +
                    '<span class="name-of-file">' + value.CLIENT_FILE_NAME + '</span>' +
                    '<i class="close-btn">×</i>' +
                    '</div>';
                meditor.find("div.uploaded-file").append(template);
                meditor.addClass('open'); //NO I18N
            });
            this.set("attachSize", size); //NO I18N
            this.set("attachFileNames", attachMent); //NO I18N
            this.set("attachments", attachMent); //NO I18N
            if(!Ember.isEmpty("editorHeight"))
                {
                    var editorHeight =  self.get("editorHeight");
                    var toolBarHeight = (self.get("hideToolBar"))? 0 :self.get("defaultIconHeight");
                    var uploadFileDivHeight =  Ember.isEmpty(self.get("attachments")) ? 0 : self.$("#"+self.get("editorId")+" .uploaded-file").height();
                    var zeAreaHeight = editorHeight - toolBarHeight - uploadFileDivHeight;
                    self.$("#"+self.get("editorId")).find(".ze_area").css('height',zeAreaHeight); //No I18N
                }
        },
        saveAccessUrl: function(event)
        {
            var self=this; 
            var port = (this.get("ACCESS_URL_PROPS.PORT_NO")).toString(); //NO I18N
            var serverName = this.get("ACCESS_URL_PROPS.SERVER_NAME"); //NO I18N
            var selectedProtocol = this.get("ACCESS_URL_PROPS.PROTOCOL"); //NO I18N
            this.set("nameAlert",''); //NO I18N
            this.set("portAlert",''); //NO I18N
            this.set('AccessURLError','');//No I18N
            if(serverName == '' || serverName ==null)
            {
                this.set('AccessURLError',I18NUtil.translate('ads.rteditor.acc_url.alert.prox_server_name'));//No I18N
                this.set("nameAlert","has-alert-error"); //NO I18N
                event.stopPropagation();
            }else if(port =='' || port == null || !ValidationUtil.isValidNumber(port) || !ValidationUtil.isValidPort(port)){
                this.set('AccessURLError',I18NUtil.translate('ads.rteditor.acc_url.alert.prox_port_num'));//No I18N
                this.set("portAlert","has-alert-error"); //NO I18N
                event.stopPropagation();
            }
            
            else{
                var accessUrlSettings = {};
                accessUrlSettings['SERVER_NAME'] = serverName;
                accessUrlSettings['SERVER_PORT'] = port;
                accessUrlSettings['PROTOCOL'] = selectedProtocol; //NO I18N
                accessUrlSettings['PRODUCT_NAME'] = this.get("PRODUCT_NAME");//NO I18N
                var saveUrl = self.get("saveAccUrl"); //NO I18N
                AjaxUtil.ajax(saveUrl , {TYPE:'POST' , PARAMS : {'JUMPTO_SETTINGS': JSON.stringify(accessUrlSettings),'ACCESS_URL':true}}, false , 'json' ,true)//No I18N 
                .then(function(json)
                {
                    //If the Settings are correct update and backUp the editor property value
                    if('sSTATUS' in json){
                        var successData = JSON.parse(JSON.stringify(self.get("ACCESS_URL_PROPS"))); //NO I18N
                        self.set('ACCESS_URL_PROPS_BACKUP', successData); //NO I18N
                        self.set("accUrlProps",self.get("ACCESS_URL_PROPS")); //NO I18N
                    }
                    //If it fails in saving update the editor property with the backUp data
                    if('eSTATUS' in json){
                        var backupData = JSON.parse(JSON.stringify(self.get("ACCESS_URL_PROPS_BACKUP"))); //NO I18N
                        self.set("accUrlProps",backupData); //NO I18N
                    }

                });
                //Reset the input error status on saving the settings
                this.set("nameAlert",''); //NO I18N
                this.set("portAlert",''); //NO I18N
                this.set('AccessURLError','');//No I18N 
                
            }
        },
        toggleAccProtocol: function(params) {
            var selectedMethod = JSON.parse(params).columnValue;
            this.set('ACCESS_URL_PROPS.PROTOCOL', selectedMethod); //No I18N
        },
        openAccURL: function(){
            //On clicking the link if it has input error update the editor property with backup data.
            if(this.get("nameAlert") == "has-alert-error" || this.get("portAlert") == "has-alert-error" ) {//NO I18N
                this.set("accUrlProps",this.get('ACCESS_URL_PROPS_BACKUP')); //NO I18N
            }else{
                //Update backUp data for every time, whenever they clicks the link.
                this.set('ACCESS_URL_PROPS_BACKUP', JSON.parse(JSON.stringify(this.get("accUrlProps")))); //NO I18N
            }
            //Reset the input error status on clicking the link.
            this.set("nameAlert",''); //NO I18N
            this.set("portAlert",''); //NO I18N
            this.set('AccessURLError','');//No I18N 
        },
      previewAction : function () {
        this.sendAction("previewAction");//No I18N
      }
    }
});
