/* $Id $*/
//ignorei18n_start
import Ember from 'ember';
import AJAXUtil from '../utils/ads-ajax-util';
import I18N from '../utils/i18n-util';
import DialogUtil from "../utils/ads-dialog-util";

export default Ember.Component.extend({
	queryBoxes: [],
	machineDetails: {},
	pageStatus: {},
	record_per_page_options: [10, 25, 50, 100],
	sql_task_map:{},
	didInsertElement()
	{
		this._super(...arguments);
		var self = this;
		self.send('initData');
		self.send('getMachineDetails');
	},
	didRender: function ()
	{
		var self = this;
		this.send("adjustTableWidth");
	},
	validateQuery: function (query)
	{
		var self=this;
		var task = query.split(" ")[0].toUpperCase();
		var flag = true;
		var tempstr = query;
		tempstr = tempstr.toUpperCase();
		if (!tempstr.match(self.get("sql_task_map")[task]))
		{
			flag = false;
		}
		return flag;

	},
	executeRunQuery: function (query, start, range)
	{
		var data = {};
		data['QUERY']=query;
		data['start']=start;
		data['range']=range;
		return new Ember.RSVP.Promise(function (resolve, reject)
			{
				AJAXUtil.ajaxNoScroll('/RestAPI/WC/runQuery?mTCall=executeRunQuery', data)
					.then(function (result)
						{
							resolve(result);
						});
			});
	},
	actions: {
		initData: function ()
		{
			var self = this;
			this.get('queryBoxes').clear();
			this.send('addQueryBox');
			AJAXUtil.ajax('/RestAPI/WC/runQuery?mTCall=getRunQueryStatus')
				.then(function (result) {
					Ember.set(self, 'isEnabled', result.status);
				});
			Ember.set(self, 'threadDumpStatus', I18N.translate('ads.common.runquery.create_thread_dump'));
			Ember.set(self, 'heapDumpStatus', I18N.translate('ads.common.runquery.create_heap_dump'));
			Ember.set(self.get("sql_task_map"),"SELECT",/SELECT\s+\S+(\s\S+)*\s+(FROM)\s\D+/);
			Ember.set(self.get("sql_task_map"),"INSERT",/INSERT\s+(INTO)\s+\D+(VALUES)\D+/);
			Ember.set(self.get("sql_task_map"),"UPDATE",/UPDATE\s+[A-Z]+\s+(SET)\s+\D+/);
			Ember.set(self.get("sql_task_map"),"DELETE",/DELETE\s+(FROM)\s+[A-Z]+($|\s+(WHERE)\s+[A-Z]+)/);
		},
		addQueryBox: function ()
		{
			var len = this.get('queryBoxes').length;
			var lastid = 0;
			if (len != 0)
			{
				lastid = this.get('queryBoxes')[len - 1].id;
			}
			this.queryBoxes.pushObject({
				'id': lastid + 1,
				query: 'select * from adsproducts',
				loading: false,
				RECORD_PER_PAGE: 10,
				RECORD_PER_PAGE_OPTIONS: this.get('record_per_page_options')

			});
		},
		removeQueryBox: function (index)
		{
			this.get('queryBoxes').removeObject(this.get('queryBoxes')[index]);
			var len = this.get('queryBoxes').length;
			if (len == 0)
			{
				this.send('addQueryBox');
			}
		},
		executeQuery: function (index)
		{
			var self = this;
			var selectedQuery = "";
			var textAreaQuery = "";
			var query = "";
			var id = 'queryBox' + self.get('queryBoxes')[index].id;
			var textAreaQuery = Ember.$("#" + id).find('textarea').val();
			if (textAreaQuery == undefined || textAreaQuery.length < 1)
			{
				this.sendAction('showStatus','danger', I18N.translate('ads.common.runquery.query_box_empty'), true);
				return;
			}
			if (window.getSelection)
			{
				selectedQuery = window.getSelection().toString();
			}
			else if (document.selection && document.selection.type != "Control")
			{
				selectedQuery = document.selection.createRange().text;
			}
			if (selectedQuery.length <= 0)
			{
				query = textAreaQuery;
			}
			else
			{
				query = selectedQuery;
			}
			query = query.replace(";", "");
			query = query.trim();
			var task = query.split(" ")[0].toUpperCase();
			var flag = self.validateQuery(query);
			if (!flag)
			{
				var result = {};
				result['eSTATUS']=I18N.translate("ads.common.runquery.invalid_query");
				Ember.set(self.get('queryBoxes')[index], 'result', result);
				Ember.set(self.get('queryBoxes')[index], 'hasTable', false);
			}
			else
			{
				if (task == "DELETE")
				{
					Ember.set(self, 'queryid', id);
					Ember.set(self, "query", query);
					Ember.set(self, "queryindex", index);
					DialogUtil.confirm(self, I18N.translate("ads.common.runquery.delete_query_warning"), "deleteQuery", I18N.translate("ads.common.text.delete"));
				}
				else
				{
					self.send('execute', id, query, index);
				}
			}
		},
		execute: function (id, query, index)
		{
			var self = this;
			self.send('showLoading', index);
			var id = 'queryBox' + self.get('queryBoxes')[index].id;
			var range = self.get('queryBoxes')[index].RECORD_PER_PAGE;
			if (range == undefined || range.length < 1)
				range = 10;
			self.executeRunQuery(query, 0, range)
				.then(function (result)
					{
						self.send('setData', index, result, (-1 * parseInt(range)) + 1, range);
					});

		},

		changeRange: function (index, val)
		{
			var self = this;
			var id = 'queryBox' + self.get('queryBoxes')[index].id;
			self.send('showLoading', index);
			var start = self.get('queryBoxes')[index].start;
			var total = self.get('queryBoxes')[index].result.ROWS.NO_OF_ROWS;
			start = start - 1;
			if ((parseInt(start) + parseInt(val)) > parseInt(total))
			{
				start = total - val;
			}
			if (start < 0)
				start = 0;
			var range = val;
			var query = self.get('queryBoxes')[index].result.QUERY;
			self.executeRunQuery(query, start, range)
				.then(function (result) {
					self.send('setData', index, result, start - range + 1, range);
					Ember.set(self.get("queryBoxes")[index], 'RECORD_PER_PAGE', val);
				});

		},
		next: function (index)
		{
			var self = this;
			var id = 'queryBox' + self.get('queryBoxes')[index].id;
			var range = self.get('queryBoxes')[index].RECORD_PER_PAGE;
			var start = self.get('queryBoxes')[index].start;
			var total = self.get('queryBoxes')[index].result.ROWS.NO_OF_ROWS;
			if (parseInt(start) + parseInt(range) <= parseInt(total))
			{
				self.send('showLoading', index);
				start = start - 1;
				if ((parseInt(start) + parseInt(range)) >= total)
				{
					start = parseInt(total) - (2 * parseInt(range));
				}
				if (parseInt(start) + parseInt(range) < 0)
					start = -1 * parseInt(range);
				var query = self.get('queryBoxes')[index].result.QUERY;
				self.executeRunQuery(query, parseInt(start) + parseInt(range), range)
					.then(function (result)
						{
							self.send('setData', index, result, start + 1, range);
						});
			}
		},
		prev: function (index)
		{
			var self = this;
			var start = self.get('queryBoxes')[index].start;
			if (parseInt(start) != 1) {
				self.send('showLoading', index);
				start = start - 1;
				var id = 'queryBox' + self.get('queryBoxes')[index].id;
				var range = self.get('queryBoxes')[index].RECORD_PER_PAGE;
				if (start - range < 0)
					start = parseInt(range);
				var query = self.get('queryBoxes')[index].result.QUERY;
				self.executeRunQuery(query, start - range, range)
					.then(function (result) {
						self.send('setData', index, result, start - (2 * parseInt(range)) + 1, range);
					});
			}
		},
		last: function (index)
		{
			var self = this;
			var id = 'queryBox' + self.get('queryBoxes')[index].id;
			var total = self.get('queryBoxes')[index].result.ROWS.NO_OF_ROWS;
			var range = self.get('queryBoxes')[index].RECORD_PER_PAGE;
			var start = parseInt(total) - parseInt(range);
			start - 1;
			if (start < 0)
			{
				start = 0;
			}
			var query = self.get('queryBoxes')[index].result.QUERY;
			self.executeRunQuery(query, start, range)
				.then(function (result)
					{
						self.send('setData', index, result, start - (parseInt(range)) + 1, range);
					});

		},
		first: function (index)
		{
			var self = this;
			var start = 0;
			var id = 'queryBox' + self.get('queryBoxes')[index].id;
			var range = self.get('queryBoxes')[index].RECORD_PER_PAGE;
			var query = self.get('queryBoxes')[index].result.QUERY;
			self.executeRunQuery(query, start, range)
				.then(function (result)
					{
						self.send('setData', index, result, -1 * parseInt(range) + 1, range);
					});


		},
		setData: function (index, result, start, range)
		{
			var self = this;
			Ember.$(".fw-custom-scroll-hover").mCustomScrollbar("destroy");
			Ember.set(self.get('queryBoxes')[index], 'hasTable', false);
			self.send('hideLoading', index);
			start = start - 1;
			Ember.set(self, "curIndex", index);
			var id = 'queryBox' + self.get('queryBoxes')[index].id;
			var task = (result.hasOwnProperty("SQL_TASK")) ? result.SQL_TASK : "task";
			task = task.toLowerCase();
			task = task.charAt(0).toUpperCase() + task.slice(1);
			if (result.hasOwnProperty('ROWS_AFFECTED'))
			{
				result.sSTATUS = I18N.translate("ads.common.runquery.successfully_executed") + " " + task + " " + I18N.translate("ads.common.runquery.query");
				if (result.ROWS_AFFECTED == 0)
				{
					result.ROWS_AFFECTED = "(" + I18N.translate("ads.common.runquery.no_rows_affected") + " )";
				}
				else
				{
					result.ROWS_AFFECTED = "(" + I18N.translate("ads.common.runquery.no_of_rows_affected") + " " + result.ROWS_AFFECTED + " )";
				}
			}
			if (result.hasOwnProperty('ROWS'))
			{
				result.sSTATUS = I18N.translate("ads.common.runquery.successfully_executed") + " " + task + " " + I18N.translate("ads.common.runquery.query");
				if (result.ROWS.NO_OF_ROWS == 0)
				{
					result.ROWS_AFFECTED = "(" + I18N.translate("ads.common.runquery.no_rows_selected") + " )";
				}
				else
				{
					result.ROWS_AFFECTED = "(" + I18N.translate("ads.common.runquery.no_of_rows_selected") + " " + result.ROWS.NO_OF_ROWS + " )";
				}
				if ((result.ROWS.tabular).length < 1)
				{
					delete result.ROWS.header;
				}
				var totalRows = parseInt(result.ROWS.NO_OF_ROWS);
				Ember.set(self.get('queryBoxes')[index], 'total', totalRows);
				start = parseInt(start) + parseInt(range);
				var end = parseInt(start) + parseInt(range);
				if (totalRows > 0)
				{
					Ember.set(self.get('queryBoxes')[index], 'hasTable', true);
				}
				if (totalRows < end)
				{
					Ember.set(self.get('queryBoxes')[index], 'end', totalRows);
				}
				else
				{
					Ember.set(self.get('queryBoxes')[index], 'end', end);
				}
				Ember.set(self.get('queryBoxes')[index], 'start', start + 1);
			}
			else
			{
				Ember.set(self.get('queryBoxes')[index], 'hasTable', false);
			}
			Ember.set(self.get('queryBoxes')[index], 'result', result);
		},
		adjustTableWidth: function ()
		{
			if (Ember.$(".fw-custom-scroll-hover").length)
			{
				Ember.$(".fw-custom-scroll-hover").each(function ()
					{
						var theme = (Ember.$(this).attr("data-theme")) ?Ember.$(this).attr("data-theme") : "dark";
						var sPosition = (Ember.$(this).attr("data-scrollbar-position")) ?Ember.$(this).attr("data-scrollbar-position") : "inside";
						var axis = ($(this).attr("data-axis")) ? Ember.$(this).attr("data-axis") : "y";
						Ember.$(this).mCustomScrollbar({
							theme: theme,
							autoHideScrollbar: false,
							scrollbarPosition: sPosition,
							axis: axis,
							callbacks: {
								onScroll: function (evt)
								{
									return false;
								},
								onTotalScroll: function (evt)
								{
									return false;
								},
								onTotalScrollBack: function (evt)
								{
									return false;
								},
							}
						});
					});
			}
		},
		deleteQuery: function ()
		{
			var id = this.get('queryid');
			var quer = this.get("query");
			var index = this.get("queryindex");
			this.send('execute', id, quer, index);
		},
		getMachineDetails: function ()
		{
			var self = this;
			AJAXUtil.ajax('/RestAPI/WC/runQuery?mTCall=getMachineDetails')
				.then(function (result)
					{
						var len = result.rows.length;
						var firstColumn = Ember.A();
						var secondColumn = Ember.A();
						firstColumn = result.rows.slice(0, Math.ceil(len / 2));
						secondColumn = result.rows.slice(Math.ceil(len / 2), len);
						Ember.set(self.get('machineDetails'), 'firstColumn', firstColumn);
						Ember.set(self.get('machineDetails'), 'secondColumn', secondColumn);
						Ember.set(self,'isSuperAdmin',result.isSuperAdmin);
					});
		},
		createThreadDump: function ()
		{
			var self = this;
			if (Ember.$("#threadDump").hasClass("disabled"))
			{
				return;
			}
			Ember.set(self, 'threadDumpStatus', I18N.translate("ads.common.runquery.create_thread_dump") + '...');
			Ember.$("#threadDump").addClass("disabled");
			setTimeout(function ()
				{
					AJAXUtil.ajax("/RestAPI/WC/runQuery?mTCall=createThreadDump")
						.then(function (json) {
							Ember.set(self, 'threadDumpStatus', I18N.translate('ads.common.runquery.create_thread_dump'));
							if (json.eSTATUS!=undefined) {
								self.sendAction('showStatus',"danger",json.eSTATUS,false);
							}else{
							Ember.set(self, "created", I18N.translate("ads.common.runquery.thread_dump_success"));
                            self.send('showDownload');
                            }
							Ember.$("#threadDump").removeClass("disabled");
						});
				}, 1000);
		},
		createHeapDump: function ()
		{
			var self = this;
			if (Ember.$("#heapDump").hasClass("disabled"))
			{
				return;
			}
			Ember.set(self, 'heapDumpStatus', I18N.translate('ads.common.runquery.create_thread_dump') + '...');
			Ember.$("#heapDump").addClass("disabled");
			setTimeout(function ()
				{
					AJAXUtil.ajax("/RestAPI/WC/runQuery?mTCall=createHeapDump")
						.then(function (json) {
                            Ember.set(self, 'heapDumpStatus', I18N.translate('Create Heap Dump'));
                            if (json.eSTATUS!=undefined) {
								self.sendAction('showStatus',"danger",json.eSTATUS,false);
							}else{
							Ember.set(self, "created", I18N.translate("ads.common.runquery.heap_dump_success"));
                            self.send('showDownload');
                            }
							Ember.$("#heapDump").removeClass("disabled");
						});
				}, 1000);

		},
		getWidth: function ()
		{
			var self = this;
			var len=self.get("queryBoxes").length;
			for(var index=0;index<len;index++)
			{
				if(self.get("queryBoxes")[index]!=undefined)
				{
					var id = 'queryBox' + self.get('queryBoxes')[index].id;
					var wid = Ember.$("#" + id).find(".ad360-table").width();
					if (wid != 100)
					{
						Ember.set(self.get('queryBoxes')[index], 'width', wid);
					}
					else
					{
						var w = self.get('queryBoxes')[index].width;
						Ember.$("#" + id).find(".ad360-table").width(w);
					}
				}
			}
		},
		showDownload:function()
		{
			Ember.$("#runQueryalert").show();
			Ember.$("#runQueryalert").css("z-index", "0");
		},
		hideDownload: function ()
		{
			Ember.$("#runQueryalert").hide();
		},
		showLoading: function (index)
		{
			var self = this;
			Ember.set(self.get('queryBoxes')[index], 'loading', true);
		},
		hideLoading: function (index)
		{
			var self = this;
			Ember.set(self.get('queryBoxes')[index], 'loading', false);
		},
		getLog:function()
		{
			window.open("/RestAPI/WC/runQuery?mTCall=getLog");
		},
	}
});
//ignorei18n_start
