/* $Id: select-input.js,v 1.9.4.2 2018/12/03 17:58:41 ganesh.venkatraman Exp $ */
import Ember from 'ember';//NO I18N
import I18NUtil from "../utils/i18n-util"; //NO I18N
import CommonUtil from "../utils/ads-common-util"; //NO I18N
export default Ember.Component.extend
({
	tagName : 'select', //NO I18N
	className : 'selectpicker hiddenselect', //NO I18N
	classNameBindings : ['className'], //NO I18N
	attributeBindings : ['data-width','data-size','data-height','disabled','data-live-search','data-container', 'data-custom-maxheight', 'multiple', 'title', 'data-apply-button'], //NO I18N
	initialActions:function(){
        CommonUtil.renderSelect(this);
    }.on('init'), //No I18N
	didInsertElement : function()
	{
		var self = this;
		var selectText=I18NUtil.translate('ads.common.text.select_empty');//NO I18N
		if(self.get('selectText') !== undefined)
		{
			selectText=self.get('selectText'); //NO I18N
		}
		Ember.$(self.get('element')).selectpicker
		({
    			noneSelectedText:selectText,//NO I18N
				size:false,

  		});

		Ember.$(self.get('element')).selectpicker('val',this.get('selectedValue')); //NO I18N
		if (!self.get('multiple'))
		{
			Ember.$(self.get('element')).change(function()
			{
				var changeAction = self.get('changeAction'); //NO I18N
				var changedValue = Ember.$(this).find('option:selected').val();
				var changedText = Ember.$(this).find('option:selected').text();
				if(changeAction !=null && changeAction.indexOf("Confirm") > -1)
				{
					Ember.$(self.get('element')).selectpicker('val',self.get('selectedValue')); //NO I18N
				}
				else
				{
					self.set('selectedValue',changedValue); //NO I18N
				}

				if(changeAction !== 'setValueOnly')
				{
					Ember.run.scheduleOnce('afterRender',this,function() //NO I18N
					{
						self.sendAction('changeAction',changedText,changedValue,self.get('parent')); //NO I18N
					});
				}
			});

			Ember.run.scheduleOnce('afterRender',function(){ //NO I18N
				Ember.$(self.get('element')).on('changed.bs.select',function(e){//NO I18N
					//console.log(self.get('selectedValue'));
					//console.log($(e.target).val());
					self.set("bindVal",Ember.$(e.target).val()); //NO I18N
					//console.log(self.get('bindVal'));
				});
			});
		}
		else
		{
			Ember.run.scheduleOnce('afterRender', function() { //NO I18N
			Ember.$(self.get('element')).off('applyButton.bs.select').on('applyButton.bs.select', function(e) //No I18N
				{
					var values = [];
					var texts = [];
					Ember.$(this).find('option:selected').each(function() {
						values.push(Ember.$(this).val());
						texts.push(Ember.$(this).text());
					})
					self.sendAction("changeAction", texts, values); //NO I18N
				});
			});
		}		
	},

	willDestroyElement: function(){
		Ember.$(this.get('element')).selectpicker('destroy');//No i18n
		Ember.$(this.get('element')).off('.bs.select');//No i18n
		Ember.$(this.get('element')).off('change');//No i18n
	},

	onChange : function()
	{
		Ember.run.scheduleOnce('afterRender',this,function()//NO I18N
		{ 
			Ember.$(this.get('element')).selectpicker('refresh'); //NO I18N
			Ember.$(this.get('element')).selectpicker('val',this.get('selectedValue')); //NO I18N
		});
	}.observes('OPTIONS','disabled'), //NO I18N
	
	selectedValueChanged : function()
	{
		Ember.run.scheduleOnce('afterRender',this,function() //NO I18N
		{ 
			if(Ember.$(this.get('element')).selectpicker('val') !== this.get('selectedValue'))
			{
				Ember.$(this.get('element')).selectpicker('val',this.get('selectedValue')); //NO I18N
			}
		});		
	}.observes('selectedValue') //NO I18N
});