/*
 * $Id: smartcard-config.js,v 1.40.4.4 2019/01/03 01:07:01 antony.v Exp $
 */

//ignorei18n_start
import Ember from 'ember'; //NO I18N
import AJAXUtil from '../utils/ads-ajax-util'; //NO I18N
import I18NUtil from "../utils/i18n-util"; //NO I18N
import DialogUtil from "../utils/ads-dialog-util"; //NO I18N
import CommonUtil from "../utils/ads-common-util"; //NO I18N
import ValidationUtil from "../utils/ads-validation-util";
import StatusUtil from "../utils/status-util"; //NO I18N
import i18nUtil from '../utils/i18n-util';
export default Ember.Component.extend({
    pageStatus: {},
    selectedDomain: {},
    selectedCertMapping: '',
    selectedADMapping: '',
    oscpServerName: '',
    oscpPortNumber: '',
    currentSmartCardConfig: {},
    TABLE_PREVIEW_CONFIG: {
        "ROW_COUNT": 5,
        "START_COUNT": 1,
        "END_COUNT": 5,
        "PAGE": 1,
        "TOTAL_COUNT": 0
    },
    IS_ENABLED: true,
    IS_SSL_ENABLED: false,
    CERTIFICATE_ATTRIBUTES: [],
    AD_ATTRIBUTES: [],
    DOMAIN_LIST: [],
    SMARTCARD_PRODUCTS: [],
    // IS_PARENT_PRODUCT:false,
    getSettings: function() {
        var self = this;

        var data = {};
        CommonUtil.showLoading();
        AJAXUtil.ajax('/RestAPI/WC/SmartCard?mTCall=getSmartCardConfig', data).then(function(response) {
            var isEnabled = response.IS_ENABLED;
            var isSSLEnabled = response.IS_SSL_ENABLED;
            var isRestartNeeded = response.SMARTCARD_NEEDS_RESTART;
            var IS_PARENT_PRODUCT = response.IS_PARENT_PRODUCT;
            self.set("IS_PARENT_PRODUCT", IS_PARENT_PRODUCT);
            self.set('IS_SSL_ENABLED', isSSLEnabled);
            self.set('CERTIFICATE_ATTRIBUTES', response.MAPPING_ATTIBIUTES_IN_CERTIFICATE);
            self.set('AD_ATTRIBUTES', response.MAPPING_ATTIBIUTES_IN_AD);
            self.set("DEFAULT_AD_ATTRIBUTE",response.DEFAULT_MAPPING_ATTIBIUTES_IN_AD)
            self.set("DEFAULT_CERTIFICATE_ATTRIBUTE",response.DEFAULT_MAPPING_ATTIBIUTES_IN_CERTIFICATE)
            var domainList = response.DOMAIN_LIST;
            var smartCardList = response.SMARTCARD_LIST;
            Ember.run.schedule("afterRender", self, function() {
                self.setDomainValue(smartCardList, domainList);
            })
            var no_ssl_enabled = true;
            var SmartCardProducts = response.SMARTCARD_PRODUCTS;
            self.set("hasMultipleComponents", SmartCardProducts.length > 1);
            self.set("SMARTCARD_PRODUCTS", SmartCardProducts);
            self.set("PRODUCT_NAME", response.PRODUCT_NAME);
            var smartCardTotalCount = response.SMARTCARD_LIST_COUNT;
            if (smartCardTotalCount >= 1) {
                self.showSmartCardConfigTable();
            }
            var config = {};
            config.OPERATION = 'ADD';
            config.AD_MAPPING_ATTRIBUTE = response.DEFAULT_MAPPING_ATTIBIUTES_IN_AD;
            config.CRETIFICATE_MAPPING_ATTRIBUTE = response.DEFAULT_MAPPING_ATTIBIUTES_IN_CERTIFICATE;
            if (domainList.length === 1) {
                config.DOMAIN_VALUE = domainList[0].DISPLAY_NAME;
                domainList[0].IS_ENABLED = true;
            } else if (domainList.length === 0) {
                config.DOMAIN_VALUE = I18NUtil.translate('ads.admin.logon_settings.no_domains');
            }
            config.DOMAIN_LIST = domainList;
            config.SMARTCARD_PRODUCTS = SmartCardProducts;
            self.set('currentSmartCardConfig', config);
            var totalCount = smartCardTotalCount;
            var domainLists = {};
            domainLists[response.PRODUCT_NAME] = response.DOMAIN_LIST;
            var datas = Ember.A();
            datas.push(smartCardList);
            Ember.run.schedule('afterRender', this, function() {
                domainLists[response.PRODUCT_NAME] = domainList;
                if (response.INTEGRATED_PRODUCT_DETAILS != undefined) {
                    for (var key = 0; key < response.INTEGRATED_PRODUCT_DETAILS.length; key++) {
                        var smartCardList={};
                        smartCardList = response.INTEGRATED_PRODUCT_DETAILS[key].SMARTCARD_LIST;
                        self.setDomainValue(smartCardList, response.INTEGRATED_PRODUCT_DETAILS[key].DOMAIN_LIST);
                        domainLists[response.INTEGRATED_PRODUCT_DETAILS[key].PRODUCT_NAME] = response.INTEGRATED_PRODUCT_DETAILS[key].DOMAIN_LIST;
                        if(response.INTEGRATED_PRODUCT_DETAILS[key].PRODUCT_NAME=='ADManager Plus'){
                           for(var i=0;i<smartCardList.length;i++){
                               smartCardList[i].IS_ADMP=true;
                           }
                        }
                        datas.push(smartCardList);
                    }
                }
                var smartCards = self.get("SMARTCARD_PRODUCTS");
                for (var j = 0; j < smartCards.length; j++) {
                    if (smartCards[j].IS_SSL_ENABLED) {
                        no_ssl_enabled = false;
                        break;
                    }
                }

                self.set("DOMAIN_LIST", domainLists);
                self.set("NO_SSL_ENABLED", no_ssl_enabled);
                var res = Array.prototype.concat.apply([], datas);
                self.set("TABLE_DATA", res);
                totalCount = res.length;
                self.set("TOTAL_SMARTCARD_COUNT", totalCount);
                if (totalCount === 0) //No Smart Card config
                {
                    self.set('SMARTCARD_LIST', smartCardList);
                    self.showSmartCardConfigForm();

                    if (no_ssl_enabled === true) {
                        Ember.run.schedule("afterRender", this, function() {
                            self.overlayStatus('smartCardConfig', 'disable');
                            $('#SMART_CARD_ALERT').removeClass("hide");
                            $('#SMART_CARD_ALERT').show();
                        });

                    } else {
                        $('#SMART_CARD_ALERT').hide();

                    }
                    if (domainList.length === 0) {
                        self.overlayStatus('smartCardConfig', 'disable');
                        self.sendAction('showStatus', 'warning', I18NUtil.translate('ads.admin.logon_settings.no_domain_configured'), false);
                    }
                } else {
                    self.set('IS_ENABLED', isEnabled);
                    self.showSmartCardConfigTable();
                    if (no_ssl_enabled == true) {
                        $('.sca-checkbox-ovrlay').addClass("disable");
                        self.overlayStatus('smartCardConfigTable', 'disable');
                        $('#SMART_CARD_ALERT').show();
                    } else {
                        self.overlayStatus('smartCardConfigTable', 'enable');
                        $('#SMART_CARD_ALERT').hide();

                    }

                    if (domainList.length === 0) {
                        self.sendAction('showStatus', 'warning', I18NUtil.translate('ads.admin.logon_settings.no_domain_configured'), false);
                    } else if (isRestartNeeded == true && self.get('isNewConfig') !== true&&isSSLEnabled) {
                        self.sendAction('showStatus', 'warning', I18NUtil.translate('ads.admin.logon_settings.smartcard_settings.restart_product_for_smartcard_changes_to_reflect'), false);
                    }
                }
                Ember.run.schedule("afterRender", self, function() {
                    self.send('sortByCompName', 'sortIcon1', 'PRODUCT_NAME');
                })

                self.resetSearch();
            });
            CommonUtil.hideLoading();

        });
    }.on('init'),
    validateSearchData(data) {
        if (data.hasOwnProperty("SEARCH_COMPONENT_NAME") && data.SEARCH_COMPONENT_NAME != "") {
            return true;
        }
        if (data.hasOwnProperty("SEARCH_CERTIFICATE") && data.SEARCH_CERTIFICATE != "") {
            return true;
        }
        if (data.hasOwnProperty("SEARCH_LINKED_DOMAINS") && data.SEARCH_LINKED_DOMAINS != "") {
            return true;
        }

        return false;
    },
    didRender: function() {
        var self = this;
        CommonUtil.renderTooltip();
        Ember.run.schedule("afterRender", self, function() {
            Ember.$(".ssl-tooltip").append("<div class=\"tooltip fade right in target fw-ml-15 fw-mt-m10\" role=\"tooltip\" ><div class=\"tooltip-arrow\" style=\"top: 48%;\"></div><div class=\"tooltip-inner\" style=\"min-width:220px;max-width:220px;\">"+I18NUtil.translate("ads.admin.logon_settings.smartcard_settings.ssl_must_be_enabled")+"<a class=\"fg-white\" href=\"#/admin/ssltool\"><u>"+I18NUtil.translate('ads.admin.logon_settings.smartcard_settings.click_here')+"</u></a></div></div>");
            Ember.$(".smartCard-disabled").append("<div class=\"tooltip fade right in target fw-ml-15 fw-mt-m10\" role=\"tooltip\" ><div class=\"tooltip-arrow\" style=\"top: 50%;\"></div><div class=\"tooltip-inner\" style=\"min-width:220px;max-width:220px;\">"+I18NUtil.translate("ads.admin.logon_settings.smartcard_settings.tooltip_admp_disabled")+"</div></div>");
            Ember.$(".admp-cancel").append("<div class=\"tooltip fade right in target fw-ml-15 fw-mt-m10\" role=\"tooltip\" ><div class=\"tooltip-arrow\" style=\"top: 40%;\"></div><div class=\"tooltip-inner\" style=\"min-width:220px;max-width:220px;\">"+I18NUtil.translate("ads.admin.logon_settings.smartcard_settings.tooltip_admp_disable")+"</div></div>");

        })
        Ember.$(".clearSearch").tooltip({
            placement:"left",
            title:i18nUtil.translate("ads.common.text.clear_search"),
            container:"body",
            html:true
        })

       Ember.$("#SmartCardForm").on("keypress",function(e) {
            var key = e.charCode || e.keyCode || 0;
            if (key == 13) {
              e.preventDefault();
            }
          });


    },
    resetSearch: function() {
        var smartCards = this.get("SMARTCARD_PRODUCTS");
        for (var i = 0; i < smartCards.length; i++) {
            Ember.set(smartCards[i], "IS_ENABLED", false);
        }
        Ember.set(this, "SMARTCARD_PRODUCTS", smartCards);
        this.set("SEARCH_COMPONENT_NAME", '');
        this.set("SEARCH_CERTIFICATE", '');
        this.set("SEARCH_EXPIRES_ON", '');
        this.set("SEARCH_LINKED_DOMAINS", '');
        Ember.set(this, "SEARCH_QUERY", {});
        this.resetSort();
    },
    getProductDetails: function(prodID) {
        let details;
        let products = this.get("SMARTCARD_PRODUCTS");
        for (var i = 0; i < products.length; i++) {
            if (products[i].PRODUCT_ID == prodID) {
                details = products[i];
                break;
            }
        }
        return details;
    },

    getSerchQuery: function() {
        var data = {};
        var componentName = this.get('SEARCH_COMPONENT_NAME');
        if (componentName !== undefined && componentName !== '') {
            var stripedHtml = $("<div>").html(componentName).text();
            data.SEARCH_COMPONENT_NAME = stripedHtml;
        }
        var certficateName = this.get('SEARCH_CERTIFICATE');
        if (certficateName !== undefined && certficateName !== '') {
            var stripedHtml = $("<div>").html(certficateName).text();
            data.SEARCH_CERTIFICATE = stripedHtml;
        }
        var linkedDomains = this.get('SEARCH_LINKED_DOMAINS');
        if (linkedDomains !== undefined && linkedDomains !== 'none') {
            var stripedHtml = $("<div>").html(linkedDomains).text();
            data.SEARCH_LINKED_DOMAINS = stripedHtml;
        }
        return data;
    },
    getProducts: function() {
        var productList = this.get("SMARTCARD_PRODUCTS");
        var products = Ember.A();
        for (var k = 0; k < productList.length; k++) {
            products.push(productList[k].PRODUCT_ID);
        }
        return products;
    },
    getDomainList: function(productName) {
        var domains = this.get("DOMAIN_LIST");
        return domains[productName];
    },
    getProductName: function(prodID) {
        var productList = this.get("SMARTCARD_PRODUCTS");
        var productName = null;
        for (var i = 0; i < productList.length; i++) {
            if (prodID == productList[i].PRODUCT_ID) {
                productName = productList[i].DISPLAY_NAME;
            }
        }
        return productName;
    },
    resetSort: function() {
        var sortData=this.get("SORT_DATA");
        if(sortData!=undefined){
            if( this.$("#" + sortData.ID).hasClass("glyphicon glyphicon-triangle-bottom")){
                this.$("#" + sortData.ID).removeClass("glyphicon glyphicon-triangle-bottom");
                }else{
                this.$("#" + sortData.ID).removeClass("glyphicon glyphicon-triangle-top");
                }
        }
        Ember.set(this,"SORT_DATA",undefined);
    },
    resetTableSettings: function(productList) {
        var self = this;
        Ember.set(self, "NO_DATA",false);
        Ember.$("#scaTable").css("min-height","0px");
        if (productList == undefined) {
            productList = this.getProducts();
        }
        var smartCardList = Ember.A();
        var tempArray = Ember.A();
        var counter = 0;

        if (productList.length >= 1) {
            CommonUtil.showLoading();
            $.each(productList, function(i, item) {
                var prodID = productList[i];
                var productDetails = self.getProductDetails(prodID);
                var domains = self.getDomainList(self.getProductName(prodID));
                var data = self.getSerchQuery();
                var no_ssl_enabled = true;
                // console.log(data)
                var TABLE_PREVIEW_CONFIG = {};
                data.PRODUCT_ID = prodID;
                var response=AJAXUtil.syncAjax('/RestAPI/WC/SmartCard?mTCall=getSmartCardTableConfig', data);
                    var temp = response.hasOwnProperty('SMARTCARD_LIST')?response.SMARTCARD_LIST:undefined;
                    if(prodID==2&&temp!=undefined){
                        for(var k=0;k<temp.length;k++){
                            temp[k].IS_ADMP=true;
                        }
                    }
                    var is_running = response.hasOwnProperty("IS_RUNNING")?response.IS_RUNNING:false;
                    counter++;
                    Ember.set(productDetails, "IS_RUNNING",is_running);
                    if (temp != undefined && temp.length !== 0) //No Smart Card config
                    {
                        self.setDomainValue(temp, domains);
                        tempArray.push(temp);

                    }
                    if (productDetails.IS_RUNNING && productDetails.IS_SSL_ENABLED) {
                        no_ssl_enabled = false;
                    }
                    if (counter == productList.length) {
                        CommonUtil.hideLoading();
                        smartCardList = Array.prototype.concat.apply([], tempArray);
                        self.set("TABLE_DATA", smartCardList);
                        var totalCount = smartCardList.length;
                        self.set("TOTAL_SMARTCARD_COUNT", totalCount);
                           if(self.get("TOTAL_SMARTCARD_COUNT")<=0){
                            Ember.set(self, "NO_DATA",true);
                            Ember.$("#scaTable").css("min-height","200px");
                        }
                        Ember.run.schedule("afterRender", self, function() {
                           // self.resetSort();
                           var sortData=self.get("SORT_DATA");
                           if(sortData!=undefined){
                               sortData.ASCENDING=!sortData.ASCENDING;
                            self.send('sortByCompName', sortData.ID, sortData.FILTER);
                           }else{
                            self.send('sortByCompName', 'sortIcon1', 'PRODUCT_NAME');
                           }
                        })

                        CommonUtil.afterRender();
                    }
                });
        } else {
            Ember.set(self, "TABLE_DATA", Ember.A());
            Ember.set(self, "NO_DATA",true);
            Ember.$("#scaTable").css("min-height","200px");
            Ember.set(self, "TOTAL_SMARTCARD_COUNT", 0);
        }

    },
    showSmartCardConfigForm: function() {
        this.set("SHOWFORM", true);
        CommonUtil.renderScrollBar();
        $('#CERTIFICATE_PATH .file-upload-input').val(''); //Resetting input file value
        $('#CERTIFICATE_PATH .file-upload-placeholder').val(I18NUtil.translate('ads.admin.logon_settings.smartcard_settings.browse_certificate_placeholder')); //Resetting input file value

    },
    overlayStatus: function(id, status) {
         Ember.run.schedule("afterRender",function(){
                if (status === 'disable') {
                    Ember.$("#" + id).find(".sca-ovrlay").addClass('disable');
                } else {
                    Ember.$("#" + id).find(".sca-ovrlay").removeClass('disable');
                }
            });
    },
    showSmartCardConfigTable: function() {
        this.set("SHOWFORM", false);

    },
    linkedDomainChange: function() {
        var smartCardList = this.get('SMARTCARD_LIST');
        Ember.run.scheduleOnce('afterRender', this, function() {
            for (var i = 0; i < smartCardList.length; i++) {
                var list = smartCardList[i];
                if ($('#' + list.SMARTCARD_ID)[0].scrollWidth > $('#' + list.SMARTCARD_ID).innerWidth()) {
                    $('#' + list.SMARTCARD_ID).css({
                        "pointer-events": "auto"
                    });
                } else {
                    $('#' + list.SMARTCARD_ID).css({
                        "pointer-events": "none"
                    });
                }
            }
        });
    }.observes('SMARTCARD_LIST.@each.LINKED_DOMAINS,SMARTCARD_LIST'),
    validateSmartCardConfig: function(smartCardConfig, operation) {
        var self = this;
        var selectedDomains = {};
        var domainList = smartCardConfig.DOMAIN_LIST;
        for (var i = 0; i < domainList.length; i++) {
            var details = domainList[i];
            if (details.IS_ENABLED) {
                selectedDomains[details.ID] = details.ID;
            }
        }
        var oscpServerName = smartCardConfig.OCSP_SERVER_NAME;
        var oscpServerPort = smartCardConfig.OCSP_SERVER_PORT;
        var certificateFile = $.trim($('#SmartCardForm [name="CERTIFICATE_PATH"]').val());
        var uploadedFileName = certificateFile.substring(certificateFile.lastIndexOf("\\") + 1, certificateFile.lastIndexOf('.'));
        var checkFile = certificateFile.split('.').pop();
        var checkDot = certificateFile.split(".");
        if (operation === 'ADD' && (checkDot === certificateFile || checkFile !== 'cer')) {
            DialogUtil.alert(self, I18NUtil.translate('ads.admin.logon_settings.smartcard_settings.alert_choose_valid_certificate')); //No I18N
            return false;
        } else if (uploadedFileName.match('^[a-zA-Z0-9\-_ ]{0,255}$') == null) {
            DialogUtil.alert(self, I18NUtil.translate('ads.admin.logon_settings.smartcard_settings.invalid_filename')); //No I18N
            return false;
        } else if (Object.keys(selectedDomains).length === 0) {
            DialogUtil.alert(self, I18NUtil.translate('ads.admin.logon_settings.smartcard_settings.alert_no_domain_selected')); //No I18N
            return false;
        } else if (oscpServerPort !== undefined && oscpServerPort !== '' && (oscpServerName === undefined || oscpServerName === '')) {
            DialogUtil.alert(self, I18NUtil.translate('ads.admin.logon_settings.smartcard_settings.alert_enter_valid_oscp_server_name')); //No I18N
            return false;
        } else if (oscpServerName !== undefined && oscpServerName !== '' && (oscpServerPort === undefined || !ValidationUtil.isValidPort(oscpServerPort))) {
            DialogUtil.alert(self, I18NUtil.translate('ads.admin.logon_settings.smartcard_settings.alert_enter_valid_oscp_server_port')); //No I18N
            return false;
        } else if (self.get("hasMultipleComponents") && smartCardConfig.SMARTCARD_PRODUCT_LIST != undefined && smartCardConfig.SMARTCARD_PRODUCT_LIST === "") {
            DialogUtil.alert(self, I18NUtil.translate('select atleast one component')); //No I18N
            return false;

        }
        return true;
    },

    getComponentID: function(productName) {
        var products = this.get("SMARTCARD_PRODUCTS");
        var prodId = null;
        for (var i = 0; i < products.length; i++) {
            if (products[i].DISPLAY_NAME == productName.trim()) {
                prodId = products[i].PRODUCT_ID;
                break;
            }
        }
        return prodId;

    },
    setDomainValue: function(smartCardList, domains) {
        var domainList = domains != undefined ? domains : undefined;
        for (var i = 0; i < smartCardList.length; i++) {
            var smartCardDetails = smartCardList[i];
            var linkedDomains = smartCardDetails.LINKED_DOMAINS;
            var dataHeight = linkedDomains.length <= 5 ? (linkedDomains.length * 30) : 150;
            Ember.set(smartCardDetails, 'LINKED_DOMAINS_DATA_HEIGHT', dataHeight + "px");
            var linkedDomainsDisplayName = [];
            if(domainList!=undefined){
            for (var j = 0; j < domainList.length; j++) {
                var details = domainList[j];
                if (linkedDomains.contains(details.DOMAIN_DNS_NAME) || linkedDomains.contains(details.ID)) {
                    linkedDomainsDisplayName[linkedDomainsDisplayName.length] = details.DOMAIN_DNS_NAME;
                }
            }
        }else{
            linkedDomainsDisplayName=linkedDomainsDisplayName.concat(linkedDomains);
        }
            Ember.set(smartCardDetails, 'LINKED_DOMAINS_DISPLAY_NAME', linkedDomainsDisplayName);
            smartCardList[i] = smartCardDetails;
        }
    },
    actions: {
        enableSmartCard: function() {
            var self = this;
            var smartcardList;
            var isEnabled = self.get('IS_ENABLED');
            var data = {};
            data.IS_ENABLED = isEnabled;
            var parentProductName = this.get("PARENT_PRODUCT_NAME");
            if (self.get("IS_PARENT_PRODUCT")) {
                var productDetails = self.getProductDetails(parentProductName);
                smartcardList = productDetails.SMARTCARD_LIST;
            } else {
                smartcardList = self.get("SMARTCARD_LIST");
            }
            AJAXUtil.ajaxNoScroll('/RestAPI/WC/SmartCard?mTCall=enableDisableSmartCard', data).then(function(response) {
                if ('sSTATUS' in response) {
                    var isRestartNeeded = response.SMARTCARD_NEEDS_RESTART;
                    var is_anyconfig_enabled = response.IS_ANYCONFIG_ENABLED != undefined ? response.IS_ANYCONFIG_ENABLED : true;
                    if (is_anyconfig_enabled == false && isEnabled == true) {
                        self.sendAction('showStatus', 'warning', I18NUtil.translate('ads.admin.logon_settings.smartcard_settings.configure_atleast_one'), false);
                    }
                    if (isRestartNeeded === true) {
                        self.sendAction('showStatus', 'warning', I18NUtil.translate('ads.admin.logon_settings.smartcard_settings.restart_product_for_smartcard_changes_to_reflect'), false);
                    }
                    if (isEnabled === true) {
                        self.overlayStatus('smartCardConfigTable', 'enable');
                    } else {
                        self.overlayStatus('smartCardConfigTable', 'disable');
                    }
                }
            });
        },
        toggle: function(id) {
            this.$('#' + id).toggle();
        },
        saveConfig: function(smartCardConfig) {
            var self = this;
            var selectedDomains = {};
            var selectedProducts = [];
            var productList = smartCardConfig.SMARTCARD_PRODUCTS;
            if (!this.get("hasMultipleComponents")) {
                selectedProducts.push(productList[0].PRODUCT_ID);
                 productList[0].IS_ENABLED=true;
            } else {
                for (var i = 0; i < productList.length; i++) {
                    var product = productList[i];
                    if (product.IS_ENABLED) {
                        selectedProducts.push(product.PRODUCT_ID);
                    }
                }
            }

            Ember.set(smartCardConfig, "SMARTCARD_PRODUCT_LIST", selectedProducts.toString());
            let alreadyChecked = false;
            var domainList = smartCardConfig.DOMAIN_LIST;
            for (var i = 0; i < domainList.length; i++) {
                var details = domainList[i];
                if (details.IS_ENABLED) {
                    selectedDomains[details.DOMAIN_DNS_NAME] = details.DOMAIN_DNS_NAME;
                }
            }
            smartCardConfig.LINKED_DOMAINS = selectedDomains;
            smartCardConfig.UPLOAD_TYPE = "FILE";
            this.$('#SMARTCARD_CONFIG').val(JSON.stringify(smartCardConfig));

            if (this.validateSmartCardConfig(smartCardConfig, 'ADD')) {
                CommonUtil.showLoading();
                this.$('[id="SmartCardForm"]').submit();
                this.$('#SmartCardIFrame').load(function(responseData) {
                    CommonUtil.hideLoading();
                    let responseHtml=Ember.$("#SmartCardIFrame").contents().find("body").text();
                    let response={};
                    try {
                        response = Ember.$.parseJSON(responseHtml);
                    } catch (e) {
                        AJAXUtil.handleSessionTimeout("403", responseHtml);
                    }

                    if (response.hasOwnProperty('ERROR_CODE') && response.ERROR_CODE == '00000014') {
                        self.sendAction('showStatus', 'danger', I18NUtil.translate('ads.common.error.demo_mode'), false);
                        return
                    }
                    var statusMessage = [];
                    var failureFlag = false;
                    var successFlag = false;
                    if (response.hasOwnProperty("eSTATUS")) {
                        var temp = {};
                        temp.value = i18nUtil.translate(response.eSTATUS);
                        if (selectedProducts.length == 1) {
                            temp.key = self.getProductName(selectedProducts[0]);
                        }
                        statusMessage.push(temp);
                        failureFlag = true;
                    } else {
                        if (productList != undefined) {
                            for (var i = 0; i < productList.length; i++) {
                                var tempFlag = false;
                                var product = productList[i];
                                if (product.IS_ENABLED) {
                                    var status = {};
                                    var element;
                                    if (response[product.DISPLAY_NAME] != undefined) {
                                        element = response[product.DISPLAY_NAME];
                                        status.key = product.DISPLAY_NAME;
                                        if (element.hasOwnProperty("eSTATUS")) {
                                            tempFlag = true;
                                            failureFlag = true;
                                            status.key = product.DISPLAY_NAME;
                                            var reason = i18nUtil.translate(element.eSTATUS);
                                            if (element.hasOwnProperty("PARAMS")) {
                                                var dArray = element.PARAMS;
                                                if (productList.length == 1) {
                                                    reason = reason.replace("{0}", product.DISPLAY_NAME);
                                                } else {
                                                    reason = reason.replace("{0}", "");
                                                }
                                                reason = reason.replace("{1}", "");
                                                status.hasDomainError = true;
                                                status.ERROR_DOMAINS = dArray;
                                                status.ERROR_DOMAIN = dArray.objectAt(0);
                                            }
                                            status.value = reason;
                                            if(element.hasOwnProperty("sSTATUS")){//for linked domain partial failure case
                                                successFlag=true;
                                            }

                                        } else if(element.hasOwnProperty("sSTATUS")) {
                                            status.value = I18NUtil.translate(element.sSTATUS);
                                            successFlag = true;
                                        }

                                        statusMessage.push(status);
                                    }
                                }
                            }
                        }
                    }

                    if (statusMessage.length >= 1 && failureFlag) {
                        if(!alreadyChecked){
                        Ember.set(self, "smartcardStatus", statusMessage);
                        if (statusMessage.length == 1 && selectedProducts.length > 1) {
                            StatusUtil.showStatusWithMessage(self, "danger", statusMessage[0].value, false);
                        } else {
                            if (successFlag) {
                                Ember.set(self, "partiallyFailed", I18NUtil.translate('ads.admin.logon_settings.smartcard_settings.partially_failed'));
                                Ember.run.schedule("afterRender", self, function() {
                                    StatusUtil.showStatusWithMessage(self, 'warning', Ember.$('#smartCardFailuremsg').html(), false);
                                })

                            } else {
                                Ember.set(self, "partiallyFailed", I18NUtil.translate('ads.admin.logon_settings.smartcard_settings.completely_failed'));
                                Ember.run.schedule("afterRender", self, function() {
                                    StatusUtil.showStatusWithMessage(self, 'danger', Ember.$('#smartCardFailuremsg').html(), false);
                                });
                            }


                        }
                        alreadyChecked=true;
                    }
                    } else if (failureFlag) {
                        self.sendAction('showStatus', 'danger', I18NUtil.translate(response.eSTATUS), false);
                    }


                    if (successFlag) {
                         Ember.run.schedule("afterRender",function(){
                                self.resetTableSettings(undefined);
                                self.showSmartCardConfigTable();
                                self.resetSearch();
                                alreadyChecked = true;

                           if(!failureFlag&&successFlag){
                        self.sendAction('showStatus', 'success', I18NUtil.translate('ads.admin.logon_settings.smartcard_settings.successfully_added_smartcard'), true);
                        }
                    });

                    }
                    return;
                });
            }
        },
        uploadCertificateFile: function() {
            var certificatePath = this.$('[name="CERTIFICATE_PATH"]').val().split('\\').pop();
            if (certificatePath.length > 20) {
                certificatePath = certificatePath.substring(0, 20) + "...";
            }
            this.$('#CERTIFICATE_PATH .file-upload-placeholder').val(certificatePath);
        },
        cancelConfig: function() {
            var smartCardListCount = this.get('TOTAL_SMARTCARD_COUNT');
                var products = this.getProducts();
                this.resetSearch();
                this.resetTableSettings(products);
                smartCardListCount = this.get('TOTAL_SMARTCARD_COUNT');
                if (smartCardListCount > 0) {
                    this.showSmartCardConfigTable();
                } else {
                    this.showSmartCardConfigForm();
                }
        },
        addConfig: function() {
            var self = this;
            var config = {};
            var domList = self.getDomainList(self.get("PRODUCT_NAME"));
            var smartCardProducts = self.get("SMARTCARD_PRODUCTS");
            for (var k = 0; k < smartCardProducts.length; k++) {
                Ember.set(smartCardProducts[k], "IS_ENABLED", false);
            }

            var domainList = domList;
            var dList = [];
            config.OPERATION = 'ADD';
            config.AD_MAPPING_ATTRIBUTE = self.get("DEFAULT_AD_ATTRIBUTE");
            config.CRETIFICATE_MAPPING_ATTRIBUTE = self.get("DEFAULT_CERTIFICATE_ATTRIBUTE");

            if (domainList.length === 1) {
                config.DOMAIN_VALUE = domainList[0].DISPLAY_NAME;
                domainList[0].IS_ENABLED = true;
            }else{
                for(var i=0;i<domainList.length;i++){
                    domainList[i].IS_ENABLED=false;
                }
            }
            config.DOMAIN_LIST = domainList;

            if (smartCardProducts != undefined) {
                config.SMARTCARD_PRODUCTS = smartCardProducts;
            }


            Ember.set(self, 'currentSmartCardConfig', config);
            this.showSmartCardConfigForm();
        },
        editConfig: function(config) {
            var productName = config.PRODUCT_NAME;
            var domList = this.getDomainList(productName);
            var domainList = Ember.$.extend(true, [], domList);
            if (domainList.length === 1) {
                config.DOMAIN_VALUE = domainList[0].DISPLAY_NAME;
                domainList[0].IS_ENABLED = true;
                Ember.set(config, 'DOMAIN_LIST', domainList);
            } else {
                domainList = Ember.$.extend(true, [], domainList);
                var linkedDomainsList = [];
                var linkedDomains = config.LINKED_DOMAINS;
                for (var i = 0; i < domainList.length; i++) {
                    var domainDetails = domainList[i];
                    var domainName = domainDetails.DOMAIN_DNS_NAME;
                    domainDetails.DISPLAY_NAME = domainDetails.DOMAIN_DNS_NAME;
                    if (linkedDomains.contains(domainName)) {
                        Ember.set(domainDetails, 'IS_ENABLED', true);
                    } else {
                        Ember.set(domainDetails, 'IS_ENABLED', false);
                    }
                    linkedDomainsList[linkedDomainsList.length] = domainDetails;
                }
                Ember.set(config, 'DOMAIN_LIST', linkedDomainsList);
            }
            if (productName != undefined) {
                Ember.set(config, "PRODUCT_NAME", productName);
            }
            Ember.set(config, 'OPERATION', 'UPDATE');
            var certificateFileName = config.CERTIFICATE_FILE_NAME;
            if (certificateFileName.length > 20) {
                certificateFileName = certificateFileName.substring(0, 20) + "...";
            }
            Ember.set(config, 'CERTIFICATE_FILE_NAME', certificateFileName);
            Ember.set(this, 'currentSmartCardConfig', config);
            this.showSmartCardConfigForm();
        },
        updateConfig: function(smartCardConfig) {
            var self = this;
            var selectedDomains = {};
            var data = {};
            var domainList = smartCardConfig.DOMAIN_LIST;
            for (var i = 0; i < domainList.length; i++) {
                var details = domainList[i];
                if (details.IS_ENABLED) {
                    selectedDomains[details.DOMAIN_DNS_NAME] = details.DOMAIN_DNS_NAME;
                }
            }
            Ember.set(smartCardConfig, "PRODUCT_ID", this.getComponentID(smartCardConfig.PRODUCT_NAME));
            Ember.set(smartCardConfig, 'IS_ENABLED', true);
            Ember.set(smartCardConfig, 'LINKED_DOMAINS', selectedDomains);
            if (this.validateSmartCardConfig(smartCardConfig, 'UPDATE')) {
                CommonUtil.showLoading();
                data.UDPATE_SMARTCARD_CONFIG = JSON.stringify(smartCardConfig);
                AJAXUtil.ajax('/RestAPI/WC/SmartCard?mTCall=updateSmartCardConfig', data).then(function(response) {
                    CommonUtil.hideLoading();
                    if ('sSTATUS' in response) {
                        self.sendAction('showStatus', 'success', I18NUtil.translate(response.sSTATUS), true);
                        Ember.set(smartCardConfig, 'IS_ENABLED', true);
                        self.resetSort();
                        self.resetTableSettings();
                        self.showSmartCardConfigTable();
                    } else if ('eSTATUS' in response) {
                        self.sendAction('showStatus', 'danger', I18NUtil.translate(response.eSTATUS), false);
                    }
                });
            }
        },
        enableDisableConfig: function(smartCardConfig) {
            var self = this;
            var smartcardList;
            var isEnabled = smartCardConfig.IS_ENABLED;
            var data = {};
            data.IS_ENABLED = !isEnabled;
            data.SMARTCARD_ID = smartCardConfig.SMARTCARD_ID;
            if (smartCardConfig.PRODUCT_NAME != undefined) {
                data.PRODUCT_ID = self.getComponentID(smartCardConfig.PRODUCT_NAME);
            }
            if (smartCardConfig.IS_ADMP) {
                data.IS_ENABLED = true;
                AJAXUtil.ajaxNoScroll('/RestAPI/WC/SmartCard?mTCall=enableDisableSmartCard', data).then(function(response) {
                    if ('sSTATUS' in response) {
                        self.resetTableSettings();
                    }
                    if ('eSTATUS' in response) {
                        StatusUtil.showStatusWithMessage(self, 'danger', I18NUtil.translate(response.eSTATUS), false);
                    }

                });
            } else {
                AJAXUtil.ajaxNoScroll('/RestAPI/WC/SmartCard?mTCall=enableDisableSmartCardConfig', data).then(function(response) {
                    if ('sSTATUS' in response) {
                        Ember.set(smartCardConfig, 'IS_ENABLED', !isEnabled);
                        StatusUtil.showStatusWithMessage(self, 'success', I18NUtil.translate(response.sSTATUS), true);
                        Ember.set(self, 'IS_ENABLED', response.IS_ANYCONFIG_ENABLED != undefined ? response.IS_ANYCONFIG_ENABLED : false);
                    }
                    if ('eSTATUS' in response) {
                        StatusUtil.showStatusWithMessage(self, 'danger', I18NUtil.translate(response.eSTATUS), false);
                    }
                });
            }
        },

        deleteConfirmation: function(smartCardConfig, productName) {
            this.set('deleteSCConfig', smartCardConfig);
            DialogUtil.confirm(this, 'ads.admin.general.smartcard.alert_del_field', 'deleteConfig', 'ads.common.text.translation.yes', null, null, null, null, 'ads.common.text.translation.no'); //No I18N
        },

        deleteConfig: function(smartCardConfig) {
            var self = this;
            var data = {};
            var smartCardConfig = this.get('deleteSCConfig');
            var productName = smartCardConfig.PRODUCT_NAME;
            var productDetails = {};
            data.SMARTCARD_ID = smartCardConfig.SMARTCARD_ID;
            if (productName != undefined) {
                data.PRODUCT_ID = this.getComponentID(productName);
            }
            var total = self.get("TOTAL_SMARTCARD_COUNT");
            AJAXUtil.ajax('/RestAPI/WC/SmartCard?mTCall=deleteSmartCardConfig', data).then(function(response) {
                if ('sSTATUS' in response) {
                    self.resetTableSettings();
                    if (total > 1) {
                        self.showSmartCardConfigTable();
                    } else {
                        self.showSmartCardConfigForm();
                    }
                }
                if ('eSTATUS' in response) {
                    StatusUtil.showStatusWithMessage(self, 'danger', response.eSTATUS, false);
                }
            });
        },
        showSmartCardFailureReason: function() {
            DialogUtil.showReason(this, Ember.$('#smartCardFailure').html());
        },
        toggleSearchBox: function() {
            if ($(".fw-icn-table-search").length) {
                $(".fw-icn-table-search").removeClass("fw-icn-table-search").addClass("fw-icn-search-clear");
                Ember.set(this,"IS_SEARCH_OPEN",true);
            } else {

                $(".fw-icn-search-clear").removeClass("fw-icn-search-clear").addClass("fw-icn-table-search");
                var data = this.get("SEARCH_QUERY");
                Ember.set(this,"IS_SEARCH_OPEN",false);
                if (this.validateSearchData(data)) {
                    this.resetSearch();
                    this.resetTableSettings();

                }
            }
            $(".target_class .search-bar").toggle();
        },

        clearSearchBox: function() {

            var data = this.get("SEARCH_QUERY");
            this.resetSearch();
            if (this.validateSearchData(data)) {
                this.resetTableSettings();
            }


        },
        searchTable: function() {
            var searchQuery = this.getSerchQuery();
            Ember.set(this, "SEARCH_QUERY", searchQuery);
            var productList = Ember.A();
            if (this.validateSearchData(searchQuery)) {
                if (searchQuery.hasOwnProperty("SEARCH_COMPONENT_NAME")) {
                    var component = (searchQuery.SEARCH_COMPONENT_NAME).toUpperCase();
                    var products = this.get("SMARTCARD_PRODUCTS");
                    for (var i = 0; i < products.length; i++) {
                        var prodName = (products[i].DISPLAY_NAME).toUpperCase();
                        if (prodName.indexOf(component) != -1) {
                            productList.push(this.getComponentID(products[i].DISPLAY_NAME));
                        }

                    }
                    this.resetTableSettings(productList);
                } else {
                    this.resetTableSettings(undefined)
                }
            }

        },
        sortByCompName: function(id, filter) {
            var sortData=this.get("SORT_DATA");
            if(sortData==undefined){
                sortData={};
                sortData.ID=id;
                sortData.ASCENDING=true;
                sortData.FILTER=filter;
                Ember.set(this,"SORT_DATA",sortData);
             this.$("#" + id).addClass("glyphicon glyphicon-triangle-bottom");
              Ember.$("#"+id).css("margin","3px");
            }else{
                if(id!=sortData.ID){
                    if( this.$("#" + sortData.ID).hasClass("glyphicon glyphicon-triangle-bottom")){
                    this.$("#" + sortData.ID).removeClass("glyphicon glyphicon-triangle-bottom");
                    }else{
                    this.$("#" + sortData.ID).removeClass("glyphicon glyphicon-triangle-top");
                    }
                    Ember.$("#"+sortData.ID).css("margin","0px");
                    Ember.$("#"+id).css("margin","3px");
                    this.$("#" + id).addClass("glyphicon glyphicon-triangle-bottom");
                    sortData.ID=id;
                    sortData.ASCENDING=true;
                    sortData.FILTER=filter;
                }else{
                    sortData.ASCENDING=!sortData.ASCENDING;
                }

            }
            var AD_PRODUCTS = this.get("TABLE_DATA");
            var products = [];
            if (sortData.ASCENDING) {
                for (var i = 0; i < AD_PRODUCTS.length; i++) {
                    for (var j = 0; j < AD_PRODUCTS.length - 1; j++) {
                        if (AD_PRODUCTS[j][filter] > AD_PRODUCTS[j + 1][filter]) {
                            var temp = AD_PRODUCTS[j];
                            AD_PRODUCTS[j] = AD_PRODUCTS[j + 1];
                            AD_PRODUCTS[j + 1] = temp;
                        }
                    }
                }
                this.$("#" + id).removeClass("glyphicon-triangle-bottom");
                this.$("#" + id).addClass("glyphicon-triangle-top")
                Ember.set(this, "TABLE_DATA", {})
                Ember.set(this, "TABLE_DATA", AD_PRODUCTS);
            } else {
                for (var i = 0; i < AD_PRODUCTS.length; i++) {
                    for (var j = 0; j < AD_PRODUCTS.length - 1; j++) {
                        if (AD_PRODUCTS[j][filter] < AD_PRODUCTS[j + 1][filter]) {
                            var temp = AD_PRODUCTS[j];
                            AD_PRODUCTS[j] = AD_PRODUCTS[j + 1];
                            AD_PRODUCTS[j + 1] = temp;
                        }
                    }
                }

                this.$("#" + id).removeClass("glyphicon-triangle-top");
                this.$("#" + id).addClass("glyphicon-triangle-bottom");
                Ember.set(this, "TABLE_DATA", {})
                Ember.set(this, "TABLE_DATA", AD_PRODUCTS);
            }

        },
        showDialog: function() {
            DialogUtil.confirm(this, I18NUtil.translate('ads.admin.logon_settings.smartcard_settings.tool_tip_redirect_ssl'), 'redirectToSSL');
        },
        redirectToSSL: function() {
            this.sendAction('redirectToSSL');
        },
        admpEnableAction: function(config) {
            if (config.IS_SMARTCARD_ENABLED) {
                DialogUtil.alert(this, I18NUtil.translate("ads.admin.logon_settings.smartcard_settings.tooltip_admp_disable"));
            } else {
                var smartCardList = this.get("TABLE_DATA");
                var flag = 0;
                for (var i = 0; i < smartCardList.length; i++) {
                    if (smartCardList[i].PRODUCT_NAME == config.PRODUCT_NAME) {
                        flag++;
                    }
                    if (flag > 1) {
                        DialogUtil.confirm(this,I18NUtil.translate("ads.admin.logon_settings.smartcard_settings.tooltip_admp_enable_dialog"), "enableDisableConfig", I18NUtil.translate('ads.common.text.ok'), config);
                        return;
                    }
                }
                this.send("enableDisableConfig", config);
            }
        }
    }
});
//ignorei18n_end