/*
 * $Id: sms-config.js,v 1.10.4.10 2018/12/28 15:16:43 ganesh.venkatraman Exp $
 */
//ignorei18n_start
import Ember from 'ember'; //NO I18N
import AJAXUtil from "../utils/ads-ajax-util"; //NO I18N
import I18NUtil from "../utils/i18n-util"; //NO I18N
import CommonUtil from "../utils/ads-common-util"; //NO I18N
import StatusUtil from "../utils/ads-status-util"; //NO I18N
import DialogUtil from "../utils/ads-dialog-util"; //NO I18N
import ValidationUtil from "../utils/ads-validation-util";  //NO I18N
import EncryptUtil from "../utils/ads-encrypt-util"; //NO I18N
export default Ember.Component.extend({

        smsSettings:{},
        isModal:false,
        navigateBack:false,
        pageStatus:{},
        successResponse:null,
        failureResponse:null,
        advancedSettingsGlyphicon:"right",
        quickHelpGlyphicon:"bottom",
        smtptomail_data:I18NUtil.translate('ads.admin.server_settings.sms_settings.custom_smtp_to_address_help_text'),
        httpparam_data:I18NUtil.translate('ads.admin.server_settings.sms_settings.custom_http_params_help_text'),
        httpreqheader_data:I18NUtil.translate('ads.admin.server_settings.sms_settings.custom_http_request_header_help_text'),
        smsConfiguration: function() {
            if(this.get('isModal') === true){
                this.set("quickHelpGlyphicon","right");
                Ember.run.scheduleOnce("afterRender",this,function() {
                      Ember.$("#"+this.get('modalData').elementID).addClass('fw-sms-modal-resize');
                });
            }
            var smsSettings=AJAXUtil.syncAjax('/RestAPI/WC/SMSSettings?mTCall=getSMSSettings',{});
            var providers = smsSettings.PROVIDERS;
            var customSMSTypes = smsSettings.CUSTOM_SMS_TYPE;
            var responseTypes = smsSettings.RESPONSE_TYPE;
            var apiSettings = {};
            var smsProviders = [];
            if (smsSettings.API_SETTINGS !== undefined){
              apiSettings = smsSettings.API_SETTINGS;
            }

            apiSettings.SMTP_SELECTION=smsSettings.IS_MAIL_SERVER_CONFIGURED;

            for (var i = 0; i < providers.length; i++) {
              var providerDetails = {};
              providerDetails.CLIENT_VALUE = I18NUtil.translate(providers[i].DISPLAY_NAME);
              providerDetails.SERVER_VALUE = providers[i].PROVIDER_NAME;
              smsProviders.push(providerDetails);

      /*If Custom SMS Means those types should be mentioned*/
      if (providers[i].PROVIDER_NAME === 'Custom') {
                apiSettings.CUSTOM_HTTP_METHOD = 'POST'; //Setting default Value

                this.set('CUSTOM_SMS_TYPES', customSMSTypes);
                if (apiSettings.CUSTOM_SMS_TYPE === undefined && customSMSTypes.length > 0) {
                  apiSettings.CUSTOM_SMS_TYPE = customSMSTypes[0].SERVER_VALUE;
                }

                this.set('RESPONSE_TYPES',responseTypes);
                if(smsSettings.RESPONSE_TYPE!== undefined && responseTypes.length >0){
                    apiSettings.RESPONSE_TYPE=responseTypes[0].SERVER_VALUE;
                }
              }
            }

            this.set('SMS_PROVIDERS', smsProviders);

            if (smsSettings.SMTP_CONNECTION_SECURITY != undefined) {
              this.set('CONNECTION_SECURITIES', smsSettings.SMTP_CONNECTION_SECURITY); //No I18N
            }
            if (smsSettings.ADDRESS_TON !== undefined) {
              this.set('ADDRESS_TON', smsSettings.ADDRESS_TON); //No I18N
            }
            if (smsSettings.ADDRESS_NPI !== undefined) {
              this.set('ADDRESS_NPI', smsSettings.ADDRESS_NPI); //No I18N
            }
            if (smsSettings.ESME_BIND_TYPE !== undefined) {
              this.set('ESME_BIND_TYPE', smsSettings.ESME_BIND_TYPE); //No I18N
            }
            if (smsSettings.SMPP_TIME_OUT !== undefined) {
              this.set('SMPP_TIME_OUT', smsSettings.SMPP_TIME_OUT); //No I18N
            }
            if (smsSettings.SELECTED_PROVIDER === undefined) {
              smsSettings.SELECTED_PROVIDER = providers[0].PROVIDER_NAME;
            }
            else if (smsSettings.SELECTED_PROVIDER === "GSMModem") {
              var portNumber = apiSettings.ACCESS_PARAM;
              apiSettings.PORT_NUMBER = portNumber;
    } else if (smsSettings.SELECTED_PROVIDER === "Custom") {
              var customSMSObj = JSON.parse(apiSettings.ACCESS_PARAM);
              var customSMSType = customSMSObj.CUSTOM_SMS_TYPE;

              apiSettings.CUSTOM_SMS_TYPE = customSMSObj.CUSTOM_SMS_TYPE;

              if (customSMSType === "HTTP") {
                apiSettings.CUSTOM_HTTP_METHOD = customSMSObj.CUSTOM_HTTP_METHOD;
                apiSettings.CUSTOM_SMS_URL = customSMSObj.CUSTOM_SMS_URL;
                apiSettings.URL_PARAMETERS = customSMSObj.URL_PARAMETERS;
                if(customSMSObj.FAILURE_RESPONSE !==undefined){
                    apiSettings.RESPONSE=customSMSObj.FAILURE_RESPONSE;
                    apiSettings.RESPONSE_TYPE=responseTypes[1].SERVER_VALUE;
                    this.set("failureResponse",customSMSObj.FAILURE_RESPONSE);
                }
                if(customSMSObj.SUCCESS_RESPONSE !==undefined){
                    apiSettings.RESPONSE_TYPE=responseTypes[0].SERVER_VALUE;
                    apiSettings.RESPONSE=customSMSObj.SUCCESS_RESPONSE;
                    this.set("successResponse",customSMSObj.SUCCESS_RESPONSE);
                }
                apiSettings.MESSAGE_INTO_UNICODE = customSMSObj.MESSAGE_INTO_UNICODE;
                apiSettings.REQUEST_HEADERS = customSMSObj.REQUEST_HEADERS;
                Ember.$('#REQUEST_HEADERS').val(apiSettings.REQUEST_HEADERS);
              }

                else if (customSMSType === "SMTP") {
                    if(customSMSObj.SMTP_SELECTION !== undefined){
                        apiSettings.SMTP_SELECTION = customSMSObj.SMTP_SELECTION;
                    }
                    apiSettings.CUSTOM_MAIL_SERVER = customSMSObj.CUSTOM_MAIL_SERVER;
                    apiSettings.CUSTOM_MAIL_PORT = customSMSObj.CUSTOM_MAIL_PORT;
                    apiSettings.CUSTOM_MAIL_USERNAME = customSMSObj.CUSTOM_MAIL_USERNAME;
                    if (customSMSObj.CUSTOM_MAIL_PASSWORD !== undefined && customSMSObj.CUSTOM_MAIL_PASSWORD !== '') {
                      apiSettings.CUSTOM_MAIL_PASSWORD = "**********";
                      apiSettings.CUSTOM_MAIL_PASSWORD_INITIAL_VALUE = customSMSObj.CUSTOM_MAIL_PASSWORD;
                    }
                        else {
                      apiSettings.CUSTOM_MAIL_PASSWORD = customSMSObj.CUSTOM_MAIL_PASSWORD;
                    }
                    apiSettings.CUSTOM_MAIL_FROM = customSMSObj.CUSTOM_MAIL_FROM;
                    apiSettings.CUSTOM_MAIL_TO = customSMSObj.CUSTOM_MAIL_TO;
                    apiSettings.CUSTOM_MAIL_SUBJECT = customSMSObj.CUSTOM_MAIL_SUBJECT;
                    apiSettings.CUSTOM_MAIL_CONTENT = customSMSObj.CUSTOM_MAIL_CONTENT;
                    apiSettings.CUSTOM_SECURE_CONNECTION = customSMSObj.CUSTOM_SECURE_CONNECTION;
              }

                  else if (customSMSType === "SMPP") {
                apiSettings.CUSTOM_SMPP_SERVER = customSMSObj.CUSTOM_SMPP_SERVER;
                apiSettings.CUSTOM_SMPP_PORT = customSMSObj.CUSTOM_SMPP_PORT;
                apiSettings.CUSTOM_SMPP_USERNAME = customSMSObj.CUSTOM_SMPP_USERNAME;
                if (customSMSObj.CUSTOM_SMPP_PASSWORD !== undefined && customSMSObj.CUSTOM_SMPP_PASSWORD !== '') {
                  apiSettings.CUSTOM_SMPP_PASSWORD = "**********";
                  apiSettings.CUSTOM_SMPP_PASSWORD_INITIAL_VALUE = customSMSObj.CUSTOM_SMPP_PASSWORD;
                } else {
                  apiSettings.CUSTOM_SMPP_PASSWORD = customSMSObj.CUSTOM_SMPP_PASSWORD;
                }

                apiSettings.CUSTOM_SMPP_TIME_OUT = customSMSObj.CUSTOM_SMPP_TIME_OUT;
                apiSettings.CUSTOM_SMPP_ESME_BIND_TYPE = customSMSObj.CUSTOM_SMPP_ESME_BIND_TYPE;
                apiSettings.CUSTOM_SMPP_ESME_SYSTEM_TYPE = customSMSObj.CUSTOM_SMPP_ESME_SYSTEM_TYPE;
                apiSettings.CUSTOM_SMPP_SOURCE_ADDRESS = customSMSObj.CUSTOM_SMPP_SOURCE_ADDRESS;
                apiSettings.CUSTOM_SMPP_SOURCE_ADDRESS_TON = customSMSObj.CUSTOM_SMPP_SOURCE_ADDRESS_TON;
                apiSettings.CUSTOM_SMPP_SOURCE_ADDRESS_NPI = customSMSObj.CUSTOM_SMPP_SOURCE_ADDRESS_NPI;
                apiSettings.CUSTOM_SMPP_DESTINATION_ADDRESS_TON = customSMSObj.CUSTOM_SMPP_DESTINATION_ADDRESS_TON;
                apiSettings.CUSTOM_SMPP_DESTINATION_ADDRESS_NPI = customSMSObj.CUSTOM_SMPP_DESTINATION_ADDRESS_NPI;
              }
              //Remove PORT Speed for custom app UI
              apiSettings.PORT_SPEED = undefined;
            }
            smsSettings.API_SETTINGS = apiSettings;
            this.set('smsSettings', smsSettings);
        }.on('init'),

            validateSMSSettings: function() {
                var status = this.validateSMSSettingsStatus();
                if (status != 'success') {
                  this.alertTypeSelection(this,status,'danger');
                  return false;
                } else {
                  return true;
                }
            },


          validateSMSSettingsStatus: function() {
            this.set('smsSettings.API_SETTINGS.URL_PARAMETERS',Ember.$('#URL_PARAMETERS').val());
            this.set('smsSettings.API_SETTINGS.REQUEST_HEADERS',Ember.$('#REQUEST_HEADERS').val());
            var smsSettings = this.get('smsSettings');
            var apiSettings = smsSettings.API_SETTINGS;
            if (smsSettings.SELECTED_PROVIDER === "GSMModem") {
              if (apiSettings.PORT_NUMBER === undefined || apiSettings.PORT_NUMBER.trim() === '') {
                return I18NUtil.translate('ads.admin.server_settings.sms_settings.gsm_valid_modem_port_number');
              } else if (apiSettings.PORT_SPEED !== undefined && apiSettings.PORT_SPEED.trim() !== '' && !ValidationUtil.isValidNumber(apiSettings.PORT_SPEED.trim())) {
                return I18NUtil.translate('ads.admin.server_settings.sms_settings.gsm_valid_modem_port_speed');
              } else if (apiSettings.MSG_CENTER !== undefined && apiSettings.MSG_CENTER.trim() !== '' && !ValidationUtil.isValidNumber(apiSettings.MSG_CENTER.trim())) {
                return I18NUtil.translate('ads.admin.server_settings.sms_settings.gsm_valid_modem_message_center');
              } else if (apiSettings.PIN_NUMBER !== undefined && apiSettings.PIN_NUMBER.trim() !== '' && !ValidationUtil.isValidNumber(apiSettings.PIN_NUMBER.trim())) {
                return I18NUtil.translate('ads.admin.server_settings.sms_settings.gsm_valid_modem_pin_number');
              }
    } else if (smsSettings.SELECTED_PROVIDER === "Custom") {
              var customSMSType = apiSettings.CUSTOM_SMS_TYPE;
              if (customSMSType === "HTTP") {

                if (apiSettings.CUSTOM_SMS_URL === undefined || apiSettings.CUSTOM_SMS_URL.trim() === '' || !this.isValidHttpUrl(apiSettings.CUSTOM_SMS_URL.trim())) {
                  return I18NUtil.translate('ads.admin.server_settings.sms_settings.custom_valid_http_url');
                } else if (apiSettings.URL_PARAMETERS === undefined || apiSettings.URL_PARAMETERS === '' || apiSettings.URL_PARAMETERS.indexOf('%mobNo%') === -1 || apiSettings.URL_PARAMETERS.indexOf('%message%') === -1) {
                  return I18NUtil.translate('ads.admin.server_settings.sms_settings.custom_valid_http_params');
                } else if (apiSettings.REQUEST_HEADERS !== undefined && apiSettings.REQUEST_HEADERS.trim() !== '' && !this.isValidHttpHeader(apiSettings.REQUEST_HEADERS.trim())) {
                  return I18NUtil.translate('ads.admin.server_settings.sms_settings.custom_valid_http_request_header');
                }
              }
              else if (customSMSType === "SMTP") {

                if (apiSettings.CUSTOM_MAIL_FROM === undefined || apiSettings.CUSTOM_MAIL_FROM.trim() === '' || !ValidationUtil.isValidEmail(apiSettings.CUSTOM_MAIL_FROM.trim())) {
                  return I18NUtil.translate('ads.admin.server_settings.sms_settings.custom_valid_smtp_from_address');
                }
                else if (apiSettings.CUSTOM_MAIL_TO === undefined || apiSettings.CUSTOM_MAIL_TO.trim() === '' || !ValidationUtil.isValidEmail(apiSettings.CUSTOM_MAIL_TO.trim())) {
                  return I18NUtil.translate('ads.admin.server_settings.sms_settings.custom_valid_smtp_to_address');
                }
                else  if((apiSettings.CUSTOM_MAIL_SUBJECT === undefined || apiSettings.CUSTOM_MAIL_SUBJECT.trim() === '' ) && (apiSettings.CUSTOM_MAIL_CONTENT===undefined || apiSettings.CUSTOM_MAIL_CONTENT.trim() === '')){
                  return I18NUtil.translate('ads.admin.server_setttings.sms_settings.custom_valid_subject_or_content');
                }
                else if(apiSettings.CUSTOM_MAIL_CONTENT!== undefined && apiSettings.CUSTOM_MAIL_CONTENT.trim() !== ''&& apiSettings.CUSTOM_MAIL_CONTENT.indexOf('%message%') === -1) {
                  return I18NUtil.translate('ads.admin.server_settings.sms_settings.custom_valid_smtp_content');
                }
                else  if(!apiSettings.SMTP_SELECTION ){

                      if(apiSettings.CUSTOM_MAIL_SERVER === undefined || apiSettings.CUSTOM_MAIL_SERVER.trim() === '' || !ValidationUtil.isValidHostName(apiSettings.CUSTOM_MAIL_SERVER.trim())) {
                         Ember.$('#SMTP_ADVANCED_SETTINGS').show();
                         return I18NUtil.translate('ads.admin.server_settings.sms_settings.custom_valid_smtp_server');
                      }
                      else  if(apiSettings.CUSTOM_MAIL_PORT === undefined || apiSettings.CUSTOM_MAIL_PORT.trim() === '' || !ValidationUtil.isValidPort(apiSettings.CUSTOM_MAIL_PORT)) {
                          Ember.$('#SMTP_ADVANCED_SETTINGS').show();
                          return I18NUtil.translate('ads.admin.server_settings.sms_settings.custom_valid_smtp_port');
                      }
                      else if((apiSettings.CUSTOM_MAIL_USERNAME!==undefined && apiSettings.CUSTOM_MAIL_USERNAME.trim() !== '') && ((apiSettings.CUSTOM_MAIL_PASSWORD === undefined) || (apiSettings.CUSTOM_MAIL_PASSWORD !== undefined && apiSettings.CUSTOM_MAIL_PASSWORD.trim() === ''))){
                            Ember.$('#SMTP_ADVANCED_SETTINGS').show();
                            return I18NUtil.translate('ads.admin.server_settings.sms_settings.custom_valid_smtp_password');
                      }
                      else if((apiSettings.CUSTOM_MAIL_PASSWORD!==undefined && apiSettings.CUSTOM_MAIL_PASSWORD.trim() !== '') && ((apiSettings.CUSTOM_MAIL_USERNAME === undefined) || (apiSettings.CUSTOM_MAIL_USERNAME !== undefined && apiSettings.CUSTOM_MAIL_USERNAME.trim() === ''))){
                            Ember.$('#SMTP_ADVANCED_SETTINGS').show();
                            return I18NUtil.translate('ads.admin.server_settings.sms_settings.custom_valid_smtp_username');
                      }

                }

              } else if (customSMSType === "SMPP") {
                if (apiSettings.CUSTOM_SMPP_SERVER === undefined || apiSettings.CUSTOM_SMPP_SERVER.trim() === '') {
                  return I18NUtil.translate('ads.admin.server_settings.sms_settings.custom_valid_smpp_server');
                } else if (apiSettings.CUSTOM_SMPP_PORT === undefined || apiSettings.CUSTOM_SMPP_PORT.trim() === '' || !ValidationUtil.isValidPort(apiSettings.CUSTOM_SMPP_PORT.trim())) {
                  return I18NUtil.translate('ads.admin.server_settings.sms_settings.custom_valid_smpp_port');
                } else if (apiSettings.CUSTOM_SMPP_USERNAME === undefined || apiSettings.CUSTOM_SMPP_USERNAME.trim() === '' || apiSettings.CUSTOM_SMPP_PASSWORD === undefined || apiSettings.CUSTOM_SMPP_PASSWORD.trim() === '') {
                  return I18NUtil.translate('ads.admin.server_settings.sms_settings.custom_valid_smpp_user_credentials');
                }
              }
              //Remove PORT Speed for custom app UI
              apiSettings.PORT_SPEED = undefined;
            }
            return "success";
          },


          validateTestSMS: function() {
            var smsSettings = this.get('smsSettings');
            smsSettings.TEST_SMS_CONTENT=Ember.$('#TEST_SMS_CONTENT').val();
            this.$('smsSettings.TEST_MOBILE_NO').val(this.$('#TEST_MOBILE_NO').val());
            if (smsSettings.TEST_MOBILE_NO === undefined || smsSettings.TEST_MOBILE_NO.trim() === '' || isNaN(smsSettings.TEST_MOBILE_NO.trim()) || !(/^[0-9]+$/.test(smsSettings.TEST_MOBILE_NO.trim()))) {
              this.alertTypeSelection(this,I18NUtil.translate('ads.admin.server_settings.sms_settings.valid_test_mobile'),'warning');
              return false;
            } else if (smsSettings.TEST_SMS_CONTENT === undefined || smsSettings.TEST_SMS_CONTENT.trim() === '') {
              this.alertTypeSelection(this,I18NUtil.translate('ads.admin.server_settings.sms_settings.valid_test_content'),'warning');
              return false;
            }
            var status = this.validateSMSSettingsStatus();
            if (status == 'success') {
              return true;
            }
            else{
                this.alertTypeSelection(this,status,'warning');
            }
            return false;
          },

          isValidHttpUrl: function(url) {
              //valid spl chars like -_.~!*
              var regexp = /^(ftp|http|https):\/\/([a-zA-Z0-9._\-~])+(:+([0-9]+))*([a-zA-Z0-9._\-~\/!*])+(([a-zA-Z0-9._\-~!*\/]))$/i;
              return regexp.test(url);
            },


            isValidHttpHeader: function(requestHeaders) {
              var headers = requestHeaders.split('\n');
              var regexp = /^[^:]+:(.+)/i;
              for (var i = 0; i < headers.length; i++) {
                if (!regexp.test(headers[i])) {
                  return false;
                }

              }
              return true;
            },


            getSMSSettingsValues: function() {
              this.set('smsSettings.API_SETTINGS.URL_PARAMETERS',Ember.$('#URL_PARAMETERS').val());
              this.set('smsSettings.API_SETTINGS.REQUEST_HEADERS',Ember.$('#REQUEST_HEADERS').val());
              var smsSettings = this.get('smsSettings');
              var apiSettings = smsSettings.API_SETTINGS;
              var newapiSettings = {};
              if (smsSettings.SELECTED_PROVIDER === "GSMModem") {
                newapiSettings.API_TYPE = 'MODEM';
                newapiSettings.ACCESS_PARAM = apiSettings.PORT_NUMBER.trim();
                if (apiSettings.PORT_SPEED !== undefined) {
                  newapiSettings.PORT_SPEED = apiSettings.PORT_SPEED.trim();
                }
                if (apiSettings.MSG_CENTER !== undefined) {
                  newapiSettings.MSG_CENTER = apiSettings.MSG_CENTER.trim();
                }
                if (apiSettings.PIN_NUMBER !== undefined) {
                  newapiSettings.PIN_NUMBER = apiSettings.PIN_NUMBER.trim();
                }
    } else if (smsSettings.SELECTED_PROVIDER === "Custom") {
      newapiSettings.API_TYPE = 'Custom';
                var customSMSDetails = {};
                var customSMSType = apiSettings.CUSTOM_SMS_TYPE;
                customSMSDetails.CUSTOM_SMS_TYPE = apiSettings.CUSTOM_SMS_TYPE;
                if (customSMSType === 'HTTP') {
                  customSMSDetails.CUSTOM_HTTP_METHOD = apiSettings.CUSTOM_HTTP_METHOD;
                  customSMSDetails.CUSTOM_SMS_URL = apiSettings.CUSTOM_SMS_URL.trim();
                  customSMSDetails.URL_PARAMETERS = apiSettings.URL_PARAMETERS.trim();
                  if(apiSettings.RESPONSE!== null && apiSettings.RESPONSE!==undefined && apiSettings.RESPONSE.trim()!=='' ){
                      if (apiSettings.RESPONSE_TYPE ==="Success") {
                        this.set("successResponse",this.get("smsSettings.API_SETTINGS.RESPONSE"));
                      }
                      if (apiSettings.RESPONSE_TYPE === "Failure") {
                        this.set("failureResponse",this.get("smsSettings.API_SETTINGS.RESPONSE"));
                      }
                  }
                  if(this.get("successResponse")!==null){
                        customSMSDetails.SUCCESS_RESPONSE = this.get("successResponse");
                  }
                  if(this.get("failureResponse")!==null){
                        customSMSDetails.FAILURE_RESPONSE = this.get("failureResponse");
                  }
                  customSMSDetails.MESSAGE_INTO_UNICODE = apiSettings.MESSAGE_INTO_UNICODE;
                  if (apiSettings.REQUEST_HEADERS !== undefined) {
                    customSMSDetails.REQUEST_HEADERS = apiSettings.REQUEST_HEADERS.trim();
                  }
                }

                    else if (customSMSType === "SMTP") {
                          customSMSDetails.SMTP_SELECTION=apiSettings.SMTP_SELECTION;
                          customSMSDetails.CUSTOM_MAIL_FROM = apiSettings.CUSTOM_MAIL_FROM.trim();
                          customSMSDetails.CUSTOM_MAIL_TO = apiSettings.CUSTOM_MAIL_TO.trim();
                          if (apiSettings.CUSTOM_MAIL_SUBJECT !== undefined) {
                            customSMSDetails.CUSTOM_MAIL_SUBJECT = apiSettings.CUSTOM_MAIL_SUBJECT.trim();
                          }
                          if (apiSettings.CUSTOM_MAIL_CONTENT !== undefined) {
                            customSMSDetails.CUSTOM_MAIL_CONTENT = apiSettings.CUSTOM_MAIL_CONTENT.trim();
                          }
                          if(!apiSettings.SMTP_SELECTION){
                              if (apiSettings.CUSTOM_MAIL_SERVER !== undefined) {
                                customSMSDetails.CUSTOM_MAIL_SERVER = apiSettings.CUSTOM_MAIL_SERVER.trim();
                              }
                              if (apiSettings.CUSTOM_MAIL_PORT !== undefined) {
                                customSMSDetails.CUSTOM_MAIL_PORT = apiSettings.CUSTOM_MAIL_PORT.trim();
                              }
                              if (apiSettings.CUSTOM_MAIL_USERNAME !== undefined) {
                                customSMSDetails.CUSTOM_MAIL_USERNAME = apiSettings.CUSTOM_MAIL_USERNAME.trim();
                              }
                              if (apiSettings.CUSTOM_MAIL_PASSWORD === "**********") {
                                customSMSDetails.CUSTOM_MAIL_PASSWORD = apiSettings.CUSTOM_MAIL_PASSWORD_INITIAL_VALUE;
                              } else if (apiSettings.CUSTOM_MAIL_PASSWORD !== undefined) {
                                customSMSDetails.CUSTOM_MAIL_PASSWORD = EncryptUtil.encryptString(apiSettings.CUSTOM_MAIL_PASSWORD.trim());
                              }
                              customSMSDetails.CUSTOM_SECURE_CONNECTION = apiSettings.CUSTOM_SECURE_CONNECTION;
                          }
                    }

                    else if (customSMSType === "SMPP") {
                          customSMSDetails.CUSTOM_SMPP_SERVER = apiSettings.CUSTOM_SMPP_SERVER.trim();
                          customSMSDetails.CUSTOM_SMPP_PORT = apiSettings.CUSTOM_SMPP_PORT.trim();
                          customSMSDetails.CUSTOM_SMPP_USERNAME = apiSettings.CUSTOM_SMPP_USERNAME.trim();
                          if (apiSettings.CUSTOM_SMPP_PASSWORD === "**********") {
                            customSMSDetails.CUSTOM_SMPP_PASSWORD = apiSettings.CUSTOM_SMPP_PASSWORD_INITIAL_VALUE;
                          } else {
                            customSMSDetails.CUSTOM_SMPP_PASSWORD = EncryptUtil.encryptString(apiSettings.CUSTOM_SMPP_PASSWORD.trim());
                          }
                          if (apiSettings.CUSTOM_SMPP_SOURCE_ADDRESS !== undefined) {
                            customSMSDetails.CUSTOM_SMPP_SOURCE_ADDRESS = apiSettings.CUSTOM_SMPP_SOURCE_ADDRESS.trim();
                          }
                          if (apiSettings.CUSTOM_SMPP_ESME_SYSTEM_TYPE !== undefined) {
                            customSMSDetails.CUSTOM_SMPP_ESME_SYSTEM_TYPE = apiSettings.CUSTOM_SMPP_ESME_SYSTEM_TYPE.trim();
                          }
                          customSMSDetails.CUSTOM_SMPP_TIME_OUT=apiSettings.CUSTOM_SMPP_TIME_OUT;
                          customSMSDetails.CUSTOM_SMPP_ESME_BIND_TYPE = apiSettings.CUSTOM_SMPP_ESME_BIND_TYPE;
                          customSMSDetails.CUSTOM_SMPP_SOURCE_ADDRESS_TON = apiSettings.CUSTOM_SMPP_SOURCE_ADDRESS_TON;
                          customSMSDetails.CUSTOM_SMPP_SOURCE_ADDRESS_NPI = apiSettings.CUSTOM_SMPP_SOURCE_ADDRESS_NPI;
                          customSMSDetails.CUSTOM_SMPP_DESTINATION_ADDRESS_TON = apiSettings.CUSTOM_SMPP_DESTINATION_ADDRESS_TON;
                          customSMSDetails.CUSTOM_SMPP_DESTINATION_ADDRESS_NPI = apiSettings.CUSTOM_SMPP_DESTINATION_ADDRESS_NPI;
                     }
                newapiSettings.ACCESS_PARAM = customSMSDetails;
              }
              return newapiSettings;
            },


            onProviderChange: function() {
                this.set('advancedSettingsGlyphicon','right');
                if(this.get('isModal') === true) {  // If provider is changed, change the quickhelpGlyphicon to right for modal
                    this.set("quickHelpGlyphicon","right");
                }
                else {
                  this.set("quickHelpGlyphicon","bottom"); // If provider is changed, change the quickhelpGlyphicon to bottom
                }
                CommonUtil.afterRender(); //For ToolTip Rendering during provider change
            }.observes('smsSettings.SELECTED_PROVIDER,smsSettings.API_SETTINGS.CUSTOM_SMS_TYPE'),

            onResponseChange:function(){
                var smsSettings = this.get('smsSettings');
                var apiSettings = smsSettings.API_SETTINGS;
                if (apiSettings.RESPONSE_TYPE ==="Success" && (this.get("successResponse")!== this.get("smsSettings.API_SETTINGS.RESPONSE"))) {
                    this.set("failureResponse",this.get("smsSettings.API_SETTINGS.RESPONSE"));
                    this.set("smsSettings.API_SETTINGS.RESPONSE",this.get("successResponse"));
                }
                else if (apiSettings.RESPONSE_TYPE === "Failure" && (this.get("failureResponse")!==  this.get("smsSettings.API_SETTINGS.RESPONSE"))) {
                    this.set("successResponse",this.get("smsSettings.API_SETTINGS.RESPONSE"));
                    this.set("smsSettings.API_SETTINGS.RESPONSE",this.get("failureResponse"));
                }
            }.observes('smsSettings.API_SETTINGS.RESPONSE_TYPE'),

            alertTypeSelection:function(th,message,type){
                if(th.get('isModal')===true){
                    th.sendAction('alertAction',message,4000,type);
                }
                else{
                    DialogUtil.alert(th,I18NUtil.translate(message));
                }
           },

          willDestroyElement(){
             if(this.get('isModal')=== true){
                 Ember.$("#"+this.get('modalData').elementID).addClass('fw-sms-modal-resize');
              }
              Ember.$('#FORM_STATUS').css('display','none');//No I18N
          },

            actions: {

              cancelSMSSettings: function() {
                this.send('resetTestSMS');
                if(this.get('isModal') === true){
                    Ember.run.scheduleOnce("afterRender",this,function() {
                          Ember.$("#"+this.get('modalData').elementID).modal("hide");
                    });
                }
                else if(this.get('navigateBack') === true){
                    this.sendAction('cancelAction');
                }
                else{
                    this.smsConfiguration();
                }
              },

              updateSMSSettings: function() {

                if (this.validateSMSSettings()) {
                  if(this.get('isModal')==true) {
                    Ember.$("#sms-config-id [data-element='loader").removeClass('hidden');
                  }
                  else {
                    CommonUtil.showLoading();
                  }
                  var newapiSettings = this.getSMSSettingsValues();
                  var smsSet = Ember.$.extend(true, {}, this.get('smsSettings'));
                  Ember.set(smsSet,'API_SETTINGS', newapiSettings);
                  var self = this;
                  var params = {};
                  params.SMS_SETTINGS = JSON.stringify(smsSet);
                  AJAXUtil.ajax('/RestAPI/WC/SMSSettings?mTCall=setSMSSettings', params)
                    .then(function(response) {
                      if(self.get('isModal') === true) {
                        Ember.$("#sms-config-id [data-element='loader").addClass('hidden');
                        Ember.run.scheduleOnce("afterRender",self,function(){
                            Ember.$("#FORM_STATUS").addClass("fw-modal-status-align");
                        });
                      }
                      else {
                        CommonUtil.hideLoading();
                      }
                      self.sendAction('showStatus',response);
                      self.smsConfiguration(); //No I18N
                      self.send('resetTestSMS');
                      if(self.get("isModal") === true){
                        self.sendAction('afterSaveAction');
                      }
                    });
                }
              },

              sendTestSMS: function() {
                var self = this;
                this.smsSettings.TEST_SMS_CONTENT=Ember.$('#TEST_SMS_CONTENT').val();
                if (this.validateTestSMS()) {
                  if(this.get('isModal')==true) {
                    Ember.$("#sms-config-id [data-element='loader").removeClass('hidden');
                  }
                  else {
                    CommonUtil.showLoading();
                  }
                  var newapiSettings = this.getSMSSettingsValues();
                  var smsSet = Ember.$.extend(true, {}, this.get('smsSettings'));
                  Ember.set(smsSet, 'API_SETTINGS', newapiSettings);
                  var self = this;
                  var params = {};
                  params.SMS_SETTINGS = JSON.stringify(smsSet);
                  params.TEST_MOBILE_NO = smsSet.TEST_MOBILE_NO.trim();
                  params.TEST_SMS_CONTENT = smsSet.TEST_SMS_CONTENT.trim();
                  AJAXUtil.ajax('/RestAPI/WC/SMSSettings?mTCall=sendTestSMS', params)
                    .then(function(response) {
                      var result = null;
                      if(self.get('isModal') === true) {
                          Ember.$("#sms-config-id [data-element='loader").addClass('hidden');
                          Ember.run.scheduleOnce("afterRender",self,function(){
                              self.$("#FORM_STATUS").addClass("fw-modal-status-align");
                          });
                        }
                      else {
                         CommonUtil.hideLoading();
                      }
                     self.sendAction('showStatus',response);
                    });
                }
              },

              resetTestSMS: function() {
                this.$('#TEST_MOBILE_NO').val('');
                this.$('#TEST_SMS_CONTENT').val('');
              },

              handleDropdown:function(){
                  var self=this;
                  this.$('#test_message_dropdown').click(function(event){
                            if(event.target.tagName !== 'BUTTON'){
                                event.stopPropagation();
                            }
                            else if(event.target.id === "closeDrop"){
                                self.$('#TEST_MOBILE_NO').val('');
                                self.$('#TEST_SMS_CONTENT').val('');
                            }
                   });
              },

              toggleQuickHelp:function(param){
                  this.$('#'+param).toggle();
                  if(this.$('#'+param).css('display')=== 'block'){
                      this.set('quickHelpGlyphicon',"bottom");
                  }
                  else if(Ember.$('#'+param).css('display') === 'none'){
                      this.set('quickHelpGlyphicon',"right");
                  }
              },
              toggleAdvancedSettings: function(param){
                  this.$('#' + param).toggle();

                  if(Ember.$('#'+param).css('display')=== 'block'){
                      this.set('advancedSettingsGlyphicon',"bottom");
                  }
                  else if(Ember.$('#'+param).css('display') === 'none'){
                      this.set('advancedSettingsGlyphicon',"right");
                  }
              },

              toggleCheckBox: function(checked, params) {
                var smsSettings = this.get('smsSettings');
                Ember.set(smsSettings, params, checked);
                this.set('smsSettings', smsSettings);
              },

              toggleMailServerSettings:function(checked,params){
                  var smsSettingsCheck = this.get('smsSettings');
                  if(!smsSettingsCheck.IS_MAIL_SERVER_CONFIGURED) {
                        Ember.run.schedule('afterRender', function(){
                                 Ember.$('#SMTP_SELECTION').parent('div').removeClass('checked');
                        });
                        this.alertTypeSelection(this,I18NUtil.translate('ads.admin.server_settings.sms_settings.smtp.mail_server_alert'),'danger');
                        Ember.set(this.get('smsSettings'),params,false);
                  }
                  else{
                        Ember.set(this.get('smsSettings'),params,checked);
                  }
              },

              toggleProtocol: function(params) {
                this.set('smsSettings.API_SETTINGS.CUSTOM_HTTP_METHOD', JSON.parse(params).columnValue);
              },

             }

});
//ignorei18n_end
