/*
 * $Id$
 */

//ignorei18n_start
import Ember from 'ember'; //NO I18N
import AJAXUtil from '../utils/ads-ajax-util'; //NO I18N
import I18NUtil from "../utils/i18n-util"; //NO I18N
import DialogUtil from "../utils/ads-dialog-util"; //NO I18N
import CommonUtil from "../utils/ads-common-util"; //NO I18N
export default Ember.Component.extend({
  pageStatus: {},
  ssoSettings: null,
  domainList: null,
  isEnabled: false,
  initialisEnabled: false,
  domainSSOConfig: null,
  currentConfig: null,
  domainCredentails: null,
  showAdvanced: false,
  showAdvancedIcon: 'fw-icn-sm-plus-invert',
  enableDisableSSO: null,
  configuredProductStatus: null,
  initialconfiguredProductStatus: null,
  ssoConfigurationStatus: null,
  initialssoConfigurationStatus: null,
  configStatusMessage: '',
  showTable: false,
  failedDetails: null,
  saveSettingsButton: null,
  configStatusAlertType: 'danger',
  freezeTable: null,
  editConfiguration: false,
  syncFailureReason: null,
  displayNote: false,
  noDomainsConfigured: false,
  singleDomainConfigured: false,
  productName: null,
  singleChooseComponent: false,
  multipleChooseComponent: false,
  domainValue: I18NUtil.translate('ads.admin.logon_settings.no_domains'),
  getSettings: function() {
    var response = AJAXUtil.syncAjax('/RestAPI/WC/NTLMSSOSettings?mTCall=getSSOSettings', {});
    this.set('ssoSettings', response['SSO_SETTINGS']);
    this.set('domainList', response['DOMAIN_LIST']);
    var isEnabled = response['IS_ENABLED'];
    this.set('initialisEnabled', isEnabled);
    this.set('isEnabled', isEnabled);
    var productDetails = response['PRODUCTS_DETAILS'];
    if (productDetails.length > 1) {
      this.set('multipleChooseComponent', true);
    } else if (productDetails.length > 0) {
      if (!productDetails[0].hasOwnProperty('SAME_PRODUCT')) {
        this.set('singleChooseComponent', true); /*If only one componet is present no need to disaply the choosecomponent dropdownlist*/
        this.set('productName', productDetails[0].DISPLAY_NAME);
      }
    } else {
      this.set('enableDisableSSO', 'disabled'); /*If no products are configured NTLM SSO Configuration is disabled*/
    }
    this.set('initialconfiguredProductStatus', Ember.$.extend(true, [], productDetails));
    var atleastOneProductEnabled = false;
    /*To choose all products if no products are enabled for promotion purpose*/
    for (var i = 0; i < productDetails.length; i++) {
      if (productDetails[i].IS_ENABLED === true) {
        atleastOneProductEnabled = true;
      }
    }
    if (atleastOneProductEnabled === false) {
      for (var i = 0; i < productDetails.length; i++) {
        Ember.set(productDetails[i], 'IS_ENABLED', true); //For Promotion Purpose  making all domains as enabled
      }
    }
    this.set('configuredProductStatus', productDetails);
    this.updateDomainSSO();
    this.enableDisableSettings();
  }.on('init'),
  updateDomainSSO: function() {
    var domainSSOConfig = [];
    var ssoConfigurationStatus = [];
    var atleastOneDomainEnabled = false;
    var failedDetails = this.get('failedDetails');
    var domainList = this.get('domainList');
    var ssoSettings = this.get('ssoSettings');
    for (var i = 0; i < domainList.length; i++) {
      var config = {};
      var ssoConfiguration = {};

      var domainDnsName = domainList[i]['DOMAIN_DNS_NAME'];
      var domainName = domainList[i]['DOMAIN_NAME'];

      config['DOMAIN_DNS_NAME'] = domainDnsName;
      config['DOMAIN_NAME'] = domainName;
      config['DOMAIN_FLAT_NAME'] = domainList[i]['DOMAIN_FLAT_NAME'];
      config['DOMAIN_USER_NAME'] = domainList[i]['USER_NAME'];
      ssoConfiguration['IS_ENABLED'] = false;

      if (failedDetails != null && Object.keys(failedDetails).length != 0) {
        var dom = failedDetails[domainName];
        if (dom != undefined && dom[domainName] != "success") {
          config["FAILED_TO_CONFIGURE"] = true;
          config["IS_CONFIGURED"] = true;
          var errorStatus = dom[domainName];
          config["ERROR_STATUS"] = errorStatus;
          if (errorStatus === "updateCredentaials") {
            config["UPDATE_CREDENTIALS"] = true;
          } else {
            config["UPDATE_CREDENTIALS"] = false;
          }
        }
      }

      if (Object.keys(ssoSettings).length > 0) {
        var domainSSOSettings = ssoSettings[domainDnsName];
        if (Object.keys(domainSSOSettings).length > 0) {
          config['IS_CONFIGURED'] = true;
          config['CONFIGURING'] = false;
          if (domainSSOSettings.hasOwnProperty('IS_ENABLED') && domainSSOSettings['IS_ENABLED'] == 'true') {
            config['IS_ENABLED'] = true;
            ssoConfiguration['IS_ENABLED'] = true;
            atleastOneDomainEnabled = true;
          } else {
            ssoConfiguration['IS_ENABLED'] = false;
          }
          if (domainSSOSettings.hasOwnProperty('jespa.service.acctname')) {
            var accountName = domainSSOSettings['jespa.service.acctname'];
            var index = accountName.indexOf('$');
            if (index != -1) {
              accountName = accountName.substr(0, index);
            }
            config['COMPUTER_ACCOUNT'] = accountName;
          }
          if (domainSSOSettings.hasOwnProperty('jespa.dns.servers')) {
            config['DNS_SERVERS'] = domainSSOSettings['jespa.dns.servers'];
          }
          if (domainSSOSettings.hasOwnProperty('jespa.dns.site')) {
            config['DNS_SITE'] = domainSSOSettings['jespa.dns.site'];
          }
        }
      }

      ssoConfiguration["ID"] = domainList[i]['DOMAIN_NAME'];
      ssoConfiguration["DISPLAY_NAME"] = domainList[i]['DOMAIN_DNS_NAME'];
      if (config['DOMAIN_DNS_NAME'] != '') {
        domainSSOConfig[domainSSOConfig.length] = Ember.Object.create(config);
        ssoConfigurationStatus[ssoConfigurationStatus.length] = ssoConfiguration;
      }
    }
    this.set('initialssoConfigurationStatus', Ember.$.extend(true, [], ssoConfigurationStatus));
    this.set('domainSSOConfig', domainSSOConfig);

    /*Showing the NTLM SSO COnfiguration  table or not */
    var showTable = false;
    for (var i = 0; i < domainSSOConfig.length; i++) {
      var config = domainSSOConfig[i];
      if (config.IS_ENABLED === true || config.FAILED_TO_CONFIGURE === true) {
        showTable = true;
      }
    }
    this.set('showTable', showTable);

    /*To choose all domains if no domains are enabled for promotion purpose*/
    for (var i = 0; i < ssoConfigurationStatus.length; i++) {
      var domain = ssoConfigurationStatus[i];
      if (domain.IS_ENABLED === true) {
        atleastOneDomainEnabled = true;
      }
    }
    if (atleastOneDomainEnabled === false && failedDetails === null) {
      for (var i = 0; i < ssoConfigurationStatus.length; i++) {
        Ember.set(ssoConfigurationStatus[i], 'IS_ENABLED', true); //For Promotion Purpose  making all domains as enabled
      }
    }
    this.set('ssoConfigurationStatus', ssoConfigurationStatus);
    if (ssoConfigurationStatus.length == 0) {
      this.set('enableDisableSSO', 'disabled');
      this.set('noDomainsConfigured', true);
      this.sendAction('showStatus', 'warning', I18NUtil.translate('ads.admin.logon_settings.no_domain_configured'), false);
    } else if (ssoConfigurationStatus.length == 1) {
      this.set('domainValue', ssoConfigurationStatus[0].DISPLAY_NAME);
      this.set('singleDomainConfigured', true);
    }
  },
  checkSSOConfig: function() {
    var currentConfig = this.get('currentConfig');
    var message = "";
    if (currentConfig.COMPUTER_ACCOUNT == undefined || currentConfig.COMPUTER_ACCOUNT == "") {
      message = I18NUtil.translate('ads_admin_logon_settings.ntlm_computer_name_empty');
    } else if (currentConfig.PASSWORD == undefined || currentConfig.PASSWORD == "") {
      message = I18NUtil.translate('ads_admin_logon_settings.ntlm_password_empty');
    }
    if (message == "") {
      return true;
    } else {
      this.set('configStatusMessage', message);
      this.set('configStatusAlertType', 'danger');
      this.$(".mini-status-alert").delay(500).slideDown('slow');
      return false;
    }
  },
  checkCredentialConfig: function() {
    var currentConfig = this.get('currentConfig');
    var message = "";
    if (currentConfig.DOMAIN_USER_NAME == undefined || currentConfig.DOMAIN_USER_NAME == "") {
      message = I18NUtil.translate('ads_admin_logon_settings.ntlm_user_name_empty');
    } else if (currentConfig.DOMAIN_PASSWORD == undefined || currentConfig.DOMAIN_PASSWORD == "") {
      message = I18NUtil.translate('ads_admin_logon_settings.ntlm_password_empty');
    }
    if (message == "") {
      return true;
    } else {
      this.set('configStatusMessage', message);
      this.set('configStatusAlertType', 'danger');
      this.$(".mini-status-alert").delay(500).slideDown('slow');
      return false;
    }
  },
  enableDisableSettings: function() {
    if (this.get('isEnabled') === true) {
      this.set('freezeTable', '');
    } else {
      this.set('freezeTable', 'loader loader-text loader-md');
    }
  }.observes('isEnabled'),
  saveSettingButton: function() {
    var initialisEnabled = this.get('initialisEnabled');
    var isEnabled = this.get('isEnabled');
    var changed = false;
    if (initialisEnabled != isEnabled) {
      changed = true;
    }
    if (isEnabled) {
      var initalConfig = this.get('initialconfiguredProductStatus');
      var currentConfig = this.get('configuredProductStatus');
      if (initalConfig != null) {
        if (JSON.stringify(initalConfig) != JSON.stringify(currentConfig)) {
          changed = true;
        }
        for (var i = 0; i < currentConfig.length; i++) {
          var product = currentConfig[i];
          if (product['ID'] === 'ADSSP') // FOr ADSSP Alone note should be displayed
          {
            if (product['IS_ENABLED'] === true) {
              this.set('displayNote', true);
            } else {
              this.set('displayNote', false);
            }
          }
        }
      }
      initalConfig = this.get('initialssoConfigurationStatus');
      currentConfig = this.get('ssoConfigurationStatus');
      if (initalConfig != null) {
        if (JSON.stringify(initalConfig) != JSON.stringify(currentConfig)) {
          changed = true;
        }
      }
    }
    if (changed) {
      this.set('saveSettingsButton', '');
    } else {
      this.set('saveSettingsButton', 'disabled');
    }
  }.observes('isEnabled,configuredProductStatus.@each.IS_ENABLED,ssoConfigurationStatus.@each.IS_ENABLED'),
  changeComputeAccount: function() {
    if (this.get('initialConfig.COMPUTER_ACCOUNT') != undefined) {
      var initailAccountName = this.get('initialConfig.COMPUTER_ACCOUNT').toLowerCase();
      var currentAccountName = this.get('currentConfig.COMPUTER_ACCOUNT').toLowerCase();
      if (initailAccountName !== currentAccountName) {
        this.set('currentConfig.PASSWORD', "");
      } else {
        this.set('currentConfig.PASSWORD', "**********");
      }
    }
  }.observes('currentConfig.COMPUTER_ACCOUNT'),
  toggleAdvancedIcon: function() {
    if (this.get('showAdvanced') === true) {
      this.set('showAdvancedIcon', 'fw-icn-sm-minus-invert');
      this.$("div#ssoConfigHeader div.toggle-panel.toggle-panel-default").addClass('open');
    } else {
      this.set('showAdvancedIcon', 'fw-icn-sm-plus-invert');
      this.$("div#ssoConfigHeader div.toggle-panel.toggle-panel-default").removeClass('open');
    }
  }.observes('showAdvanced'),
  actions: {
    editConfig: function(config) {

      if (config != undefined && config != null) {
        if (config.hasOwnProperty('COMPUTER_ACCOUNT')) {
          config["PASSWORD"] = "**********";
          config['createAccount'] = false;
          this.set('showAdvanced', true);
          this.set('editConfiguration', true);

        } else {
          config['createAccount'] = true;
          this.set('editConfiguration', false);
        }
        this.set('initialConfig', Ember.$.extend(true, {}, config));
        this.set('currentConfig', Ember.$.extend(true, {}, config));
      }
      this.$(".mini-status-alert").slideUp();
      this.$('#ssoConfigDialog').modal({
        backdrop: 'static',
        keyboard: false
      });
    },
    enableSSO: function(val) {
      if (val != this.get('isEnabled')) {
        this.set('isEnabled', val);
        this.enableDisableSettings();
      }
    },
    showSyncFailureReason: function() {
      DialogUtil.showReason(this, this.$('#syncFailReasonDiv').html());
    },
    saveSettings: function() {
      var self = this;
      if (this.get('isEnabled')) {
        var data = {};
        var domainStatus = false;
        var componentStatus = false;
        var ssoConfigurationStatus = self.get('ssoConfigurationStatus');
        var configuredProductStatus = self.get('configuredProductStatus');
        var ssoConfig = {};
        for (var i = 0; i < ssoConfigurationStatus.length; i++) {
          ssoConfig[i] = ssoConfigurationStatus[i];
          if (!domainStatus) {
            domainStatus = ssoConfigurationStatus[i].IS_ENABLED;
          }
        }
        var products = {};
        for (var ii = 0; ii < configuredProductStatus.length; ii++) {
          products[ii] = configuredProductStatus[ii];
          if (!componentStatus) {
            componentStatus = configuredProductStatus[ii].IS_ENABLED;
          }
        }
        data['CONFIGURED_PRODUCTS'] = JSON.stringify(products);
        data['DOMAIN_SSO_CONFIG'] = JSON.stringify(ssoConfig);
        if (!domainStatus) {
          CommonUtil.hideLoading();
          DialogUtil.alert(self, I18NUtil.translate('ads_admin_logon_settings.select_domains_empty')); //No I18N
          return;
        }
        if (!componentStatus) {
          CommonUtil.hideLoading();
          DialogUtil.alert(self, I18NUtil.translate('ads_admin_logon_settings.select_components_empty')); //No I18N
          return;
        }
        CommonUtil.showLoading();
        AJAXUtil.ajax('/RestAPI/WC/NTLMSSOSettings?mTCall=ssoConfiguration', data).then(function(response) {
          CommonUtil.hideLoading();
          if (!response.hasOwnProperty("eSTATUS")) {
            var jsonResponse = response["NTLM_SSO_CONFIGURATION"];
            self.set('failedDetails', jsonResponse);
            self.getSettings();
            var isEnabled = self.get('isEnabled');
            if (isEnabled === false) /*Is the save configuration failed without configuring for single domain , retaining configured products*/ {
              self.set('isEnabled', true);
              self.set('ssoConfigurationStatus', ssoConfigurationStatus);
              self.set('configuredProductStatus', configuredProductStatus);
              self.set('saveSettingsButton', 'disabled');
            }
            var result = response["SAVE_SETTINGS"];
            var partialSave = response["SAVE_PARTIALLY"];
            var syncFailureReason = response["SYNC_STATUS"];
            if (result === true) {
              if (syncFailureReason != undefined) {
                self.set('syncFailureReason', syncFailureReason);
                Ember.$('#globalFailureMsg').html(self.$('#syncFailureMsgDiv').html());
                if (partialSave === true) {
                  self.sendAction('showStatus', 'warning', I18NUtil.translate('ads.admin.logon_settings.partial_and_syncnow.sync_failure') + Ember.$('#globalFailureMsg').html(), false);
                } else {
                  self.sendAction('showStatus', 'warning', I18NUtil.translate('ads.admin.logon_settings.success_and_syncnow.sync_failure') + Ember.$('#globalFailureMsg').html(), false);
                }
                return;
              } else if (partialSave === true) {
                self.sendAction('showStatus', 'warning', I18NUtil.translate('ads.admin.logon_settings.partial_success'), false);
              } else {
                self.sendAction('showStatus', 'success', I18NUtil.translate('ads.admin.logon_settings.saved_succesfully'), false);
              }
            } else {
              self.sendAction('showStatus', 'danger', I18NUtil.translate('ads.admin.logon_settings.save_failed'), false);
            }
          } else {
            self.sendAction('showStatus', 'danger', response.eSTATUS, false);
          }
        });
      } else {
        var data = {};
        var configuredProductStatus = self.get('configuredProductStatus');
        var products = {};
        for (var i = 0; i < configuredProductStatus.length; i++) {
          products[i] = configuredProductStatus[i];
        }
        data['CONFIGURED_PRODUCTS'] = JSON.stringify(products);

        CommonUtil.showLoading();
        AJAXUtil.ajax('/RestAPI/WC/NTLMSSOSettings?mTCall=disableSettings', data).then(function(response) {
          CommonUtil.hideLoading();
          if (!response.hasOwnProperty("eSTATUS")) {
            var syncFailureReason = response["SYNC_STATUS"];
            var result = response["STATUS"];
            if (result == 'success') {
              if (syncFailureReason != undefined) {
                self.set('syncFailureReason', syncFailureReason);
                Ember.$('#globalFailureMsg').html(self.$('#syncFailureMsgDiv').html());
                self.sendAction('showStatus', 'warning', I18NUtil.translate('ads.admin.logon_settings.success_and_syncnow.sync_failure') + Ember.$('#globalFailureMsg').html(), false);
              } else {
                self.sendAction('showStatus', 'success', I18NUtil.translate('ads.admin.logon_settings.saved_succesfully'), false);
              }

            } else {
              self.sendAction('showStatus', 'danger', I18NUtil.translate('ads.admin.logon_settings.save_failed'), false);
            }
            self.getSettings();
          } else {
            self.sendAction('showStatus', 'danger', response.eSTATUS, false);
          }
        });
      }
    },
    saveConfig: function() {

      if (this.checkSSOConfig()) {
        var data = {};
        data['domainName'] = this.get('currentConfig.DOMAIN_NAME');
        data['computerAccount'] = this.get('currentConfig.COMPUTER_ACCOUNT');
        var password = this.get('currentConfig.PASSWORD');
        if (password !== "**********" || data['createComputerAccount'] === "true") {
          data['password'] = password;
        }
        data['createComputerAccount'] = this.get('currentConfig.createAccount');
        data['dnsServers'] = this.get('currentConfig.DNS_SERVERS');
        data['dnsSite'] = this.get('currentConfig.DNS_SITE');
        data['isEnabled'] = true;
        var configuredProductStatus = this.get('configuredProductStatus');
        var products = {};
        for (var ii = 0; ii < configuredProductStatus.length; ii++) {
          products[ii] = configuredProductStatus[ii];
        }
        data['CONFIGURED_PRODUCTS'] = JSON.stringify(products);

        this.$(".mini-status-alert").slideUp();
        this.$('#ssoLoader').css('display', 'block');

        var self = this;
        AJAXUtil.ajax('/RestAPI/WC/NTLMSSOSettings?mTCall=saveSettings', data).then(function(response) {
          self.$('#ssoLoader').css('display', 'none');
          if (!response.hasOwnProperty("eSTATUS")) {
            var result = response["STATUS"];
            if (result === 'success') {
              var syncStatus = response["SYNC_STATUS"];

              if (syncStatus != undefined) {
                self.set('syncFailureReason', syncStatus);
                Ember.$('#globalFailureMsg').html(self.$('#syncFailureMsgDiv').html());
                self.sendAction('showStatus', 'warning', I18NUtil.translate('ads.admin.logon_settings.success_and_syncnow.sync_failure') + Ember.$('#globalFailureMsg').html(), false);
              } else {
                self.sendAction('showStatus', 'success', I18NUtil.translate('ads.admin.logon_settings.saved_succesfully'), false);
              }
              self.$('#ssoConfigDialog').modal('hide');
              self.getSettings();
            } else {
              self.set('configStatusMessage', result);
              self.set('configStatusAlertType', 'danger');
              self.set('initialConfig', Ember.$.extend(true, {}, self.get('currentConfig')));
              self.set('currentConfig', self.get('currentConfig'));
              if (result === 'updateCredentaials') {
                result = I18NUtil.translate('ads_admin_logon_settings_ntlm_invalid_credential');
                self.set('configStatusMessage', result);
                self.$('#ssoConfigDialog').modal('hide');
                self.$('#domainPasswordAlertBox').modal({
                  backdrop: 'static',
                  keyboard: false
                });
                self.$(".mini-status-alert").delay(500).slideDown('slow');
              }
              self.$(".mini-status-alert").delay(500).slideDown('slow');
            }
          } else {
            self.set('configStatusMessage', I18NUtil.translate('ads.common.error.demo_mode'));
            self.set('configStatusAlertType', 'danger');
            self.$(".mini-status-alert").delay(500).slideDown('slow');
          }
        });
      }
    },
    toggleCreateAccount: function(val) {
      this.set('currentConfig.createAccount', val);
    },
    toggleShowAdvanced: function() {
      this.set('showAdvanced', !this.get('showAdvanced'));
    },
    closeAlert: function() {
      this.$(".mini-status-alert").delay(50).slideUp('slow');
    },
    updateCredentaials: function(config) {
      if (config != undefined && config != null) {
        this.set('currentConfig', Ember.$.extend(true, {}, config));
        this.$('#domainPasswordAlertBox').modal({
          backdrop: 'static',
          keyboard: false
        });
      }
    },
    updateCredentaialsSave: function(config) {
      if (this.checkCredentialConfig()) {
        var data = {};
        data['domainName'] = this.get('currentConfig.DOMAIN_NAME');
        data['computerAccount'] = this.get('currentConfig.COMPUTER_ACCOUNT');
        var password = this.get('currentConfig.PASSWORD');
        if (password !== "**********" || data['createComputerAccount'] === "true") {
          data['password'] = password;
        }
        data['createComputerAccount'] = this.get('currentConfig.createAccount');
        data['dnsServers'] = this.get('currentConfig.DNS_SERVERS');
        data['dnsSite'] = this.get('currentConfig.DNS_SITE');
        data['isEnabled'] = true;
        data['DOMAIN_NAME'] = this.get('currentConfig.DOMAIN_NAME');
        data['DOMAIN_USER_NAME'] = this.get('currentConfig.DOMAIN_USER_NAME');
        data['DOMAIN_PASSWORD'] = this.get('currentConfig.DOMAIN_PASSWORD');
        var configuredProductStatus = this.get('configuredProductStatus');
        var products = {};
        for (var ii = 0; ii < configuredProductStatus.length; ii++) {
          products[ii] = configuredProductStatus[ii];
        }
        data['CONFIGURED_PRODUCTS'] = JSON.stringify(products);
        this.$(".mini-status-alert").slideUp();
        this.$('#credentialLoader').css('display', 'block');
        var self = this;
        AJAXUtil.ajax('/RestAPI/WC/NTLMSSOSettings?mTCall=enableSettings', data).then(function(response) {
          self.$('#credentialLoader').css('display', 'none');
          if (!response.hasOwnProperty("eSTATUS")) {
            var syncFailureReason = response["SYNC_STATUS"];
            var result = response["STATUS"];
            if (result == 'success') {
              if (syncFailureReason != undefined) {
                self.set('syncFailureReason', syncFailureReason);
                Ember.$('#globalFailureMsg').html(self.$('#syncFailureMsgDiv').html());
                self.sendAction('showStatus', 'warning', I18NUtil.translate('ads.admin.logon_settings.success_and_syncnow.sync_failure') + Ember.$('#globalFailureMsg').html(), false);
              } else {
                self.sendAction('showStatus', 'success', I18NUtil.translate('ads.admin.logon_settings.saved_succesfully'), false);
              }
              self.$('#domainPasswordAlertBox').modal('hide');
              self.getSettings();
            } else {
              self.set('configStatusMessage', result);
              self.set('configStatusAlertType', 'danger');
              if (result === 'updateCredentaials') {
                result = I18NUtil.translate('ads_admin_logon_settings_ntlm_invalid_credential');
                self.set('configStatusMessage', result);
                self.$('#domainPasswordAlertBox').modal({
                  backdrop: 'static',
                  keyboard: false
                });
              } else {
                self.$('#domainPasswordAlertBox').modal('hide');
                self.$('#ssoConfigDialog').modal({
                  backdrop: 'static',
                  keyboard: false
                });
              }
              self.$(".mini-status-alert").delay(500).slideDown('slow');
            }
          } else {
            self.set('configStatusMessage', response.eSTATUS);
            self.set('configStatusAlertType', 'danger');
            self.$(".mini-status-alert").delay(500).slideDown('slow');
          }
        });
      }
    },
  }
});
//ignorei18n_end
