/*
 *$Id : component.js $
 */
import Ember from 'ember';		//NO I18N
import ESCUTIL from "../utils/escape-util"; //NO I18N

export default Ember.Component.extend({
	colWidth : "30%",
	didReceiveAttrs(){
		this._super(...arguments);
		var noOfCols = this.dataModelObject.columns.length;
		this.set('colWidth',  95/noOfCols+'%');		//NO I18N
		Ember.run.scheduleOnce('afterRender', this, function(){		//NO I18N
			if($('#SelectAll') != undefined){
				this.updateSelectAllCheckbox();
			}
		});
	},
	didRender(){
		if($(".fw-custom-scroll").length){ 	       
			$(".fw-custom-scroll").each(function () {
				$(this).mCustomScrollbar();
			}); 
		}
	},
	updateSelectAllCheckbox(){
		var all = $('#ResultRows :checkbox').length;
		var checked = $('#ResultRows :checkbox:checked').length;
		if (all == checked){
			$('#SelectAll').parent().addClass('checked');
			$('#SelectAll').prop('checked', true);
		}else{
			$('#SelectAll').parent().removeClass('checked');
			$('#SelectAll').prop('checked', false);
		}
	},
	actions : {
		updateAllToSelectedList(value){
			$('#ResultRows :checkbox').each(function(){
				if(value){
					$(this).iCheck('check');
				}else{
					$(this).iCheck('uncheck');
				}
			});
		},
		updateToSelectedList(value, id){
			this.sendAction('updateToSelectedList', id);		//No I18N
			if(value){
				this.updateSelectAllCheckbox();
			}else{
				$('#SelectAll').parent().removeClass('checked');
				$('#SelectAll').prop('checked', false);
			}
		},
		updateAsSelectedItem(id){
			this.sendAction('updateToSelectedList', id);		//No I18N
		},
		changeInputSel(uniqueColVal){

				var jElement = '#Checkbox_'+ESCUTIL.escapeSelectorId(uniqueColVal);	//NO I18N
				if($(jElement).prop('checked')){
					$(jElement).iCheck('uncheck');
				}else{
					$(jElement).iCheck('check');
				}
			
		}
	}
});
