/*$Id$*/
import Ember from 'ember';//No I18N
import $ from "jquery";//No I18N
import DialogUtil from "../utils/ads-dialog-util";//No I18N
import CommonUtil from "../utils/ads-common-util";//No I18N
import AJAXUtil from '../utils/ads-ajax-util';//No I18N

let NAVIGATION = Ember.Object.extend({
startCount:0,
endCount:0,
totalCount:-1,
nPage:1,
recordsPerPage:0,
updatePageNavigationParameters() {
	var current_page=this.nPage;
	var rpp=this.recordsPerPage;
	this.set('endCount',rpp*current_page);//No I18N
	if(this.endCount > this.totalCount)
	{
		this.set('endCount',this.totalCount);//No I18N
	}
	var start=(rpp*current_page)-rpp;
	this.set('startCount',start+1);//No I18N
	return;
}
});

let checkBoxDefault = Ember.Object.extend({
	nCaseSensitive:false,
	nWholeWord:false,
	mCaseSensitive:false,
	mWholeWord:false,
	fCaseSensitive:false,
	fWholeWord:false,
	resetCheckBox() {
		this.set('nCaseSensitive',false); //No I18N
		this.set('nWholeWord',false); //No I18N
		this.set('mCaseSensitive',false); //No I18N
		this.set('mWholeWord',false); //No I18N
		this.set('fCaseSensitive',false); //No I18N
		this.set('fWholeWord',false); //No I18N
	}
});

diff_match_patch.prototype.html = function (a,flag) {
    var text;
    text = "";
    a.forEach(function (d,i) {
        if (a[i][0] === 0) {
            text += "" + a[i][1] + "";
        } else if (a[i][0] === 1 && flag) {
            text += "<span class='highlight-replace no-bor-tra'>" + a[i][1] + "</span>";
        } else if (a[i][0] === -1 && !flag) {
            text += "<span class='highlight no-bor-tra'>" + a[i][1] + 			 "</span>";
        }
    });
    return text;
};

const dmp = new diff_match_patch();

dmp.Diff_Timeout = 3;

export default Ember.Component.extend({
navData:NAVIGATION.create(),
apiNamespace:'/RestAPI/WC/Translation', //No I18N
checkBoxValue:checkBoxDefault.create(),
pageStatus : {},
searchQuery:'',
localeID:'',
replaceWith:'',
find:'',
currentText:'',
toBeReplaced:'',
Checkbox_selected:0,
isButtonDisabled:Ember.computed('replaceWith','find',function() { //No I18N
    let replaceWith=this.replaceWith;
	let find=this.find;
	if(find.length==0 || replaceWith.length==0 || find.replace(/\s/g,'').length==0 || replaceWith.replace(/\s/g,'').length==0) {
		return true;
	}
	return false;
}),

isReplaceButtonDisabled:Ember.computed('Checkbox_selected',function() { //No I18N
	if(this.Checkbox_selected==0) {
		return true;
	}
	return false;
}),

clrSrh:Ember.computed('searchQuery',function() { //No I18N
	if(this.searchQuery=='') {
		return false;
	}
	else {
		return true;
	}
}),

diff: Ember.computed("currentText", "toBeReplaced", function () { //No I18N
    var firstText = this.get("currentText").trim(); //No I18N
		 firstText=firstText.replace(/</g,"&lt;").replace(/&n/g,"&#38;n");
    var secondText = this.get("toBeReplaced").trim(); //No I18N
		secondText=secondText.replace(/</g,"&lt;").replace(/&n/g,"&#38;n");
    if (!firstText) {
			return null;
		}
    const d = dmp.diff_main(firstText, (secondText  || firstText));
		dmp.diff_cleanupSemantic(d);
    return d;
}),

rCurrentText: Ember.computed("diff", function () { //No I18N
  if (this.get("diff")) {
      return dmp.html(this.get("diff"),false); //No I18N
  }
	else {
    return "";
  }
}),

rReplacedText: Ember.computed("diff", function () { //No I18N
    if (this.get("diff")) {
      return dmp.html(this.get("diff"),true); //No I18N
    }
		else {
      return "";
    }
}),

init:function()
{
	this._super(...arguments);
	var self=this;
	self.set('rtlLanguage',[]);//No I18N
	var responseData=AJAXUtil.syncAjax(self.apiNamespace + '?mTCall=getParams',null, null, 'json');//No I18N
	self.set('SELECTED_LANGUAGE',responseData.SELECTED_LANGUAGE);//No I18N
	self.set('rtlLanguage',responseData.rtl);//No I18N
	self.set('isNoteEnabled',responseData.IS_NOTE_ENABLED); //No I18N

	var responseData=AJAXUtil.syncAjax("/RestAPI/WC/ADSPersonalize?mTCall=getPersonalizeSettings",null,null,'json');//No I18N
	responseData.AVAILABLE_LANGUAGES.splice(0,1);
	if(responseData.SELECTED_LANGUAGE!=0) {
		self.set('SELECTED_LANGUAGE',responseData.SELECTED_LANGUAGE);//No I18N
	}
	self.set('personalizeData',responseData);//No I18N
	self.set('boundOnClick', self.get('outsideClick').bind(self)); //No I18N
},

willInsertElement() {
    this._super(...arguments);
    window.addEventListener('click', this.get('boundOnClick'), false);
},

willDestroyElement() {
    this._super(...arguments);
    window.removeEventListener('click', this.get('boundOnClick'), false);
},

didInsertElement:function() {
	this.send('getResult',25,1,false);//No I18N
	CommonUtil.afterRender();
},

didRender: function() {
	this.send('checkForRTL',false);//No I18N
	var windowHeight=$(window).height();
	var height=windowHeight-340;
	$(".fw-custom-scroll-hover").attr("style","height:"+height+"px; overflow: hidden;");
	this.set('nheight',height-35);//No I18N
	this.set('npadding',Math.ceil(this.nheight/2));//No I18N
	if(this.isNoteEnabled) {
		$("#NOTE").removeClass('hide');
	}
},

outsideClick:function(e) {
	if (!$('.drop-tra').is(e.target) && $('.drop-tra').has(e.target).length === 0 && $('.open').has(e.target).length === 0) {
		$('.drop-tra').removeClass('open');
		$('.advanceFindAct').addClass('hide');
	}
},

setInitValues: function(localeID,update)
{
	var self=this;
	self.set('initData',{}); //No I18N
	var data={"LOCALE_ID":localeID,"SEARCH_QUERY":this.searchQuery};//No I18N
	AJAXUtil.ajax(self.apiNamespace + '?mTCall=getInitValues', data, null, 'json').then(//No I18N
	function(responseData)
	{
		self.set('initData',responseData); //No I18N
		if(update==false) {
			self.set('navData.totalCount',self.initData.resultCount);//No I18N
			self.set('navData.startCount',0);//No I18N
			if(self.initData.resultCount!==0) {
				self.set('navData.startCount',1);//No I18N
			}
			self.set('navData.nPage',1);//No I18N
			self.set('navData.endCount',self.navData.recordsPerPage);//No I18N
			if(self.navData.recordsPerPage > self.initData.resultCount) {
				self.set('navData.endCount',self.initData.resultCount);//No I18N
			}
		}
		if(update==true) {
			if(self.navData.totalCount==self.navData.endCount) {
				self.set('navData.totalCount',self.initData.resultCount);//No I18N
				self.set('navData.endCount',self.navData.totalCount);//No I18N
			}
			else {
				self.set('navData.totalCount',self.initData.resultCount);//No I18N
			}
		}
	}
	)
	return;
},

openReplace: function()
{
	this.send('getResult',25,1,null,null,true);//No I18N
	this.set('Checkbox_selected',0);//No I18N
	$("#replaceContainer").removeClass("hide");
	$("#defaultView").addClass("hide");
	$('#searchBox').addClass('hide');
	$('.result-tot-count').removeClass('hide');
	this.set('replaceWithText',this.replaceWith); //No I18N
	this.set('findWhat',this.find); //No I18N
	this.set('fCaseSensitive',this.checkBoxValue.fCaseSensitive); //No I18N
	this.set('fWholeWord',this.checkBoxValue.fWholeWord); //No I18N
	return;
},

bulkModify: function()
{
	var self=this;
	var localeID=$('#LOCALE_ID').val();
	var key=self.get('bulkModifyKey');//No I18N
	var replaceWith=this.get('replaceWithText');//No I18N
	replaceWith=this.escapeString(replaceWith);
	if(this.preventXSS(replaceWith)) {
		DialogUtil.alert(this,'ads.common.translation.xss_message');//No I18N
	}
	else {
		var searchFor=self.findWhat;
	    var obj={"LOCALE_ID":localeID,"SEARCH_FOR":searchFor,"REPLACE_WITH":replaceWith,"KEY_ARRAY":key,"IS_CASE_SENSITIVE":self.fCaseSensitive,"MATCH_WHOLE_WORD":self.fWholeWord}; //No I18N
		var data={"DATA":JSON.stringify(obj)};//No I18N
		AJAXUtil.ajax(self.apiNamespace + '?mTCall=bulkModify',data, null, 'json').then(//No I18N
		function(responseData)
		{
			('sSTATUS' in responseData) ? self.sendAction('showStatus','success',responseData.sSTATUS,true) :	self.sendAction('showStatus','danger',responseData.eSTATUS,false);//No I18N
			self.set('Checkbox_selected',0);//No I18N
			$('#FULL_SELECT').prop('checked', false);
			$('#FULL_SELECT').iCheck('update');
			self.setInitValues(localeID,true);
			self.send('getResult',self.navData.recordsPerPage,self.navData.nPage);//No I18N
		}
		)
	}
},

simpleModify: function(key,value,path)
{
	var self=this;
	var localeID=$('#LOCALE_ID').val();
	var params= {"LOCALE_ID":localeID,"KEY":key,"VALUE":value,"PATH":path};//No I18N

	AJAXUtil.ajax(self.apiNamespace + '?mTCall=modify', params, null, 'json').then(//No I18N
	function(responseData)
	{

		('sSTATUS' in responseData) ? self.sendAction('showStatus','success',responseData.sSTATUS,true) :	self.sendAction('showStatus','danger',responseData.eSTATUS,false);//No I18N
		self.send('getResult',self.navData.recordsPerPage,self.navData.nPage,null,true);//No I18N
		if($('.table-modal').hasClass('open')) {
			self.send('openModal','no');//No I18N
		}
	}
	)
},

setResultData: function(page,rpp,searchKey,localeID,update,isFAR)
{
	this.set('resultData',[]);//No I18N
	this.set('preResultData',[]);//No I18N
	var self=this;
	var isCaseSensitive=this.checkBoxValue.nCaseSensitive;
	var matchWholeword=this.checkBoxValue.nWholeWord;
	if(isFAR!=undefined && isFAR==true || !$('.result-tot-count').hasClass('hide')) {
		isCaseSensitive=this.checkBoxValue.fCaseSensitive;
		matchWholeword=this.checkBoxValue.fWholeWord;
	}
	var params= {"LOCALE_ID":localeID,"SEARCH_QUERY":searchKey,"RECORDS_PER_PAGE":rpp,"PAGE":page,"IS_CASE_SENSITIVE":isCaseSensitive,"MATCH_WHOLE_WORD":matchWholeword};//No I18N

	AJAXUtil.ajax(self.apiNamespace + '?mTCall=getResources', params, null, 'json').then(//No I18N
	function(responseData)
	{
		if(update!==undefined) {
			self.setInitValues(localeID,update);
		}
		self.set('resultData',responseData);//No I18N
		if(self.resultData.length==0) {
			self.set('noResultFound',true); //No I18N
		}
		else {
			self.set('noResultFound',false); //No I18N
		}
		self.setPreResultData(self.noResultFound);
	}
	)
},

setPreResultData: function(noResultFound)
{
	if(noResultFound) {
		this.send('cancelReplace');//No I18N
	}
	var result=this.get('resultData'); //No I18N
	var self=this;
	var replaceWith=this.get('replaceWith'); //No I18N
	this.set('preResultData',[]);//No I18N
	var isEnabled;
	result.forEach(function(entry)
	{
		var obj={"KEY":entry.KEY,"IS_ENABLED":false,"ORIGINAL_VALUE":entry.VALUE,"PATH":entry.PATH};//No I18N
		self.get('preResultData').pushObject(obj); //No I18N
	});
},

preventXSS:function(text)
{
	if(text.indexOf("<script") >= 0 || text.indexOf("</script>") >= 0) {
		return true;
	}
	return false;
},

escapeString:function(str)
{
	return str.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g,'\\$&');
},

filterExp:function(query,isCaseSensitive,matchWholeword)
{
		let regexFlags;
		let regexp;
		query=this.escapeString(query);

		if(!isCaseSensitive && !matchWholeword) {
			regexFlags = 'gmi'; //No I18N
			regexp=new RegExp(query,regexFlags);
		}
		else if(!isCaseSensitive && matchWholeword) {
			regexFlags = 'gmi'; //No I18N
			query='\\b(?:'+query+')(?=\\s|$)'; //No I18N
			regexp=new RegExp(query,regexFlags);
		}
		else if(isCaseSensitive && !matchWholeword) {
			regexFlags = 'gm'; //No I18N
			regexp=new RegExp(query,regexFlags);
		}
		else {
			regexFlags = 'gm'; //No I18N
			query='\\b(?:'+query+')(?=\\s|$)'; //No I18N
			regexp=new RegExp(query,regexFlags);
		}
		return regexp;
},

actions:
{
	getResult: function(rPerPage,page,isEmpty,skipScroll,isFAR)
	{
		CommonUtil.showLoading();
		var rpp=rPerPage;
		var searchKey=$('#SEARCH_QUERY').val();
		if(isFAR!=undefined && isFAR==true || !$('.result-tot-count').hasClass('hide')) {
			searchKey=this.find;
		}
		if(searchKey.replace(/\s/g,'').length==0 && isEmpty) {
			DialogUtil.alert(this,'ads.common.text.alert.valid_text');//No I18N
		}
		else {
			var localeID=$('#LOCALE_ID').val();
			if(localeID==null ||localeID==undefined) {
				localeID=this.SELECTED_LANGUAGE.toString();
			}
			localeID.toString();
			if(this.localeID!==localeID || this.searchQuery!==searchKey || this.navData.recordsPerPage!==rpp || page===1) {
				this.set('Checkbox_selected',0);//No I18N
				$('#FULL_SELECT').prop('checked', false);
				$('#FULL_SELECT').iCheck('update');
				this.set('navData.recordsPerPage',rpp);//No I18N
				this.set('localeID',localeID);//No I18N
				this.set('searchQuery',searchKey);//No I18N
				if(isFAR!=undefined && isFAR==true || !$('.result-tot-count').hasClass('hide')) {
					this.setResultData(page,rpp,searchKey,localeID,false,true);
		  	}
				else {
					this.setResultData(page,rpp,searchKey,localeID,false);
				}
			}
			else {
				if(isFAR!=undefined && isFAR==true || !$('.result-tot-count').hasClass('hide')) {
					this.setResultData(page,rpp,searchKey,localeID,true,true);
		  	}
				else {
					this.setResultData(page,rpp,searchKey,localeID,true);
				}
				this.navData.updatePageNavigationParameters();
			}
		}
		if(skipScroll==undefined || !skipScroll) {
			$('.mCSB_dragger').attr('style','position: absolute; min-height: 30px; height: 60px; top: 0px; display: block; max-height: 310px;');
			$('.mCSB_container').attr('style','position: relative; top: 0px; left: 0px;');
		}
		var windowHeight=$(window).height();
		var height=windowHeight-340;
		$(".fw-custom-scroll-hover").attr("style","height:"+height+"px; overflow: hidden;");
		this.set('nheight',height-35);//No I18N
		this.set('npadding',Math.ceil(this.nheight/2));//No I18N
		CommonUtil.hideLoading();
	},

	openModal: function(open) {
		var self=this;
		self.set('modifiedTextResult',[]);//No I18N
		self.set('filterResult',[]);//No I18N
		var localeID =$('#LOCALE_ID').val();
		var data={"LOCALE_ID":localeID};//No I18N
		AJAXUtil.ajax(self.apiNamespace + '?mTCall=getModifiedText', data, null, 'json').then(//No I18N
			function(responseData)
			{
				self.set('modifiedTextResult',responseData);//No I18N
				self.set('filterResult',self.get('modifiedTextResult'));//No I18N
				if(open==="yes") {
					$('.table-modal').addClass('open');
					var height=self.nheight+25;
					if(!($('#replaceContainer').hasClass("hide"))) {
						height=height+47;
					}
					$('.modal-height').attr("style","height:"+height+"px;");
					$(".freeze-mod-bg").removeClass("hide");
				}
				else {
					if(self.modifiedTextResult.length==0) {
						self.send('closeModal'); //No I18N
					}
					else {
						self.send('filterMyModification','yes'); //No I18N
					}
				}
			}
		)
	},

	filterMyModification: function(escape) {
		var self=this;
		var searchKey=$('#mmSearch_query').val();
		if(searchKey.replace(/\s/g,'').length==0 && escape!='yes' ) {
			DialogUtil.alert(this,'ads.common.text.alert.valid_text');//No I18N
		}
		else	{
			self.set('filterResult',[]);//No I18N
			if(!searchKey.length==0) {
				$('.clr-srh-mod').removeClass("hide");
				var result=this.get('modifiedTextResult');//No I18N
				const regexp=self.filterExp(searchKey,self.checkBoxValue.mCaseSensitive,self.checkBoxValue.mWholeWord);
				result.forEach(function(entry)
				{
					var str=entry.VALUE;
					if(str.match(regexp)) {
						self.get('filterResult').pushObject(entry);//No I18N
					}
				});
				if(self.filterResult.length==0) {
					$(".no-res-modal").removeClass("hide");
					self.set('modSearchQ',searchKey); //No I18N
				}
				else {
					$(".no-res-modal").addClass("hide");
				}
			}
			else {
				self.set('filterResult',self.get('modifiedTextResult')); //No I18N
				if(self.filterResult.length==0) {
					$(".no-res-modal").removeClass("hide");
				}
				else {
					$(".no-res-modal").addClass("hide");
				}
			}
		}
	},

	closeModal: function() {
		$('#mmSearch_query').val('');
		$('.table-modal').removeClass('open');
		$(".no-res-modal").addClass("hide");
		$(".freeze-mod-bg").addClass("hide");
	},

	resetAll: function() {
		var self=this;
		var localeID =$('#LOCALE_ID').val();
		var data={"LOCALE_ID":localeID};//No I18N
		AJAXUtil.ajax(self.apiNamespace + '?mTCall=resetAll',data, null, 'json').then(//No I18N
			function(responseData)
			{
				('sSTATUS' in responseData) ? self.sendAction('showStatus','success',responseData.sSTATUS,true) :	self.sendAction('showStatus','danger',responseData.eSTATUS,false);//No I18N
				self.set('modifiedTextResult',[]);//No I18N
				self.set('filterResult',[]);//No I18N
				self.setInitValues(localeID,true);
				self.send('getResult',self.navData.recordsPerPage,self.navData.nPage);//No I18N
				self.send('closeModal'); //No I18N
			}
		)
	},

	pageNavigationCheck(page) {
		if(this.get('Checkbox_selected')!=0) {
			this.set('navPage',page); //No I18N
			DialogUtil.confirm(this,'ads.common.text.alert.navigation.message','previewGotoPage','ads.common.text.translation.yes',null,null,null,null,'ads.common.text.translation.no');//No I18N
		}
		else {
			this.send('previewGotoPage',page);//No I18N
		}
	},

	previewGotoPage:function(page) {
		if(page==null) {
			page=this.navPage
			$('#FULL_SELECT').prop('checked', false);
			$('#FULL_SELECT').iCheck('update');
			this.set('Checkbox_selected',0);//No I18N
		}
		var rpp=this.navData.recordsPerPage;
		var pageVal = this.get('navData.nPage');//No I18N
		if (page == 'first') {
			pageVal = 1;
		}
		else if (page == 'next') {
			pageVal = pageVal + 1;
		}
		else if (page == 'prev') {
			pageVal = pageVal - 1;
			if (pageVal < 1) {
				pageVal = 1;
			}
		}
		else if (page == 'end') {
			pageVal = Math.ceil(this.get('navData.totalCount') / rpp);//No I18N
		}
		else {
			pageVal = 1;
		}
		this.set('navData.nPage',pageVal);//No I18N
		this.send('getResult',rpp,pageVal);//No I18N
		$('.mCSB_dragger').attr('style','position: absolute; min-height: 30px; height: 60px; top: 0px; display: block; max-height: 310px;');
		$('.mCSB_container').attr('style','position: relative; top: 0px; left: 0px;');
	},

	modify:function(val,id) {
		$("[spanindex="+id+"]").attr("data-old-text",val);//No I18N
		$("#"+id).val(val);
		var rows=Math.ceil(val.length / 100);
		if(rows==1) {
			$("#"+id).attr("style","width:600px;height:21px;");
		}
		else {
			$("#"+id).attr("style","width:600px;height:66px;");
		}
		$("[index="+id+"]").addClass('open');
	},

	modalModify:function(value,id) {
		$("[modalspanindex="+id+"]").attr("data-old-text",value);//No I18N
		$("[data="+id+"]").val(value);
		$("[modalindex="+id+"]").addClass('open');
		var rows=Math.ceil(value.length / 100);
		if(rows==1) {
			$("[data="+id+"]").attr("style","width:600px;height:21px;");
		}
		else {
			$("[data="+id+"]").attr("style","width:600px;height:66px;");
		}
	},

	save:function(id,key,path) {
		var message=$("#"+id).val();
		if(message.replace(/\s/g,'').length==0) {
			DialogUtil.alert(this,'ads.common.text.alert.replacement_string');//No I18N
		}
		else if(this.preventXSS(message)) {
			DialogUtil.alert(this,'ads.common.translation.xss_message');//No I18N
		}
		else {
			$("[spanindex="+id+"]").text(message);//No I18N
			$("[index="+id+"]").removeClass('open');
			if(  $("[spanindex="+id+"]").text() !=  $("[spanindex="+id+"]").attr("data-old-text")) {
				$("[removehide="+id+"]").removeClass('hide');
				this.simpleModify(key,message,path);//No I18N
			}
		}
	},

	modalSave:function(id,key,path) {
		var message=$("[data="+id+"]").val();
		if(message.replace(/\s/g,'').length==0) {
			DialogUtil.alert(this,'ads.common.text.alert.replacement_string');//No I18N
		}
		else if(this.preventXSS(message)) {
			DialogUtil.alert(this,'ads.common.translation.xss_message');//No I18N
		}
		else {
			$("[modalspanindex="+id+"]").text(message);//No I18N
			$("[modalindex="+id+"]").removeClass('open');
			if(  $("[modalspanindex="+id+"]").text() !=  $("[modalspanindex="+id+"]").attr("data-old-text")) {
				this.simpleModify(key,message,path);//No I18N
			}
		}
	},

	resetConfirmation: function(key,ct,path,id,isModal) {
		var self=this;
		if(isModal==true)
		{
			var currentText=$("[modalspanindex="+id+"]").text();//No I18N
			this.set('isModal',true);//No I18N
		}
		else
		{
			this.set('isModal',false);//No I18N
			var currentText=$("[spanindex="+id+"]").text();//No I18N
		}
		self.set('currentText',currentText);//No I18N
		self.set('resetKey',key);//No I18N
		self.set('path',path);//No I18N
		self.set('index',id);//No I18N
		var localeID=$('#LOCALE_ID').val();
		var data={"LOCALE_ID":localeID,"KEY":key,"PATH":path};//No I18N
		AJAXUtil.ajax(self.apiNamespace + '?mTCall=getParentText',data, null, 'json').then(//No I18N
			function(responseData)
			{
				self.set('toBeReplaced',responseData.to_be_replaced);//No I18N
				$("#reset").modal('show');
			}
		)
	},

	reset: function() {
		var self=this;
		var key=self.resetKey;
		var path=self.path;
		var id=self.index;
		var localeID=$('#LOCALE_ID').val();
		var data={"LOCALE_ID":localeID,"KEY":key,"PATH":path};//No I18N

		AJAXUtil.ajax(self.apiNamespace + '?mTCall=reset',data, null, 'json').then(//No I18N
			function(responseData)
			{
				('sSTATUS' in responseData) ? self.sendAction('showStatus','success',responseData.sSTATUS,true) :	self.sendAction('showStatus','danger',responseData.eSTATUS,false);//No I18N
				if($('.table-modal').hasClass('open')) {
					self.send('openModal','no');//No I18N
				}
				$("#reset").modal('hide');
				self.send('getResult',self.navData.recordsPerPage,self.navData.nPage);//No I18N
			}
		)
	},

	replaceButton: function() {
		var key=null;
		var self=this;
		self.set('bulkModifyKey',[]);//No I18N
		var resultData=this.get('preResultData').filterBy('IS_ENABLED',true);//No I18N
		resultData.forEach(function(entry)
		{
		 	key='{"KEY":"'+entry.KEY+'",'+'"PATH":"'+entry.PATH+'"}'; //No I18N
		 	self.get('bulkModifyKey').pushObject(key);//No I18N
		});
		this.bulkModify();//No I18N
	},

	cancelReplace: function() {
 		$("#replaceContainer").addClass("hide");
 		$("#defaultView").removeClass("hide");
 		$('#searchBox').removeClass('hide');
 		$('.result-tot-count').addClass('hide');
 		this.set('replaceWith','');//No I18N
 		this.set('find',''); //No I18N
 		this.set('Checkbox_selected',0);//No I18N
 		$('#FULL_SELECT').prop('checked', false);
 		$('#FULL_SELECT').iCheck('update');
	},

	checkForRTL:function(getResult) {
		var localeID=$('#LOCALE_ID').val();
		var rtlLanguage=this.get('rtlLanguage');//No I18N
		if(rtlLanguage.indexOf(parseInt(localeID)) >=0 ) {
			$('.ad360-rtl-support').addClass('ad360-rtl');
		}
		else {
			$('.ad360-rtl-support').removeClass('ad360-rtl');
		}
		if(getResult) {
			this.send('clearSearch');//No I18N
		}
	},

	clearSearch:function(isModal) {
		this.checkBoxValue.resetCheckBox(); //No I18N
		if(isModal=='true') {
			CommonUtil.showLoading();
    	$('.clr-srh-mod').addClass("hide");
			$('#mmSearch_query').val('');
			this.send('openModal',"no"); //No I18N
			CommonUtil.hideLoading();
		}
		else {
			if(!$("#replaceContainer").hasClass("hide")) {
				this.send('cancelReplace'); //No I18N
			}
			CommonUtil.showLoading();
			$('#SEARCH_QUERY').val('');
			CommonUtil.hideLoading();
			this.send('getResult',25,1,false);//No I18N
		}
	},

	cancel:function(id) {
		$("[index="+id+"]").removeClass('open');
	},

	modalCancel:function(id) {
		$("[modalindex="+id+"]").removeClass('open');
	},

	resetAllConfirmation: function () {
		var self=this;
		DialogUtil.confirm(self,'ads.admin.personalize.translation.resetAll','resetAll','ads.common.text.translation.yes',null,null,null,null,'ads.common.text.translation.no');//No I18N
	},

	update: function(value,index) {
		var resultData=this.preResultData;
		Ember.set(resultData.objectAt(index),'IS_ENABLED',value); //No I18N
		this.set('preResultData',resultData); //No I18N
		var count=this.get('preResultData').filterBy('IS_ENABLED',true).get('length'); //No I18N
		if(count==resultData.length) {
			$('#FULL_SELECT').prop('checked', true);
			$('#FULL_SELECT').iCheck('update');
		}
		if(!value) {
			$('#FULL_SELECT').prop('checked', false);
			$('#FULL_SELECT').iCheck('update');
		}
		var total=this.get('navData.endCount')-this.get('navData.startCount')+1; //No I18N
		if(value==true && this.Checkbox_selected!=total) {
			var count=this.get('preResultData').filterBy('IS_ENABLED',true).get('length');//No I18N
			this.set('Checkbox_selected',count); //No I18N
		}
		if(value==false && this.Checkbox_selected!=0) {
			this.set('Checkbox_selected',this.Checkbox_selected-1); //No I18N
		}
	},

	selectAll:function(value) {
    this.get("preResultData").setEach('IS_ENABLED',value);//No I18N
    this.set('Checkbox_selected',0);//No I18N
	if(value==true && this.navData.totalCount!=0) {
		this.set('Checkbox_selected',this.get('navData.endCount')-this.get('navData.startCount')+1);//No I18N
	}
	},

	findAndReplace:function() {
		if(this.preventXSS(this.replaceWith)) {
			DialogUtil.alert(this,'ads.common.translation.xss_message'); //No I18N
			this.send('closeFindReplace'); //No I18N
		}
		else {
			$('#SEARCH_QUERY').val('');
			this.send('closeFindReplace'); //No I18N
			this.openReplace();//No I18N
		}
	},

	closeNote:function() {
		AJAXUtil.ajax(this.apiNamespace + '?mTCall=disableNote');//No I18N
		$('#NOTE').fadeOut('slow');
	},

	openFindReplace:function() {
		$('.drop-tra').addClass('open');
	},

	closeFindReplace:function() {
		$('.advanceFindAct').addClass('hide');
		$('.drop-tra').removeClass('open');
	},

	openOptions:function() {
		$('.advanceFindAct').toggleClass('hide');
		$('.tog-caret').toggleClass("right");
	},

	updateModalCBox:function(value,index) {
		(index==1)?this.set('checkBoxValue.mCaseSensitive',value) : this.set('checkBoxValue.mWholeWord',value); //No I18N
	},

	updateFindReplaceCBox:function(value,index) {
		(index==1)?this.set('checkBoxValue.fCaseSensitive',value) : this.set('checkBoxValue.fWholeWord',value); //No I18N
	},

	updatePageCBox:function(value,index) {
		(index==1)?this.set('checkBoxValue.nCaseSensitive',value) : this.set('checkBoxValue.nWholeWord',value); //No I18N
	},

	reload:function() {
		if(window.location.host==top.location.host) {
				window.parent.location.reload();
		}
	}
}
});
