/*
 *$Id : component.js $
 */
import Ember from 'ember';		//NO I18N

Ember.Checkbox.reopen({
  attributeBindings: ['uniqueColumn','uniqueDisplayColumn']		//No I18N
});

export default Ember.Component.extend({
	didReceiveAttrs(){
		this._super(...arguments);
		var self = this;
		Ember.run.scheduleOnce('afterRender', this, function(){				//No I18N
			$('#maintree').on('changed.jstree', function(e, data) {	
				if(data.node != undefined){
					self.updateSelectedList(data.node.id, data.node);
				}
			});
		}); 
	},
	didRender(){
		if($(".fw-custom-scroll").length){ 	       
			$(".fw-custom-scroll").each(function () {

        if ($(this).attr('data-height')) {
                $(this).height($(this).attr('data-height')).css({
                    "overflow": "hidden" //NO I18N
                });
            }

        var theme = ($(this).attr("data-theme")) ? $(this).attr("data-theme") : "light"; //NO I18N
            var axis = ($(this).attr("data-axis")) ? $(this).attr("data-axis") : "";
            var sPosition = ($(this).attr("data-scrollbar-position")) ? $(this).attr("data-scrollbar-position") : "inside"; //NO I18N
            var hover = ($(this).attr("data-hover")) ? $(this).attr("data-hover") : "false";

            $(this).mCustomScrollbar({
                theme: theme,
                autoHideScrollbar: hover,
                scrollbarPosition: sPosition,
                axis: axis,
                advanced:{
                    autoExpandHorizontalScroll:true //optional (remove or set to false for non-dynamic/static elements)
                },
                callbacks: {
                    onScroll: function(evt) {
                        return false;
                    },
                    onTotalScroll: function(evt) {
                        return false;
                    },
                    onTotalScrollBack: function(evt) {
                        return false;
                    }

                }
            });
			});
		}
	},
	updateSelectedList(id, node){
		this.sendAction('updateToSelectedList', id, node);	//NO I18N
	},
	actions : {
		updateAllToSelectedList(value, id){
			this.sendAction('updateToSelectedList', id);	//NO I18N
		}
	}
});
