/*
  $Id: ads-status-util.js,v 1.2.12.2 2018/12/04 14:35:16 ganesh.venkatraman Exp $
*/
//ignorei18n_start
import Ember from 'ember';//NO I18N
import I18NUtil from "../utils/i18n-util";//No I18N

export default Ember.Object.create
({
	/*
	 * Usage :
	 * var params = []; params[1]='value';//0th element will be allocated to message
	 * StatusUtil.showStatus(this, '1i8nkey/value', params);
	 */
	showStatus : function(th, statusModel, params)
	{
		if(th.get("GLOBAL_DATA.FORM_STATUS_TIMEOUT")!=null)
		    clearTimeout(th.get("GLOBAL_DATA.FORM_STATUS_TIMEOUT"));//No I18N
		var autoClose = true;
		if('AUTO_CLOSE' in statusModel)
		{
			autoClose=statusModel.AUTO_CLOSE;
		}
		var fsm={};
		if('sSTATUS' in statusModel)
		{
			fsm.TYPE='status-alert-success';//No I18N
			fsm.ICON='icn-status-alert-success';//No I18N
			fsm.MESSAGE=I18NUtil.translate(statusModel.sSTATUS, params);
			/* th.set('GLOBAL_DATA.FORM_STATUS_MODEL.ICON', 'icn-status-alert-success');//No I18N
			th.set('GLOBAL_DATA.FORM_STATUS_MODEL.MESSAGE', I18NUtil.translate(statusModel.sSTATUS, params));//No I18N	 */
			th.set("GLOBAL_DATA.FORM_STATUS_MODEL",fsm);//No I18N
		}
		else if('eSTATUS' in statusModel)
		{
			fsm.TYPE='status-alert-danger';//No I18N
			fsm.ICON='icn-status-alert-danger';//No I18N
			fsm.MESSAGE=I18NUtil.translate(statusModel.eSTATUS,params);
			/* th.set('GLOBAL_DATA.FORM_STATUS_MODEL.ICON', 'icn-status-alert-danger');//No I18N
			th.set('GLOBAL_DATA.FORM_STATUS_MODEL.MESSAGE', I18NUtil.translate(statusModel.eSTATUS, params));//No I18N	 */
			th.set("GLOBAL_DATA.FORM_STATUS_MODEL",fsm);//No I18N
			if(!('AUTO_CLOSE' in statusModel))
			    autoClose = false;
		}

		Ember.$("#FORM_STATUS").insertBefore(Ember.$("ad360-top-pane"));
		Ember.$("#FORM_STATUS").delay(500).slideDown('slow');

		if(autoClose)
		{
			var timer = setInterval(function()
			{
				Ember.$('#FORM_STATUS').delay(500).slideUp('slow');
				clearTimeout(timer);
			}, 5000);
			th.set("GLOBAL_DATA.FORM_STATUS_TIMEOUT",timer);//No I18N
			Ember.$('#FORM_STATUS').attr('TIMER', timer);//NO I18N
		}
	},
	showStatusWithMessage : function(th,type,message,autoClose)
	{
		if(th.get("GLOBAL_DATA.FORM_STATUS_TIMEOUT")!=null)
		clearTimeout(th.get("GLOBAL_DATA.FORM_STATUS_TIMEOUT"));//No I18N
		var fsm={};
	    fsm.MESSAGE=message;
		if(type=='success')
		{
			fsm.TYPE='status-alert-success';//No I18N
		    fsm.ICON='icn-status-alert-success';//No I18N
		}
		else if(type=='danger')
		{
			fsm.TYPE='status-alert-danger';//No I18N
			fsm.ICON='icn-status-alert-danger';//No I18N
		}
		else if(type=='info')
		{
			fsm.TYPE='status-alert-info';//No I18N
			fsm.ICON='icn-status-alert-info';//No I18N
		}
		else if(type=='warning')
		{
			fsm.TYPE='status-alert-warning';//No I18N
			fsm.ICON='icn-status-alert-warning';//No I18N
		}
		th.set("GLOBAL_DATA.FORM_STATUS_MODEL",fsm);//No I18N
		Ember.$("#FORM_STATUS").insertBefore(Ember.$("ad360-top-pane"));
		Ember.$("#FORM_STATUS").delay(500).slideDown('slow');
		if(autoClose)
		{
			var timer = setInterval(function()
			{
				Ember.$('#FORM_STATUS').delay(500).slideUp('slow');
				clearTimeout(timer);
			}, 5000);
			th.set("GLOBAL_DATA.FORM_STATUS_TIMEOUT",timer);//No I18N
			Ember.$('#FORM_STATUS').attr('TIMER', timer);//NO I18N
		}
	}
});
//ignorei18n_end