/**
 * $Id$
 */

var doCallSelectAllHandler = true;

var PopupDataModel = function(pdmObj){
	this.advancedFilterId = pdmObj.advancedFilterId;
	this.popupDataModelId = pdmObj.popupDataModelId;
	this.viewModelId = pdmObj.viewModelId;
	this.priority = pdmObj.priority;
	this.isDefaultSelected = pdmObj.isDefaultSelected;
	this.isSingleOrMultiple = pdmObj.isSingleOrMultiple;
	this.menuItemList = new Array();
	this.initMenuItemList(pdmObj.menuItemList);
	this.isLoaded = false;
	this.isFiltersApplied = false;
	this.rangeNavigationConfig = pdmObj.rangeNavigationConfig || {"start":1,"end":10,"rangeList":[10,25,50,100],"url":""}; //NO I18N	
	this.searchText = '';
}

PopupDataModel.prototype.initMenuItemList = function(menuItemLists){
	for(var i=0; i<menuItemLists.length; i++){
		this.menuItemList[i] = menuItemLists[i];
	}
}
PopupDataModel.onClicked = function(pdmId){
	popup.currentTab.currentAFO.currentPDM = popup.currentTab.currentAFO.getPdmObject(pdmId);
	popup.currentTab.currentAFO.currentPDM.onClicked();
	popup.currentTab.currentAFO.currentPDM.updateListToUI();
}
/**
 * Here two scenario will come 1. isLoaded true and another one is false
 */
PopupDataModel.prototype.onClicked = function(){
	if(!this.isLoaded){
		this.isLoaded = true;
		if(!this.popupNavigation){
			this.popupNavigation = new PopupNavigation();
			this.popupNavigation.init(this.rangeNavigationConfig);
			this.popupNavigation.setUniqueId(this.popupDataModelId);
		}
		this.getPDMView();
	}
	else {
		this.showPDMView();
	}
}
PopupDataModel.onSearch = function(pdmId){	
	adsjQuery('#ClearOU_'+pdmId).show();//No I18N
	if(!adsjQuery('#searchText_'+pdmId).val())	//When manually clears the text
	{
		adsjQuery('#ClearOU_'+pdmId).hide();//No I18N
	}
	if(popup.currentTab.currentAFO.currentPDM.onSearch() == false)
		return;
	setTimeout(function() { adsjQuery('#searchText_'+pdmId).focus(); }, 100);	//On IE, only the delayed-focus works
}

PopupDataModel.processExcludeChildOU = function(isChecked)
{
	adsjQuery('[name=excludeChildOU]').prop('checked', isChecked);	//No I18N
}

PopupDataModel.onExcludeOUChange = function(object)
{	
	var isExcludeChildOU = adsjQuery(object).prop("checked");	//No I18N
	popup.commonMenuConf.put("exclude_child_ou", isExcludeChildOU);	//No I18N	
}

PopupDataModel.onDomainChange = function(){	
	PopupDataModel.resetNavigation();	
	var domainName = adsjQuery('#domainSelection').val();//No I18N
	var index = adsjQuery("#domainSelection option:selected").index();//No I18N
	if(index == 0)
		popup.params.put("allDomains", "true");		//NO I18N
	else
	{	popup.params.put("domainDN", domainName);	//NO I18N
		popup.params.put("allDomains", "false");	//NO I18N
	}
	popup.currentTab.currentAFO.currentPDM.getPDMView(); 
}

PopupDataModel.clearSearch = function(pdmId){
	PopupDataModel.clearSearchComponent(pdmId);
	popup.currentTab.currentAFO.currentPDM.onSearch();
}
PopupDataModel.onNext = function(){
	popup.currentTab.currentAFO.currentPDM.onNext();
}
PopupDataModel.onPrev = function(){
	popup.currentTab.currentAFO.currentPDM.onPrev();
}
PopupDataModel.onNextAll = function(){
	popup.currentTab.currentAFO.currentPDM.onNextAll();
}
PopupDataModel.onPrevAll = function(){
	popup.currentTab.currentAFO.currentPDM.onPrevAll();
}
PopupDataModel.onSelectOrClearAll = function(){
	popup.currentTab.currentAFO.currentPDM.onSelectOrClearAll()
}
PopupDataModel.setRange = function(rangeVal){
	popup.currentTab.currentAFO.currentPDM.setRange(rangeVal);
}
PopupDataModel.prototype.onSelectOrClearAll = function(){
	if(popup.isFlatTheme)
	{
		this.onSelectOrClearAllFT();
		return;
	}
	var list = PopupDataModel.getSelectedList();//popup.currentTab.selectedList;
	var unSelectedList = PopupDataModel.getUnSelectedList();	
	var resultDivId = this.getResultDivId();
	if(adsjQuery('#PopupSelectAll_'+this.popupDataModelId).attr("checked")){
		//Need to process all the check box and if any of the check box is not checked...we need to check that and include it in selectedList
		adsjQuery('#'+resultDivId+' input:checkbox[name="BulkCheckBoxList"]').each(function() { //No I18N
			if(!adsjQuery(this).attr("checked")){
				var alreadySelected = false;
				var fnName = PopupScriptConfig["Popup_"+popup.popupScriptConfigId].onSelectItem;
				if(fnName)
				{	if(!FunctionUtil.getFunctionFromName(fnName)(docid(adsjQuery(this).attr('id')))) //No I18N
					alreadySelected = true;}
				if(!alreadySelected)
				{var val = PopupDataModel.getDisplayValue(adsjQuery(this).attr('id'));	//No I18N
				list.put(adsjQuery(this).val(), val);
				unSelectedList.remove(adsjQuery(this).val());
				adsjQuery(this).attr("checked",true);//No I18N
			}
			}
		});			
	}
	else {
		//Need to process  all the checked checkbox and remove it from the list
		adsjQuery('#'+resultDivId+' input:checkbox[name="BulkCheckBoxList"]:checked').each(function() { //No I18N
			if(adsjQuery(this).attr("checked")){
				var val = PopupDataModel.getDisplayValue(adsjQuery(this).attr('id'));     //No I18N
				list.remove(adsjQuery(this).val());
				unSelectedList.put(adsjQuery(this).val(),val);
				adsjQuery(this).attr("checked",false);//No I18N
			}
		});
	}
	popup.updateCount();
	popup.currentTab.currentAFO.currentPDM.changeStateOfSelectAll();
}
PopupDataModel.prototype.onSelectOrClearAllFT = function(){
	if(!doCallSelectAllHandler)
		return;
	var resultDivId = this.getResultDivId();
	if(adsjQuery('#PopupSelectAll_'+this.popupDataModelId).attr("checked")){
		//Need to process all the check box and if any of the check box is not checked...we need to check that and include it in selectedList
		adsjQuery('#'+resultDivId+' input:checkbox[name="BulkCheckBoxList"]').each(function() { //No I18N
			if(!adsjQuery(this).attr("checked")){
				var alreadySelected = false;
				var fnName = PopupScriptConfig["Popup_"+popup.popupScriptConfigId].onSelectItem;
				if(fnName)
				{	
					if(!FunctionUtil.getFunctionFromName(fnName)(docid(adsjQuery(this).attr('id')))) //No I18N
						alreadySelected = true;
				}
				if(!alreadySelected)
				{
					var checkBoxId = adsjQuery(this).attr('id'); //No I18N
					$('#'+JSONUtil.escapeSelectorId(checkBoxId)).iCheck('check');//No I18N
				}
			}
		});			
	}
	else {
		//Need to process  all the checked checkbox and remove it from the list
		adsjQuery('#'+resultDivId+' input:checkbox[name="BulkCheckBoxList"]:checked').each(function() { //No I18N
			if(adsjQuery(this).attr("checked")){
				var checkBoxId = adsjQuery(this).attr('id'); //No I18N
				$('#'+JSONUtil.escapeSelectorId(checkBoxId)).iCheck('uncheck');//No I18N
			}
		});
	}
}
PopupDataModel.prototype.changeStateOfSelectAll = function(checked){
	if(popup.isFlatTheme)
	{
		this.changeStateOfSelectAllFT(checked);
		return;
	}
	var isAllSelected = true;
	var resultDivId = this.getResultDivId();
	adsjQuery('#'+resultDivId+' input:checkbox[name="BulkCheckBoxList"]').each(function() { //No I18N
		if(!adsjQuery(this).attr("checked")){
			isAllSelected = false;	
		}
	});
	if(isAllSelected){
		if(adsjQuery('#PopupSelectAll_'+this.popupDataModelId)){
			adsjQuery('#PopupSelectAll_'+this.popupDataModelId).attr("checked",true); //No I18N
		}
	}
	else {
		if(adsjQuery('#PopupSelectAll_'+this.popupDataModelId)){
			adsjQuery('#PopupSelectAll_'+this.popupDataModelId).attr("checked",false); //No I18N
		}
	}
	popup.updateCount();
}
/**
 * 
 * 
 */
PopupDataModel.prototype.changeStateOfSelectAllFT = function(checked){
	var isAllSelected = true;
	var resultDivId = this.getResultDivId();
	adsjQuery('#'+resultDivId+' input:checkbox[name="BulkCheckBoxList"]').each(function() { //No I18N
		if(!adsjQuery(this).attr("checked")){
			isAllSelected = false;	
		}
	});
	if(isAllSelected){
		if(adsjQuery('#PopupSelectAll_'+this.popupDataModelId)){
			if(!adsjQuery('#PopupSelectAll_'+this.popupDataModelId).attr("checked"))
			{
				doCallSelectAllHandler = false; // To prevent recursive call of Select All Checked Handler
				$('#PopupSelectAll_'+this.popupDataModelId).iCheck('check');
				doCallSelectAllHandler = true;
			}
		}
	}
	else {
		if(adsjQuery('#PopupSelectAll_'+this.popupDataModelId)){
			if(adsjQuery('#PopupSelectAll_'+this.popupDataModelId).attr("checked"))
			{
				doCallSelectAllHandler = false; // To prevent recursive call of Select All Checked Handler
				$('#PopupSelectAll_'+this.popupDataModelId).iCheck('uncheck');
				doCallSelectAllHandler = true;
			}
		}
	}
	popup.updateCount();
}

//Only for flatTheme version which utilizes jstree plugin
PopupDataModel.prototype.changeStateOfParentNode = function(parentNodeId,isDontInheritChildOUsSelected){
	var list = PopupDataModel.getSelectedList();
	var childNodes = ($('#jsTreeOuPopup').jstree('get_node',parentNodeId)).children;
	var isAllSelected = true;
	var isDomain = (parentNodeId == 'PopupSelectAll_'+popup.currentTab.currentAFO.currentPDM.popupDataModelId); //No I18N
	var key = $('#'+parentNodeId).attr('value');
	var val = PopupDataModel.getDisplayValue(parentNodeId);
	for (i = 0; i < childNodes.length; i++)
	{
		var childNodeDetails = $('#jsTreeOuPopup').jstree('get_node',childNodes[i]);
		if((childNodeDetails.id).startsWith('CheckBoxList_') && !childNodeDetails.state.selected)
		{
			isAllSelected = false;
			break;
		}
	}
	if(isAllSelected)
	{
		$('#jsTreeOuPopup').jstree().select_node(parentNodeId,true,false);
		if(!isDomain)
		{
			list.put(key, val);
		}
	}
	else
	{
		if(!isDontInheritChildOUsSelected)
		{
			$('#jsTreeOuPopup').jstree().deselect_node(parentNodeId,true);
			if(!isDomain)
				list.remove(key);
		}
	}

}

PopupDataModel.prototype.getResultDivId = function(){
	if(popup.currentTab.currentAFO.currentPDM.isFiltersApplied)
	{
		return 'FilterSelectionArea';	//No I18N
	}
	else
	{
		return 'Result_'+this.popupDataModelId;	//No I18N
	}
}
PopupDataModel.updateToSelectedList = function(obj){
	if(popup.isFlatTheme)
	{
		this.updateToSelectedListFT(obj);
		return;
	}
	var fnName = PopupScriptConfig["Popup_"+popup.popupScriptConfigId].onSelectItem;
	var nodeSelectorId = JSONUtil.escapeSelectorId(obj.value);
	if(fnName && !FunctionUtil.getFunctionFromName(fnName)(obj))
	{	return false;	}
	//1.update to the AFO selected list
	var list = PopupDataModel.getSelectedList();	
	var val = PopupDataModel.getDisplayValue(obj.getAttribute('id'));			//NO I18N
	if(popup.currentTab.currentAFO.currentPDM.isSingleOrMultiple === 2){
		if(popup.currentTab.currentAFO.currentPDM.viewModelId == 13)
		{
			var isExcludeSelected = false;
			if(popup.currentTab.currentAFO.currentPDM.menuItemList.contains(PopupSelectionConstants.EXCLUDE_CHILD_OU)) 
			{
			isExcludeSelected = adsjQuery('[name=excludeChildOU]').prop('checked');	//No I18N
				/* Update the Unselected list in UI based only when we have exclude option in POP-UP  */
				PopupDataModel.updateToUnselectedList(obj, isExcludeSelected);
			}
			
			if(!isExcludeSelected)
			{
				var level = parseInt(adsjQuery("#"+nodeSelectorId).attr('level'))+1;		//No I18N
				
				var childDiv = adsjQuery("#"+nodeSelectorId).find('#childDiv_'+level);
				childDiv.find('input').each(function(){
				adsjQuery(this).attr('checked', obj.checked); 	//No I18N
				if(this.checked)
				{
					list.put(this.value,PopupDataModel.getDisplayValue(this.getAttribute('id')));					
				}
				else {
					list.remove(this.value);
				}
				});
			}
			else		// We need to Manage all the unSelected checkboxes so that we can maintain a Stable Usecase for all the scenario's
			{
				var level = parseInt(adsjQuery("#"+nodeSelectorId).attr('level'))+1;		//No I18N
				var childDiv = adsjQuery("#"+nodeSelectorId).find('#childDiv_'+level);
				childDiv.find('input').each(function(){
					if(!this.checked)
					{
						PopupDataModel.updateToUnselectedList(this, isExcludeSelected);	
					}	
				});
			}
		}
		if(obj.checked){
			list.put(obj.value, val);
		}
		else {
			list.remove(obj.value);
		}
		
		popup.currentTab.currentAFO.currentPDM.changeStateOfSelectAll(obj.checked);
	}
	else {
		if(list.keys[0]){
			list.remove(list.keys[0]);
		}
		list.put(obj.value, val);
	}
}
PopupDataModel.updateToSelectedListFT = function(obj){
	var fnName = PopupScriptConfig["Popup_"+popup.popupScriptConfigId].onSelectItem;
	var value = $(obj).attr('value');
	//var nodeSelectorId = JSONUtil.escapeSelectorId(value);
	if(fnName && !FunctionUtil.getFunctionFromName(fnName)(obj))
	{	return false;	}
	//1.update to the AFO selected list
	var list = PopupDataModel.getSelectedList();
	var selectedNodeId = $(obj).prop('id');
	var val = PopupDataModel.getDisplayValue(selectedNodeId);
	var isChecked = $(obj).prop('checked');
	var isDomain = false; // If Domain Root Node Selected

	if(popup.currentTab.currentAFO.currentPDM.isSingleOrMultiple === 2){
		if(popup.currentTab.currentAFO.currentPDM.viewModelId == 13)
		{
			var isDontInheritChildOUsSelected = adsjQuery('#DontInheritOUs').prop('checked'); //No I18N
			isChecked = $('#jsTreeOuPopup').jstree().is_selected(selectedNodeId); //No I18N
			if(!isDontInheritChildOUsSelected)
			{
				var childNodesDetails = ($('#jsTreeOuPopup').jstree('get_node',selectedNodeId)).children_d;
				for (i = 0; i < childNodesDetails.length; i++) {
					if(childNodesDetails[i].startsWith('CheckBoxList_')) // To filter out empty/dummy nodes
					{
						var domNode = $('#'+childNodesDetails[i]);
						var nodeKey = domNode.attr('value'); //No I18N
						var nodeValue;
						if(nodeKey != undefined)
						{
							nodeValue = PopupDataModel.getDisplayValue(domNode.prop('id')); //No I18N
						}
						else{
							// Parent node not expanded. Can't use DOM, So need to fetch value via jstree
							var jstreeNodeDetails = $('#jsTreeOuPopup').jstree('get_node',childNodesDetails[i]);
							nodeKey = jstreeNodeDetails.li_attr.value;
							nodeValue = jstreeNodeDetails.li_attr.uniquedisplaycolumn;
						}
						if(isChecked)
						{
							$('#jsTreeOuPopup').jstree().select_node(childNodesDetails[i],true,false);
							list.put(nodeKey,nodeValue);
						}
						else
						{
							$('#jsTreeOuPopup').jstree().deselect_node(childNodesDetails[i],true);
							list.remove(nodeKey);
						}
					}
				}
			}
			isDomain = (selectedNodeId == 'PopupSelectAll_'+popup.currentTab.currentAFO.currentPDM.popupDataModelId); //No I18N
		}
		if(!isDomain){
			if(isChecked){
				list.put(value, val);
			}
			else {
				list.remove(value);
			}
		}
		popup.updateCount();
		if(popup.currentTab.currentAFO.currentPDM.viewModelId == 11)
		{	
			popup.currentTab.currentAFO.currentPDM.changeStateOfSelectAll(isChecked);
		}
		else if(popup.currentTab.currentAFO.currentPDM.viewModelId == 13)
		{
			if(!isDomain)
			{
				popup.currentTab.currentAFO.currentPDM.changeStateOfParentNode('PopupSelectAll_'+popup.currentTab.currentAFO.currentPDM.popupDataModelId,isDontInheritChildOUsSelected); // No I18N
			}
		}
	}
	else {
		if(list.keys[0]){
			list.remove(list.keys[0]);
		}
		list.put(value, val);
	}

}

PopupDataModel.updateToUnselectedList = function(obj, isExcludeSelected){
	var unSelectedList = PopupDataModel.getUnSelectedList();	
	var val = PopupDataModel.getDisplayValue(obj.getAttribute('id'));
	var nodeSelectorId = JSONUtil.escapeSelectorId(obj.value);
	if(popup.currentTab.currentAFO.currentPDM.viewModelId == 13)
	{
		if(!isExcludeSelected){
			var level = parseInt(adsjQuery("#"+nodeSelectorId).attr('level'))+1;		//No I18N
			
			var childDiv = adsjQuery("#"+nodeSelectorId).find('#childDiv_'+level);
			childDiv.find('input').each(function(){
				adsjQuery(this).attr('checked', obj.checked);	//No I18N
				if(this.checked)
				{
					unSelectedList.remove(this.value);	// Add to UnSelected list When a OU check Box is removed 
				}
				else {
					unSelectedList.put(this.value,PopupDataModel.getDisplayValue(this.getAttribute('id')));  // Remove from Unselected list if its selected again
				}
			});
		}	
	}
		
	if(obj.checked)
	{
		unSelectedList.remove(obj.value);	// Remove from Unselected list if its selected again
	}
	else {
		unSelectedList.put(obj.value,val);	// Add to UnSelected list When a OU check Box is removed 
	}
}
PopupDataModel.openNode = function(nodeId)
{
	if(popup.isFlatTheme)
	{
		this.openNodeFT(nodeId);
		return;
	}
	var nodeSelectorId = JSONUtil.escapeSelectorId(nodeId);
	var anchorimg = adsjQuery('#'+nodeSelectorId+'_ancimg').attr('src');//No I18N
	var level = parseInt(adsjQuery('#'+nodeSelectorId).attr('level'))+1;//No I18N
	var childDiv = adsjQuery('#'+nodeSelectorId).find('#childDiv_'+level);
	var isParentSelected = "";
	if(popup.currentTab.currentAFO.currentPDM.isSingleOrMultiple == 2)	
		isParentSelected = document.getElementById('CheckBoxList_'+nodeSelectorId).checked;
	else					
		isParentSelected = document.getElementById('RadioBoxList_'+nodeSelectorId).checked;
	if(anchorimg.match('images/trplus.png'))
	{
		var params = new PopupRequestParams();
		params.init();
		params.setNodeId(nodeId);
		if(childDiv.length == 0)
		{
			AjaxAPI.sendRequest({URL:"ADSPopupAction.do?methodToCall=getDataModelUIDesign",PARAMETERS:"params="+params.toJSONString(),ONSUCCESSFUNC:"PopupDataModel.appendToNode", ONFAILUREFUNC:"PopupDataModel.fetchDataFailure",NODEID:nodeSelectorId,OPSTATUSID:"popupLoadingDiv",OPSTATUSTYPE:"", OPSTATUSMESSAGE: "Loading ...", OPSTATUSLOADINGCLASS: "templateLoadingmessage ", OPSTATUSLOADEDCLASS: "templateLoadedmessage "});	//Appends response to current node	//No I18N
		}
		else
		{
			adsjQuery('#'+nodeSelectorId+'_ancimg').attr('src','images/trminus.png'); //No I18N
			childDiv.show();
		}
	}
	else if(anchorimg.match('images/trminus.png'))
	{
		childDiv.hide();
		adsjQuery('#'+nodeSelectorId+'_ancimg').attr('src','images/trplus.png');//No I18N
	}	
}
PopupDataModel.appendToNode = function(response, requestOptions)
{
	var nodeId = requestOptions['NODEID'];
	var level = parseInt(adsjQuery('#'+nodeId).attr('level'))+1;//No I18N
	var isParentSelected = requestOptions['ISPARENTSELECTED'];
	var isExcludeSelected;
	var resultTable = adsjQuery(adsjQuery(adsjQuery(response.responseText).filter('#heightDiv').get(0)).contents().filter('table').get(0));			//NO I18N
	adsjQuery('#'+nodeId).children('td:first').append(resultTable);//No I18N
	adsjQuery('#'+nodeId).children('td:first').find('table:first').attr('id', 'childDiv_'+level);						//NO I18N
	isExcludeSelected = adsjQuery('[name=excludeChildOU]').attr('checked');	//No I18N
	var childDiv = adsjQuery('#'+nodeId).find('#childDiv_'+level);
	adsjQuery('#'+nodeId+'_ancimg').attr('src','images/trminus.png');//No I18N
	if(adsjQuery.trim(childDiv.text())=="")	{	
		adsjQuery('#'+nodeId+'_anchor').before(adsjQuery('<img width="20" height="20" border="0" align="absmiddle" src="images/trans.gif">'));
		adsjQuery('#'+nodeId+'_anchor').remove();	//No I18N
	}
	childDiv.find('tr').each(function(){
		adsjQuery(this).attr('level',level);//No I18N
		for(var i=1; i<level; i++)
			adsjQuery(this).find('td:first').prepend(adsjQuery('<img width="20" height="20" border="0" align="absmiddle" src="images/trans.gif">'));
	}); 
	if(isParentSelected && !isExcludeSelected)
	{
		childDiv.find('input').each(function()
		{
     		adsjQuery(this).attr('checked',true); 	//No I18N
			PopupDataModel.updateToSelectedList(this);
		});	
	}
	else	// We need to Manage all the unSelected checkboxes so that we can maintain a Stable Usecase for all the scenario's
	{
		childDiv.find('input').each(function()
		{
			PopupDataModel.updateToUnselectedList(this, isExcludeSelected);
		});	
	}
	childDiv.show();
	popup.currentTab.currentAFO.currentPDM.updateListToUI();
}
PopupDataModel.openNodeFT = function(nodeId)
{
	var nodeSelectorId = JSONUtil.escapeSelectorId(nodeId);
	var isParentSelected = $('#jsTreeOuPopup').jstree().is_selected('#CheckBoxList_'+nodeSelectorId); //No I18N
	adsjQuery('#CheckBoxList_'+nodeSelectorId).addClass('jstree-loading'); //No I18N
	var params = new PopupRequestParams();
	params.init();
	params.setNodeId(nodeId);
	var paramsStr = params.toJSONString() + '&isFlatTheme=' + popup.isFlatTheme; //No I18N
	AjaxAPI.sendRequest({URL:"ADSPopupAction.do?methodToCall=getDataModelUIDesign",PARAMETERS:"params="+paramsStr,ONSUCCESSFUNC:"PopupDataModel.appendToNodeFT", ONFAILUREFUNC:"PopupDataModel.fetchDataFailureFT",NODEID:nodeSelectorId, ISPARENTSELECTED:isParentSelected});	//Appends response to current node	//No I18N
}
PopupDataModel.appendToNodeFT = function(response, requestOptions)
{
	//For handling session timeout
	if(response.transport.responseText.indexOf('isLoginPage') > -1){ //No I18N
		location.href = "../";	  //No I18N
		return;
	}
	var nodeId = requestOptions['NODEID'];
	var parentId = 'CheckBoxList_'+nodeId; //No I18N
	var isParentSelected = requestOptions['ISPARENTSELECTED']; //No I18N
	var isExcludeSelected = true;
	var resultTable = adsjQuery(adsjQuery(adsjQuery(response.responseText).filter('#heightDiv').get(0)).contents().find('ul').get(0));//NO I18N
	resultTable.contents('li').each(function(){ //No I18N
		$('#jsTreeOuPopup').jstree().create_node(parentId ,  
			{ 
				"id" : $(this).prop('id'), //No I18N
				"text" : encodeHtmlEntities($(this).attr('uniquedisplaycolumn')), //No I18N
				"li_attr" : {"nodeId" : $(this).attr('nodeId') , "name" : $(this).attr('name') ,"value" : $(this).attr('value') , "level" : $(this).attr('level') ,"uniquedisplaycolumn" : $(this).attr('uniquedisplaycolumn')}  //No I18N
			},
			"last",function(){ $('#jsTreeOuPopup').jstree().open_node(parentId); } //No I18N
		);
		//Empty list in order to render the expand arrow for the jstree nodes from level 2 children
		$('#jsTreeOuPopup').jstree().create_node( $(this).prop('id') ,  //No I18N
			{ 
				"id" :"",//No I18N
				"text" : "", //No I18N
				"li_attr" : {"class" : "emptyNode"}  //No I18N
			},
			"last",function(){} //No I18N
		);
	});
	adsjQuery('#'+parentId).removeClass('jstree-loading'); //No I18N
	if(isParentSelected && !isExcludeSelected)
	{
		PopupDataModel.updateToSelectedList(adsjQuery('#'+parentId));
	}
}
PopupDataModel.getSelectedList = function(){
	if(popup.isFlatTheme)
	{
		return this.getSelectedListFT();
	}
	var list = new Hashtable();
	if(adsjQuery('#popupButton').is(':visible'))	//If popup button is visible then this pdm should update tab selected list or else this pdm is for filter
	{
		list = popup.currentTab.selectedList;
	}
	else
	{
		list = popup.currentTab.currentAFO.selectedList;
	}
	return list;
}
PopupDataModel.getSelectedListFT = function(){
	var list = new Hashtable();
	list = popup.currentTab.selectedList;
	return list;
}
PopupDataModel.getUnSelectedList = function(){
	var list = new Hashtable();
	if(adsjQuery('#popupButton').is(':visible'))	//If popup button is visible then this pdm should update tab selected list or else this pdm is for filter
	{
		list = popup.currentTab.unSelectedList;
	}
	else
	{
		list = popup.currentTab.currentAFO.unSelectedList;
	}
	return list;
}

/**
 * Update the selected list in UI based on the checkbox or radio
 */
PopupDataModel.prototype.updateListToUI = function(){
	if(popup.isFlatTheme)
	{
		this.updateListToUIFT();
		return;
	}
	var list = PopupDataModel.getSelectedList();
	var resultDivId = this.getResultDivId();
	adsjQuery('#'+resultDivId+' input:checkbox[name="BulkCheckBoxList"]').each(function() { //No I18N
		adsjQuery(this).attr("checked",false);//No I18N
	});
	if(this.isSingleOrMultiple === 2)
	{
		if(this.viewModelId==PopupSelectionConstants.TABLE_DATA_MODEL || this.viewModelId == PopupSelectionConstants.TREE_DATA_MODEL) 
		{
			for(var i=0; i<list.keys.length; i++){
				adsjQuery('#'+resultDivId+' input:checkbox[id="CheckBoxList_'+list.keys[i]+'"]').attr("checked", true);//No I18N
				if(popup.currentTab.currentAFO.currentPDM.menuItemList.contains(PopupSelectionConstants.EXCLUDE_CHILD_OU))
				{
					popup.currentTab.currentAFO.currentPDM.updateUnSelectedListToUI(); // Update the Unselected list in UI based only when we have exclude option in TREE VIEW - in POP-UP 
				}
			}
			this.changeStateOfSelectAll();
		}
		else if(this.viewModelId==PopupSelectionConstants.ADD_REMOVE_DATA_MODEL) {	// Add/Remove Data model
			for(var i=0; i<list.keys.length; i++){
				var key = list.keys[i];
				var value = list.get(key);
			
				var selectObj = adsjQuery('#attr'); //No I18N
				for(var j=0; j<selectObj.options.length; j++) {
					var optionObj = selectObj.options[j];

					var optionValue = optionObj.value;
					if(key == optionValue) {
						var groupType = adsjQuery(optionObj).attr("groupType");		// Member Of in User Mgmt under layout only, this variable is used.//No I18N

						if(typeof groupType!='undefined' && groupType!=null) {
	
							adsjQuery('#attr1').append(//No I18N
								adsjQuery('<option></option>').val(key).html(value).attr("groupType", groupType)	//NO I18N
							);
						}
						else {
							adsjQuery('#attr1').append(//No I18N
								adsjQuery('<option></option>').val(key).html(value)
							);
						}
						
						 selectObj.options[j] = null;
						 j--;

					}	
				}	
			}
		}
		else if(this.viewModelId === 14) 
		{
			for(var i=0; i<list.keys.length; i++){
				var key = list.keys[i];
				var value = list.get(key);
				
				adsjQuery("#attr1 option[value="+key+"]").attr('selected','selected');//No I18N
			
			}
		}
	}
	else {
		//at any point of time there will be only one key in single selection
		if(list.keys[0]){
			var key = JSONUtil.escapeSelectorId(list.keys[0]);
			adsjQuery('#'+resultDivId+' input:radio[id="CheckBoxList_'+list.keys[i]+'"]').attr("checked", true);//No I18N
		}
	}
}

PopupDataModel.prototype.updateListToUIFT = function(){
	var list = PopupDataModel.getSelectedList();
	var tempSelectedList = JSON.parse(JSON.stringify(list.keys)); // Selected list will be emptied when unchecking all
	var resultDivId = this.getResultDivId();
	if(this.isSingleOrMultiple === 2)
	{
		if(this.viewModelId==PopupSelectionConstants.TABLE_DATA_MODEL) 
		{
			adsjQuery('#'+resultDivId+' input:checkbox[name="BulkCheckBoxList"]').each(function() { //No I18N
				$('#'+JSONUtil.escapeSelectorId(adsjQuery(this).prop('id'))).iCheck('uncheck');//No I18N
			});
			for(var i=0; i<tempSelectedList.length; i++){
				$('#CheckBoxList_'+JSONUtil.escapeSelectorId(tempSelectedList[i])).iCheck('check');//No I18N
			}
		}
		else if(this.viewModelId == PopupSelectionConstants.TREE_DATA_MODEL)
		{
			// FT jsTree updation, deselecting all the nodes and selecting from them selected list
			$('#jsTreeOuPopup').jstree().deselect_all(false);
			for(var i=0; i<tempSelectedList.length; i++){
				var key = tempSelectedList[i];
				if(key=='WHOLE_DOMAIN') // whole domain was selected 
				{
					//Selecting all the opened nodes
					list.remove(key);
					$('li[id^="CheckBoxList_"]').each(function(){
						var nodeId = $(this).attr('id');
						var value = $(this).attr('value');
						var val = $(this).attr('uniquedisplaycolumn');
						$('#jsTreeOuPopup').jstree().select_node(nodeId,true,false);
						list.put(value,val);
					});
					break;
				}
				var nodeId = '#CheckBoxList_'+JSONUtil.escapeSelectorId(key); //No I18N
				var val = adsjQuery(nodeId).attr('uniquedisplaycolumn'); //No I18N
				if(val == undefined)
				{
					// Parent node not expanded. Can't use DOM, So need to fetch value via jstree
					var jstreeNodeDetails = $('#jsTreeOuPopup').jstree('get_node',nodeId);
					if(jstreeNodeDetails==undefined || jstreeNodeDetails==false)
					{
						// Child nodes opening failed
						PopupDataModel.fetchDataFailureFT();
						return;
					}
					val = jstreeNodeDetails.li_attr.uniquedisplaycolumn;
				}
				$('#jsTreeOuPopup').jstree().select_node(nodeId,true,false);
				list.put(key,val);
			}
			this.changeStateOfParentNode('PopupSelectAll_'+this.popupDataModelId,false);//No I18N
		}
		else if(this.viewModelId==PopupSelectionConstants.ADD_REMOVE_DATA_MODEL) {	// Add/Remove Data model
			adsjQuery('#'+resultDivId+' input:checkbox[name="BulkCheckBoxList"]').each(function() { //No I18N
				adsjQuery(this).attr("checked",false);//No I18N
			});
			for(var i=0; i<list.keys.length; i++){
				var key = list.keys[i];
				var value = list.get(key);
			
				var selectObj = adsjQuery('#attr'); //No I18N
				for(var j=0; j<selectObj.options.length; j++) {
					var optionObj = selectObj.options[j];

					var optionValue = optionObj.value;
					if(key == optionValue) {
						var groupType = adsjQuery(optionObj).attr("groupType");		// Member Of in User Mgmt under layout only, this variable is used.//No I18N

						if(typeof groupType!='undefined' && groupType!=null) {
	
							adsjQuery('#attr1').append(//No I18N
								adsjQuery('<option></option>').val(key).html(value).attr("groupType", groupType)	//NO I18N
							);
						}
						else {
							adsjQuery('#attr1').append(//No I18N
								adsjQuery('<option></option>').val(key).html(value)
							);
						}
						 selectObj.options[j] = null;
						 j--;

					}	
				}	
			}
		}
		else if(this.viewModelId === 14) 
		{
			adsjQuery('#'+resultDivId+' input:checkbox[name="BulkCheckBoxList"]').each(function() { //No I18N
				adsjQuery(this).attr("checked",false);//No I18N
			});
			for(var i=0; i<list.keys.length; i++){
				var key = list.keys[i];
				var value = list.get(key);
				
				adsjQuery("#attr1 option[value="+key+"]").attr('selected','selected');//No I18N
			
			}
		}
		popup.updateCount(); //To handle the selected objects display case, when groups changed in summary but back button takes it to OUs tab
	}
	else {
		adsjQuery('#'+resultDivId+' input:checkbox[name="BulkCheckBoxList"]').each(function() { //No I18N
			adsjQuery(this).attr("checked",false);//No I18N
		});
		//at any point of time there will be only one key in single selection
		if(list.keys[0]){
			var key = JSONUtil.escapeSelectorId(list.keys[0]);
			adsjQuery('#'+resultDivId+' input:radio[id="CheckBoxList_'+list.keys[i]+'"]').attr("checked", true);//No I18N
		}
	}
}

PopupDataModel.prototype.updateUnSelectedListToUI = function(){
	var resultDivId=this.getResultDivId();
	var unSelectedList = PopupDataModel.getUnSelectedList();
	if(unSelectedList.keys.length > popup.currentTab.currentAFO.currentPDM.popupNavigation.range) {
		adsjQuery('#'+resultDivId+' input:checkbox[name="BulkCheckBoxList"]').each(function() {	//No I18N
			if(unSelectedList.keys.contains(this.value))
			{
				var obj = document.getElementById('CheckBoxList_' + this.value);
				adsjQuery(obj) .attr('checked', false); // No i18N
			}
		});
	}
	else {
		for(var i=0; i<unSelectedList.keys.length; i++) {
			var obj = document.getElementById('CheckBoxList_' + unSelectedList.keys[i]);
			adsjQuery(obj).attr('checked', false); // No i18N
		}
	}
}

PopupDataModel.prototype.onNext = function(){
	if(this.popupNavigation){
		this.popupNavigation.onNext();
		this.getPDMView();
	}
}
PopupDataModel.prototype.onPrev = function(){
	if(this.popupNavigation){
		this.popupNavigation.onPrev();
		this.getPDMView();
	}
}
PopupDataModel.prototype.onNextAll = function(){
	if(this.popupNavigation){
		this.popupNavigation.onNextAll();
		this.getPDMView();
	}
}
PopupDataModel.prototype.onPrevAll = function(){
	if(this.popupNavigation){
		this.popupNavigation.onPrevAll();
		this.getPDMView();
	}
}
PopupDataModel.prototype.setRange = function(rangeVal){
	if(this.popupNavigation){
		this.popupNavigation.setRange(rangeVal);
		this.getPDMView();
	}
}

PopupDataModel.prototype.onSearch = function(){
	if(adsjQuery('#searchText_'+this.popupDataModelId).val() == this.searchText)//No I18N
		return false;
	this.searchText = adsjQuery('#searchText_'+this.popupDataModelId).val();//No I18N
	var range = this.popupNavigation.range;
	this.popupNavigation = new PopupNavigation();
	this.popupNavigation.init(this.rangeNavigationConfig);
	this.popupNavigation.setUniqueId(this.popupDataModelId);
	if(popup.isFlatTheme)
	{
		//Since FlatTheme has range provision
		this.popupNavigation.setRange(range);
	}
	this.getPDMView();
	return true;
}
PopupDataModel.clearSearchComponent = function(pdmId){
	adsjQuery('#ClearOU_'+pdmId).hide();//No I18N
	adsjQuery('#searchText_'+pdmId).val('');	//No I18N
}
PopupDataModel.refreshView = function(){
	PopupDataModel.resetNavigation();
	if(popup.isFlatTheme)
		popup.currentTab.currentAFO.currentPDM.searchText="";
	var params = new PopupRequestParams();
	params.init();
	params.setRefreshView();	
	params.resetFilters();	
	popup.params.put("colFilter", "{}"); //NO I18N	
	var paramsStr = params.toJSONString() + '&isFlatTheme=' + popup.isFlatTheme; //No I18N
	var successFunction = (popup.isFlatTheme)?"fetchDataSuccessFT":"fetchDataSuccess"; //No I18N
	var failureFunction = (popup.isFlatTheme)?"fetchDataFailureFT":"fetchDataFailure"; //No I18N
	AjaxAPI.sendRequest({URL:"ADSPopupAction.do?methodToCall=getDataModelUIDesign",PARAMETERS:"params="+paramsStr,ONSUCCESSFUNC:"PopupDataModel."+successFunction, ONFAILUREFUNC:"PopupDataModel."+failureFunction,OPSTATUSID:"popupLoadingDiv",OPSTATUSTYPE:"", OPSTATUSMESSAGE: "Loading ...", OPSTATUSLOADINGCLASS: "templateLoadingmessage", OPSTATUSLOADEDCLASS: "templateLoadedmessage "});	//NO I18N
}
/**
 * This is the single place where we will get the data and display
 */
PopupDataModel.prototype.getPDMView = function(){
	var params = new PopupRequestParams();
	params.init();	
	params.setPrevSelItems(PopupScriptConfig.getSelectedList());
	params.setUnPrevSelItems(PopupScriptConfig.getUnSelectedList());
	var paramsStr = params.toJSONString() + '&isFlatTheme=' + popup.isFlatTheme + '&popupDataModelId=' + this.popupDataModelId; //No I18N
	var successFunction = (popup.isFlatTheme)?"fetchDataSuccessFT":"fetchDataSuccess";//No I18N
	var failureFunction = (popup.isFlatTheme)?"fetchDataFailureFT":"fetchDataFailure";//No I18N
	AjaxAPI.sendRequest({URL:"ADSPopupAction.do?methodToCall=getDataModelUIDesign",PARAMETERS:"params="+paramsStr,ONSUCCESSFUNC:"PopupDataModel."+successFunction, ONFAILUREFUNC:"PopupDataModel."+failureFunction,OPSTATUSID:"popupLoadingDiv",OPSTATUSTYPE:"", OPSTATUSMESSAGE: "Loading ...", OPSTATUSLOADINGCLASS: "templateLoadingmessage", OPSTATUSLOADEDCLASS: "templateLoadedmessage "});	//NO I18N
}
PopupDataModel.fetchDataSuccess = function(response, requestOptions){
	adsjQuery('#Result_'+popup.currentTab.currentAFO.currentPDM.popupDataModelId).html(response.responseText); //NO I18N	
	if(popup.currentTab.currentAFO.currentPDM.popupNavigation){//No I18N
		popup.currentTab.currentAFO.currentPDM.popupNavigation.setTotal(defaultPopupNavigation.total);	
		popup.currentTab.currentAFO.currentPDM.popupNavigation.processDiv();
	}
	popup.currentTab.currentAFO.currentPDM.showPDMView();
	adsjQuery('#PopupDiv').show();//No I18N
	popup.currentTab.currentAFO.currentPDM.updateListToUI();
	popup.isLoaded = true;

	if(adsjQuery('#searchText_'+popup.currentTab.currentAFO.currentPDM.popupDataModelId).length > 0)//To avoid - IE placing cursor at the beginning of text onfocus //No I18N
	{
		adsjQuery('#searchText_'+popup.currentTab.currentAFO.currentPDM.popupDataModelId).focus(function(){	adsjQuery(this).val(adsjQuery(this).val());	}); //No I18N
	}
	
	var postDataLoadFnName = PopupScriptConfig["Popup_"+popup.popupScriptConfigId].postDataLoad;
	if(postDataLoadFnName){
		FunctionUtil.callFunctionByName(postDataLoadFnName,window);		//NO I18N
	}
}
PopupDataModel.fetchDataSuccessFT = function(response, requestOptions){
	//For handling session timeout
	if(response.transport.responseText.indexOf('isLoginPage') > -1){ //No I18N
		location.href = "../";	  //No I18N
		return;
	}
	if(popup.currentTab.currentAFO.currentPDM.popupDataModelId == 12 || popup.currentTab.currentAFO.currentPDM.popupDataModelId == 13)
	{	// For table view in flatTheme, toptoolbox will not be rendered again
		var topToolBoxContent = adsjQuery('#TopToolBox_'+popup.currentTab.currentAFO.currentPDM.popupDataModelId).html(); // No I18N
		adsjQuery('#Result_'+popup.currentTab.currentAFO.currentPDM.popupDataModelId).html('');//No I18N
		var topToolBoxContentElement =adsjQuery("<div class='top-tool-box' id='TopToolBox_"+popup.currentTab.currentAFO.currentPDM.popupDataModelId+"'></div>").html(topToolBoxContent);// No I18N
		adsjQuery('#Result_'+popup.currentTab.currentAFO.currentPDM.popupDataModelId).append(topToolBoxContentElement); //NO I18N
		adsjQuery('#Result_'+popup.currentTab.currentAFO.currentPDM.popupDataModelId).append(response.responseText); //NO I18N
		$('#Result_'+popup.currentTab.currentAFO.currentPDM.popupDataModelId+' .PopupTableViewContent td span[data-toggle="tooltip"]').tooltip({ html: false,container:"#PopupDiv" }); //No I18N
	}
	else
		adsjQuery('#Result_'+popup.currentTab.currentAFO.currentPDM.popupDataModelId).html(response.responseText); //NO I18N	
	if(popup.currentTab.currentAFO.currentPDM.popupNavigation){//No I18N
		popup.currentTab.currentAFO.currentPDM.popupNavigation.setTotal(defaultPopupNavigation.total);
		popup.currentTab.currentAFO.currentPDM.popupNavigation.processDiv();
	}
	popup.currentTab.currentAFO.currentPDM.updateListToUI();

	if(adsjQuery('#searchText_'+popup.currentTab.currentAFO.currentPDM.popupDataModelId).length > 0)			//To avoid - IE placing cursor at the beginning of text onfocus//No I18N
		adsjQuery('#searchText_'+popup.currentTab.currentAFO.currentPDM.popupDataModelId).focus(function(){adsjQuery(this).val(adsjQuery(this).val());});//No I18N
	if(popup.currentTab.currentAFO.currentPDM.searchText!='')
		adsjQuery('#searchText_'+popup.currentTab.currentAFO.currentPDM.popupDataModelId).val(popup.currentTab.currentAFO.currentPDM.searchText); //No I18N

	popup.currentTab.currentAFO.currentPDM.showPDMView();
	adsjQuery('#PopupDiv').show();//No I18N
	popup.isLoaded = true;
	var postDataLoadFnName = PopupScriptConfig["Popup_"+popup.popupScriptConfigId].postDataLoad;
	if(postDataLoadFnName){
		FunctionUtil.callFunctionByName(postDataLoadFnName,window);		//NO I18N
	}
}
PopupDataModel.fetchDataFailure = function(){
	alertMsg(jsTitleMsg.unknown_error); //NO I18N
}
PopupDataModel.fetchDataFailureFT = function(){
	DialogBox.closeDialog();
	showAlertBox(jsTitleMsg.unknown_error); //NO I18N
}
/**
 * 1. Enable the currentAFO link and view link.
 * 2. show currentAFO and view div alone
 */
PopupDataModel.prototype.showPDMView = function(){
	adsjQuery('#PopupDiv div[id|="tabLink"]').show();//No I18N
	adsjQuery('#PopupDiv div[id|="afolink"]').show();//No I18N
	adsjQuery('#PopupDiv div[id|="pdmlink"]').show();//No I18N
	//If there is only one Tab and under this Only one PDM then no need to show AFO and Pdm link
	//if(popup.tabsList.length === 1){
	//	adsjQuery('#PopupDiv div[id|="tabLink"]').hide();
	//}

	//If there is only one AFO and under this Only one PDM then no need to show AFO and Pdm link
	if(popup.currentTab.afoList.length === 1){
		adsjQuery('#Tab_'+popup.currentTab.tabId+' div[id|="afolink"]').hide();	//This should hide only the afolink under the specified tab //No I18N
	}
	//If there is only one AFO and under this two pdm then no need to show AFO link only show pdm link
	if(popup.currentTab.currentAFO.pdmList.length == 1){
		adsjQuery('#Afo_'+popup.currentTab.currentAFO.advancedFilterId+' div[id|="pdmlink"]').hide(); //No I18N
	} 

	//1. changing the class for tab link
	adsjQuery('#tabLink div[tabLinkId*="tabLink_"]').each(function(){//No I18N 
		adsjQuery(this).removeClass('popup-tab-active');//No I18N
		adsjQuery(this).addClass('popup-tab-normal');	//No I18N
		});
	adsjQuery('#tabLinkId_'+popup.currentTab.tabId).removeClass('popup-tab-normal').addClass('popup-tab-active');//No I18N
	adsjQuery('#showAllLink_'+popup.currentTab.tabId).hide();//No I18N
	if(!popup.currentTab.currentAFO.isDefaultSelected)	//If not default afo we will hide the filters and display show all link
	{
		adsjQuery('#PopupDiv div[id|="afolink"]').hide();//No I18N
		adsjQuery('#showAllLink_'+popup.currentTab.tabId).show();//No I18N
	}	

	//2. changing the class for pdm link
	adsjQuery('#Afo_'+popup.currentTab.currentAFO.advancedFilterId+' div[id*="pdmLinkId_"][pdmlinkId*="pdmlink_"]').each(function() {		 //No I18N
		adsjQuery(this).removeClass('opacityDiv').find('a').removeClass('disabledLink');						//NO I18N
		});
	adsjQuery('#pdmLinkId_'+popup.currentTab.currentAFO.currentPDM.popupDataModelId).addClass('opacityDiv').find('a').addClass('disabledLink');	//NO I18N
	adsjQuery('#AppliedFilterSelection').hide();//No I18N 
	adsjQuery('#backLinkId').hide(); //No I18N
	//3.showing approriate div 
	adsjQuery('#PopupDiv div[isafodiv|=true]').hide(); //No I18N
	adsjQuery('#PopupDiv div[ispdmdiv|=true]').hide();//No I18N
	adsjQuery('#PopupDiv div[istabdiv|=true]').hide();//No I18N
	adsjQuery('#Tab_'+popup.currentTab.tabId).show();//No I18N
	adsjQuery('#Afo_'+popup.currentTab.currentAFO.advancedFilterId).show();//No I18N
	adsjQuery('#PopupDataModel_'+popup.currentTab.currentAFO.currentPDM.popupDataModelId).show(); //No I18N
	//Divs that should be shown when div is loaded.Need to set these every time as once hidden these will not open again as header design will not load again
	if(popup.isFlatTheme)
	{
		adsjQuery('#Result_'+popup.currentTab.currentAFO.currentPDM.popupDataModelId+' .PopupTableViewContent').show();//No I18N
	}
	else
	{
		adsjQuery('#errorMsg').hide();	//No I18N
	}
	adsjQuery('#Result_'+popup.currentTab.currentAFO.currentPDM.popupDataModelId).show();//No I18N	
	adsjQuery('#buttonsDiv').show();//No I18N
	adsjQuery('#popupEaseNavigateDiv').show();//No I18N
	if(popup.currentTab.currentAFO.currentPDM.popupNavigation.total == 0 && popup.currentTab.currentAFO.currentPDM.menuItemList.contains(PopupSelectionConstants.NAVIGATE))	//this is when navigation is present.Menus will be present only in this view and menuitem check for knowing whether this pdm has navigation component or not
	{	
		if(popup.isFlatTheme)
		{
			adsjQuery('#Result_'+popup.currentTab.currentAFO.currentPDM.popupDataModelId+' .PopupTableViewContent').hide();//No I18N
		}
		else
		{
			adsjQuery('#Result_'+popup.currentTab.currentAFO.currentPDM.popupDataModelId).hide();//No I18N
			adsjQuery('#buttonsDiv').hide();//No I18N
			adsjQuery('#errorMsg').show();	//No I18N
		}
		var msg = "";
		if(adsjQuery('#searchText_'+popup.currentTab.currentAFO.currentPDM.popupDataModelId).val())	//when search txt is present should not hide the search txt
		{
			if(popup.currentTab.currentAFO.currentPDM.menuItemList.contains(PopupSelectionConstants.REFRESH))
			{
				msg = "adssp_popup_common_search_errormsg_text_no_objs_found_refresh";	//No I18N
				adsjQuery('#refreshDiv').show();//No I18N
			}
			else
			{
				msg = "adssp_popup_common_search_errormsg_text_no_objs_found"; 	//No I18N
				//adsjQuery('#refreshDiv').hide();
			}
			adsjQuery('#popupEaseNavigateDiv').hide();//No I18N
		}
		else
		{
			if(popup.currentTab.currentAFO.currentPDM.menuItemList.contains(PopupSelectionConstants.REFRESH))
			{
				msg = "adssp_popup_common_errormsg_text_no_objs_found_refresh";	//No I18N
				adsjQuery('#refreshDiv').show();//No I18N
			}
			else
			{
				msg = "adssp_popup_common_errormsg_text_no_objs_found";	//No I18N
				//adsjQuery('#refreshDiv').hide();
			}
			adsjQuery('#PopupDataModel_'+popup.currentTab.currentAFO.currentPDM.popupDataModelId).hide()//No I18N
		}
		if(popup.isFlatTheme)
			adsjQuery('#Result_'+popup.currentTab.currentAFO.currentPDM.popupDataModelId+' #errorMsgArea').html(jsTitleMsg[msg]);	//No I18N
		else
			adsjQuery('#errorMsgArea').html(jsTitleMsg[msg]);	//No I18N
	}
	if(adsjQuery('#searchText_'+popup.currentTab.currentAFO.currentPDM.popupDataModelId).val())	//when search txt is present should not hide the search txt
	{
		adsjQuery('#searchText_'+popup.currentTab.currentAFO.currentPDM.popupDataModelId).focus();//No I18N
		if(popup.isFlatTheme)
			adsjQuery('#ClearOU_'+popup.currentTab.currentAFO.currentPDM.popupDataModelId).show();//No I18N
	}
	if(popup.showSummaryViewOnly)
	{
		popup.showSummaryViewOnly = false;
		SummaryView.getSummaryView();
	}
	if(popup.currentTab.currentAFO.currentPDM.menuItemList.contains(PopupSelectionConstants.DONT_INHERIT_OUS))
	{
		adsjQuery("#_DIALOG_LAYER_"+popup.dialogBox.dialogId).find('#DontInheritOUs').removeAttr('checked');//No I18N
		var id = PopupScriptConfig["Popup_"+popup.popupScriptConfigId].DontInheritOUs;
		if(id && adsjQuery('#'+id).is(':checked'))	{	adsjQuery("#_DIALOG_LAYER_"+popup.dialogBox.dialogId).find('#DontInheritOUs').attr('checked', true);	}	
	}
	if(popup.currentTab.currentAFO.currentPDM.menuItemList.contains(PopupSelectionConstants.EXCLUDE_CHILD_OU))
	{
		PopupDataModel.processExcludeChildOU(popup.commonMenuConf.get("exclude_child_ou"));	//NO I18N
		//process Exclude Child OU..
	}
}

PopupDataModel.onUpdateOuInheritance = function(obj){
	var fnName = PopupScriptConfig["Popup_"+popup.popupScriptConfigId].onUpdateOuInheritance;
	if(fnName)
	{		
		FunctionUtil.getFunctionFromName(fnName)(obj);
	}
}
PopupDataModel.onSelectColumnFilter = function(colName, filterValue){	
	var oldVal = popup.params.get("colFilter");					//NO I18N
	PopupDataModel.resetNavigation();
	popup.params.put("colFilter", "{'"+colName+"':'"+filterValue+"'}");		//NO I18N
	popup.currentTab.currentAFO.currentPDM.getPDMView(); 

}
PopupDataModel.resetNavigation = function(){
	PopupDataModel.clearSearchComponent(popup.currentTab.currentAFO.currentPDM.popupDataModelId);	//Only UI elements
	popup.currentTab.currentAFO.currentPDM.popupNavigation = new PopupNavigation();
	popup.currentTab.currentAFO.currentPDM.popupNavigation.init(popup.currentTab.currentAFO.currentPDM.rangeNavigationConfig);
	popup.currentTab.currentAFO.currentPDM.popupNavigation.setUniqueId(popup.currentTab.currentAFO.currentPDM.popupDataModelId);	
}

PopupDataModel.getDisplayValue = function(elementId) {
	var obj = docid(elementId);
	var val = obj.getAttribute('uniquedisplaycolumn');
	if((popup.currentTab.currentAFO.currentPDM.menuItemList.contains(PopupSelectionConstants.DOMAIN_SELECTION) || popup.headerMenuItemList.contains(PopupSelectionConstants.DOMAIN_SELECTION)) && PopupScriptConfig.isForestDomainsOnly())
	{
		var args = obj.getAttribute('args');
		if(args && args != "")	{
			var argsObj = eval('('+args+')');
			if(argsObj.DOMAIN_NAME)
			val += " ["+argsObj.DOMAIN_NAME+"]"; 		//NO I18N
		}
	}
	return val;
}
