/**
 * $Id$
 */

var defaultPopupNavigation;
var PopupNavigation = function(){
	this.url = "";
	this.start = 1;
	this.end =3;
	this.range = 3;
	this.total = 0;
	this.uniqueId = "";
	this.rangeList = [3,10,25,100]
	this.defaultRangeNavigationConfig = {"start":1,"end":3,"rangeList":[3,10,25,100],"url":""}; //NO I18N
}
defaultPopupNavigation = new PopupNavigation();

PopupNavigation.prototype.setTotal = function(totall){
	this.total = totall;
}
PopupNavigation.prototype.setUniqueId = function(uniqueIdd){
	this.uniqueId = uniqueIdd;
}
PopupNavigation.prototype.setRange = function(range){
	this.range = range;
	this.start = 1;
	this.end = this.start + this.range - 1;
}
PopupNavigation.prototype.init = function(config){
	if(config){
		this.initUsingConfig(config);	
	}
	else {
		this.initUsingConfig(this.defaultRangeNavigationConfig);
	}
}
PopupNavigation.prototype.initUsingConfig = function(config){
	this.url = config.url || "";
	this.start = config.start || 1;
	this.end = config.end || 3;
	this.range = config.rangeList[0] || 3;
	this.rangeList = config.rangeList || [3,10,25,100];
	this.total = 0;
}
PopupNavigation.prototype.onNext = function(){	
	this.start = this.start + this.range;
	this.end = this.start + this.range - 1;	
}
PopupNavigation.prototype.onNextAll = function(){	
	this.start = this.total - (((this.total % this.range)!=0 ? (this.total % this.range) : this.range)) + 1;
	this.end = this.total;	
}
PopupNavigation.prototype.onPrev = function(){	
	this.start = this.start - this.range;
	this.end = this.start + this.range - 1;
}
PopupNavigation.prototype.onPrevAll = function(){	
	this.start = 1;
	this.end = this.start + this.range - 1;	
}
PopupNavigation.prototype.processDiv = function(){
	if(popup.isFlatTheme)
	{
		this.processDivFT();
		return;
	}
	//start assigning
	if(this.end > this.total){
		this.end = this.total;
	}	
	var navigate = adsjQuery('#navigMessage'+this.uniqueId).html();	//Value from an element that holds the L10N key value //No I18N
	if(navigate!=null)
	{
		navigate = navigate.replace('{0}',this.start);
		navigate = navigate.replace('{1}',this.end);
		navigate = navigate.replace('{2}',this.total);
	}
	adsjQuery('#showCount'+this.uniqueId).html(navigate);	//Can't use DWRUtil here.So,replacing it directly.	//No I18N	

	//hide all the img tag under the PopupEaseNavigate
	adsjQuery('#PopupEaseNavigate'+this.uniqueId+' div[id^=Popup_]').hide();//No I18N

	if(this.start>1){
		adsjQuery('#Popup_EnablePrevImg'+this.uniqueId).show();//No I18N
	}
	else {
		adsjQuery('#Popup_DisablePrevImg'+this.uniqueId).show();//No I18N
	}

	if(this.end <this.total){
		adsjQuery('#Popup_EnableNextImg'+this.uniqueId).show();//No I18N
	}
	else {
		adsjQuery('#Popup_DisableNextImg'+this.uniqueId).show();//No I18N
	}
}

PopupNavigation.prototype.processDivFT = function(){
	//start assigning
	if(this.end > this.total){
		this.end = this.total;
	}	
	var navigate = adsjQuery('#navigMessage'+this.uniqueId).html();	//Value from an element that holds the L10N key value //No I18N
	if(navigate!=null)
	{
		if(this.total == 0){this.start = this.end = 0;}
		navigate = navigate.replace('{0}',this.start);
		navigate = navigate.replace('{1}',this.end);
		navigate = navigate.replace('{2}',this.total);
	}
	adsjQuery('#showCount'+this.uniqueId).html(navigate);	//Can't use DWRUtil here.So,replacing it directly.	//No I18N	

	//hide all the img tag under the PopupEaseNavigate
	adsjQuery('#PopupEaseNavigate'+this.uniqueId+' i[id^=Popup_]').hide();//No I18N
	if(this.start>1){
		adsjQuery('#Popup_EnablePrevIcon'+this.uniqueId).show();//No I18N
		adsjQuery('#Popup_EnablePrevAllIcon'+this.uniqueId).show();//No I18N
	}
	else {
		adsjQuery('#Popup_DisablePrevIcon'+this.uniqueId).show();//No I18N
		adsjQuery('#Popup_DisablePrevAllIcon'+this.uniqueId).show();//No I18N
	}

	if(this.end <this.total){
		adsjQuery('#Popup_EnableNextIcon'+this.uniqueId).show();//No I18N
		adsjQuery('#Popup_EnableNextAllIcon'+this.uniqueId).show();//No I18N
	}
	else {
		adsjQuery('#Popup_DisableNextIcon'+this.uniqueId).show();//No I18N
		adsjQuery('#Popup_DisableNextAllIcon'+this.uniqueId).show();//No I18N
	}
}
