/**
 * $Id$
 */

var popup;
var PopupSelection = function(popupObj){
	this.popupId = popupObj.popupId || 1;
	this.isFlatTheme = false;
	this.popupTypeId = popupObj.popupTypeId || 1;
	this.popupScriptConfigId = popupObj.popupScriptConfigId || 1;
	this.tabsList = new Array();
	this.initTabs(popupObj.popupTabs);
	this.isLoaded = false;
	this.currentTab = 0;
	this.buttonName = popupObj.buttonName;
	this.params = new Hashtable();
	this.showSummaryViewOnly = false;
    this.commonMenuConf = new Hashtable();
	this.popupHeaderMenuDataModelList = popupObj.popupHeaderMenuDataModelList;
	this.popupHeaderMenuItems = popupObj.popupHeaderMenuItems;
	this.headerMenuItemList = new Array();
	this.initHeaderMenuItemList();
	this.dialogBox = new DialogBox();
	this.dialogBox.dialogId = DialogBoxGroup.dialogBoxArray.length;
	DialogBoxGroup.dialogBoxArray.push(this.dialogBox);
}

PopupSelection.prototype.initTabs = function(tabsObj){
	for(var i=0;i<tabsObj.length; i++){
		this.tabsList[i] = new PopupTabObject(tabsObj[i]);
	}
}

PopupSelection.prototype.initHeaderMenuItemList = function(){
	var headerMenuDataModelIds=this.popupHeaderMenuDataModelList;
	var headerMenuItems=this.popupHeaderMenuItems;
	for(var i=0;i<headerMenuDataModelIds.length;i++){
		var headerMenuDataModelId=headerMenuDataModelIds[i];
		var menuItem=headerMenuItems[headerMenuDataModelId];
		this.headerMenuItemList.push(menuItem.menuId);
	}
}
/**
 * This will be called for the first time after the loading the configuration data of the popup.
 * This will load the Header design
 */
PopupSelection.prototype.onFirstLoad = function(){
	//this.isLoaded = true;  It has to be initialized only after rendering the html to the client
	this.getHeaderMenuDMView();
	var tabObj = this.getDefaultTab();
	this.currentTab = tabObj;
	this.currentTab.onClicked();
	if(popup.buttonName!=null)
	{
		adsjQuery('#popupButtonVal').attr("value"," "+jsTitleMsg[this.buttonName]+" ");	//This button is for popup alone //No I18N
		adsjQuery('#popupButton').show();//No I18N
		adsjQuery('#filterButton').hide();//No I18N
	}
	this.updateCount();	
}

PopupSelection.prototype.updateCount = function()
{
	if(popup.isFlatTheme)
	{
		this.updateCountFT();
		return;
	}
	var count = 0;
	for(var i=0;i<this.tabsList.length;i++)
	{
		//count+=this.tabsList[i].selectedList.size();	
		count+=this.tabsList[i].selectedList.keys.length;
	}
	adsjQuery('#popupSelectedCount').html(count);	//No I18N
	if(count == 0) adsjQuery('#popupSelectedCountDiv') .hide();
	else adsjQuery('#popupSelectedCountDiv') .show();	//No I18N
}

PopupSelection.prototype.updateCountFT = function()
{
	var selectedCounts = new Hashtable();
	for(var i=0;i<this.tabsList.length;i++)
	{
		if(this.tabsList[i].selectedList!=null)
			selectedCounts.put(this.tabsList[i].tabId,this.tabsList[i].selectedList.keys.length);
	}
	for(var i=0;i<this.tabsList.length;i++)
	{
		adsjQuery('#popupSelectedCount_'+this.tabsList[i].tabId).html(selectedCounts.get(this.tabsList[i].tabId));	//No I18N
	}
}
/**
 * It will return the default selected AFO object for the calling PopupSelection object
 */
PopupSelection.prototype.getDefaultTab = function(){
	for(var i=0;i<this.tabsList.length ;i++){
		if(this.tabsList[i].isDefaultSelected === true){
			return this.tabsList[i];
		}
	}
	return this.tabsList[0];
}
PopupSelection.prototype.getTab = function(popupTabId){
	for(var i=0; i<this.tabsList.length; i++){
		if(this.tabsList[i].tabId === popupTabId){
			return this.tabsList[i];
		}
	}
	return this.tabsList[0];
}
PopupSelection.openPopup = function(popupId,showSummary,isFlatTheme){
	AjaxAPI.sendRequest({URL:"ADSPopupAction.do?methodToCall=getConfigData",PARAMETERS:"popupId="+popupId,ONSUCCESSFUNC:PopupSelection.loadConfigSuccess,ONFAILUREFUNC:PopupSelection.loadConfigFailure,SHOWSUMMARY:showSummary,FLAT_THEME:isFlatTheme});  //NO I18N
}
PopupSelection.loadConfigSuccess = function(response,requestOptions){
	adsjQuery('select').hide();//No I18N
	var showSummary = requestOptions['SHOWSUMMARY'];
	var flatTheme = requestOptions['FLAT_THEME'];
	var jsonText = response.responseText;
	var popupConfigObj = eval('('+jsonText+')');
	popup = new PopupSelection(popupConfigObj[0].objString);
	if(showSummary)
	{
		popup.showSummaryViewOnly = showSummary;
	}
	if(flatTheme)
	{
		popup.isFlatTheme = flatTheme;
	}
	var params = 'popupId='+popup.popupId + '&isFlatTheme='+popup.isFlatTheme + '&selDomain='+adsjQuery('#DOMAIN_NAME').val() ;		//NO I18N

	// Some popups only need input, while loading Popup_Header.. So, if 'getHeaderInputParamsJson' name is mentioned in PopupScriptConfig.js, then the output of that fn will be passed in given below AJAX requestr.
	var getHeaderInputsFnName = PopupScriptConfig["Popup_"+popup.popupScriptConfigId].getHeaderInputParamsJson;
	if(getHeaderInputsFnName)
		params += '&headerSpecificInput='+FunctionUtil.callFunctionByName(getHeaderInputsFnName,window);		//NO I18N

	AjaxAPI.sendRequest({URL:"ADSPopupAction.do?methodToCall=getPopupHeader", PARAMETERS:params, ONSUCCESSFUNC:PopupSelection.showHeaderDesign, ONFAILUREFUNC:PopupSelection.getHeaderDesignFailed});  //NO I18N
}

PopupSelection.loadConfigFailure = function(){
	if(!popup.isFlatTheme)
	{
		alertMsg(jsTitleMsg.unknown_error); 
	}
	else
	{
		showAlertBox(jsTitleMsg.unknown_error);
	}
}

PopupSelection.showHeaderDesign = function(response,requestOptions){

	if(popup.isFlatTheme == true)
	{
		popup.dialogBox.showFTDialog(response.responseText, "modal=yes,freezeLayerBGColor=#000B0B,position=absolute,title=Untitled", PopupSelection.setPopupTitle, PopupSelection.onClose); //No I18N
	}
	else
	{
		if(PopupScriptConfig["Popup_"+popup.popupScriptConfigId].setPopupStyle)
		{
			popup.dialogBox.showDialog(response.responseText, PopupScriptConfig["Popup_"+popup.popupScriptConfigId].setPopupStyle+",title=Untitled", PopupSelection.setPopupTitle, PopupSelection.onClose); // NO I18N
		}
		else
		{
			popup.dialogBox.showDialog(response.responseText ,"modal=yes, closeOnEscKey=yes, top=80, left=430, width=600, freezeLayerBGColor=#000B0B,position=absolute,title=Untitled", PopupSelection.setPopupTitle, PopupSelection.onClose); // NO I18N		
		}
	}

	//Need to update the AFO selected list from the PopupSelPrevList .
	popup.updatePrevSelList();
	popup.updatePrevSelListToTab();
	popup.updatePrevUnSelListToTab();
	popup.onFirstLoad();	
}

PopupSelection.onClose = function() {
	adsjQuery('select').show();//No I18N
}

PopupSelection.setPopupTitle = function() {
	var str = PopupScriptConfig["Popup_"+popup.popupScriptConfigId].popupTitle;
	adsjQuery('#dialogTitle_'+popup.dialogBox.dialogId).text(jsTitleMsg[str]);	//NO I18N
}

PopupSelection.getHeaderDesignFailed = function(){
	if(!popup.isFlatTheme)
	{
		alertMsg(jsTitleMsg.unknown_error);
	}
	else
	{
		showAlertBox(jsTitleMsg.unknown_error); //NO I18N
	}
}
PopupSelection.prototype.updatePrevSelList = function(){
	var onPopupLoadFunctionName = PopupScriptConfig["Popup_"+popup.popupScriptConfigId].onPopupLoad;
	if(onPopupLoadFunctionName)
		FunctionUtil.callFunctionByName(onPopupLoadFunctionName,window);
}
PopupSelection.prototype.updatePrevSelListToTab = function(){
	for(var i=0; i<this.tabsList.length; i++)
	{
		if(PopupSelPrevList["Popup_"+this.popupId].get(this.tabsList[i].objectTypeId)){
			this.tabsList[i].selectedList = PopupSelPrevList["Popup_"+this.popupId].get(this.tabsList[i].objectTypeId);
		}
	}
}

PopupSelection.prototype.updatePrevUnSelListToTab = function(){
	for(var i=0; i<this.tabsList.length; i++)
	{
		if(PopupPrevUnSelectedList["Popup_"+this.popupTypeId].get(this.tabsList[i].objectTypeId)){
			this.tabsList[i].unSelectedList = PopupPrevUnSelectedList["Popup_"+this.popupTypeId].get(this.tabsList[i].objectTypeId);
		}
	}
}

PopupSelection.prototype.getHeaderMenuDMView = function(){
	var menuDataModelIds=popup.popupHeaderMenuDataModelList;
	var menuItems=popup.popupHeaderMenuItems;
	for(var i=0;i<menuDataModelIds.length;i++)
	{
		var params = new PopupRequestParams();
		var menuDataModelId=menuDataModelIds[i];
		var menuItem=menuItems[menuDataModelId];
		params.initHeaderMenuItem(menuItem);
		var paramStr = params.toJSONString() + '&isFlatTheme=' + popup.isFlatTheme; //No I18N
		AjaxAPI.sendRequest({URL:"ADSPopupAction.do?methodToCall=getDataModelUIDesign",PARAMETERS:"params="+paramStr,ONSUCCESSFUNC:"PopupSelection.fetchMenuDataSuccess", ONFAILUREFUNC:"PopupSelection.fetchMenuDataFailure",MENUDMID:menuDataModelId });	//NO I18N
	}
}

PopupSelection.fetchMenuDataSuccess = function(response, requestOptions){
	var menuDataModelId=requestOptions['MENUDMID'];
	adsjQuery('#HeaderMenuItem_'+menuDataModelId).html(response.responseText); //NO I18N
}

PopupSelection.fetchMenuDataFailure = function(){
	if(!popup.isFlatTheme)
	{
		alertMsg(jsTitleMsg.unknown_error);
	}
	else
	{
		showAlertBox(jsTitleMsg.unknown_error);
	}
}

PopupSelection.openPopupWithSummary = function(popupId)
{
	PopupSelection.openPopup(popupId,true);
}
PopupSelection.initPrevSelList = function(popupSelectedListDetails){
	if(popupSelectedListDetails)
	{
		for(var i=0; i<popupSelectedListDetails.count; i++)
		{
			var objectId = popupSelectedListDetails.keys[i];
			var selectedList = popupSelectedListDetails.get(objectId);
			PopupSelPrevList["Popup_"+objectId].put(objectId, selectedList);		//Format: PopupSelPrevList["Popup_"+objectId] is a hashtable with key as a objectId and value as a hashtable (which contains details about objects selected by the user in popup corresponding to objectId)
		}
	}
}

PopupSelection.initPrevUnSelList = function(popupUnSelectedListDetails){
	if(popupUnSelectedListDetails)
	{
		for(var i=0; i<popupUnSelectedListDetails.count; i++)
		{
			var objectId = popupUnSelectedListDetails.keys[i];
			var unSelectedList = popupUnSelectedListDetails.get(objectId);
			PopupPrevUnSelectedList["Popup_"+objectId].put(objectId, unSelectedList);		//Format: PopupSelPrevList["Popup_"+objectId] is a hashtable with key as a objectId and value as a hashtable (which contains details about objects selected by the user in popup corresponding to objectId)
		}
	}
}